var m_1614328142482Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Loginapp Design Kit page settings configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142482\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> page settings configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N10007\">Page settings allow configuring the behavior of certain UI pages. Some pages do not have any settings while others like the configurable UI require significant settings configurations.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N1000D1614592568385\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Basic configuration and lookup strategy<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N100111614592568385\">UI page settings are configured using <code class=\"codeinline\">config.pages<\/code> section in <code class=\"codeinline\">custom.sdk.config.js<\/code>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The <code class=\"codeinline\">config.pages<\/code> section consists of an array of page settings:<\/li><li class=\"enum-element\">Each entry defines the path of the page.<\/li><li class=\"enum-element\">The first entry whose path matches the current browser URL is used to for rendering the page.<\/li><li class=\"enum-element\">The path may contain a placeholder <code class=\"codeinline\">FLOW<\/code> to resolve the flow ID at runtime or the flow ID may be hard coded.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1003D\">config.pages = [ \r\n    \/\/ Password page \r\n    { \r\n        path: \'\/auth\/flow\/{{FLOW}}\/password\', \r\n        ... \r\n    }, \r\n    \/\/ Password change page \r\n    { \r\n        path: \'\/auth\/flow\/fixed-flow-id\/password\/change\', \r\n        ... \r\n    }, \r\n    ... \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142482_N10047\">The above example shows two entries in <code class=\"codeinline\">config.pages<\/code>. One uses the <code class=\"codeinline\">FLOW<\/code> placeholder, the other hardcoding the flow ID.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142482_N10057\">Page settings currently do not support the use of <i class=\"italics\">stepId<\/i> and all steps will use the same configuration. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N100891614592568385\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Full page settings configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N1008D1614592568385\">The following code block shows the full configuration of the <code class=\"codeinline\">config.pages<\/code> section supported by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span>: <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10017\">pages: [
    {
        path: '/auth/flow/{{FLOW}}/airlock-2fa/challenge',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/airlock-2fa/challenge-only',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/cronto/challenge',
        additionalAttributes: {
            'challenge': {
                'onlineValidation': true,
                'pushed': true,
                'pushDevice': {
                    'label': 'My iPhone',
                    // the platform property is only used if label is set to null
                    'platform': 'IOS'
                }
            }
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/password',
        pageSettings: {
            publicSelfServiceLink: '{{SPA}}/self-service/flow/default',
            userSelfRegistrationLink: '{{SPA}}/registration/flow/default'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/password/change',
        pageSettings: {
            oldPasswordRequired: false
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/mtan',
        additionalAttributes: {
            resendPossible: true,
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/mtan/registration/verification/otp',
        additionalAttributes: {
            resendPossible: true,
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/airlock-2fa/additional-activation',
        pageSettings: {
            showAppDeviceActivationLink: true
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/airlock-2fa/migration',
        pageSettings: {
            showAppDeviceActivationLink: true
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/message',
        additionalAttributes: {
            messageId: 'default'
        }
    },
    {
        path: 'auth/flow/{{FLOW}}/matrix',
        additionalAttributes: {
            matrixChallenges: ['A13']
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/oauth2/consent',
        additionalAttributes: {
            grantableScopes: [
                {
                    scope: 'email',
                    granted: true,
                    updatedAt: '2024-10-23'
                },
                {
                    scope: 'phone',
                    granted: false,
                    updatedAt: '2023-08-15'
                },
                {
                    scope: 'address',
                    granted: false
                }
            ]
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/email/otp',
        additionalAttributes: {
            resendPossible: true,
            emailAddress: 'john.doe@example.com'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/email/verification/otp/check',
        additionalAttributes: {
            emailAddress: 'john.doe@example.com'
        }
    },
    {
        path: '/auth/flow/{{FLOW}}/username',
        additionalAttributes: {
            captcha: {
                // supported types are 'RE_CAPTCHA' and 'H_CAPTCHA' - the property 'key' can also be set to use your own site key
                type: 'RE_CAPTCHA'
            }
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/approval/airlock-2fa/challenge',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/approval/airlock-2fa/challenge-only',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/approval/cronto/challenge',
        additionalAttributes: {
            'challenge': {
                'onlineValidation': true,
                'pushed': true,
                'pushDevice': {
                    'label': 'My iPhone',
                    // the platform property is only used if label is set to null
                    'platform': 'IOS'
                }
            }
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/approval/matrix',
        additionalAttributes: {
            matrixChallenges: ['A13']
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/approval/mtan',
        additionalAttributes: {
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/message',
        additionalAttributes: {
            messageId: 'default'
        }
    },
    {
        path: '/self-service/flow/{{FLOW}}/username',
        additionalAttributes: {
            captcha: {
                type: 'RE_CAPTCHA'
            }
        }
    },
    {
        path: '/registration/flow/{{FLOW}}/data/example',
        additionalAttributes: {
            captcha: {
                type: 'H_CAPTCHA'
            }
        }
    },
    {
        path: '/registration/flow/{{FLOW}}/message',
        additionalAttributes: {
            messageId: 'default'
        }
    },
    {
        path: '/registration/flow/{{FLOW}}/airlock-2fa/device/add',
        pageSettings: {
            showAppDeviceActivationLink: true
        }
    },
    {
        path: '/registration/flow/{{FLOW}}/verification/email',
        additionalAttributes: {
            captcha: null,
            emailAddress: 'john.doe@example.com'
        }
    },
    {
        path: '/registration/flow/{{FLOW}}/verification/phone-number',
        additionalAttributes: {
            captcha: null,
            resendPossible: true,
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/airlock-2fa/device/add',
        pageSettings: {
            showAppDeviceActivationLink: true
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/approval/airlock-2fa/challenge',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/approval/airlock-2fa/challenge-only',
        pageSettings: {
            showAppApprovalLink: true,
            // supported factors are 'ONLINE_QR_CODE' and 'ONE_TOUCH'
            factor: 'ONLINE_QR_CODE'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/approval/cronto/challenge',
        additionalAttributes: {
            'challenge': {
                'onlineValidation': true,
                'pushed': false,
                'pushDevice': {
                    'label': 'My iPhone',
                    // the platform property is only used if label is set to null
                    'platform': 'IOS'
                }
            }
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/approval/matrix',
        additionalAttributes: {
            matrixChallenges: ['A13']
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/approval/mtan',
        additionalAttributes: {
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/email/verification/otp/check',
        additionalAttributes: {
            emailAddress: 'john.doe@example.com'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/message',
        additionalAttributes: {
            messageId: 'default'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/mtan/registration/verification/otp',
        additionalAttributes: {
            resendPossible: true,
            phoneNumber: '+41791234567'
        }
    },
    {
        path: '/protected/flow/{{FLOW}}/vasco/device/activation',
        additionalAttributes: {
            activatableDevices: [
                {
                    id: '0',
                    serialNumber: '000-1111-33'
                },
                {
                    id: '1',
                    serialNumber: '111-2222-44'
                }
            ]
        }
    },
    {
        path: '/protected/portal',
        pageSettings: {
            portalGroups: [
                {
                    identifier: 'self-services',
                    portalTargets: [
                        {identifier: 'cronto-device-management'},
                        {identifier: 'address-change'},
                        {identifier: 'password-change'}
                    ]
                },
                {
                    identifier: 'custom-group',
                    portalTargets: [
                        {identifier: 'custom-target'}
                    ]
                }
            ]
        }
    },
    {
        path: '/error/message',
        pageSettings: {
            titleKey: 'general.error.title',
            message: {key: 'general.error.description', arguments: null}
        }
    }
],<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142482_N100AF1614592568385\">To clear a value, use <code class=\"codeinline\">null<\/code>. The following example removes the password reset link and the user self-registration link on the password page:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100651614765385008\">config.pages = [ \r\n    { \r\n        path: \'\/auth\/flow\/{{FLOW}}\/password\', \r\n        pageSettings: { \r\n            passwordResetLink: null, \r\n            userSelfRegistrationLink: null \r\n        } \r\n    } \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N100E91614592568385\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Field-based validation messages<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N100ED\">Validation messages are configured separately for each page. The following example demonstrates how a <code class=\"codeinline\">validations<\/code> section is added to the password page:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100751614765385008\">config.pages = [ \r\n    \/\/ Password page \r\n    { \r\n        path: \'\/auth\/flow\/{{FLOW}}\/password\', \r\n        validations: [ \r\n            { \r\n                htmlId: \'username\', \r\n                messages: [ \r\n                    {key: \'error.validation-failed.required\'}, \r\n                    {key: \'error.validation-failed.min-length\', arguments: {requiredLength: 6}} \r\n                ] \r\n            }, \r\n            { \r\n                htmlId: \'password\', \r\n                messages: [ \r\n                    {key: \'error.validation-failed.required\'}, \r\n                ] \r\n            } \r\n        ] \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142482_N1004C\">In the above example, the UI fields for username and password are configured to display validation messages. Parameters to the validation message translation can be passed using arguments.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N1014E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom configuration-based UI<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N10152\">Custom UIs are a special type of UIs that are characterized by their dynamic nature. While the content on most product pages is fixed, the content on custom UIs is either determined by a server-side configuration or by JavaScript.<\/p><p class=\"par\" id=\"1614328142482_N10158\">The configuration of Airlock IAM provides a configuration option based on the <span class=\"dialog\">Custom Configuration-Based UI<\/span> plugin that enables administrators to configure the fields to display in a UI. Since the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> operates without an actual IAM instance, it provides means to define the content of the configuration-based UI. Below is a configuration showing the usage of each available type of UI control:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100B31614765385008\">config.pages = [ \r\n    { \r\n        path: \'\/auth\/flow\/{{FLOW}}\/ext\/example\', \r\n        uiElements: [ \r\n            { \r\n                type: \'form\', \r\n                uiElements: [ \r\n                     { \r\n                        type: \'text\', \r\n                        htmlId: \'itemText\', \r\n                        text: \'some text w\/o &lt;i&gt;HTML code&lt;\/i&gt;\' \r\n                     },\r\n                       { \r\n                        type: \'input\', \r\n                        htmlId: \'itemUsername\', \r\n                        label: \'authentication.data.item-label.username\', \r\n                        property: \'username\', \r\n                    }, \r\n                    { \r\n                        type: \'checkbox\', \r\n                        htmlId: \'itemOfficePhone\', \r\n                        label: \'authentication.data.item-label.office-phone\', \r\n                        labelLeft: true, \r\n                        property: \'officePhone\', \r\n                    }, \r\n                    { \r\n                        type: \'captcha\' \r\n                    },  \r\n                    { \r\n                        type: \'drop-down\', \r\n                        htmlId: \'itemSelection\', \r\n                        label: \'registration.selection.instructions\', \r\n                        property: \'selection\', \r\n                        options: [ \r\n                            { \r\n                                id: \'selectionOption1\', \r\n                                label: \'registration.selection.options.airlock-2fa\', \r\n                                value: \'value1\', \r\n                                disabled: false \r\n                            }, \r\n                            { \r\n                                id: \'selectionOption2\', \r\n                                label: \'registration.selection.options.cronto\', \r\n                                value: \'value2\', \r\n                                disabled: false \r\n                            } \r\n                        ] \r\n                    }, \r\n                    { \r\n                        type: \'radio\', \r\n                        htmlId: \'itemRadio\', \r\n                        label: \'registration.data.item-label.correspondence-language\', \r\n                        property: \'radio\', \r\n                        inline: true, \r\n                        options: [ \r\n                            {id: \'radioOption1\', label: \'general.language.de\', value: \'value1\', disabled: false}, \r\n                            {id: \'radioOption2\', label: \'general.language.en\', value: \'value2\', disabled: false} \r\n                        ] \r\n                    }, \r\n                    { \r\n                        type: \'button-group\', \r\n                        buttons: [ \r\n                            { \r\n                                type: \'button\', \r\n                                label: \'authentication.data.actions.continue\', \r\n                                alignment: \'RIGHT\', \r\n                                htmlId: \'continueButton\' \r\n                            }, \r\n                            { \r\n                                type: \'cancel-button\', \r\n                                alignment: \'RIGHT\' \r\n                            } \r\n                        ] \r\n                    } \r\n                ] \r\n            } \r\n        ] \r\n    } \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142482_N100C0\">Note that the custom configuration-based UI must be added to <code class=\"codeinline\">customUi<\/code> of the navigation menu.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142482_N100DC\">The Loginapp UI uses <code class=\"codeinline\">\/ext<\/code> path for pages that were explicitly configured using the <span class=\"dialog\">Custom Configuration-Based UI<\/span> plugin. However, IAM is also able to automatically infer the UI configuration for certain steps which results in pages being available using data instead of <code class=\"codeinline\">\/ext<\/code> in their path.  For example: <code class=\"codeinline\">\/auth\/flow\/{{FLOW}}\/data\/example<\/code> . The underlying mechanisms and the configuration in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> however are the same.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N100C6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Adding CAPTCHAs to custom pages<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N100CB1659683104932\">Two external CAPTCHA services are supported by Airlock IAM, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929280371.html\">reCAPTCHA and hCAPTCHA<\/a>.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To add a CAPTCHA element on a custom page:<\/li><li class=\"step\">Add the <code class=\"codeinline\">type: \'captcha\'<\/code> to the list of <code class=\"codeinline\">uiElements<\/code> (see example code in section <span class=\"dialog\">Custom configuration-based UI<\/span>).<\/li><li class=\"step\">Define the path and CAPTCHA type in the page settings (see example code in section <span class=\"dialog\">Full page settings configuration<\/span>).<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N100CA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overwriting automatic type formatting<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N100A5\">For <code class=\"codeinline\">type: \'input\'<\/code> fields, validators are used to set the type of input (e.g. <code class=\"codeinline\">type: \'text\'<\/code>). To overwrite the validator, add a corresponding subtype to the <code class=\"codeinline\">type: \'input\'<\/code> section:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100B3\">config.pages = [  \r\n    {  \r\n        path: \'\/auth\/flow\/{{FLOW}}\/ext\/example\',  \r\n        uiElements: [  \r\n            {  \r\n                type: \'form\',  \r\n                uiElements: [  \r\n                    {  \r\n                        type: \'input\',  \r\n                        <mark class=\"marker\">subtype: \'email\',<\/mark> \r\n                        htmlId: \'itemUsername\',  \r\n                        label: \'authentication.data.item-label.username\',  \r\n                        property: \'username\',  \r\n                    },  \r\n                    ... <\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Frequently used supported subtypes are:<\/li><li class=\"enum-element\"><code class=\"codeinline\">\'text\'<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\'email\'<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\'password\'<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\'number\'<\/code><\/li><p class=\"par\" id=\"1614328142482_N100D0\">Note that other input types may also be used with <mark class=\"marker\">limited support<\/mark>. For example, there is no out-of-the-box support for formatting when using the subtype <code class=\"codeinline\">\'date\'<\/code>. <br\/>A list of all possible values applicable as subtypes can be found here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.w3schools.com\/html\/html_form_input_types.asp\" target=\"_blank\">(w3schools) HTML input types<\/a>.<\/p><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N100F2\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom JavaScript-Based UI<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142482_N100EB\">Even more flexible are pages that are entirely written in JavaScript and configured using the <span class=\"dialog\">Custom JavaScript-Based UI<\/span> plugin in an <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instance. A custom JavaScript-based UI is nothing else than a custom configuration-based UI using an empty array for <code class=\"codeinline\">uiElements<\/code>:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1010E\">config.pages = [ \r\n    { \r\n        path: \'\/auth\/flow\/{{FLOW}}\/ext\/example\', \r\n        uiElements: [] \r\n    } \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142482_N10112\">As mentioned, the page must be added to a <code class=\"codeinline\">customUi<\/code> section of the navigation menu.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142482_N10116\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Menu-related customization: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142469.html\">Loginapp Design Kit navigation menu configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929282064.html\">Customizing the CAPTCHA look and feel<\/a><\/li><li class=\"enum-element\">More details about how to write an entire page using JavaScript: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142561.html\">Adding new pages using the Loginapp Design Kit<\/a><\/li><li class=\"enum-element\">A list of HTML subtypes (some with only limited support) can be found here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.w3schools.com\/html\/html_form_input_types.asp\" target=\"_blank\">(w3schools) HTML input types<\/a><\/li><li class=\"enum-element\">For CAPTCHAs in IAM flow configurations, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929280371.html\">CAPTCHAs in the Loginapp REST API and the Loginapp UI<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';