var m_1614328142505Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Change the Loginapp UI appearance with the Design Kit<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142505\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Change the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> appearance with the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N10006\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Styling using SASS and CSS<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N10007\">The look and feel of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> can be changed using <i class=\"italics\">SASS<\/i> or plain <i class=\"italics\">CSS<\/i>. The relevant files are located in:<br\/><code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/sass\/custom<\/code><\/p><p class=\"par\" id=\"1614328142505_N10009\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> provides useful variables to quickly change the Loginapp UI. For a list of variables, see below. These variables can be added here:<br\/><code class=\"codeinline\">_custom-variables.scss<\/code> <\/p><p class=\"par\" id=\"1614328142505_N1003B1614780383984\">The SASS variables are a very easy and quick way to get started and our recommendation unless they don\'t cover all relevant aspects. Whenever more advanced customizations are required,  you can write custom SASS or just plain CSS styles here:<br\/><code class=\"codeinline\">_custom-styles.scss<\/code><\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142505_N10044\">All variables used have to be explicitly defined or uncommented, e.g. when assigning the value of one variable to another.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N100691666256737505\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Change the favicon<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N1006C\">To change the favicon of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span>, replace the original <code class=\"codeinline\">favicon.ico<\/code> in the <code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/assets\/img<\/code> folder and rebuild the customized <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> zip-file with the new favicon.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">List of available SASS variables<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N10069\">The following table shows all the variables supported by the <span class=\"dialog\">Loginapp UI.<\/span>  Copies of all variables that need to be adapted for your styling should be added in:<br\/><code class=\"codeinline\">_custom-variables.scss<\/code> <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10075\">
/** **************
 * Colors
 * **************/
$iam-color-black: #000 !default;
$iam-color-white: #fff !default;
$iam-color-gray-dark: #373a3c !default;
$iam-color-very-dark-gray: #555 !default;
$iam-primary-color: rgb(62 92 112) !default;

/** **************
 * Font
 * **************/
$iam-font-family-base: 'TypoPRO Source Sans Pro', sans-serif !default;
$iam-font-size-base: 1rem !default;

/** **************
 * Basic settings
 * **************/
$iam-body-color: #212529 !default;
$iam-body-bg: $iam-color-white !default;
$iam-line-height-base: 1.5 !default;
$iam-border-radius: .25rem !default;
$iam-border-width: 1px !default;

/** **************
 * Header, content, footer containers
 * **************/
$iam-header-container-padding: 0 15px !default;
$iam-header-container-full-width: false !default;
$iam-content-container-padding: 0 15px !default;
$iam-content-container-full-width: false !default;
$iam-footer-container-padding: 0 15px !default;
$iam-footer-container-full-width: false !default;

/** **************
 * Logo
 * **************/
$iam-show-logo: true !default;
$iam-logo-url: product-asset('img/logo.svg') !default;
$iam-logo-width: 95px !default;
$iam-logo-height: 35px !default;

/** **************
 * Portal Target
 * **************/
$iam-portal-target-icon: product-asset('img/icon-target.svg') !default;
$iam-portal-target-mobile-right-icon: product-asset('img/icon-chevron-compact-right.svg') !default;
$iam-portal-target-mobile-right-icon-white: product-asset('img/icon-chevron-compact-right-white.svg') !default;

/** **************
 * Loader
 * **************/
$iam-loader-show: true !default;
$iam-loader-logo-url: $iam-logo-url !default;
$iam-loader-logo-width: $iam-logo-width !default;
$iam-loader-logo-height: $iam-logo-height !default;
$iam-loader-animated-circle: true !default;
$iam-loader-animated-circle-size: 200px !default;
$iam-loader-animated-circle-thickness: 2px !default;
$iam-loader-animated-circle-color: $iam-primary-color !default;

/** **************
 * Links
 * ***************/
$iam-link-color: #555 !default;
$iam-link-decoration: underline !default;
$iam-link-hover-decoration: none !default;

/** **************
 * Logout Link
 * ***************/
$iam-show-logout-link: false !default;
$iam-show-logout-link-icon: product-asset('img/logout.svg') !default; // Use false if no icon required
$iam-hide-logout-link-icon-on-small-devices: false !default;
$iam-hide-logout-link-text-on-small-devices: true !default;

/** **************
 * Cards
 * **************/
$iam-card-header-font-size: $iam-font-size-base * 1.75 !default;
$iam-card-header-font-weight: bold !default;
$iam-card-header-padding: .5rem 1.5rem !default;
$iam-card-header-text-align: left !default;
$iam-card-header-font-color: $iam-color-white !default;
$iam-card-header-background: $iam-primary-color !default;
$iam-card-border-width: $iam-border-width !default;
$iam-card-border-color: rgba($iam-color-black, .125) !default;
$iam-card-border-radius: $iam-border-radius !default;
$iam-card-body-padding: 1.75rem 1.5rem !default;
$iam-detail-card-header-background: lighten($iam-card-header-background, 60%) !default;
$iam-detail-card-header-font-size: $iam-font-size-base * 1.25 !default;
$iam-detail-card-header-padding: .1rem 1.5rem !default;
$iam-detail-card-header-font-weight: bold !default;
$iam-detail-card-header-font-color: $iam-body-color !default;
$iam-detail-card-body-padding: 1rem 1.5rem;
$iam-detail-card-margin-bottom: 1rem !default;

/** **************
 * Buttons
 * ***************/
$iam-btn-primary-bg: $iam-color-white !default;
$iam-btn-primary-color: $iam-color-gray-dark !default;
$iam-btn-primary-border: 1px solid $iam-color-very-dark-gray !default;
$iam-btn-border-radius: $iam-border-radius !default;
$iam-btn-transition: color .15s ease-in-out, background-color .15s ease-in-out, border-color .15s ease-in-out, box-shadow .15s ease-in-out !default;

/** **************
 * Forms
 * **************/
$iam-input-border-color: #ced4da !default;
$iam-input-focus-border-color: lighten($iam-input-border-color, 25%) !default;
$iam-input-color: #55595c !default;
$iam-input-padding-y: .375rem !default;
$iam-input-padding-x: .75rem !default;
$iam-input-height: (($iam-font-size-base * $iam-line-height-base) + ($iam-input-padding-y * 2)) !default;
$iam-input-transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out !default;
$iam-form-group-margin-bottom: 1rem !default;
$iam-label-font-weight: bold !default;
$iam-label-always-on-top: false !default;
$iam-form-required-content: '*' !default;
$iam-form-required-content-color: $iam-color-gray-dark !default;
$iam-form-required-content-size: inherit !default;
$iam-form-required-content-vertical-align: baseline !default;
$iam-form-feedback-invalid-color: #dc3545 !default;
$iam-form-feedback-enable-validation-icons: true !default;

/** **************
 * Alerts
 * **************/
$iam-alert-border-radius: $iam-border-radius !default;
$iam-alert-danger-text: #721c24 !default;
$iam-alert-danger-bg: #f8d7da !default;
$iam-alert-danger-border: darken($iam-alert-danger-bg, 5%) !default;
$iam-alert-warning-text: #856404 !default;
$iam-alert-warning-bg: #fff3cd !default;
$iam-alert-warning-border: darken($iam-alert-warning-bg, 5%) !default;
$iam-alert-success-text: #155724 !default;
$iam-alert-success-bg: #d4edda !default;
$iam-alert-success-border: darken($iam-alert-success-bg, 5%) !default;
$iam-alert-info-text: #0c5460 !default;
$iam-alert-info-bg: #d1ecf1 !default;
$iam-alert-info-border: darken($iam-alert-info-bg, 5%) !default;<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N100311614598737196\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Referencing static files in SASS<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N100351614598737196\">In some cases, static files \u2013 often called <i class=\"italics\">assets<\/i> \u2013 like images or fonts need to be referenced. We recommend using the SASS function custom-asset to reference assets relative to:<br\/> <code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/assets\/custom<\/code><\/p><p class=\"par\" id=\"1614328142505_N10063\">For example,  in _custom-variables.scss  the logo is referenced as follows:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1004A1614598737196\">$iam-logo-url: custom-asset(\'img\/your_logo_file_name.svg\') !default;<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N10092\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Examples for _custom-styles.scss<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N10095\">The following example illustrates how to use the _custom-styles.css to add CSS that goes beyond using the product\'s SASS variables\":<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1009D\"> \/\/  \r\n \/\/ Example 1) align buttons left instead of right: \r\n \/\/.iam-button-group { \r\n \/\/\t.iam-btn { \r\n \/\/\t\tfloat: left !important; \r\n \/\/\t\tmargin-left: 0 !important; \r\n \/\/\t\tmargin-right: $spacer; \r\n \/\/\t} \r\n \/\/ \r\n \/\/\t.iam-btn-wrapper { \r\n \/\/\t\tfloat: left !important; \r\n \/\/\t} \r\n \/\/}  \r\n \r\n \/\/ Example 2) Hiding the language selection: \r\n \/\/.iam-language-switcher { \r\n \/\/\tvisibility: hidden; \r\n \/\/}\r\n  \r\n \/\/ Example 3) Making the container on the login page smaller: \/\/#iamAuthPassword .iam-card { \r\n \/\/    width: 480px; \r\n \/\/    margin-left: auto; \r\n \/\/    margin-right: auto; \r\n \/\/}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N10057\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Drop styles provided by IAM<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142505_N1005B\">In some cases, the required look and feel is vastly different from Airlock IAMs default styles and it may be preferable to drop all provided styling and start from scratch. The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> allows for this by enabling the following option here: <br\/><code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/sdk\/config\/custom.sdk.config.js<\/code><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142505_N1007B\"><strong class=\"emphasis\">Example:<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1007E\">config.build = { \r\n    dropStyles: true \r\n};<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142505_N10028\">As a consequence of dropping all standard styles, variables defined in <code class=\"codeinline\">_custom-variables.scss<\/code> have no effect anymore. Instead, all SASS\/CSS work has to be done in <code class=\"codeinline\">_custom-styles.scss<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142505_N100AD\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further links and information<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For more information on <i class=\"italics\">flow ID<\/i> and <i class=\"italics\">step ID<\/i> see: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142469.html\">Loginapp Design Kit navigation menu configuration<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';