$(document).ready(function () {
	
	var p = parseQueryString(location.search);
	if (p['highlight']){
		$("#section-column-main-content").SearchHighlight({
			exact: "partial",
			style_name: "highlight",
			style_name_suffix: false,
			keys: p['highlight'],
			highlight: "#section-column-main-content"
		});
	}

	$(this).on("click", ".isSubsection", function () {
		var linkId = this.getAttribute("id");
		linkId = linkId.substring(linkId.indexOf("_") + 1)
		var linkTarget = $("#"+linkId);
		var activeLinks = [];
		if(linkTarget[0]){
			$(this).parents("li").each(function (){
				activeLinks.push($(this).children("a")[0].getAttribute("id"));
				if(!$(this).hasClass("active")){
					$(this).addClass("active");
				}
			});
			$(".navigation li.active").each(function () {
				var currentLinkId = $(this).children("a")[0].getAttribute("id");
				if(!activeLinks.includes(currentLinkId)){
					$(this).removeClass("active");
				}
			});
		}
	});

	$(this).on("click", ".collapsibleHeader", function () {
		var bockCt = $(this).closest(".collapsible")[0];
		if($(bockCt).hasClass("closed")){
			$(bockCt).removeClass("closed");
		}else{
			$(bockCt).addClass("closed");
		}
	});

	var startupHash = window.location.hash;
	if (startupHash && startupHash.indexOf("#") > -1){
		startupHash = startupHash.substring(startupHash.indexOf("#") + 1);
		var navToHash = $("#nav_" + startupHash);
		if(navToHash.length > 0){
			$(navToHash).parents("li").each(function (){
				if(!$(this).hasClass("active")){
					$(this).addClass("active");
				}
			});
		}

	}
		
	function parseQueryString(queryString) {
		var params = new Object();
		if (queryString == null)
			return params;
		if (queryString.substring(0, 1) == "?")
			queryString = queryString.substring(1);

		var paramsArr = queryString.split("&");
		for (var i = 0; i < paramsArr.length; i++)
		{
			var item = paramsArr[i];
			var pos = item.indexOf("=");
			if (pos > -1)
			{
				var arr = item.split("=");
				params[arr[0]] = decodeURIComponent(arr[1]);
			}
			else
				params[item] = "";
		}
		return params;
	};

	function setCookie(cname, cvalue, exdays) {
		var d = new Date();
		d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
		var expires = "expires="+d.toUTCString();
		document.cookie = cname + "=" + cvalue + ";path=/;" + expires + ";";
	}

	function getCookie(cName) {
		var name = cName + "=";
		var ca = document.cookie.split(';');
		for(var i = 0; i < ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0) == ' ') {
				c = c.substring(1);
			}
			if (c.indexOf(name) == 0) {
				return c.substring(name.length, c.length);
			}
		}
		return "";
	}
	
});