ALTER TABLE token
    DROP CONSTRAINT fk_activates_token_id;
ALTER TABLE token
    DROP CONSTRAINT fk_obsoletes_token_id;
DROP INDEX IF EXISTS activates_token_id_index;
DROP INDEX IF EXISTS obsoletes_token_id_idx;

ALTER TABLE token
    ALTER COLUMN token_id LONG auto_increment;
ALTER TABLE token
    ALTER COLUMN obsoletes_token_id LONG;
ALTER TABLE token
    ALTER COLUMN activates_token_id LONG;
ALTER TABLE token
    ALTER COLUMN active TINYINT DEFAULT 0 NOT NULL;
ALTER TABLE token_assignment
    ALTER COLUMN ta_token_id LONG NOT NULL;
ALTER TABLE token_assignment
    ALTER COLUMN ta_order_new TINYINT DEFAULT 0 NOT NULL;

ALTER TABLE token
    ADD CONSTRAINT fk_obsoletes_token_id FOREIGN KEY (obsoletes_token_id) REFERENCES token (token_id);
ALTER TABLE token
    ADD CONSTRAINT fk_activates_token_id FOREIGN KEY (activates_token_id) REFERENCES token (token_id);

CREATE TABLE IF NOT EXISTS oauth2_session
(
    pk BIGINT      NOT NULL AUTO_INCREMENT,
    id VARCHAR(40) NOT NULL,

    PRIMARY KEY (pk)
);
CREATE UNIQUE INDEX IF NOT EXISTS ux_oauth2_session_id
    ON oauth2_session (id);

CREATE TABLE IF NOT EXISTS oauth2_session_attribute
(
    oauth2_session_pk BIGINT       NOT NULL,
    name              VARCHAR(50)  NOT NULL,
    value             VARCHAR(200) NOT NULL,

    CONSTRAINT fk_oauth2_session_pk FOREIGN KEY (oauth2_session_pk) REFERENCES oauth2_session (pk) ON DELETE CASCADE
);
CREATE INDEX IF NOT EXISTS ix_osa_oauth2_session_pk
    ON oauth2_session_attribute (oauth2_session_pk);


CREATE TABLE IF NOT EXISTS last_selection
(
    last_selection_id INTEGER      NOT NULL AUTO_INCREMENT,
    username          VARCHAR(100) NOT NULL,
    option_id         VARCHAR(50)  NOT NULL,
    selected_at       DATETIME     NOT NULL,
    step_id           VARCHAR(50)  NOT NULL,
    tenant_id         VARCHAR(50)  NOT NULL,

    PRIMARY KEY (last_selection_id)
);
CREATE UNIQUE INDEX IF NOT EXISTS ux_last_selection
    ON last_selection (username, tenant_id, step_id);
