/*
 Migrates the Airlock IAM DB schema from version 7.4 to version 7.5.
 Written for H2 DB.
 */

CREATE TABLE airlock_2fa_activation_order
(
    id                  VARCHAR(36)  NOT NULL,
    airlock_2fa_user_pk INTEGER      NOT NULL,
    creator             VARCHAR(100) NOT NULL,
    ordered_at          BIGINT       NOT NULL
);
-- FOREIGN KEY indexes
CREATE INDEX ix_a2fa_activ_order_user_pk
    ON airlock_2fa_activation_order (airlock_2fa_user_pk);
ALTER TABLE airlock_2fa_activation_order
    ADD CONSTRAINT fk_a2fa_activ_order_user_pk FOREIGN KEY (airlock_2fa_user_pk) REFERENCES airlock_2fa_user (pk) ON DELETE CASCADE;
-- Additional indexes
CREATE UNIQUE INDEX ux_a2fa_activ_order_id
    ON airlock_2fa_activation_order (id);
