/*
 Migrates the Airlock IAM DB schema from version 7.6 to version 7.7.
 Written for H2 DB.
 */

CREATE TABLE flow_continuation_token
(
    pk                    BIGINT       NOT NULL AUTO_INCREMENT,
    token_hash            VARCHAR(86)  NOT NULL,
    user_id               VARCHAR(100) NOT NULL,
    target_flow_id        VARCHAR(30)  NOT NULL,
    created_at            BIGINT       NOT NULL,
    valid_until           BIGINT       NOT NULL,
    configuration_context VARCHAR(50)  NOT NULL,
    forward_url           VARCHAR(200),
    tenant_id             VARCHAR(50)  NOT NULL,

    CONSTRAINT pk_flow_continuation_token PRIMARY KEY (pk)
);
-- Additional indexes
CREATE UNIQUE INDEX ux_flow_continuation_token ON flow_continuation_token (token_hash);
