/*
 Migrates the Airlock IAM DB schema from version 7.4 to version 7.5.
 Written for MSSQL.
 */

CREATE TABLE airlock_2fa_activation_order
(
    id                  NVARCHAR(36) COLLATE SQL_Latin1_General_CP1_CS_AS  NOT NULL,
    airlock_2fa_user_pk INT                                                NOT NULL,
    creator             NVARCHAR(100) COLLATE SQL_Latin1_General_CP1_CS_AS NOT NULL,
    ordered_at          BIGINT                                             NOT NULL
);
-- FOREIGN KEY indexes
CREATE INDEX ix_a2fa_activ_order_user_pk
    ON airlock_2fa_activation_order (airlock_2fa_user_pk);
ALTER TABLE airlock_2fa_activation_order
    ADD CONSTRAINT fk_a2fa_activ_order_user_pk FOREIGN KEY (airlock_2fa_user_pk) REFERENCES airlock_2fa_user (pk) ON DELETE CASCADE;
-- Additional indexes
CREATE UNIQUE INDEX ux_a2fa_activ_order_id
    ON airlock_2fa_activation_order (id);
