LOCK TABLES
    token WRITE,
    token_assignment WRITE;

alter table token_assignment
    DROP FOREIGN KEY fk_ta_token_id;
alter table token
    DROP FOREIGN KEY fk_obsoletes_token_id,
    DROP FOREIGN KEY fk_activates_token_id;

alter table token
    modify token_id bigint NOT NULL AUTO_INCREMENT,
    modify active tinyint default 0 not NULL,
    modify obsoletes_token_id bigint NULL,
    modify activates_token_id bigint null;

alter table token_assignment
    modify ta_token_id bigint not NULL,
    modify ta_order_new tinyint default 0 not null;

ALTER TABLE token_assignment
    ADD CONSTRAINT fk_ta_token_id FOREIGN KEY (ta_token_id) REFERENCES token (token_id);
ALTER TABLE token
    ADD CONSTRAINT fk_obsoletes_token_id FOREIGN KEY (obsoletes_token_id) REFERENCES token (token_id),
    ADD CONSTRAINT fk_activates_token_id FOREIGN KEY (activates_token_id) REFERENCES token (token_id);

UNLOCK TABLES;

CREATE TABLE oauth2_session
(
    pk BIGINT                                 NOT NULL AUTO_INCREMENT,
    id VARCHAR(40) COLLATE utf8mb4_0900_ai_ci NOT NULL,

    PRIMARY KEY (pk)
) CHARACTER SET utf8mb4
  COLLATE utf8mb4_0900_ai_ci;
CREATE UNIQUE INDEX ux_oauth2_session_id
    ON oauth2_session (id);

CREATE TABLE oauth2_session_attribute
(
    oauth2_session_pk BIGINT                               NOT NULL,
    name              VARCHAR(50) COLLATE utf8mb4_0900_bin NOT NULL,
    value             VARCHAR(200)                         NOT NULL,

    CONSTRAINT fk_oauth2_session_pk FOREIGN KEY (oauth2_session_pk) REFERENCES oauth2_session (pk) ON DELETE CASCADE
) CHARACTER SET utf8mb4
  COLLATE utf8mb4_0900_ai_ci;
CREATE INDEX ix_osa_oauth2_session_pk
    ON oauth2_session_attribute (oauth2_session_pk);

CREATE TABLE IF NOT EXISTS last_selection
(
    last_selection_id INTEGER                              NOT NULL AUTO_INCREMENT,
    username          VARCHAR(100)                         NOT NULL,
    option_id         VARCHAR(50) COLLATE utf8mb4_0900_bin NOT NULL,
    selected_at       DATETIME                             NOT NULL,
    step_id           VARCHAR(50) COLLATE utf8mb4_0900_bin NOT NULL,
    tenant_id         VARCHAR(50) COLLATE utf8mb4_0900_bin NOT NULL,

    PRIMARY KEY (last_selection_id)
) CHARACTER SET utf8mb4
  COLLATE utf8mb4_0900_ai_ci;
CREATE UNIQUE INDEX ux_last_selection
    ON last_selection (username, tenant_id, step_id);
