var m_1579527945262Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Performance tuning and scaling best practices<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945262\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Performance tuning and scaling best practices<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N100081627993683773\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10008\">There are various aspects that influence the performance and ability to scale an <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> system depending on the precise usage scenario. This article highlights the most common bottlenecks.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Audit log<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N1000C\">In <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> audit log signing is disabled by default. The signature ensures that manipulations of log messages are detectable. The generation of log sequence numbers and digital signatures limits scaling with the number of CPU cores. Disabling audit log signing can speed up the whole system significantly. Audit log messages are still written - but not signed anymore.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To change audit log signing:<\/li><li class=\"step\">Open the instance configuration (e.g. instances\/auth\/instance.properties) in an editor.<\/li><li class=\"step\">To disable set the property \"iam.audit-log.signing.enabled\" to <code class=\"codeinline\">false<\/code>.<\/li><li class=\"step\">To enable set the property \"iam.audit-log.signing.enabled\" to <code class=\"codeinline\">true<\/code>.<\/li><li class=\"step result\">Restart the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instance to activate the changes.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N10024\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database selection<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N1001D\">The <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1595233447002.html\">Data sources (databases, directories)<\/a> section lists the supported databases.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Choose your database according to your requirements:<\/li><li class=\"enum-element\">Some of them are known to scale well with the number of users or tokens. <\/li><li class=\"enum-element\">Others, like the H2 database, are fine for smaller scenarios only.<\/li><\/ul><p class=\"par\" id=\"1579527945262_N10032\">The supported H2 database has limitations, therefore we recommend using it only for testing purposes and for small production scenarios with some hundreds of users.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Limitations of the H2 database:<\/li><li class=\"enum-element\">H2 uses only one index per logical table at a time in each query.<\/li><li class=\"enum-element\">The H2 cluster feature imposes additional limitations on performance (result sets are completely loaded into memory).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N1004C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database monitoring<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N1003F\">The chosen database, as well as the database host, have to be monitored to detect unexpected increasing system load, a high proportion of I\/O wait, or inefficient queries due to missing indexes.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N1004F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database indices<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10045\">To scale well, a database needs indices that are based on the most frequent use cases. Since <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> is highly configurable regarding database fields, the indices have to be set with the knowledge of the field configuration and usage.<\/p><p class=\"par\" id=\"1579527945262_N10047\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> defines indices and primary keys in the database schema setup scripts. The database schemas are not updated automatically when updating the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> software. Changes to the database schemas have to be performed manually.<\/p><p class=\"par\" id=\"1579527945262_N10049\">The schema files and the schema update files per database can be found here:<br\/><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1595233447002.html\">Data sources (databases, directories)<\/a><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database statistics<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N1004E\">DB systems use optimizers to tune queries on their own. The decisions of the query optimizer are base on database usage statistics. The statistics have to be up-to-date to result in the best decisions.<\/p><div xmlns=\"\" class=\"container-warning advice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_advice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945262_N10050\">We strongly recommend configuring the DB system to create new statistics regularly.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N100611627994165047\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database connection pool<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10055\">Connections from <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> to the DB are handled by connection pools.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The idea is to run only as many parallel requests in the database as it can handle at a time:<\/li><li class=\"enum-element\">Using too few DB connections will result in a bottleneck (wait events in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span>).<\/li><li class=\"enum-element\">Using too many DB connections can result in DB wait events and lower the overall performance as well.<\/li><\/ul><p class=\"par\" id=\"1579527945262_N1005F\">Each configured database connection has its own pool size. A separate connection pool is used by each module (Loginapp, Adminapp, SOAP Interface, Service Container, Transaction Approval) and connection pool configuration (e.g. pool size). The Loginapp typically needs more database connections than the Adminapp.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945262_N10061\">As a rule of thumb, the developers of the \"Hikari\" connection pool recommend limiting the number of connections to twice the number of CPU cores of the database server plus the number of disk spindles.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945262_N10063\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/brettwooldridge\/HikariCP\/wiki\/About-Pool-Sizing\" target=\"_blank\">https:\/\/github.com\/brettwooldridge\/HikariCP\/wiki\/About-Pool-Sizing<\/a> for more information about connection pool sizing.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N100A8\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Current JDBC driver<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N1007B\">Database vendors provide JDBC drivers for specific versions of their databases. JDBC drivers are not bundled with Airlock IAM and must be downloaded and deployed separately. It is essential to use the latest JDBC driver that matches the database version currently in use. Unexpected behavior including degraded performance can result from an inappropriate driver version.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N10175\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Persistency plugins<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10178\">The choice of persistency plugins has an influence on the performance:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Whenever possible favor using <span class=\"dialog\">User Store<\/span> plugins over <span class=\"dialog\">User Persister<\/span> plugins. This is especially true for the user management in the Adminapp.<\/li><li class=\"enum-element\">If combining multiple persistence systems (e.g. the IAM database and an external system via a custom plugin), minimize calls to potentially slow external systems. Typically, not all calls in all plugins need to involve external persistence systems.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N10097\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Hash algorithms<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10080\">Some hash algorithms, such as <span class=\"dialog\">scrypt<\/span> are expensive by design in order to make brute-force attacks on hash databases unfeasible, i.e. increase the security of the hashed data. On the other hand, choosing an expensive hash algorithm limits the number of requests that a system is able to process per time unit. Other hash algorithms, such as <span class=\"dialog\">sha256<\/span> are pretty fast and therefore easier to brute-force.<\/p><p class=\"par\" id=\"1579527945262_N10082\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> uses hashes for various use cases. Depending on the use case a different hash algorithm is suitable.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">We recommend:<\/li><li class=\"enum-element\">Scrypt for passwords, secret questions, and IAK letters.<\/li><li class=\"enum-element\">SHA-256 for OAuth, Open ID Connect, and matrix cards.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945262_N1008C\">See also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1627907720735.html\">Selection and parametrization of hash functions<\/a> for further information and tuning options.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N100C91627995287685\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Keep your IAM release version up to date<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945262_N10091\">New <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> versions are often bringing additional performance optimizations. We recommend checking for newer versions and updating\/upgrading on a regular basis. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N101A3\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Adjust file descriptor limits in <i class=\"italics\">systemd<\/i> service files<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945524_N1000A\">For Docker deployments, this information does not apply. Please refer to the Docker documentation or the documentation of your orchestration software (Kubernetes, OpenShift, etc.).<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945262_N101BB\">Under rare circumstances, such as during SAML performance and integration testing, a large peak number of requests can generate exception errors <code class=\"codeinline\">(Too many open files)<\/code> in the IAM log files. In this case, the currently configured limits for file descriptors have been exceeded and can be adjusted for the corresponding service.<\/p><p class=\"par\" id=\"1579527945262_N101B8\">Airlock IAM uses <code class=\"codeinline\">systemd<\/code> to start and stop IAM and IAM services, see also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945524.html\">Starting and stopping Airlock IAM (system service integration)<\/a>. Because of this,  <i class=\"italics\">file descriptor limits<\/i> for services have to be configured for <code class=\"codeinline\">systemd<\/code> and not by changing <code class=\"codeinline\">ulimit<\/code> values.<\/p><p class=\"par\" id=\"1579527945262_N101DF\">The IAM CLI allows adjusting the file descriptor limit per service using the option <code class=\"codeinline\">-l<\/code> or <code class=\"codeinline\">--limit-file-descriptors<\/code> as in the following example:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101EB\">iam systemd -i auth -l 8192<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945262_N101ED1659087433142\">This creates a <code class=\"codeinline\">systemd<\/code> service file with a file descriptor limit of 8192 for the <code class=\"codeinline\">auth<\/code> service.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N100B41627994165047\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example of Dimensioning and Scaling<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Assumed Hardware:<\/strong><\/li><li class=\"enum-element\">Server with 2 CPUs each with 8 cores at 2.5 GHz.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Assumed Configuration:<\/strong><\/li><li class=\"enum-element\">Passwords with <span class=\"dialog\">scrypt<\/span> hashes as the first factor.<\/li><li class=\"enum-element\">mTAN as the second factor.<\/li><li class=\"enum-element\">The audit log signing is switched off.<\/li><li class=\"enum-element\">The database connection pool has a size of 16 and fits well the performance of the DB server.<\/li><li class=\"enum-element\">The suggested indices are created.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Expected Performance:<\/strong><\/li><li class=\"enum-element\">50-90 entire login\/logout roundtrips per second<\/li><\/ul><p class=\"par\" id=\"1579527945262_N100C7\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> scales well with the number of CPUs and cores. However, CPU threads won\'t help, since the system is CPU-bound (<span class=\"dialog\">scrypt<\/span>). CPU threads are beneficial if a CPU core has to wait for I\/O.<\/p><p class=\"par\" id=\"1579527945262_N100C9\">For further scaling, it is possible to load-balance multiple <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> behind <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945262_N10111\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1595233447002.html\">Data sources (databases, directories)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1627907720735.html\">Selection and parametrization of hash functions<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/brettwooldridge\/HikariCP\/wiki\/About-Pool-Sizing\" target=\"_blank\">https:\/\/github.com\/brettwooldridge\/HikariCP\/wiki\/About-Pool-Sizing<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';