var m_1579527945288Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Configuration environments<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945288\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Configuration environments<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945288_N100B9\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945288_N100BA\">Configuration environments allow centralized management of the configuration of multiple similar IAM instances.\u00A0<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10012\"><strong class=\"emphasis\">Configuration environments vs. configuration variables<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10019\">Some use cases of the configuration variables feature overlap with applications of the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945288.html\">Configuration environments<\/a> feature.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The main difference between the two features are:<\/li><li class=\"enum-element\">Using the configuration environment feature, environment-specific values for all environments are stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration file <code class=\"codeinline\">medusa-configuration.xml<\/code>. The environment-specific values, therefore, need to be <strong class=\"emphasis\">known at configuration time<\/strong>.<\/li><li class=\"enum-element\">Values are assigned to configuration variables at start-up time during configuration activation and <strong class=\"emphasis\">do not have to be known at configuration time<\/strong>. Moreover, they are not stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration file <code class=\"codeinline\">medusa-configuration.xml<\/code>.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945288_N10019\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Enabling configuration environments<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945288_N1015D\">In\u00A0instance.properties\u00A0the\u00A0<span class=\"dialog\">iam.environment.id<\/span> <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945274.html\">parameter<\/a> defines the identifier of the instance\'s environment (further referred to as the\u00A0instance environment). The identifier may contain any character, but leading and trailing white space will be removed.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945288_N10178\">It is also possible to set the configuration environment ID through the \"IAM_ENVIRONMENT_ID\" process environment variable.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945288_N1017A\"><strong class=\"emphasis\">Environment ID definition in instance configuration:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1017D\">## The configuration environment identifier of this instance. (e.g. Production)\r\n## By default the configuration environments feature is disabled. Defining this property enables the configuration environment feature.\r\niam.environment.id = Production<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945288_N1017F\"><strong class=\"emphasis\">Example values:<\/strong><\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Dev1<\/li><li class=\"enum-element\">ProdHA<\/li><li class=\"enum-element\">Customer XYZ Stage Production<\/li><li class=\"enum-element\">BankAProd<\/li><\/ul><p class=\"par\" id=\"1579527945288_N1018B\">If an instance does NOT define an\u00A0environment ID\u00A0the environment feature is disabled and any configuration containing environments can not be activated.<\/p><p class=\"par\" id=\"1579527945288_N10190\">After defining the environment ID,\u00A0configurations containing environment-specific values can be deployed to the instance.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945288_N10198\">Be careful when disabling the feature (removing\/commenting out the property \u00A0<span class=\"dialog\">iam.enironment.id<\/span>). When the <span class=\"dialog\">medusa-configuration.xml<\/span> contains environments and the instance has the feature disabled the configuration can NOT be activated. Meaning the activation on start-up could fail if the feature was previously disabled.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1591893496060.html\" style=\"margin-left:0px\">9.1.1. Configuration environments in the Config Editor<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1591893496044.html\" style=\"margin-left:0px\">9.1.2. Config example scenarios and usage<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';