var m_1579527945357Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Front-side Kerberos authentication<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945357\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Front-side Kerberos authentication<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945357_N101FC\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945357_N101FD\">With front-side Kerberos, Airlock IAM authenticates users based on a Kerberos ticket. This allows the implementation of single sign-on in Windows environments for all target applications connected to Airlock IAM without the need to make them Kerberos-aware.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945357_N10207\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945357_N10208\">The following image shows the basic steps to authenticate users with Front-side Kerberos authentication against Airlock IAM:<\/p><p class=\"par\" id=\"1579527945357_N1020A\"><span class=\"media-theme-inline\" id=\"1579527945357_N1020B\"><img alt=\"Frontside Kerberos\" class=\"media-theme-img-tag-inline png\" src=\"..\/media\/03_Media\/XML-Diagrameditor\/IAM\/Frontside_Kerberos.theme\/1.1\/en-us.Frontside_Kerberos_html.png\" style=\"width:;height:675px;border:0;\"\/><\/span><\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The user requests access to the back-end application <span class=\"dialog\">Web App A<\/span> which is protected by Airlock Gateway. This web application is accessible through the virtual host <code class=\"codeinline\">a.airlock.com<\/code>. Authentication enforcement is configured on Airlock Gateway. Since the user is not yet authenticated the request is passed to Airlock IAM.<\/li><li class=\"step\">Airlock IAM receives the request from 1). Because it does not contain a Kerberos ticket, Airlock IAM asks for such a ticket by responding with <code class=\"codeinline\">HTTP 401<\/code> and the necessary header to trigger Kerberos authentication in the browser.<\/li><li class=\"step\">Now the browser requests a Kerberos service ticket for the service <code class=\"codeinline\">a.airlock.com<\/code> from the Active Directory domain controller.<\/li><li class=\"step\">The browser repeats the request from 1) and appends the Kerberos service ticket received in 3) from the Active Directory domain controller. The user is still not authenticated, so the request is passed again to Airlock IAM.<\/li><li class=\"step\">Airlock IAM receives the request which has now a Kerberos service ticket appended and verifies whether the ticket is valid or not and extracts information from it.<\/li><li class=\"step\">In case the user has sent a valid Kerberos ticket, Airlock IAM additionally validates the user through LDAPS in the Active Directory. If necessary, additional group membership checks, etc. can be performed at this point. After the user has been successfully authenticated, Airlock IAM sets the necessary Gateway roles and the information for identity propagation to the target application.<\/li><li class=\"step\">Because the user is now authenticated, the original request can now access the desired back-end application. From now on, the user\'s session is authenticated, so further requests are passed directly to the back-end application.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945357_N1004B\">Please note that this example illustrates the One-Shot authentication flow. In the case of the Redirect authentication flow, the sequence looks a bit different.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960529.html\" style=\"margin-left:0px\">10.2.12.1. Requirements<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960533.html\" style=\"margin-left:0px\">10.2.12.2. Browser configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960535.html\" style=\"margin-left:0px\">10.2.12.3. Active Directory configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960537.html\" style=\"margin-left:0px\">10.2.12.4. One-shot vs. redirect flow<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960543.html\" style=\"margin-left:0px\">10.2.12.5. Sessionless authentication<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960545.html\" style=\"margin-left:0px\">10.2.12.6. Troubleshooting Kerberos issues<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1580218960547.html\" style=\"margin-left:0px\">10.2.12.7. References<\/a><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945357_N100C2\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1580218960539.html\">Front-Side Kerberos configuration (one-shot flow) <\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1660804711176.html\">Front-Side Kerberos configuration in the Loginapp REST API<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';