var m_1579527945408Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Device tokens - REST authentication API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945408\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Device tokens - REST authentication API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945408_N100CA\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945408_N100CB\">Using the\u00A0<i class=\"italics\">Device Token<\/i> feature, a REST client (e.g. mobile app) can authenticate itself using public-key cryptography without user interaction. The feature can be used as the first or second factor.<\/p><p class=\"par\" id=\"1579527945408_N100D0\">It is thought for the following scenario:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\"><strong class=\"emphasis\">Initial authentication<\/strong>: The HTTP client authenticates using username, password, and a 2nd factor (e.g. MTAN).<\/li><li class=\"step\"><strong class=\"emphasis\">Device Token registration<\/strong>: The HTTP client generates a key pair and associates the public key with the user account.<\/li><li class=\"step\"><strong class=\"emphasis\">Following logins: <\/strong>Dependent on the configuration, HTTP clients authenticate either using the device token step as the first factor or using username, password, and device token step as the second factor.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945408_N100E5\">The device token authentication step does not require user interaction - it only requires access to the private key on the \"device\" (e.g. mobile app).<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945408_N100E7\">Multiple \"device tokens\" can be associated with the user account and device tokens can be managed in the IAM Adminapp using a <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945514.html\">generic token controller<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945408_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Device token registration<\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1579527945408_N1007D\"><img alt=\"Device token registration\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/XML-Diagrameditor\/IAM\/Device_token_registration.theme\/1.2\/en-us.Device_token_registration_html.png\" style=\"width:;height:539px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945408_N10052\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><strong class=\"emphasis\">Device token authentication as 1st factor<\/strong><\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1579527945408_N1008F\"><img alt=\"Device token authentication as 1st factor\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/XML-Diagrameditor\/IAM\/Device_token_authentication_as_1st_factor.theme\/1.1\/en-us.Device_token_authentication_as_1st_factor_html.png\" style=\"width:;height:366px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945408_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><strong class=\"emphasis\">Device token authentication as 2nd factor<\/strong><\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1579527945408_N100A1\"><img alt=\"Device token authentication as 2nd factor\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/XML-Diagrameditor\/IAM\/Device_token_authentication_as_2nd_factor.theme\/1.1\/en-us.Device_token_authentication_as_2nd_factor_html.png\" style=\"width:;height:366px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636413792.html\" style=\"margin-left:0px\">17.1.2.7.1. REST API Usage<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636413800.html\" style=\"margin-left:0px\">17.1.2.7.2. Airlock Device Token Configuration in the Loginapp REST API<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636413802.html\" style=\"margin-left:0px\">17.1.2.7.3. Sample Usage of Device Token (REST API Examples)<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';