var m_1579527945415Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Transaction approval REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945415\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Transaction approval REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945415_N10143\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945415_N10144\">The transaction approval module exposes a REST API that allows a <i class=\"italics\"><span class=\"dialog\">delegating entity<\/span><\/i> to verify transactions with the user\'s 2nd authentication factor such as Airlock 2FA.<\/p><p class=\"par\" id=\"1579527945415_N10010\">By the term <i class=\"italics\"><span class=\"dialog\">delegating entity<\/span>,<\/i> we refer to 3rd party applications such as e-banking systems.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N1014D\">The transaction approval interface\u00A0is intended to be used in the internal infrastructure. e.g. invoked from an e-banking system acting as a delegating entity on behalf of a user. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N1001A\">It is not intended to be exposed directly to the internet.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N10152\">Transaction Approval requires the separate license bundle <i class=\"italics\">TRANSACTION APPROVAL<\/i>.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945415_N10154\">The transaction approval process is organized and configured as a sequence of steps. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">A typical transaction approval flow is as follows:<\/strong><\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1656675605591.html\">Flow selection<\/a>  \u2013 Selects the corresponding flow from the available transaction approval flows.<\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1583435031020.html\">User identifying step<\/a>  \u2013 Identifies the user to IAM.<\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1583435031075.html\">Parameter step and message providers<\/a>  \u2013 Send transaction detail to IAM.<\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1583435031113.html\">Selection of authentication token and authTokenId usage<\/a> (optional) \u2013 If the user has multiple tokens, one must be selected for transaction approval.<\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1583435031206.html\">Approval steps<\/a>  \u2013 An authentication token (e.g. Airlock 2FA, mTAN, or Cronto) is used to send transaction details to the user and have them approved. The transaction details are formatted using a message provider.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N100231657785665271\">Since IAM 7.7, multiple transaction approval flows can be configured in parallel, therefore requiring a flow selection call. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N1008E\">If no flow selection call is made, the flow with ID <code class=\"codeinline\">legacy-default-flow<\/code> is automatically selected. This flow ID is given to the one flow when migrating from older IAM versions. Thus, existing delegating entities (that did not yet know about the flow selection call) will still work after migration to IAM 7.7 or later.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945415_N10094\">If relying on this, do not change the flow ID <code class=\"codeinline\">legacy-default-flow<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945415_N101A2\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Flow concepts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945415_N101A3\">The transaction approval REST API is built on the \"flow engine\". <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Refer to the general documentation about flows for further information:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1600698368517.html\">Flows as Airlock IAM concept<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1600698367533.html\">General information about Airlock IAM flows<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1579527945395.html\">Flow error handling<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref Title\" href=\"data\/1646935255035.html\">Mapping Flow steps to REST API next step codes<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1656675605591.html\" style=\"margin-left:0px\">20.1.1. Transaction approval flow selection<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031020.html\" style=\"margin-left:0px\">20.1.2. User identifying step<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031075.html\" style=\"margin-left:0px\">20.1.3. Parameter step and message providers<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031113.html\" style=\"margin-left:0px\">20.1.4. Selection of authentication token and authTokenId usage<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031206.html\" style=\"margin-left:0px\">20.1.5. Approval steps<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1579527945417.html\" style=\"margin-left:0px\">20.1.6. Message provider configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031232.html\" style=\"margin-left:0px\">20.1.7. Authentication of the delegating entity (REST client authentication)<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435037857.html\" style=\"margin-left:0px\">20.1.8. Transaction approval with Airlock 2FA<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031284.html\" style=\"margin-left:0px\">20.1.9. Transaction approval with mTAN (SMS)<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1583435031419.html\" style=\"margin-left:0px\">20.1.10. Transaction approval with Cronto Push<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';