var m_1579527945426Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Authentication of REST API calls with client certificates (X.509)<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945426\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Authentication of REST API calls with client certificates (X.509)<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945426_N1006E\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945426_N1000C\">This guide explains how to authenticate REST clients using X.509 client certificates by enforcing mutual authentication in the TLS handshake followed by extracting and validating the client certificate.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945426_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945426_N10012\">To configure client-certificate authentication, follow the instructions below.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The configuration entry points are:<\/li><li class=\"enum-element\">Loginapp REST API: <span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Session-less REST Endpoints<\/span> &gt;&gt; <span class=\"dialog\">Request Authentication<\/span><\/li><li class=\"enum-element\">Adminapp REST API: <span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">REST API Configuration<\/span> &gt;&gt; <span class=\"dialog\">Request Authentication<\/span><\/li><li class=\"enum-element\"><span class=\"dialog\">Transaction Approval<\/span> &gt;&gt; <span class=\"dialog\">Request Authentication<\/span><\/li><\/ul><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to the corresponding configuration entry point in the Config Editor (see above).<\/li><li class=\"step\">For property Request Authentication, choose the plugin <span class=\"dialog\">Client Certificate (X.509) Request Authentication<\/span><\/li><li class=\"step\">Configure the desired certificate validation settings (validity period and certificate status checks).<\/li><li class=\"step\">In property <span class=\"dialog\">User Attribute<\/span>, choose what part of the client certificates subject to use as the REST client\'s user ID. The Username Transformation property allows to transform the username if required.<\/li><li class=\"step\">If the REST API to be protected is accessed via Airlock Gateway, the <span class=\"dialog\">Airlock Gateway (WAF) Settings<\/span> of the corresponding module (Loginapp, Adminapp, Transaction Approval) must be configured. This tells IAM how to extract the client certificate from the request.<\/li><li class=\"step result\">A valid client certificate is now required to access the corresponding REST API.<\/li><li class=\"step\">To restrict access to specific client certificates, i.e., specific subjects, configure the <span class=\"dialog\">User Store<\/span> used to look up the REST client (or user) with the extracted user attribute. A REST client (or user) must be valid, unlocked and - where applicable - have the required roles.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945426_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Information on self-signed certificates: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945285.html\">Securing Airlock IAM with HTTPS<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';