var m_1579527945437Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Securing REST APIs\/service APIs<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945437\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Securing REST APIs\/service APIs<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945437_N100FB\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945437_N100FC\">This tutorial shows different ways how to protect REST APIs using the <span class=\"dialog\">Airlock Secure Access Hub<\/span>. It is especially thought for <i class=\"italics\">protecting APIs used by mobile apps<\/i>.<\/p><p class=\"par\" id=\"1579527945437_N10102\">Further information about the REST API (especially Authentication API) can be found here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945388.html\">IAM REST APIs<\/a>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">It covers the following cases:<\/strong><\/li><li class=\"enum-element\">Using the Authentication REST API (Loginapp) with cookie-based session tracking. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636416167.html\">Using gateway-generated cookies for session tracking<\/a>.<\/li><li class=\"enum-element\">Using the Authentication REST API (Loginapp) with header-based session tracking. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636416169.html\">Using header tokens for session tracking<\/a>.<\/li><li class=\"enum-element\">Using JWT bearer tokens.<\/li><li class=\"enum-element\">Using the Device Token authentication step.<\/li><li class=\"enum-element\">Persistent REST Authentication using OAuth 2 PKCE (\"Pixy\").<\/li><\/ul><p class=\"par\" id=\"1579527945437_N1011F\">The tutorial assumes the following scenario including usage of the \"one-shot\" authentication flow (see also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945348.html\">HTTP request authentication (One-Shot flow)<\/a>):<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1579527945437_N1014C\"><img alt=\"63982028.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/_c3_9cberarbeitete_Altdaten\/references\/mediaset\/PNG\/6x\/63982028.png.theme\/1.5\/en-us.63982028.png_html.png\" style=\"width:;height:462px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636407689_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416163.html\" style=\"margin-left:0px\">12.3.1. Using the flow authentication API with Airlock Gateway sessions<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1691686264422.html\" style=\"margin-left:10px\">12.3.1.1. Session tracking modes and configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416167.html\" style=\"margin-left:20px\">12.3.1.1.1. Using gateway-generated cookies for session tracking<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416169.html\" style=\"margin-left:20px\">12.3.1.1.2. Using header tokens for session tracking<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416171.html\" style=\"margin-left:0px\">12.3.2. Using the flow authentication API with JWTs and one-shot authentication<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416173.html\" style=\"margin-left:10px\">12.3.2.1. Request flow<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416175.html\" style=\"margin-left:10px\">12.3.2.2. Configuration using JWT bearer tokens<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416177.html\" style=\"margin-left:0px\">12.3.3. Using Device Tokens to authenticate mobile apps<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416179.html\" style=\"margin-left:0px\">12.3.4. Using OAuth 2 for native apps (RFC 8252)<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416183.html\" style=\"margin-left:10px\">12.3.4.1. Request flow<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416185.html\" style=\"margin-left:10px\">12.3.4.2. Configuration<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';