var m_1579527945441Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>SAML 2.0 (conceptual information)<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945441\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">SAML 2.0 (conceptual information)<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945441_N10087\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945441_N10088\">SAML (Security Assertion Markup Language) is an XML-based framework for <i class=\"italics\">cross-domain single sign-on<\/i>. SAML is an open standard defined by OASIS.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Basically, SAML defines three roles:<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Principal:<\/strong> An entity (typically a user) signing in to one or more applications.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">IDP (Identity Provider):<\/strong> The entity which authenticates the principals.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">SP (Service Provider):<\/strong> One of the applications to which the principals sign in.<\/li><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945441_N10026\">Throughout this documentation, we use the terms <i class=\"italics\">principal<\/i> and <i class=\"italics\">user<\/i> as synonyms.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">A typical scenario for a user trying to access a service on the SP:<\/li><li class=\"step\">If the principal has not yet been authenticated at the SP, it is redirected by the SP to the IDP.<\/li><li class=\"step\">The IDP authenticates the user.<\/li><li class=\"step\">The IDP issues a <i class=\"italics\">SAML assertion<\/i> for the principal.\u00A0<\/li><li class=\"step\">The SAML assertion is validated in the SP and access to the service is granted.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945441_N100B3\">A SAML assertion issued by the IDP can only be used to access a specific SP.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945441_N100B9\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">SAML support in Airlock IAM<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945441_N100BA\">Airlock IAM supports SAML 2.0 and can be for both IDP and SP. It is possible to configure a single instance of Airlock IAM with one IDP and multiple SPs simultaneously.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">IAM supports the following SAML features:<\/li><li class=\"enum-element\">IDP and SP<\/li><li class=\"enum-element\">Web browser SSO (single sign-on)<\/li><li class=\"enum-element\">IDP-initiated SSO<\/li><li class=\"enum-element\">SP-initiated SSO<\/li><li class=\"enum-element\">Single logout<\/li><li class=\"enum-element\">POST binding<\/li><li class=\"enum-element\">HTTP artifact binding<\/li><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945441_N100C4\">Configuration Contexts should not be used in SAML plugins, both for the IDP and SP.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945441_N100C6\">The underlying SAML library does not support configuration depending on contexts. Therefore, the separation of SAML entities via contexts might not work as expected.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1642782501334.html\" style=\"margin-left:0px\">14.1. SAML terms and definitions<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416189.html\" style=\"margin-left:0px\">14.2. SAML web browser SSO with POST binding<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416191.html\" style=\"margin-left:0px\">14.3. SAML web browser SSO with HTTP artifact binding<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594636416193.html\" style=\"margin-left:0px\">14.4. SAML Single logout (SLO)<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1627571813093.html\" style=\"margin-left:0px\">14.5. How to set up a proxy for SAML artifact binding<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1579527945456.html\" style=\"margin-left:0px\">14.6. Troubleshooting SAML<\/a><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945441_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">IDP configuration: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642782502780.html\">SAML IDP setup with the Loginapp REST API<\/a><\/li><li class=\"enum-element\">SP configuration: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659429980997.html\">SAML SP setup with the Loginapp REST API<\/a><\/li><li class=\"enum-element\">Specifications overview: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.oasis-open.org\/security\/saml\/Post2.0\/sstc-saml-tech-overview-2.0.html\" target=\"_blank\">https:\/\/docs.oasis-open.org\/security\/saml\/Post2.0\/sstc-saml-tech-overview-2.0.html<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';