var m_1579527945446Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Set up multiple SAML IDPs with load balancing<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945446\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Set up multiple SAML IDPs with load balancing<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945446_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945446_N10007\">When using artifact resolution, the SPs exchange the artifact for a SAML assertion by directly connecting to the IDP (not via the user\'s browser). <\/p><p class=\"par\" id=\"1579527945446_N1000F1711437315194\">In deployments with more than one active IAM instance (<i class=\"italics\">active-active setups<\/i>), the instance handling the artifact resolution request must be able to access the information required to issue the SAML assertion. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two ways to achieve this:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917388944.html\">Storing session state in an external Redis session repository<\/a>. This is the preferred way. This article is not about this way.<\/li><li class=\"enum-element\">Let IAM internally forward requests to the instance holding the information for creating the SAML assertion. This setup is described in this article.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N10029\">This article is not about the recommended setup. It describes a way to handle artifact resolution for active-active setups without storing the session state in Redis.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N1002B\">Due to its complexity, the setup described here should only be used if storing the session state in a Redis cluster is not an option.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945446_N1002D\">The SAML IDP implementation supports load-balanced IAM instances by annotating every SAML artifact with an ID identifying the source IDP so that SPs can fetch the Assertion from the correct IDP.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945446_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The IDPs must be able to directly access each other to cater to misguided artifact resolution requests.<\/li><li class=\"step\">The IDPs must be directly reachable from the SP.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N1001E\">The load balancing itself is not done by <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> but by an upfront load balancer, typically <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945446_N10028\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration Step 1 - Airlock IAM\u00A0configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945446_N10049\">Every server must use its own <i class=\"italics\">internal<\/i> protocol, hostname, port, and context path in the loginapp\'s IDP configuration (i.e., the values required so that every IDP can access the other IDP(s) directly).<\/p><p class=\"par\" id=\"1579527945446_N10038\">We use the following example values:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1579527945446_N1003B\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945446_N10054\">First IDP<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N100591645434563526\">Second IDP<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N1005F\">Protocol<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945446_N10064\">https<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N10069\">https<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N1006F\">Hostname<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945446_N10074\">host1<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N100791645434563526\">host2<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-header table-header-vertical table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N1007F\">Port<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945446_N10084\">8080<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N10089\">9090<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-header table-header-vertical table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N1008F1645434563526\">Context path<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945446_N100941645434563526\">\/auth<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945446_N10099\">\/auth<\/p><\/div><\/td><\/tr><\/tbody><\/table><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Goto to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML<\/span> &gt;&gt; <span class=\"dialog\">SAML 2.0 Identity Provider<\/span><\/li><li class=\"step\">In the <span class=\"dialog\">Load-Balancing<\/span> property group, fill in the properties <span class=\"dialog\">Protocol<\/span>, <span class=\"dialog\">Host<\/span>, <span class=\"dialog\">Port<\/span>, and <span class=\"dialog\">Context Path<\/span> of the IDP instance being configured. Again, note that the combination of these properties must allow other IDP instances to access this very IDP instance.<\/li><li class=\"step\">In the <span class=\"dialog\">Server List<\/span> property, provide the connection details of all IDPs (the one being configured and all other IDP instances). <br\/>Example value: <br\/><code class=\"codeinline\">https:\/\/host1.example.com:8080\/auth<br\/>\u00A0<\/code><code class=\"codeinline\">https:\/\/host2.example.com:9090\/auth<\/code><\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N10092\">It is crucial to configure the <span class=\"dialog\">Server List<\/span> property identically in all IDP instances.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N10129\">This is because it is used to define the internal ID encoded in the <code class=\"codeinline\">MessageHandle<\/code> of an Artifact which is relevant in internal processing.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945446_N100921596548088218\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration Step 2 - SAML metadata files<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945446_N1009A\">In each IDP metadata file, the URLs of the <span class=\"dialog\">Server List<\/span> property are used according to the following two rules:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Each IDP gets assigned an index (starting at 0 without gaps) according to the <span class=\"dialog\">Server List<\/span> property. The assigned indices are the same for all IDPs\' metadata files.<\/li><li class=\"enum-element\">Each IDP puts its own URL for the <code class=\"codeinline\">ArtifactResolutionService<\/code> at the top of the list.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N10157\">When putting the IDP\'s own URL to the top of the list, make sure to move the whole <code class=\"codeinline\">ArtifactResoluationService<\/code> XML tag and do not only change the index.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945446_N100CF\"><strong class=\"emphasis\">Example for the first IDP (Index 0):<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100A8\">&lt;ArtifactResolutionService index=\"0\"\r\n\tBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:SOAP\"\r\n\tLocation=\"https:\/\/host1.example.com:8080\/auth\/ArtifactResolver\/metaAlias\/iamIdp\" \/&gt;\r\n&lt;ArtifactResolutionService index=\"1\"\r\n\tBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:SOAP\"\r\n\tLocation=\"https:\/\/host2.example.com:9090\/auth\/ArtifactResolver\/metaAlias\/iamIdp\" \/&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945446_N100AA\"><strong class=\"emphasis\">Example for the second IDP (Index 1)<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AE\">&lt;ArtifactResolutionService index=\"1\"\r\n\tBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:SOAP\"\r\n\tLocation=\"https:\/\/host2.example.com:9090\/auth\/ArtifactResolver\/metaAlias\/iamIdp\" \/&gt;\r\n&lt;ArtifactResolutionService index=\"0\"\r\n\tBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:SOAP\"\r\n\tLocation=\"https:\/\/host1.example.com:8080\/auth\/ArtifactResolver\/metaAlias\/iamIdp\" \/&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945446_N100B0\">Note that it makes no difference which <code class=\"codeinline\">idp.xml<\/code> is passed on to the SP. Only if the SP does not support this scenario, it would always take the first entry listed by default.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945446_N10167\">After changing the metadata XML files, the IAM instance must be restarted.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945446_N1018C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Internal links<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917388944.html\">Alternative and recommended setup using Redis<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';