var m_1579527945473Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>OAuth 2.0 scopes  and claims<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945473\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">OAuth 2.0 scopes  and claims<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1000B\">The purpose of OAuth 2.0 scopes is to limit the authorization granted by the user to a client.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">With <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Airlock IAM as AS<\/a>, this can be implemented as follows:<\/strong><\/li><li class=\"step\">The client requests a set of scopes when starting an OAuth flow.<\/li><li class=\"step\">The AS applies a scope policy. Depending on the scope policy configuration, the policy is used to validate the clients\' request scopes.<\/li><li class=\"step\">The AS filter removes non-allowed scopes from the client\'s request. <\/li><li class=\"step\">The AS presents the filtered scopes to the user during authentication.<\/li><li class=\"step\">The user decides which scopes to grant through local or remote consent.<\/li><li class=\"step\">Claims are added to the resulting tokens by the AS scope processor based on the granted scopes.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N10027\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scope policies<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1002A\">The Airlock IAM  <span class=\"dialog\">Scope Policy<\/span> property allows configuring the scope handling <i class=\"italics\">per client<\/i> (for static and persisted clients). Scope policies can <i class=\"italics\">remove non-allowed scopes<\/i> or replace scopes with default scopes. The effect of scope policies on the client\'s scopes depends on the client type (static or persisted) and configuration, i.e., the list of <span class=\"dialog\">Allowed\/Default Scopes<\/span> and whether <span class=\"dialog\">Filter Requested Scopes<\/span> is enabled or disabled. The property <span class=\"dialog\">Allow Issuing Tokens With No Scope<\/span> can be enabled to allow issuing tokens even when applying the scope policy results in an empty scope (by default, the request fails in this case).<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1639690251641_N1001D\">The scope policy defines how the requested scopes are validated and processed before they are used for scope consent or filtering.    Notice that the mandatory <code class=\"codeinline\">openid<\/code> scope requested by the client merely acts as a marker and is ignored when applying the policy, i.e., when requesting only the <code class=\"codeinline\">openid<\/code> scope, the scope policy treats this as a request without scopes.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are 4 scope policies available:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Scopes Mandatory<\/i> \u2013  here, the request must contain at least one scope in addition to the scope <code class=\"codeinline\">openid<\/code>. Otherwise, the request is denied. <\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Allowed<\/i> \u2013  it is optional for the client to request scopes other than <code class=\"codeinline\">openid<\/code>.<\/li><li class=\"enum-element\"><i class=\"italics\">Always Overwrite Scopes<\/i> \u2013 the scopes requested by the client are ignored and replaced by the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list. If the client has no default scopes, this is treated as if the client has not requested any scopes.<\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Overwritten<\/i> \u2013 when the client does not request any scopes other than <code class=\"codeinline\">openid<\/code>, the request is treated as if the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list were requested.<\/li><p class=\"par\" id=\"1639690251641_N10050\">See the IAM plugin documentation for full details of the scope policy configuration.<\/p><\/ul><p class=\"par\" id=\"1639690251641_N100321689601916556\"><strong class=\"emphasis\">The scope policies can be configured separately for each grant\/flow type:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1639690251641_N1002F1689576244839\"><col style=\"width:25%;\"\/><col style=\"width:50%;\"\/><col style=\"width:25%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100ED\">Grant type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100E7\">Where to configure<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10046\">Scope handling<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1004C1689576244839\">OAuth 2.0 Authorization Code Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100FC\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Authorization Code Grant<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span> (section Advanced Settings)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\" rowspan=\"3\" valign=\"middle\"><div><p class=\"par\" id=\"1639690251641_N100521689576244839\">The selected policy is applied to the requested scopes before the scope filtering and the consent step for all grant types.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10058\">OAuth 2.0 Client Credentials Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1011B\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Client Credentials Grant<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1005E1689576244839\">OIDC Authorization Code \/ Hybrid Flow<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10130\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OIDC Authorization Code \/ Hybrid Flow<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span> (section Advanced Settings)<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10159\">OAuth 2.0 Token Exchange Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10146\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Token Exchange Grant<\/span> &gt;&gt; <span class=\"dialog\">Token Exchange Rules<\/span> &gt;&gt; <span class=\"dialog\">Scope Claim<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100691689576244839\">The selected scope policy is applied to the output of the IAM scope processor.<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1579527945473_N1012A\">For configuration examples, see article <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690251641.html\">Scope configuration in IAM flows<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N1004C1640851417965\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scope translator<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1004F\">Scopes are presented to the user when granting consent is required. Airlock IAM allows for multi-language, user-friendly explanations of access rights using a scope translator.<\/p><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To support human-readable scopes, two translation mechanisms are provided:<\/strong><\/li><li class=\"enum-element\">Server-side translation, where the translations are configured on the server.<\/li><li class=\"enum-element\">Client-side translations where the client will provide the translations. If the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> is used, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> can manage the client-side translations.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The Loginapp UI displays scopes based on the following rule: <\/strong><\/li><li class=\"step\">Use server-side translated scope (configuration) if present.<\/li><li class=\"step\">Use client-side translated scope if present.<\/li><li class=\"step\">Use technical scope name.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945473_N10065\">If scopes change often, server-side translation is preferable because deploying new translations on clients tends to be more costly. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N10020\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scope filtering<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Airlock IAM supports several mechanisms to filter scopes:<\/li><li class=\"step\">Dynamically registered clients may only request scopes they were registered for. A configuration option defines whether registering clients without scopes means <i class=\"italics\">allow all scopes<\/i> or <i class=\"italics\">allow no scopes<\/i>.<\/li><li class=\"step\">The client (static or dynamic) may request any scope if no scopes have been registered.<\/li><li class=\"step\">Scopes requested by the client are filtered against<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">roles from various sources (user persister, SSO token, etc.).<\/li><li class=\"enum-element\">flow properties of the current authentication flow.<\/li><li class=\"enum-element\">scopes may also be altered by <span class=\"dialog\">Granted Scope Processors<\/span> (e.g. to meet STET PSD2 requirements) before being presented to the user.<\/li><\/ul><li class=\"step\">After the user has granted scopes, scopes may again be filtered by the AS. <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N1019B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom and conditional custom claims<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N101A0\">With the <span class=\"dialog\">Custom Claims<\/span> property, custom claims can be added to every token or JSON response after processing scope policies and scope filtering. In addition, a <span class=\"dialog\">Claim Condition<\/span> can be set in order to add custom claims <i class=\"italics\">conditionally<\/i>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The available claim conditions are:<\/strong> <\/li><li class=\"enum-element\"><i class=\"italics\"> Required Scopes Claim Condition<\/i> \u2013 this is fulfilled when the configured required claims have been granted.<\/li><li class=\"enum-element\"><i class=\"italics\">And Claim Condition<\/i>, <i class=\"italics\">Not Claim Condition<\/i>, <i class=\"italics\">Or Claim Condition<\/i> \u2013 these conditions allow logical combinations of claims. The condition is fulfilled when the logic requirements match the granted scopes\/token\'s claims.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following plugin types offer the conditional claim property:<\/strong> <\/li><li class=\"enum-element\">Custom ID token claims, i.e. <i class=\"italics\">Custom Claims<\/i> for the <code class=\"codeinline\">OpenIDConnectClaimsConfiguration<\/code> plugin.  <\/li><li class=\"enum-element\">Standard OIDC claims, i.e. <i class=\"italics\">Standard Claims<\/i> for the <code class=\"codeinline\">OpenIDConnectUserInfoEndpointConfig<\/code> plugin.<\/li><li class=\"enum-element\">Custom JWT claims, i.e. <i class=\"italics\">Custom Claims<\/i> for the <code class=\"codeinline\">JwtAccessTokenFormatConfig<\/code> and <code class=\"codeinline\">OpenIDConnectUserInfoEndpointConfig<\/code> plugins.<\/li><li class=\"enum-element\">OAuth 2.0 Resource Providers, i.e. <i class=\"italics\">Resource Providers<\/i> in the <code class=\"codeinline\">OAuth2ResourceConfig<\/code> plugin.    <\/li><li class=\"enum-element\">OAuth 2.0 Token Exchange <i class=\"italics\">Custom Claims<\/i>, i.e. <code class=\"codeinline\">OAuth2TokenExchangeJwtCustomClaimConfig<\/code> plugin.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N10049\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">Configuration article <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690251641.html\">Scope configuration in IAM flows<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945458.html\">Supported OAuth\/OIDC Features<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';