var m_1579527945498Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>HTTP request signature verification for STET<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945498\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">HTTP request signature verification for STET<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945498_N1006E\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945498_N1006F\">This document describes how to use the plugin <span class=\"dialog\"><\/span> (within the Loginapp\'s one-shot feature\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945348.html\">HTTP request authentication (One-Shot flow)<\/a>) in order to provide STET compliant HTTP signature verification.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945498_N10081\">The described plugin provides the ability to check HTTP signatures according to the internet draft <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/datatracker.ietf.org\/doc\/draft-cavage-http-signatures\/\" target=\"_blank\">Signing HTTP Messages<\/a> as required in STET.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945498_N10096\">This documentation gives examples and lists the HTTP headers that need to be verified as specified in the STET v1.4.1.3 specification.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945498_N10098\">The documentation may be used as an example but does not guarantee that the legal PSD2 requirements are met. Please ensure the correct configuration by examining the latest PSD2 specifications.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945498_N1009E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Plugin features<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945498_N100A2\"><strong class=\"emphasis\">Two certificates of the TPP are involved in STET:<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">signing certificate<\/i> used to sign HTTP requests<\/li><li class=\"enum-element\">The <i class=\"italics\">client certificate<\/i> used in the SSL\/TLS handshake (also called \"mutual TLS\").<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945498_N100B0\">The plugin <span class=\"dialog\">HTTP Signature Verification Credential Extractor<\/span> provides the following features:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Extract the original HTTP request (using\u00A0Airlock environment cookies).<\/li><li class=\"enum-element\">Check HTTP request signature:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Verify the signature itself: the set of headers that must be signed can be defined by the IAM configuration<\/li><li class=\"enum-element\">Verify the signature was created with a <i class=\"italics\">signing certificate<\/i> issued by a trusted issuer<\/li><li class=\"enum-element\">Check CRLs and OCSPs to verify the validity of the TPPs signing certificate<\/li><\/ul><li class=\"enum-element\">Extract the\u00A0<i class=\"italics\">client certificate<\/i>\u00A0and <i class=\"italics\">OAuth Access Token<\/i>\u00A0for later authentication of the TPP<\/li><li class=\"enum-element\">Verify that the\u00A0<i class=\"italics\">signing certificate<\/i> and the\u00A0<i class=\"italics\">client certificate<\/i>\u00A0have been issued for the same TPP.<\/li><li class=\"enum-element\">Every step may fail and result in the bank API request being blocked.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636407689_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594920813017.html\" style=\"margin-left:0px\">12.6.3.4.1. Configuration<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594920813019.html\" style=\"margin-left:10px\">12.6.3.4.1.1. Defining the signature scope<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1594920813021.html\" style=\"margin-left:10px\">12.6.3.4.1.2. Other config properties<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';