var m_1579527945510Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Content Security Policy for the Loginapp UI<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945510\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Content Security Policy for the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945510_N10119\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945510_N1011A\">A Content Security Policy (CSP)\u00A0[1] allows the prevention of certain XSS, clickjacking, and other code injection attacks. This is achieved by only allowing approved content (such as scripts, styles, frames, fonts, images, etc.) to execute in the browser.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945510_N10122\">It is recommended to enable the Airlock IAM Content Security Policy. As a <span class=\"dialog\">defense in depth<\/span> mechanism, it allows for reducing risks of XSS, clickjacking, and other code injection attacks.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945510_N10124\">The policy is defined by the server in the <span class=\"dialog\">Content-Security-Policy<\/span> header and enforced by the browser. Note that the browser support for CSP varies a lot, and especially older browsers do not support the most recent CSP version or have no CSP support at all, see [4]. To deal with this situation, the CSP provided by <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> contains potentially redundant policies for multiple versions of the CSP specification.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945510_N1003A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">What does the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> CSP do?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945510_N1004B\">Once the CSP feature is activated for the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span>, IAM adds a CSP HTTP header whenever the application page is sent to the browser.<\/p><p class=\"par\" id=\"1579527945510_N1006C\">Consider the following example:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10157\">default-src \'self\'; object-src \'none\'; script-src \'nonce-jf-sdL_tbhJREn-z4qouE8c0abnhZfak9pcURfyj-wA\' \'strict-dynamic\' \'self\'; img-src \'self\' data:; base-uri \'self\'; frame-ancestors \'none\';<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945510_N1015E\">A nonce is added both in the header (see above) and in all HTML <code class=\"codeinline\">&lt;script&gt;<\/code> tags:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10163\">&lt;script nonce=\"milXqzvec4bEkKJi5z35imBH9A043R1jKzWoVM5DsT4\"&gt; (...) &lt;\/script&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945510_N10083\">The purpose of the nonce is to allow the browser to block attacker-injected JavaScript code.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Nonces are handled as follows by browsers supporting CSP version 2 and 3:<\/li><li class=\"enum-element\">The browser verifies that the nonce value in the header and those in the script tags are identical. This ensures that the server provided both header and all script tags.<\/li><li class=\"enum-element\">The server will generate new nonce values for each request. This renders script injection difficult since it is hard for an attacker to predict the nonce.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945510_N1008F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">What does the Airlock IAM CSP achieve? <\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945510_N10172\">The policy contains several <i class=\"italics\">directives<\/i>, such as:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10177\">script-src \'nonce-milXqzvec4bEkKJi5z35imBH9A043R1jKzWoVM5DsT4=\' \'strict-dynamic\' \'unsafe-inline\' \'self\';<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1579527945510_N10179\">The directives are used to define approved content. Browsers supporting CSP will read the directives and only allow content that is explicitly approved by the policy. For example, modern browsers with CSP 3 support interpret the above directive ensuring that every HTML script tag must contain a \'nonce\' attribute with a matching nonce. (This is a slight simplification, as <span class=\"dialog\">strict-dynamic<\/span> allows scripts to load dependencies [2].) This is an XSS protection: an attacker script inserted through an XSS vulnerability will not be executed under the assumption that the attacker is unable to guess the nonce or modify the CSP header.<\/p><p class=\"par\" id=\"1579527945510_N1017B\">Discussing the guarantees of the IAM CSP in full detail is beyond the scope of this document. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For detailed information we refer to the following resources:<\/li><li class=\"enum-element\">IAM implements a\u00A0<i class=\"italics\">strict CSP, <\/i>a best practice proposed by Google. For a detailed discussion, please refer to [3]. Strict CSP aims at:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Providing a good level of security for all CSP versions (see below).<\/li><li class=\"enum-element\">Creating policies that are maintainable: historically, policies tended to be long and complicated.<\/li><\/ul><li class=\"enum-element\">Browser support for CSP varies a lot [4]. CSP exists in versions 1, 2, and 3. Users may use browsers that do not support CSP at all (such as Internet Explorer), or old versions of e.g. Firefox that do not support CSP in the most recent version 3. A useful tool for analyzing how a given CSP is interpreted in the three CSP versions can be found in [5].<\/li><li class=\"enum-element\">Details on the policies of CSP version 3 can be found in [1].<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945510_N100CF\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945510_N100D2\">To configure the CSP for the Loginapp, go to: <\/p><p class=\"par\" id=\"1579527945510_N100BF\"><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Loginapp UI Content Security Policy (CSP)<\/span><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945510_N10213\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.w3.org\/TR\/CSP3\/\" target=\"_blank\">https:\/\/www.w3.org\/TR\/CSP3\/<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.w3.org\/TR\/CSP3\/#strict-dynamic-usage\" target=\"_blank\">https:\/\/www.w3.org\/TR\/CSP3\/#strict-dynamic-usage<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/csp.withgoogle.com\/docs\/strict-csp.html\" target=\"_blank\">https:\/\/csp.withgoogle.com\/docs\/strict-csp.html<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/HTTP\/CSP#Browser_compatibility\" target=\"_blank\">https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/HTTP\/CSP#Browser_compatibility<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/csp-evaluator.withgoogle.com\/\" target=\"_blank\">https:\/\/csp-evaluator.withgoogle.com\/<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';