var m_1579527945517Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Generic token REST endpoint<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945517\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Generic token REST endpoint<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N100E7\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N100E8\">The Adminapp REST API offers an interface to manage arbitrary tokens, i.e. tokens for authentication methods that are not integrated into the product.<\/p><p class=\"par\" id=\"1579527945517_N1010C\">The API supports a variety of use cases such as the creation, update, enabling, disabling, and deletion of tokens,\u00A0as well as the management of activation letters.<\/p><p class=\"par\" id=\"1579527945517_N1010F\">The API is protected by role-based access control just like the rest of the Adminapp features.<\/p><p class=\"par\" id=\"1579527945517_N100EE\">Although the generic token controller solution has been designed with authentication token management in mind, it may be used to manage any data connected to a user (e.g. display app\/device information).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N100161669385041454\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">REST API<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N10019\">The REST API of the generic token endpoint is documented here in: <a href="adminapp-rest/index.html" target="_blank">Adminapp REST API Reference</a><\/p><p class=\"par\" id=\"1579527945517_N1001B\">The generic token endpoints are: <code class=\"codeinline\">\/rest\/users\/userId\/tokens\/generic\/<\/code> followed by the <span class=\"dialog\">ID<\/span> configured in the <span class=\"dialog\">Generic Token Controller<\/span> plugin.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">General Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N1000C\">To configure the token endpoint of a <span class=\"dialog\">Generic Token Controller<\/span>:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> &gt;&gt; <span class=\"dialog\">Authentication Tokens (Credentials)<\/span><\/li><li class=\"step\">Choose an existing <span class=\"dialog\">Generic Token Controller<\/span> or create a new one and in it, choose an <span class=\"dialog\">ID<\/span>. The ID is used in the REST endpoints, as authentication method identifier, and in the translation keys for text elements (in case a UI is configured).<\/li><li class=\"step\">In property <span class=\"dialog\">Token Endpoint<\/span>, add a <span class=\"dialog\">Generic Token Endpoint<\/span> plugin. It controls the behavior of the REST interface. In particular, it defines which repository (persistency) is to be used and which internal token attributes should be available in the REST API.<\/li><li class=\"step\">A UI for the REST API may be configured later: see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421874953.html\">Generic Token Controller UI configuration<\/a>.<\/li><li class=\"step\">Open the <span class=\"dialog\">Token Endpoint<\/span> configuration and configure a <span class=\"dialog\">Token Repository<\/span> as described below.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N10048\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Token Repository configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N10050\">The token repository defines how token information is obtained from either the IAM database or from 3rd party systems. It also defines how token attributes are mapped to the REST API.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are three types of token repositories:<\/li><li class=\"enum-element\">The <span class=\"dialog\">Token Based Generic Token Repository<\/span> plugin: the default implementation based on the <i class=\"italics\">token data model<\/i> strong token information in the IAM database. Whenever possible, use this repository.<\/li><li class=\"enum-element\">The <span class=\"dialog\">Credential Based Generic Token Repository<\/span> plugin: an implementation based on the <i class=\"italics\">credential data model<\/i> storing token information in the IAM database. Use this only if token data is stored directly in the user profile and if there is only one token per user.<\/li><li class=\"enum-element\">Custom token repository plugins: use this to connect to 3rd party services. <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N1006D1669386303580\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Attribute mapping<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Within the plugins <span class=\"dialog\">Token Based Generic Token Repository<\/span> and <span class=\"dialog\">Credential Based Generic Token Repository<\/span>, the property <span class=\"dialog\">Token Attribute Mapping<\/span> defines:<\/li><li class=\"enum-element\">Set of token attributes available in the REST API.<\/li><li class=\"enum-element\">Names of the attributes in the REST API.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N10030\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Attribute mapping for the  <span class=\"dialog\">Token Based Generic Token Repository<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N10116\">The following attributes are supported in the token-based token repository implementation.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1579527945517_N10118\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10128\">Attribute<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1012B\">Data Type<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1012F\">Token ID<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10132\">String<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10136\">Serial ID<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10139\">String<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1013D\">Enabled<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10140\">Boolean<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10144\">Activation Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10147\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1014B\">Valid From<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1014E\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10152\">Valid To<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10155\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10159\">Generation Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1015C\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10160\">First Usage Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10163\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10167\">Latest Usage Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1016A\">Date<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1016E\">Total Usages<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10171\">Integer<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10175\">Tracking ID<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10178\">String<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1017C\">Data<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1017F\">String<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10183\">Generic Data Element 1 - 12<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N10186\">String<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N101311596693896326\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Attribute mapping for the <span class=\"dialog\">Credential Based Generic Token Repository<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N10196\">The credential-based repository supports a limited set of attributes. At most two credentials (tokens) exist per user. Normally, a\u00A0<code class=\"codeinline\">current<\/code>\u00A0and a\u00A0<code class=\"codeinline\">next<\/code>\u00A0credential. The first can be accessed by Token ID &lt;username&gt;<code class=\"codeinline\">-current<\/code>, the latter by &lt;username&gt;<code class=\"codeinline\">-next<\/code>.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1579527945517_N101A4\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101B8\">Attribute<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101BB\">Data Type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101BE\">Remark<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101C2\">Data<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101C5\">String<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101C8\">The data is stored either as a String or in binary form on the database.<\/p><p class=\"par\" id=\"1579527945517_N101CA\">Binary data is represented as a Base64 String when read from the system.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101CE\">Data Encoding<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101D1\">String<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101D4\">Value is either \'STRING\' or \'BINARY\' (see above)<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101D8\">Delivery Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101DB\">Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101E0\">Generation Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101E3\">Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101E8\">Serial Number<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101EB\">String<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101F0\">Not Active Before<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101F3\">Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N101F8\">Not Active After<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N101FB\">Date<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N10275\">Context Data Fields<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1579527945517_N1027A\">Map<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1579527945517_N1027F\">Maps user context data fields to REST attributes. Context data fields are available in <code class=\"codeinline\">data.attributes.contextData.<\/code> within the REST responses.<\/p><p class=\"par\" id=\"1579527945517_N1028B\">Example:<\/p><pre class=\"code\" id=\"N1028E\">\"attributes\": {\r\n\t\"someAttribute\": \"someValue\",\r\n\t\"contextData\": {\r\n\t\t\"contextDataName\": \"contextDataValue\"\r\n\t}\r\n}<\/pre><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945517_N1020C\">The credential model should not be used for new token implementations. Please use the token-based model with a token-based repository.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945517_N102A5\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom token repository plugins<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945517_N102A8\">To provide your own repository implementation (e.g. connect to a 3rd party system), implement a custom plugin for interface <code class=\"codeinline\">com.airlock.iam.admin.api.application.configuration.token.generic.GenericTokenRepositoryConfig<\/code> (configuration) and <code class=\"codeinline\">com.airlock.iam.admin.api.domain.model.token.generic.GenericTokenRepository<\/code> (logic).<\/p><p class=\"par\" id=\"1642098242727_N10006\">  You can request the latest version of the <i class=\"italics\">IAM Custom Development Guide<\/i> by opening a support ticket. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/techzone.ergon.ch\/support-process\" target=\"_blank\">(ergon.ch) Techzone - Airlock support process<\/a>) for more information.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';