var m_1579527945525Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Sandboxing with profiles<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945525\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Sandboxing with profiles<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945525_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945525_N10007\">Sandboxing is the process by which components of Airlock IAM can be separated from other components or resources. With profiles, sandboxing can be applied to\/between web application modules such as Loginapp and Adminapp.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945525_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Why use sandboxing?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945525_N1000E\">Depending on your set-up and configuration, it may be the case that Loginapp\u00A0cannot access some information managed by Adminapp. From a security perspective it makes sense to separate the more exposed components from the internal privileged components. This separation can occur on different levels.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">By default, the web applications are separated by means of class-loader isolation. This is typical for Java web application servers, such as the Tomcat server used in Airlock IAM.<\/li><li class=\"step\">The \"profiles\" feature of Airlock IAM allows different sets of web applications to run in separate processes.<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Processes\u00A0benefit from operating-system-provided security features such as memory protection.<\/li><li class=\"step\">You may use separate sensitive value stores with IAM, thereby keeping secrets isolated from more exposed applications.<\/li><\/ol><li class=\"step\">When using separate Docker containers or virtual machines to run each process, the additional separation strengthens the protection further.<\/li><li class=\"step\">One more possible step is to not share the configuration directory at all. Note that this virtually results in Adminapp and Loginapp\u00A0being in separate instances. Since the applications don\'t know about each other, some features\u00A0may no longer work, including but not limited to activation of other applications from the Config Editor and the log viewer.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945525_N10023\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Default behavior without profiles<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945525_N10024\">When no profile is specified, all modules enabled in\u00A0<code class=\"codeinline\">instance.properties<\/code>\u00A0are launched in the same process. This is described as Level 1 in the description above.<\/p><p class=\"par\" id=\"1579527945525_N10029\">Which modules are enabled is defined by the\u00A0<code class=\"codeinline\">iam.modules<\/code>\u00A0property in the\u00A0<code class=\"codeinline\">instance.properties<\/code> configuration file. See:\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945274.html\">Application parameters<\/a><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945525_N1004D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816675.html\">Using profiles<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';