var m_1580218960640Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Stealth mode for user self-registration flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1580218960640\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Stealth mode for user self-registration flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1580218960640_N10658\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1580218960640_N10659\">Stealth Mode changes the behaviour of the IAM system to support\u00A0enumeration prevention for channel verifiable data attributes (e.g. email address, mobile phone number) during a stealth-protected\u00A0operation.\u00A0To achieve this goal during self-registration, the system will continue processing requests as if the self-registration process had not generated conflicts with an existing account so as to not leak information to the attacker.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1580218960640_N10010\">Stealth Mode can be enabled in the \'User Self-Registration Flow\' Advanced Settings for each flow individually. <\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649929046362_N10069\">The Send Email Link Step cannot be used in conjunction with the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1580218960640.html\">Stealth Mode<\/a>.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649929046362_N1007E\">The stealth mode in user self-registration flows is based on the fact that the channel verification step is <i class=\"italics\">interactive<\/i> and that the user cannot get past it if stealth mode is in action. Since the Send Email Link Step is non-interactive, it does not support the stealth mode.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1580218960640_N1065B\"><strong class=\"emphasis\">To take advantage of Stealth Mode, the following requirements must be met:<\/strong><\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The attribute to be protected must be the first\u00A0channel verification target. Meaning the system must be able verify that the registering user is really in possession of this communication channel.\u00A0<\/li><li class=\"enum-element\">The attribute to be protected must be unique. E.g. if stealth mode is used with email, no two accounts may have the same email configured.<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1580218960640_N10027\">If uniqueness is not required then enumeration is not possible and there is no need for stealth mode protection.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">It is recommended to put channel verification as early as possible in the flow to make attacks on subsequent steps more difficult.<\/li><\/ul><p class=\"par\" id=\"1580218960640_N10669\"><strong class=\"emphasis\">Stealth mode in self-registration has some limitations:<\/strong><\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Only the first channel verifiable user item is protected. All other user items (including login names) remain vulnerable to enumeration attacks.<\/li><\/ul><p class=\"par\" id=\"1580218960640_N1066F\">A similar feature is also used to protect accounts against enumeration during authentication, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435033143.html\">Authentication REST API<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1580218960640_N1068F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Best practice - Stealth mode in the Loginapp REST self-registration API<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1580218960640_N10690\"><strong class=\"emphasis\">During registration we want to enable stealth mode to ascertain:<\/strong><\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">zero information leakage on the first CVT<\/li><li class=\"enum-element\">channel verification on email addresses supplied by the registering entity<\/li><\/ul><p class=\"par\" id=\"1580218960640_N10698\"><strong class=\"emphasis\">The following table compares two methods, how stealth mode protection can be used during the registration process:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1580218960640_N1069A\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106AE\"><\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1580218960640_N106B1\">Email as username<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106B4\">Email as alias<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106B8\">Configuration<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Username is configured as an email address.<\/li><li class=\"enum-element\">Email verification is enabled.<\/li><li class=\"enum-element\">Setting the login name is the first step of the registration process.<\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Username is generated automatically.<\/li><li class=\"enum-element\">Email verification is enabled.<\/li><li class=\"enum-element\">Email verification is done as early as possible.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106CE\">Advantages<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Very simple setup<\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The email address may be changed during the lifetime of the account (not during the self-registration process)<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106DC\">Disadvantages<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The email address can never be changed (username is a primary key).<\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Supporters must understand the difference between username and alias.<\/li><li class=\"enum-element\">Special care should be taken not to expose the username.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1580218960640_N106EC\">Other considerations<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\" colspan=\"2\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Both methods will allow additional aliases to be used.<\/li><\/ul><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1580218960640_N10704\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Best practice - Use of nicknames<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1580218960640_N10705\">Many applications require the use of nicknames to protect their users from each other (e.g. multiplayer games, message boards, etc.).<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Best practice is to define a nickname attribute as unique but not as an alias for the following reasons:<\/strong><\/li><li class=\"enum-element\">Nicknames cannot be protected against enumeration attacks, but player nicknames or names on messages boards are visible anyway and do not need to be enumeration protected.<\/li><li class=\"enum-element\">Configuring nicknames as unique will allow the application to be only aware of the nickname and not the login name.<\/li><li class=\"enum-element\">Using a login name (e.g. email) during authentication makes it easier for the user to remember the login name.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';