var m_1582547572406Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Prerequisites to setup IAM as SAML IDP<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1582547572406\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Prerequisites to setup IAM as SAML IDP<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1582547572406_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1582547572406_N1000B\">To set up IAM as a SAML identity provider, the following preparations are required.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1582547572406_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create a SAML directory<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1582547572406_N10010\">The SAML configuration is partly stored in the IAM configuration but refers to standardized XML files called <i class=\"italics\">SAML metadata files<\/i>. They contain a lot of the details configuring the SAML IDP and SPs.  Moreover, the SAML configuration involves key stores and key store password files.<\/p><p class=\"par\" id=\"1582547572406_N10015\">To separate the SAML files from the \u200Bother Airlock IAM configuration file, it is advisable to create a separate SAML directory within the IAM instance directory.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572406_N1014B\"><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572406_N10043\">In his tutorial, we assume a directory  \/<code class=\"codeinline\">saml\/<\/code> in the Airlock IAM instance being configured.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572406_N10023\">Example: <code class=\"codeinline\">instances\/auth\/saml<\/code>\/<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572406_N10029\">We call the directory <i class=\"italics\">the SAML directory<\/i>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1582547572406_N1002F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Service provider metadata<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1582547572406_N10032\">From each SAML service provider, the corresponding metadata file plus some additional information is required. The metadata file contains all relevant endpoints (URLs), public keys, and other information about the service provider. This is covered in .<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1582547572406_N1003D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prepare a key store<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1582547572406_N10040\">The identity provider requires one or more key pairs in order to sign and encrypt SAML messages.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following information is required:<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Key store:<\/strong> A JKS or PKCS12 key store with one or more key pairs. It is recommended to use separate key pairs for signing and encryption. The public keys are made available to the service providers in the form of X.509 certificates. The certificates may be self-signed.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Key store password:<\/strong> The password for the key store.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Private key passwords:<\/strong> The password for the private keys. This may be the same as the key store password.<\/li><li class=\"enum-element\">The <i class=\"italics\"><\/i><i class=\"italics\"><\/i><strong class=\"emphasis\">aliases<\/strong> (also called <i class=\"italics\">friendly names<\/i>) of the certificates within the key store. An alias uniquely identifies a key pair within a set of keys contained in the key store.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572406_N1013A\">How to create a key store and export its public key is described here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945455.html\">Creating a key store for SAML<\/a><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1582547572406_N1005D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Next steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1582547572406_N10062\">To configure the IDP, proceed with <\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';