var m_1583435025512Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Passcode authentication<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1583435025512\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-theme-ct\"><div class=\" headline-theme-content\"><h1 class=\" headline-theme\">Use case<\/h1><\/div><\/div><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Passcode authentication<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435025512_N1000C\">This article explains on a conceptual level how Airlock 2FA Passcode authentication works. It also provides some detailed information on correct use and configuration.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand Passcode authentication in general.<\/li><li class=\"enum-element\">Understand the interaction between involved components.<\/li><li class=\"enum-element\">Learn details about prerequisites and limitations of Passcode.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435025512_N10042\">Authentication with passcode is intended as an offline alternative to the online factors One-Touch and Online QR Code. The latter two require the smartphone to be able to connect to the Futurae cloud whereas passcode authentication works completely offline.<\/p><p class=\"par\" id=\"1583435025512_N1003A\">Authentication with passcode is also possible with OTP hardware tokens.<\/p><p class=\"par\" id=\"1583435025512_N10065\">Passcode authentication is based on time-based OTPs (one-time passwords) that are generated every 30 seconds. They are displayed in the Airlock 2FA app and must be manually entered by the user.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435025512_N1006B1583479247455\">Time-based OTPs are not challenge-response based and offer therefore less security than One-Touch or Online QR code authentication. Disable passcode authentication in the Airlock 2FA configuration if it does not meet your security needs. Consider Offline QR code as an alternative offline fallback factor.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">User account exists in IAM.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has Airlock 2FA enabled as a possible authentication method.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Passcode authentication is enabled in the Airlock 2FA configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has installed the Airlock 2FA app on the smartphone or has an appropriate Airlock 2FA hardware token.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Passcode authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435025512_N100F4\">The following flow chart shows the use of passcode as the main authentication factor, i.e. if all other Airlock 2FA factors are disabled in the configuration. This should be offered as an offline fall-back to One-Touch.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1583435025512_N100AA\"><img alt=\"UC-Passcode\" class=\"media-theme-img-tag svg\" src=\"..\/media\/03_Media\/Vector_drawings\/Airlock_2FA\/8745.UC-Passcode.theme\/1.5\/en-us.8745.UC-Passcode_original.svg\" style=\"width:;height:646.72px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1583435025512_N1009F\"><col style=\"width:5%;\"\/><col style=\"width:95%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100B1\">(1)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100B4\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">The user is identified by IAM (e.g. by entering username and password in the browser).<\/span><\/p><p class=\"par\" id=\"1583435025512_N100AB\"><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100DD\">(2)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100BF1583421751155\">IAM asks the user to enter a passcode.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100E9\">(3)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100C51583421751155\">The user opens the Airlock 2FA app and types the passcode into the browser\'s input field.<\/p><p class=\"par\" id=\"1583435025512_N100DB1583479247455\">The smartphone must be unlocked - this may involve a PIN, fingerprint, or face recognition (depending on the smartphone\'s capabilities and setup).<\/p><p class=\"par\" id=\"1583435025512_N100BF1606294448680\">Alternatively, the user uses an OTP hardware token.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100F5\">(4)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100DF\">IAM verifies the passcode with the Futurae cloud to complete authentication.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435025512_N10109\">(5)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435025512_N100E5\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM automatically redirects the user\'s browser to the intended target application or service.<\/span><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N1007F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following limitations apply when using passcode authentication:<\/li><li class=\"enum-element\">Note that passcodes from any app assigned to the user are accepted for login. There is no binding of the authentication process to a specific app instance.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435025512_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849713225.html\">Airlock 2FA passcode - REST flow example<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597341380787.html\">Hardware tokens for Airlock 2FA<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';