var m_1583435031113Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Selection of authentication token and authTokenId usage<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1583435031113\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Selection of authentication token and authTokenId usage<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435031113_N10247\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Depending on the user and the authentication tokens used for transaction approval, there may be more than one token to choose from the following examples:<\/li><li class=\"enum-element\">A user may have both an MTAN\/SMS token and a Cronto token<\/li><li class=\"enum-element\">A user may have multiple MTAN\/SMS tokens or multiple Cronto tokens<\/li><\/ol><p class=\"par\" id=\"1583435031113_N10250\">There are two strategies for how the token to be used can be determined: selection-based and authTokenId-based.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435031113_N10256\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Selection-based token choice<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435031113_N10257\">In this strategy, the delegating entity (e.g. e-banking system) chooses the token. It may do so on its own or have the user choose the token. The latter requires that the delegating entity is interacting with the user at the time of transaction approval.<\/p><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Technically, the token choice may have two origins:<\/li><li class=\"step\">Within a step implementation (e.g. the \"mTAN Authentication\" step may ask which phone number to use).<\/li><li class=\"step\">Explicitly configured \"Selection\" Step (used to choose among several steps such as mTAN and Cronto).<\/li><\/ol><p class=\"par\" id=\"1583435031113_N10261\"><strong class=\"emphasis\">The following configuration example shows the explicitly configured selection step:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1583435031113_N1028E1581062901804\"><img alt=\"81010237.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/81010237.png.theme\/2.1\/en-us.81010237.png_html.png\" style=\"width:1024px;height:240.25889967637542px;border:0;\"\/><\/div><\/figure><figure class=\"media\"><div class=\"media-theme\" id=\"1583435031113_N10299\"><img alt=\"81011502.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/81011502.png.theme\/2.1\/en-us.81011502.png_html.png\" style=\"width:1024px;height:182.04444444444445px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1583435031113_N10273\"><strong class=\"emphasis\">Example REST response indicating that a selection is required (as a response to the parameter step):<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10278\">HTTP 200 OK\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2022-04-13T11:04:46.588+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"transaction-approval.session\",\r\n        \"id\": \"799681179\",\r\n        \"attributes\": {\r\n            \"nextStep\": \"SELECTION_REQUIRED\"\r\n        }\r\n    }\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435031113_N1027E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">authTokenId token choice<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435031113_N1027F\">In most situations, the delegating entity (e.g. e-banking system) does neither want to choose the correct token nor have it chosen by the user. It expects IAM to use the same token for transaction approval that has been used during the login process.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In order to achieve this, the\u00A0<code class=\"codeinline\">authTokenId<\/code> must be passed to the transaction approval interface in the parameter step:<\/li><li class=\"enum-element\">The authTokenId is produced during the login process (user authentication) in the IAM loginapp.<\/li><li class=\"enum-element\">The authTokenId may be passed to the protected backends (e.g. e-banking system) in identity propagation<\/li><li class=\"enum-element\">The delegating entity must have access to the authTokenId and pass it to the transaction approval interface<\/li><li class=\"enum-element\">The authentication token (used during login) and the transaction approval step must both support the authTokenId. This is currently the case for Airlock 2FA, mTAN and Cronto tokens for <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> <span class=\"include-text\" data-objid=\"1597341380965\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">8.0<\/span>.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435031113_N10293\"><code class=\"codeinline\">authTokenID<\/code><strong class=\"emphasis\"> in identity propagation<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To send the <\/strong><code class=\"codeinline\">authTokenId<\/code><strong class=\"emphasis\"> to the protected applications after login, the used identity propagator plugin must be configured accordingly:<\/strong><\/li><li class=\"enum-element\">As value reference use \"AUTH_TOKEN_ID\"<\/li><li class=\"enum-element\">Store it in the ID propagation token using a name of your choice (e.g. \"authTokenId\"). The receiving system (e.g. e-banking-system) must know this name to extract the AuthTokenId.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1583435031113_N102AC\"><strong class=\"emphasis\">The authTokenId is subsequently sent to the transaction approval interface in the parameter step 3 as in the following example:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102B1\">POST https:\/\/internal-iam-host.com\/auth-transaction-approval\/rest\/transaction-approval\/parameters\/\r\n{\r\n    \"authTokenId\" : \"123456abcdef\",\r\n\t\"messageParameters\" : \r\n    {\r\n    \t\"accountNumber\" : \"0123456\",\r\n    \t\"amount\" : \"9999\",\r\n    \t\"currency\" : \"CHF\"\r\n    }\r\n}\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1583435031113_N102B3\"><strong class=\"emphasis\">In the transaction approval interface, the selection options must include a selection condition respecting the auth token ID parameter:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1583435031113_N10304\"><img alt=\"81010335.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/81010335.png.theme\/2.1\/en-us.81010335.png_html.png\" style=\"width:1024px;height:199.13425549227014px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435031113_N102C0\">In a more realistic scenario, you might want to configure a <i class=\"italics\">logical AND<\/i> condition that additionally checks whether or not the user has an mTAN token (as shown in the demo configuration).<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';