var m_1583435037857Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Transaction approval with Airlock 2FA<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1583435037857\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Transaction approval with Airlock 2FA<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435037857_N103E0\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435037857_N103E1\">The following\u00A0example\u00A0illustrates the transaction approval of an\u00A0e-banking\u00A0system that uses Airlock IAM for authentication and transaction approval with Airlock 2FA.<\/p><p class=\"par\" id=\"1583435037857_N1000D\">It uses the One-Touch method. The QR code (online and offline) and mobile-only methods are not shown.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435037857_N103E7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Flow diagram (using One-Touch)<\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1583435037857_N10016\"><img alt=\"Airlock2FA-TransactionApproval\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/Airlock_2FA\/8854.Airlock2FA-TransactionApproval.theme\/3.3\/en-us.8854.Airlock2FA-TransactionApproval_original.svg\" style=\"width:;height:1086px;border:0;\"\/><\/div><\/figure><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">(1)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">User authentication and identity propagation:<\/li><li class=\"enum-element\">The user authenticates with Airlock 2FA.<\/li><li class=\"enum-element\">The AuthTokenID is sent to the e-banking application as part of the identity propagation.<\/li><li class=\"enum-element\">The e-banking application stores the AuthTokenID in its session. It is used to select the appropriate Airlock 2FA token during transaction approval.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(2)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Transaction approval decision:<\/li><li class=\"enum-element\">The user interacts with the e-banking application and starts a transaction (e.g. enters a payment).<\/li><li class=\"enum-element\">The e-banking application decides that approval is necessary for the transaction and thus starts the transaction approval process.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(3)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Selection of transaction approval flow<\/li><li class=\"enum-element\">The e-banking application decides which IAM transaction approval flow to use.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(4)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">User identifying step:<\/li><li class=\"enum-element\">The e-banking application calls the Airlock IAM transaction approval REST API and identifies the end-user.<\/li><li class=\"enum-element\">If the user is valid and not locked, Airlock IAM asks the e-banking application to provide transaction data to be verified.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Parameter Step:<\/li><li class=\"enum-element\">The e-banking application sends transaction data to <span class=\"no-linebreak\" style=\"white-space:nowrap;\">Airlock IAM<\/span>. It also sends the AuthTokenID (optional).<\/li><li class=\"enum-element\">If no AuthTokenID is sent, Airlock IAM will ask the e-banking application to select one of several available Airlock 2FA tokens (not shown in the diagram).<\/li><li class=\"enum-element\">IAM verifies the transaction data and asks the e-banking application to poll for the result.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(6)<\/td><td><\/td><td class=\"legend-def\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Approval step:<\/li><li class=\"enum-element\">Airlock IAM formats the transaction data using the configured message provider.<\/li><li class=\"enum-element\">Airlock IAM sends the transaction data via the Futurae cloud to the user\'s smartphone (Airlock 2FA app).<\/li><li class=\"enum-element\">The e-banking application starts polling for the result.<\/li><li class=\"enum-element\">The user verifies the transaction data on the smartphone and presses the <span class=\"dialog\">Approve<\/span> button.<\/li><li class=\"enum-element\">Airlock IAM gets the result from the Futurae cloud and returns the <i class=\"italics\">OK <\/i>to the e-banking application.<\/li><\/ul><p class=\"par\" id=\"1583435037857_N10065\">During step (5), the e-banking application may choose to show a QR code and accept an OTP code entered by the user (offline scenario). For simplicity, this is not shown in the diagram.<\/p><\/td><\/tr><\/table><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435037857_N10412\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435037857_N10413\">The configuration is the same as in mTAN example except that the last step is an Airlock 2FA step:<\/p><figure class=\"media shadow\"><div class=\"media-theme shadow\" id=\"1583435037857_N10097\"><img alt=\"TransactionApprovalConigScreenshot\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/TransactionApprovalConigScreenshot.theme\/2.3\/en-us.TransactionApprovalConigScreenshot_html.png\" style=\"width:;height:154px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435037857_N10421\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">REST call sequence<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435037857_N10422\">The following REST call sequence shows how to use the transaction approval API from a REST client\'s point of view.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For simplicity, in this example:<\/li><li class=\"enum-element\">authentication information (e.g. Basic Auth header) and other HTTP headers are not shown.<\/li><li class=\"enum-element\">the user\'s Airlock 2FA app is online and therefore capable to do One-Touch.<\/li><\/ul><table border=\"0\" cellspacing=\"0\" class=\"table table table-Normal table-Normal table- table-block-description table-\" id=\"1583435037857_N100DB\"><col style=\"width:25%;\"\/><col style=\"width:75%;\"\/><thead class=\"thead-Normal\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-header table-header-horizontal table-cell-col-odd-Normal\" colspan=\"2\"><div><p class=\"par\" id=\"1583435037857_N100D4\"><strong class=\"emphasis\">REST interaction 1 \u2013 Step 3 in the above diagram: <\/strong><\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-Normal\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N100ED\">HTTP Request - Flow selection<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N10433\">POST https:\/\/internal-iam-host.com\/auth-transaction-approval\/rest\/transaction-approval\/flows\/my-flow-1\/select\r\n<\/pre><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N100FA\"> HTTP Response - User identification required after flow selection<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N10438\">HTTP\/1.1 200 OK\r\n\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2022-07-17T11:05:10.408+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"transaction-approval.session\",\r\n        \"id\": \"121849797510425576\",\r\n        \"attributes\": {\r\n            \"nextStep\": \"USERNAME_REQUIRED\"\r\n        }\r\n    }\r\n}\r\n<\/pre><\/div><\/td><\/tr><\/tbody><\/table><table border=\"0\" cellspacing=\"0\" class=\"table table table-Normal table-Normal table- table-block-description table-\" id=\"1583435037857_N10121\"><col style=\"width:30%;\"\/><col style=\"width:70%;\"\/><thead class=\"thead-Normal\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-header table-header-horizontal table-cell-col-odd-Normal\" colspan=\"2\"><div><p class=\"par\" id=\"1583435037857_N10430\"><strong class=\"emphasis\">REST interaction 2 - Step 4 in the above diagram:<\/strong><\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-Normal\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N10136\">HTTP Request - User identifying step<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N100F61658478411013\">POST https:\/\/internal-iam-host.com\/auth-transaction-approval\/rest\/transaction-approval\/user\/identify\/\r\n{\r\n    \"username\" : \"jdoe\"\r\n}<\/pre><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N1014A\"> HTTP Response - User identifying step<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N10103\">HTTP\/1.1 200 OK\r\n\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2020-03-17T11:05:12.408+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"transaction-approval.session\",\r\n        \"id\": \"121849797510425576\",\r\n        \"attributes\": {\r\n            \"nextStep\": \"PARAMETERS_REQUIRED\"\r\n        }\r\n    }\r\n}\r\n<\/pre><\/div><\/td><\/tr><\/tbody><\/table><table border=\"0\" cellspacing=\"0\" class=\"table table table-Normal table-Normal table- table-block-description table-\" id=\"1583435037857_N10169\"><col style=\"width:30%;\"\/><col style=\"width:70%;\"\/><thead class=\"thead-Normal\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-header table-header-horizontal table-cell-col-odd-Normal\" colspan=\"2\"><div><p class=\"par\" id=\"1583435037857_N1043A\"><strong class=\"emphasis\">REST interaction 3 - Step 5 in the above diagram:<\/strong><\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-Normal\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N1017E\">HTTP Request - Send transaction details<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N1043D\">POST https:\/\/internal-iam-host.com\/auth-transaction-approval\/rest\/transaction-approval\/parameters\/\r\n{\r\n    \"authTokenId\" : \"123456abcdef\", \r\n    \"messageParameters\" : \r\n    {\r\n    \t\"accountNumber\" : \"0123456\",\r\n    \t\"amount\" : \"9999\",\r\n    \t\"currency\" : \"CHF\"\r\n    }\r\n}<\/pre><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N10192\"> HTTP Response - Send transaction details<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N10442\">HTTP\/1.1 200 OK\r\n\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2020-03-17T11:05:15.185+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"transaction-approval.session\",\r\n        \"id\": \"121849797510425576\",\r\n        \"attributes\": {\r\n            \"nextStep\": \"AIRLOCK_2FA_POLLING_OR_OTP_REQUIRED\"\r\n        }\r\n    }\r\n}<\/pre><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1583435037857_N10444\">At this point, polling for the result (approval or denying) starts.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-Normal table-Normal table- table-block-description table-\" id=\"1583435037857_N101B7\"><col style=\"width:30%;\"\/><col style=\"width:70%;\"\/><thead class=\"thead-Normal\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-header table-header-horizontal table-cell-col-odd-Normal\" colspan=\"2\"><div><p class=\"par\" id=\"1583435037857_N10446\"><strong class=\"emphasis\">REST interaction 4 - Step 6 in the above diagram:<\/strong><\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-Normal\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N101CC\">HTTP Request - Polling in approval step<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N10449\">POST https:\/\/internal-iam-host.com\/auth-transaction-approval\/rest\/transaction-approval\/airlock-2fa\/status\/poll\/<\/pre><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1583435037857_N101E0\"> HTTP Response - Polling in approval step<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><pre class=\"code\" id=\"N100F8\">HTTP\/1.1 200 OK\r\n\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2020-03-17T11:05:19.251+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"transaction-approval.session\",\r\n        \"id\": \"121849797510425576\",\r\n        \"attributes\": {\r\n            \"nextStep\": \"AIRLOCK_2FA_POLLING_OR_OTP_REQUIRED\"\r\n        }\r\n    }\r\n}<\/pre><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1583435037857_N1044B\">The system keeps polling until approved or denied.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435037857_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Note the payload encryption feature mentioned in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1582547572547.html\">Airlock 2FA Settings plugin \u2013 global shared Airlock 2FA configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435031284.html\">Transaction approval with mTAN (SMS)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.airlock.com\/iam\/nightly\/transaction-approval-rest\/index.html\" target=\"_blank\">Transaction Approval REST API Reference<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';