var m_1585668115590Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>API access control - how it works in detail<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1585668115590\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">API access control - how it works in detail<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N10013\">This article gives detailed insights on how API access control based on API keys works in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1585668115590_N1001D\">The focus of this content is on the usage of API keys. It does not provide details about other access control mechanisms of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N10016\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Mapping information<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N10019\">As with any HTTP request sent to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>, the applicable <span class=\"dialog\">Mapping<\/span> is determined based on the virtual host used and the request URI.<\/p><p class=\"par\" id=\"1585668115590_N1001E\">All mapping-specific access control mechanisms like filters or API enforcement are applied as usual.<\/p><p class=\"par\" id=\"1585668115590_N10020\">API key-based access control relies on the following settings in the mapping:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Access restrictions based on <span class=\"dialog\">API plans<\/span><\/li><li class=\"enum-element\">How to communicate with the <span class=\"dialog\">API Policy Service<\/span> (of Airlock IAM)<\/li><li class=\"enum-element\">How to extract API keys from HTTP requests<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N1002C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Access restrictions based on API plans<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N1002F\">To take access decisions, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> uses the <span class=\"dialog\">Access restrictions<\/span> in the mapping\'s <span class=\"dialog\">Access<\/span> tab.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1574686289771_N102DC\">If the restriction list is empty or no restriction matches, access is granted. For example, if a restriction only matches HTTP GET requests, POST or PATCH requests on the same URL must be covered by separate restriction rules. Otherwise, they will be allowed.<\/p><\/div><\/div><\/div><\/div><\/div><figure class=\"media\"><div class=\"media-theme\" id=\"1585668115590_N10038\"><img alt=\"Access Restrictions Section\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/GW\/Airlock_GW_Control_Center\/Reverse_Proxy\/Access_Restrictions_Section.theme\/1.0-3.3\/en-us.Access_Restrictions_Section_html.png\" style=\"width:1024px;height:280.2271293375394px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1585668115590_N10042\">Access is granted for a restricted HTTP request if all matching (HTTP method and path) access restrictions are met: The required roles, as well as the required plans, must have been granted for the request to be successfully authorized.<\/p><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">Roles<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N10049\">Roles are typically used to implement access control for users and are granted on the session or for the request using the <span class=\"dialog\">Control API<\/span>. This is independent of API key-based access control and not further elaborated here.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">Plans<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N10052\">Plans are assigned to Tech-Clients in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>. The <span class=\"dialog\">Tech-Client<\/span> that issued a request is identified using the API key sent with the request. The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> looks up <span class=\"dialog\">Tech-Client<\/span> plans (and other attributes) by calling the Airlock IAM <span class=\"dialog\">API Policy Service<\/span>.<\/p><p class=\"par\" id=\"1585668115590_N10074\">Plans consist of an identifier and an optional rate limit. Rate limits are counted and enforced by <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><\/td><\/tr><\/table><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N100D6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Rate limit counters on <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N100E91588864105032\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> enforces <span class=\"dialog\">rate limits<\/span> defined on <span class=\"dialog\">plans<\/span> by maintaining counters.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The relevant <span class=\"dialog\">plan<\/span> for each request is determined as described above.<\/li><li class=\"enum-element\">If multiple <span class=\"dialog\">plans<\/span> are relevant for a request: <\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1585668115590_N10110\"><img alt=\"Access restrictions with multiple rate limits\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/GW\/Airlock_GW_Control_Center\/Access_restrictions_with_multiple_rate_limits.theme\/1.3\/en-us.Access_restrictions_with_multiple_rate_limits_html.png\" style=\"width:;height:119px;border:0;\"\/><\/div><\/figure><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The rate counters of all relevant <span class=\"dialog\">plans<\/span> for the calling <span class=\"dialog\">Tech-Client<\/span> count up.<\/li><li class=\"enum-element\">The request is forwarded to the protected back-end service until all count limits are used up.<\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N100691585898019599\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tech-Client attributes provided by <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N1006C1585898019599\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> sends requests to <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>\'s API Policy Service in order to get the following Tech-Client attributes given an API key:<\/p><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">Tech-Client ID<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N1005E\">A unique identifier for the <span class=\"dialog\">Tech-Client<\/span>. It is used for reporting and logging and may be sent to the protected service.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">Display name<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N10064\">A typically human-readable name of the <span class=\"dialog\">Tech-Client<\/span>. It may be used for reporting purposes.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">Label<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N1006A\">The label is a string value attribute of a  <span class=\"dialog\">Tech-Client<\/span>. It is searchable and may be used to group <span class=\"dialog\">Tech-Clients<\/span> (e.g. organization name, stage name, etc.).<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">Plans<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N10070\">A list of plans assigned to the Tech-Client. Each plan consist of its identifier (e.g. <span class=\"dialog\">payments<\/span>) and an optional rate limit (e.g. 10 requests\/second).<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">State<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1585668115590_N10076\">Information about the state of the Tech-Client and its API key: A <span class=\"dialog\">Tech-Client<\/span> and every API key may be locked, API keys may expire or not yet be valid.<\/p><\/td><\/tr><\/table><\/div><div xmlns=\"\" class=\"container-warning advice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_advice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1585668115590_N100A9\">Note that the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> may cache the Tech-Client information to improve performance. The cache timeout is configurable.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1585668115590_N100AB\">If the cache is disabled, a call to the <span class=\"dialog\">API Policy Service<\/span> is required for every API request processed by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>!<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N100B3\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tech-Client attribute retrieval<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N100B6\">To retrieve Tech-Client attributes from <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> connects to the <span class=\"dialog\">API Policy Service<\/span>. It is crucial for security that only trusted IAM instances are contacted by the gateway.<\/p><p class=\"par\" id=\"1585668115590_N100BB\">For this reason, a <span class=\"dialog\">shared secret<\/span> is used on both sides in addition to the connection security measures (TLS). The shared secret is used to sign requests and involves a timestamp. It is therefore essential that the clocks of all involved components (<span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> and <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>) are synchronized.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1585668115590_N100C3\">Note that the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> can connect to multiple IAM instances for different APIs. The <span class=\"dialog\">API Policy Service<\/span> to connect to is therefore selected in the <span class=\"dialog\">Mapping<\/span> configuration.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N100E9\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">API key extraction<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1585668115590_N100EC\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> extracts API keys from HTTP requests. The extraction mechanism is configured in the <span class=\"dialog\">Mapping<\/span> configuration. There are three types:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1585668115590_N100F4\"><caption class=\"table-title\">Table: API key extraction types<\/caption><col style=\"width:20%;\"\/><col style=\"width:80%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1585668115590_N10107\">Type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1585668115590_N1010C\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1585668115590_N10112\">Header<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1585668115590_N10117\">The API key is in an HTTP header line. This is the recommended API key extraction type.<\/p><p class=\"par\" id=\"1585668115590_N10119\">Example: <code class=\"codeinline\">Api-Key: w5bziGy4N2u...<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1585668115590_N10123\">Query parameter<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1585668115590_N10128\">The API key is in a URL query parameter. This type is less secure but may be especially useful in conjunction with HTTP redirects or links sent to the client.<\/p><p class=\"par\" id=\"1585668115590_N1012A\">Example: <code class=\"codeinline\">http:\/\/host.com\/some\/uri?api_key=w5bziGy4N2u<\/code><\/p><div xmlns=\"\" class=\"container-warning observe compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1585668115590_N10134\">URLs are often logged or stored in URL histories. Depending on the application of API keys, this may impose a security risk.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1585668115590_N1013A\">Cookie value<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1585668115590_N1013F\">The API key is transported in an HTTP cookie. This type may be useful in-browser applications and may leverage the cookie security measures built into browsers.<\/p><p class=\"par\" id=\"1585668115590_N10141\">Example: <code class=\"codeinline\">Cookie: ApiKey=w5bziGy4N2u...<\/code><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1585668115590_N102C3\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1585668119333.html\">Configure the Airlock IAM API policy service<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';