var m_1589475710412Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using the container image<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710412\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using the container image<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710412_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710412_N10295\">In this section we\'ll use the Docker image locally, which is useful for integration, testing, and troubleshooting. Docker, e.g.\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.docker.com\/products\/docker-desktop\" target=\"_blank\">Docker Desktop<\/a>,\u00A0must be installed and running. You should also create a new empty directory to which you can change (<code class=\"codeinline\">cd<\/code>). <\/p><p class=\"par\" id=\"1589475710412_N10329\">The directory will be used to store Airlock IAM configuration files:<\/p><p class=\"par\" id=\"1589475710412_N102AA\"><span class=\"dialog\">Preparation<\/span><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102AD\">mkdir -p ~\/airlock-iam-docker &amp;&amp; cd ~\/airlock-iam-docker  # Create new directory\r\ndocker info  # Make sure Docker daemon is running<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710412_N102AF\">Using the CLI to perform application-level configuration tasks works very similarly to the way it does on a traditional installation without docker. The\u00A0<code class=\"codeinline\">iam<\/code> command is the default entry-point of the Docker image. <\/p><p class=\"par\" id=\"1589475710412_N1033A\">This means that any CLI command can be executed inside a Docker image as follows:<\/p><p class=\"par\" id=\"1589475710412_N102B4\"><span class=\"dialog\">Docker CLI<\/span><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102B7\"># Show all available parameters and their default values\r\ndocker run --rm docker.io\/ergon\/airlock-iam:8.2 default-parameters\r\n\r\n# Correct permissions when using native Docker on Linux\r\nmkdir -p \"$(pwd)\/iam\" &amp;&amp; sudo chown -R 1000:0 \"$(pwd)\/iam\"\r\n\r\n# Create new instance named \"auth\"\r\ndocker run --rm -v \"$(pwd)\/iam:\/home\/airlock\/iam\" docker.io\/ergon\/airlock-iam:8.2 init --instance auth\r\n\r\n# Upgrade configuration of instance named \"auth\"\r\ndocker run --rm -v \"$(pwd)\/iam:\/home\/airlock\/iam\" docker.io\/ergon\/airlock-iam:8.2 upgrade -i auth\r\n\r\n# Run Airlock IAM and forward the HTTPS port 8443 to the host\r\ndocker run --rm -v \"$(pwd)\/iam:\/home\/airlock\/iam\" -p 8443:8443 docker.io\/ergon\/airlock-iam:8.2 run -i auth<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710412_N102BD\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Shell access<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710412_N102BE\"><strong class=\"emphasis\">To access the Airlock IAM CLI without a running\u00A0container:<\/strong><\/p><p class=\"par\" id=\"1589475710412_N102C0\"><span class=\"dialog\">Docker CLI<\/span><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102C3\">docker run --rm -it --entrypoint \/bin\/bash -v \"$(pwd)\/iam:\/home\/airlock\/iam\" docker.io\/ergon\/airlock-iam:8.2<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1565679354540_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Chapter content<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"generate-box generate-Contents\"><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1589475710479.html\" style=\"margin-left:0px\">6.4.2.1. Application parameters as environment variables<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1589475710477.html\" style=\"margin-left:0px\">6.4.2.2. Timezone<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1589475710475.html\" style=\"margin-left:0px\">6.4.2.3. Separate external\/internal containers<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1589475710473.html\" style=\"margin-left:0px\">6.4.2.4. Logging<\/a><\/div><div class=\"margin-normalize\"><a class=\"generateContents link link-xref\" href=\"data\/1589475710471.html\" style=\"margin-left:0px\">6.4.2.5. Resource limits and cgroups<\/a><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';