var m_1589475710416Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Storage and\u00A0volumes<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710416\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Storage and\u00A0volumes<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710416_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710416_N1038D\">The Airlock IAM docker image is designed for containers to be ephemeral. For this reason, we have used <code class=\"codeinline\">--rm<\/code> in the previous examples, which deletes the container storage upon completion.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710416_N1038F\">To keep the configuration directory persistent, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/storage\/volumes\/\" target=\"_blank\">Docker volumes<\/a>\u00A0or bind mounts can be used. Inside the Docker image, Airlock IAM expects the configuration directory at <code class=\"codeinline\">\/home\/airlock\/iam<\/code>.<\/p><p class=\"par\" id=\"1589475710416_N103A7\">Creating and copying the complete configuration directory during the build phase is a viable alternative for production use.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710416_N103BB\">During integration,\u00A0using bind mounts is more convenient because config files can be edited locally.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710416_N103C1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Read-only root filesystem<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710416_N103C2\">With Docker volumes, the container\'s root filesystem can be made read-only. Read-only filesystems provide improved security through stronger isolation.<\/p><p class=\"par\" id=\"1589475710416_N103C4\">The work directory\u00A0<code class=\"codeinline\">\/home\/airlock\/work<\/code>\u00A0must always be writable. To make the config root directory <code class=\"codeinline\">\/home\/airlock\/iam<\/code> read-only, all writeable files must be configured to be stored outside this directory. This can be achieved by configuring the path settings in the <code class=\"codeinline\">instance.properties<\/code> file. <br\/>Currently, only the optional <code class=\"codeinline\">.activated-configs<\/code> directory would require the <code class=\"codeinline\">\/home\/airlock\/iam<\/code> directory to be writeable. The path to a writeable filesystem can be set in the <code class=\"codeinline\">instance.properties<\/code> file (see code excerpt).<\/p><p class=\"par\" id=\"1589475710416_N10059\"><strong class=\"emphasis\">Code excerpt:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10060\">## Directory to store activated configurations and activation states (displayed in the config editor) \r\n## Set to empty to not store the activated configurations nor the activation states. \r\n## Otherwise it must be a writable directory (relative to the instance directory or as absolute path) \r\n#iam.activated-configs.dir = .activated-configs<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710416_N10065\">In IAM active-active setups, with multiple Airlock IAMs per instance, the activation status of the IAMs and their plugins would overwrite each other\'s files in the <code class=\"codeinline\">.activated-configs<\/code> directory. In this case, we recommend configuring an empty <code class=\"codeinline\">iam.activated-configs.dir<\/code> (see code excerpt above).<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710416_N1047D\">For the working directory, ephemeral <code class=\"codeinline\">tmpfs<\/code> mounts can be used since their contents are always re-created during start-up.<\/p><p class=\"par\" id=\"1589475710416_N103C6\"><strong class=\"emphasis\">Run the following in the Docker CLI:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N103C9\">docker run --rm --read-only --mount type=volume,target=\/home\/airlock\/iam --mount type=tmpfs,target=\/home\/airlock\/work docker.io\/ergon\/airlock-iam:8.2<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710416_N103CB\"><strong class=\"emphasis\">Set the volumes and temporary file systems in the docker-compose.yml:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N103CE\">version: \'3.7\'\r\nservices:\r\n  iam:\r\n    image: docker.io\/ergon\/airlock-iam:8.2    read_only: true\r\n    volumes:\r\n      - type: volume\r\n        target: \"\/home\/airlock\/iam\"\r\n      - type: tmpfs\r\n        target: \"\/home\/airlock\/work\"<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710416_N103D3\">You may also use\u00A0<code class=\"codeinline\">type=volume<\/code> instead of <code class=\"codeinline\">type=tmpfs<\/code> to create an\u00A0anonymous\u00A0volume. See\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/storage\/\" target=\"_blank\">https:\/\/docs.docker.com\/storage\/<\/a>\u00A0for a complete overview of all Docker storage options and how they differ.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';