var m_1589475710420Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Example - Docker stack<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710420\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Example - Docker stack<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710420_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710420_N10415\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/compose\/compose-file\/\" target=\"_blank\">Docker Compose files<\/a> can also be used in swarm cluster environments.<\/p><p class=\"par\" id=\"1589475710420_N10429\">The following example uses <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/storage\/volumes\/\" target=\"_blank\">Docker volumes<\/a>, profiles,  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/engine\/swarm\/secrets\/\" target=\"_blank\">secrets<\/a> and <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/config\/containers\/resource_constraints\/\" target=\"_blank\">limit the resources<\/a> to deploy Adminapp and Loginapp as separate containers.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10043\"><strong class=\"emphasis\">Caution when using  <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code><\/strong> <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10048\">The option <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code> limits the amount of heap available to the JVM to the specified percentage of the total amount of memory available for the container.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N1004E\"><strong class=\"emphasis\">It is important not to set this value too high (e.g. to 100):<\/strong> If the JVM and additional processes running in the container (e.g. through <code class=\"codeinline\">docker exec<\/code>) exceed the container\'s memory limit, the container may be killed.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10056\">The default value for <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code> is <code class=\"codeinline\">50<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710420_N1053A\"><strong class=\"emphasis\">This template can be used with \"<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/engine\/reference\/commandline\/stack\/\" target=\"_blank\">docker stack<\/a>\":<\/strong><\/p><p class=\"par\" id=\"1589475710420_N10477\"><span class=\"dialog\">docker-compose.yml<\/span><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1047A\">version: \'3.7\'\r\nservices:\r\n  loginapp:\r\n    image: \"${IAM_IMAGE}\" # Use container image from local environment variable\r\n    read_only: true\r\n    volumes:\r\n      - type: volume\r\n        source: \"airlock_iam_config\"\r\n        target: \"\/home\/airlock\/iam\"\r\n      - type: tmpfs\r\n        target: \"\/home\/airlock\/work\"\r\n    environment:\r\n      - \"TZ=Europe\/Zurich\"\r\n      - \"IAM_JAVA_OPTS=-XX:MaxRAMPercentage=50\"\r\n      - \"IAM_MODULES=loginapp\"\r\n      - \"IAM_SENSITIVE_VALUES_CONFIG=secrets:\/run\/secrets\/airlock_iam_secrets\"\r\n      - \"IAM_LICENSE=\/run\/secrets\/airlock_iam_license\"\r\n    ports:\r\n      - \"8443\"\r\n    deploy:\r\n      resources:\r\n        limits:\r\n          memory: \"4G\"\r\n  adminapp:\r\n    image: \"${IAM_IMAGE}\"\r\n    read_only: true\r\n    volumes:\r\n      - type: volume\r\n        source: \"airlock_iam_config\"\r\n        target: \"\/home\/airlock\/iam\"\r\n      - type: tmpfs\r\n        target: \"\/home\/airlock\/work\"\r\n    environment:\r\n      - \"TZ=Europe\/Zurich\"\r\n      - \"IAM_JAVA_OPTS=-XX:MaxRAMPercentage=50\"\r\n      - \"IAM_MODULES=adminapp,service-container\"\r\n      - \"IAM_SENSITIVE_VALUES_CONFIG=secrets:\/run\/secrets\/airlock_iam_secrets\"\r\n      - \"IAM_LICENSE=\/run\/secrets\/airlock_iam_license\"\r\n    ports:\r\n      - \"8443\"\r\n    deploy:\r\n      resources:\r\n        limits:\r\n          memory: \"2G\"\r\n\r\nvolumes:\r\n  airlock_iam_config:\r\n    external: true\r\n\r\nsecrets:\r\n  airlock_iam_secrets:\r\n    external: true\r\n  airlock_iam_license:\r\n    external: true<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';