var m_1589475710424Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Troubleshooting <\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710424\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Troubleshooting <\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710424_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Bind mounts and permissions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710424_N104A4\">The previous examples use simple bind mounts with the \"-v\" option. For integration and testing, bind mounts are an easy way to get started. But\u00A0when running native Docker on Linux,\u00A0be aware that the\u00A0<code class=\"codeinline\">airlock<\/code>\u00A0user inside the container has the UID\u00A0<code class=\"codeinline\">1000<\/code>\u00A0by default, which may not match your local user ID.<\/p><p class=\"par\" id=\"1589475710424_N104AC\">The UID of the\u00A0<code class=\"codeinline\">airlock<\/code>\u00A0user will \"leak\" through to your local filesystem. <\/p><p class=\"par\" id=\"1589475710424_N10599\"><strong class=\"emphasis\">Run the following troubleshooting steps, in case you run into problems with file permissions:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104B1\">ls -l iam\/instances\/* # You may notice that the owner of the files is \"1000\" or a user other than your current user\r\n# Use \"chown\" to change the owner and \"chmod\" to fix the file permissions\r\nsudo chown -R 1000:0 iam\/\r\n# If changing the owner is not enough, fixing the permission modes with \"chmod\" might be necessary\r\nsudo chmod -R u+rwX iam\/<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710424_N104B3\">You may also use\u00A0<code class=\"codeinline\">--user $(id -u)<\/code>\u00A0as part of\u00A0<code class=\"codeinline\">docker run<\/code>\u00A0to use your user ID inside the container:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104BB\">docker run --rm --user $(id -u) -v \"$(pwd)\/iam:\/home\/airlock\/iam\" docker.io\/ergon\/airlock-iam:8.2  # &lt;iam-cli-options&gt;...<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710424_N104BD\">Be aware that when copying the configuration files to production, or any other machine or environment, you must change the owner back to \"1000:0\":<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104BF\">COPY --chown=1000:0 .\/iam\/ \/home\/airlock\/iam\/<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104C1\"># To fix problems with file permissions, you can add the \"--user 0\" option to a run command to get temporary root-level access inside the container\r\ndocker run --rm --entrypoint \/bin\/bash -it \\\r\n\t-v \"$(pwd)\/iam\/:\/home\/airlock\/iam\/\" \\\r\n\t--user 0 \\\r\n\tdocker.io\/ergon\/airlock-iam:8.2 \\\r\n\t-c \'chown -R 1000:0 \/home\/airlock\/iam\/\'<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';