var m_1589475710471Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Resource limits and cgroups<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710471\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Resource limits and cgroups<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710471_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710471_N10344\">In the context of Docker,\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.kernel.org\/doc\/Documentation\/cgroup-v1\/\" target=\"_blank\">cgroups<\/a>\u00A0(control groups) are used to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.docker.com\/config\/containers\/resource_constraints\/\" target=\"_blank\">limit the resources<\/a>\u00A0of a container.<\/p><p class=\"par\" id=\"1589475710471_N1036C\">IAM containers use up to a fixed amount of 4GB of heap because\u00A0<code class=\"codeinline\">IAM_JAVA_OPTS=-Xmx4G<\/code>\u00A0is the default. To scale with Docker resource limits instead, the option <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code> can be used.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10043\"><strong class=\"emphasis\">Caution when using  <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code><\/strong> <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10048\">The option <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code> limits the amount of heap available to the JVM to the specified percentage of the total amount of memory available for the container.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N1004E\"><strong class=\"emphasis\">It is important not to set this value too high (e.g. to 100):<\/strong> If the JVM and additional processes running in the container (e.g. through <code class=\"codeinline\">docker exec<\/code>) exceed the container\'s memory limit, the container may be killed.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710471_N10056\">The default value for <code class=\"codeinline\">-XX:MaxRAMPercentage<\/code> is <code class=\"codeinline\">50<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710471_N10374\"><span class=\"dialog\">Docker CLI<\/span> (adapt to use correct IAM version)<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10377\">docker run --rm --memory 4g --env \"IAM_JAVA_OPTS=-XX:MaxRAMPercentage=50\" docker.io\/ergon\/airlock-iam:8.2<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710471_N10379\"><span class=\"dialog\">docker-compose.yml<\/span> (adapt to use correct IAM version)<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1037C\">version: \'3.7\'\r\nservices:\r\n  iam:\r\n    image: docker.io\/ergon\/airlock-iam:8.2    environment:\r\n      - \"IAM_JAVA_OPTS=-XX:MaxRAMPercentage=50\"\r\n    deploy: # Only for Docker Swarm\r\n      resources:\r\n        limits:\r\n          memory: \"4G\"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710471_N10071\">Note that the <code class=\"codeinline\">-XshowSettings:vm<\/code> option will log the memory consumption of the JVM. The <code class=\"codeinline\">-XshowSettings:vm<\/code> option can be added to  IAM_JAVA_OPTS. With the option enabled, this additional log output will be generated:<\/p><pre class=\"code\" id=\"N10383\">VM settings:\r\n    Max. Heap Size (Estimated): 2.00G\r\n    Using VM: OpenJDK 64-Bit Server VM<\/pre><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';