var m_1591893495528Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>HTTPS\/TLS with authentication of IAM<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1591893495528\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">HTTPS\/TLS with authentication of IAM<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1591893495528_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1591893495528_N1007B\">The use of HTTPS\/TLS in conjunction with a server certificate for IAM guarantees that only IAM can send commands using the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> Control API to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> and the privacy of the data exchanged between <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Gateway<\/span> and IAM. IAM is delivered with a default certificate for HTTPS which should be replaced by a custom certificate since the same private key is included in all IAM installations.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">HTTPS\/TLS with authentication of IAM is configured as follows (requires OpenSSL):<\/strong><\/li><li class=\"step\">Create a self-signed Certificate:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100A0\">openssl req -x509 -sha512 -newkey rsa:3072 -keyout iam-private-key.pem -out iam-certificate.pem -days 365<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893495528_N10088\">If \"BackendSSLVerifyHost\" is set to \"TRUE\" in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> expert settings on the Airlock IAM backend, the common name (CN) of the certificate must match the hostname of the host running Airlock IAM.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Create a key store containing the generated certificate and private key if not already done:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AF\">openssl pkcs12 -export -name IamServerCert -in iam-certificate.pem -inkey iam-private-key.pem -out iam-keystore.p12<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">In order to keep all configuration files in the same place, the created <code class=\"codeinline\">iam-keystore.p12<\/code>\u00A0should be copied into the relevant instance\'s configuration directory. (e.g. <code class=\"codeinline\">instances\/auth\/iam-keystore.p12<\/code>)<\/li><li class=\"step\">Update the instance parameters in <code class=\"codeinline\">instance.properties:<\/code><\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100C21580713010316\"># Only enable the HTTPS connector\r\niam.web-server.connectors = https\r\n\r\n# Configure key store\r\niam.web-server.https.keystore.type = PKCS12\r\niam.web-server.https.keystore.file = instances\/auth\/iam-keystore.p12\r\niam.web-server.https.keystore.password = &lt;keystore-password&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Restart Airlock IAM<\/li><li class=\"step\">Add the self-signed IAM server certificate as <code class=\"codeinline\">BackendSSLServerCA<\/code> certificate to the IAM back-end group of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> and enable <code class=\"codeinline\">BackendSSLVerifyHost<\/code> for this backend group (for a detailed description of this step see: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/techzone.airlock.com\/backend-ssl\" target=\"_blank\">https:\/\/techzone.airlock.com\/backend-ssl<\/a>).<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1591893495528_N100C5\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Microgateway<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1591893495528_N100D7\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Microgateway<\/span>  is configured with a YAML config file using a DSL (domain-specific language) to configure HTTPS and the certificate-related settings.  The <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.airlock.com\/microgateway\/latest\/?topic=MGW-00000034#data\/amorecomplex.html\" target=\"_blank\">Complex example configuration with Airlock IAM SSL\/TLS<\/a> show how to achieve this.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';