var m_1591893496028Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Planning configuration contexts<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1591893496028\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Planning configuration contexts<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1591893496028_N100081592291212581\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1591893496028_N10009\">The use of configuration contexts requires thorough planning and careful configuration. The following content guides you through those two stages.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1591893496028_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 - Determine the configuration context<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1591893496028_N10049\">For every HTTP request sent to Airlock IAM (e.g. answer an authentication request), the\u00A0active configuration context is determined, in order to select the corresponding configuration. <\/p><p class=\"par\" id=\"1591893496028_N10015\">The configuration context is determined by evaluating the current HTTP request using the configured context extractor plugin(s).<\/p><p class=\"par\" id=\"1591893496028_N1005E\">There are several context extractor plugins. Custom context extractor plugins can be written if required.<\/p><p class=\"par\" id=\"1591893496028_N10060\"><strong class=\"emphasis\">Example plugins:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1591893496028_N10063\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N10073\">Plugin Name<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N10076\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N1007A\">URL Context Extractor<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N1007D\">Determines the configuration context by matching the URL (as seen by the browser; including the domain) against a list of configured rules.<\/p><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N10062\">Note that for the Loginapp UI, the considered request URLs are the ones on the REST requests sent to the server and not the URLs displayed in the browser\'s address bar.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N10088\">IP Address Context Extractor<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N1008B\">Determines the configuration context by matching the client (browser) IP address against a list of configured rules.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N1008F\"><i class=\"italics\">Client Certificate Context Extractor<\/i><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N10093\">Determines the configuration context by matching information from a client certificate (mutual SSL) against a list of configured rules.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N10097\">HTTP Parameter Context Extractor<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N1009A\">Determines the configuration context by matching an HTTP parameter against a list of configured rules.<\/p><div xmlns=\"\" class=\"container-warning important compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N100B31662108814054\">For this extractor to work, the IAM server must be able to extract the HTTP parameter from the HTTP request.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N100B5\">The parameter can be part of the URL (GET request with query parameters) or be available POST request data but not part of a JSON body.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N100B7\">The usage of this extractor for the Loginapp REST API is therefore limited to GET requests with query parameters.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N100A6\">This extractor will not work with the Loginapp UI since the Loginapp UI does not forward parameters.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1591893496028_N1009E\">Static Context Extractor<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1591893496028_N100A1\">Uses a statically configured context.<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1591893496028_N100AC\">There are plugins combining several of the above methods:\u00A0<span class=\"dialog\">Combining Context Extractor<\/span> and\u00A0<span class=\"dialog\">Concatenating Context Extractor<\/span>.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1591893496028_N100B6\">To get a full list of existing context extractor plugins, please open the Config Editor and add a new context extractor plugin.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1591893496028_N100CA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 - Context-dependent configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Every configuration property may be defined differently for each configuration context.<\/li><li class=\"enum-element\">If no context-specific value is configured for a given context, the default context value is used.<\/li><\/ul><p class=\"par\" id=\"1591893496028_N100C3\">Thus, only the values that are really context-dependent \u2013 these are typically very few \u2013 must be configured for each context. All the rest of the configuration is defined only once.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';