var m_1592482454621Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using multiple apps in one service<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1592482454621\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using multiple apps in one service<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1592482454621_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1592482454621_N10009\">Multiple different apps may be used at the same time with the same Airlock 2FA service.  but some restrictions apply.<\/p><p class=\"par\" id=\"1592482454621_N1000D1592912654267\">Migration of apps is a use case scenario where the ability to support multiple apps simultaneously is very useful. <\/p><p class=\"par\" id=\"1592482454621_N10010\"><strong class=\"emphasis\">Example:<\/strong> when migrating from the <span class=\"dialog\">Airlock 2FA App<\/span> to a custom app or from the <span class=\"dialog\">FUTURAE App<\/span> to the <span class=\"dialog\">Airlock 2FA App<\/span> these use cases will be common:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Existing users still use the <span class=\"dialog\">old<\/span> app<\/li><li class=\"enum-element\">New users are using the <span class=\"dialog\">new<\/span> app<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1592482454621_N1003C1584524273773\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Primary app and usage restrictions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1592482454621_N1006B1585064612445\">For the described scenario to work, both apps must be used with one and the same Airlock 2FA service account.<\/p><p class=\"par\" id=\"1592482454621_N1002C\">However, each Airlock 2FA service account knows exactly one app as its <span class=\"dialog\">primary<\/span> app. Thus, at some point, you must choose the <span class=\"dialog\">new<\/span> app to be the <span class=\"dialog\">primary<\/span> app. This comes with the following restrictions:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Usage restrictions:<\/li><li class=\"enum-element\">New devices can only be enrolled (activated) with the <span class=\"dialog\">primary<\/span> app. The <span class=\"dialog\">old<\/span> app can no more be used for enrollments.<\/li><li class=\"enum-element\">Mobile-only authentication (authentication of custom apps using the FUTURAE SDK) only works with the <span class=\"dialog\">primary<\/span> app.<\/li><\/ul><p class=\"par\" id=\"1592482454621_N10048\">The following use-cases are still possible with the <span class=\"dialog\">old<\/span> app:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Authentication (for already enrolled devices)<\/li><li class=\"enum-element\">Transaction approval (for already enrolled devices)<\/li><li class=\"enum-element\">Activation letters that have been generated before making the <span class=\"dialog\">new<\/span> app the <span class=\"dialog\">primary<\/span> are still valid but only work with the <span class=\"dialog\">primary<\/span> app.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1592482454621_N100691592912909990\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Migrating to a new app<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1592482454621_N1006C\">With the above restrictions in mind, the migration from one app to another should be done as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Publish the new app (make it available in the app stores)<\/li><li class=\"step\">Inform users to only use the new app when activating new devices (e.g. change respective documentation, instruct help desk, etc.)<\/li><li class=\"step\">Make the new app the <span class=\"dialog\">primary<\/span> app in the Airlock 2FA service definition (contact Airlock staff at <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:order@airlock.com?subject=Airlock%202FA%20custom%20app\">order@airlock.com<\/a>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1592482454621_N10068\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435050445.html\">The Airlock 2FA app<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1592482454424.html\">Alternatives to the Airlock 2FA App<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';