var m_1593183841303Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>IAM One-Shot end-point configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1593183841303\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">IAM One-Shot end-point configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1593183841303_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1593183841303_N10162\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> handles one-shot requests in a different way than redirect requests: The <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> sends the one-shot requests to IAM end-point \'<code class=\"codeinline\">login-oneshot<\/code>\' (instead of \'<code class=\"codeinline\">check-login<\/code>\' for redirect workflow).<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The one-shot end-point is configured as follows in IAM:<\/strong><\/li><li class=\"enum-element\"><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">One-Shot Authentication<\/span><\/li><li class=\"enum-element\">Define the target applications or services to be protected.<\/li><li class=\"enum-element\">For each target application the following settings are specific for one-shot:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"dialog\">Credential Extractor<\/span>: specifies how to extract a credential (e.g. a token, a ticket, or a header containing information about the authenticated user) from the HTTP request.<\/li><li class=\"enum-element\"><span class=\"dialog\">Authenticator<\/span>: specifies how to check whether the credential is valid and thus whether the request is authenticated<\/li><li class=\"enum-element\"><span class=\"dialog\">Failure Responses<\/span> (error mapper): specifies how to respond to the HTTP Client if the request is not authenticated<\/li><\/ul><li class=\"enum-element\">All other properties (ID propagator, URL pattern, etc.) are the same as in normal target applications.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1593183841303_N10040\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication workflow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1593183841303_N10183\">The configured elements mentioned above (<span class=\"dialog\">Credential Extractor<\/span>, <span class=\"dialog\">Authenticator<\/span>, <span class=\"dialog\">Failure Responses<\/span>) are used as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The credential extractor extracts a credential (authentication information) from the HTTP request. Depending on the credential extractor, you have to choose <span class=\"dialog\">One-Shot<\/span> or <span class=\"dialog\">One-Shot with body<\/span> in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1593183841299.html\">Airlock Gateway target application\/service mapping configuration<\/a>. In case the credential extraction was not successful, the error mapper (<span class=\"dialog\">Failure Responses<\/span>) defines the response that is sent to the client. Otherwise, the workflow continues with the next step.<\/li><li class=\"step\">The extracted credential is checked using the configured authenticator. The credential must be compatible with that authenticator. The credential type produced is documented in the extractor plugin and the authenticator plugin usually documents the supported credential types. In case of authentication failures, the configured behavior of the error mapper (<span class=\"dialog\">Failure Responses<\/span>) is executed. In case none of the error types match the given authentication failure type, the default authentication behavior is selected and executed. If authentication is successful, the workflow continues with the next step.<\/li><li class=\"step\">The roles granted by the authenticator are matched against the required roles (a property on the target application - see group <span class=\"dialog\">Roles Processing<\/span>) after applying any role transformation rules.<\/li><p class=\"par\" id=\"1593183841303_N10214\">Access is granted and the workflow proceeds to the next step if at least one of the required roles is granted by the authenticator. Otherwise, the error mapper (<span class=\"dialog\">Failure Responses<\/span>) defines how to respond to the client.<\/p><li class=\"step\">Eventually, the identity propagator\u00A0adds identity information (e.g. a JWT header) to the response and the roles using the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> Control-API (CAPI) such that the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Gateway<\/span> can forward the \"temporarily stopped\" request to the back-end.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';