var m_1594028006479Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Kerberos system user<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594028006479\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Kerberos system user<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594028006479_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594028006479_N1047C\">In a Kerberos environment, the client requests a Kerberos service ticket to authenticate against this kerberized service. With Airlock IAM Front-side Kerberos, the Loginapp is the kerberized web application, which authenticates the clients. This requires that a system user is created for IAM for which the service principal name (SPN) is registered.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594028006479_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create system user<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to <span class=\"dialog\">Administrative Tools<\/span>, select <span class=\"dialog\">Active Directory Users and Computers<\/span> and create a user for Airlock IAM (e.g. syskerb-airlock-a).<\/li><li class=\"step\">Configure the following settings on the user:<\/li><p class=\"par\" id=\"1594028006479_N10188\"><span class=\"dialog\">User cannot change password<\/span> is <span class=\"dialog\">enabled<\/span><\/p><p class=\"par\" id=\"1594028006479_N1018F\"><span class=\"dialog\">Password never expires<\/span> is <span class=\"dialog\">enabled<\/span><\/p><p class=\"par\" id=\"1594028006479_N10196\"><span class=\"dialog\">Account is disabled<\/span> is <span class=\"dialog\">NOT enabled<\/span><\/p><p class=\"par\" id=\"1594028006479_N1019D\"><span class=\"dialog\">This account supports Kerberos AES 256 bit encryption<\/span> is <span class=\"dialog\">enabled<\/span><\/p><\/ol><p class=\"par\" id=\"1594028006479_N104A8\">Administrators wanting to create the user with PowerShell can use the following snippet:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104AA\">function create_systemuser ($_systemuser_name, $_etype, $_systemuser_password){\r\n    New-ADUser -Name ${_systemuser_name} `\r\n        -Enabled $True `\r\n        -CannotChangePassword $True `\r\n        -PasswordNeverExpires $True `\r\n        -KerberosEncryptionType ${_etype} `\r\n        -AccountPassword (ConvertTo-SecureString \"${_systemuser_password}\" -asplaintext -force)\r\n}\r\n\r\n$systemuser_password = \"STRONG_PASSWORD\"\r\n$encryption_type = \"AES256\"\r\n \r\ncreate_systemuser \"syskerb-airlock-a\" `\r\n   ${encryption_type} `\r\n   ${systemuser_password}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594028006479_N104AF\">As this is a very important user, a strong password is highly recommended!<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594028006479_N1004F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Register SPN for the system user<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594028006479_N104B6\">A client requests a Kerberos service ticket from the Active Directory Domain Controller in order to access a kerberized web application. This Kerberos service ticket is issued for a service principal name (SPN) which must match the FQDN of the domain being accessed by the browser.<\/p><p class=\"par\" id=\"1594028006479_N104B8\">The SPN always starts with <code class=\"codeinline\">HTTP\/<\/code> (no matter whether the URL is HTTP or HTTPS), followed by the fully-qualified domain name (without any port or path information). For example, the SPN for the URL\u00A0 <code class=\"codeinline\">https:\/\/a.airlock.com\/auth-login\/check-spnego<\/code>\u00A0 would be\u00A0 <code class=\"codeinline\">HTTP\/a.airlock.com<\/code><\/p><p class=\"par\" id=\"1594028006479_N104C3\">The SPN must be registered to the previously created\u00A0System User. <\/p><p class=\"par\" id=\"1594028006479_N101CC\"><strong class=\"emphasis\">To add an SPN for domain a.airlock.com, execute the following command in the PowerShell:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104C6\">setspn -s HTTP\/a.airlock.com syskerb-airlock-a<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning warning\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_warning\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For the encryption types AES 128 and AES 256 a salt is required by the OS. Windows uses the UserPrincipalName, which is set to the registered SPN by executing this command. Because of this, a separate system user is required for each SPN!<\/li><li class=\"enum-element\">An SPN can be registered only for one object (user or machine account). The SPN registration may fail or the authentication attempts may result in strange behavior if the SPN is registered several times. To find the object an SPN is registered to, run the command\u00A0<code class=\"codeinline\">setspn -Q HTTP\/a.airlock.com<\/code> . An SPN can be deleted from an object by running the command\u00A0 <code class=\"codeinline\">setspn -D HTTP\/a.airlock.com username<\/code><\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594028006479_N104D7\"><strong class=\"emphasis\">To retrieve important information about the system user, execute the command below (example output is displayed):<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104D9\">PS C:\\&gt; Get-ADUser syskerb-airlock-a -property userPrincipalName,sAMAccountName,pwdLastSet,servicePrincipalName,msDS-SupportedEncryptionTypes,msDS-KeyVersionNumber\r\n\r\nDistinguishedName             : CN=syskerb-airlock-a,CN=Users,DC=airlock,DC=com\r\nEnabled                       : True\r\nGivenName                     :\r\nmsDS-KeyVersionNumber         : 3\r\nmsDS-SupportedEncryptionTypes : 16\r\nName                          : syskerb-airlock-a\r\nObjectClass                   : user\r\nObjectGUID                    : 2a0d9e42-fbfb-4f55-b8c7-a17493f91038\r\npwdLastSet                    : 131807014257991663\r\nSamAccountName                : syskerb-airlock-a\r\nservicePrincipalName          : {HTTP\/a.airlock.com}\r\nSID                           : S-1-5-21-146862041-1632464460-2791201798-1138\r\nSurname                       :\r\nUserPrincipalName             : HTTP\/a.airlock.com@AIRLOCK.COM<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594028006479_N1008C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create the keytab file<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594028006479_N104E0\">The following steps are required to create a keytab file, which is used later in the IAM configuration. The following PowerShell function simplifies the creation steps:<\/p><p class=\"par\" id=\"1594028006479_N104E2\"><strong class=\"emphasis\">PowerShell: Helper function to create a keytab file<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N104E5\">function create_keytab_file ($_princ, $_mapuser, $_etype, $_password, $_outfile) {\r\n    $_tmp_file = $_outfile + \".tmp\"\r\n    $_tmp_file_name = [System.IO.Path]::GetFileName($_tmp_file)\r\n     \r\n    If (Test-Path ${_outfile}) {\r\n        If (Test-Path ${_tmp_file}) { Remove-Item ${_tmp_file} }\r\n        Rename-Item -Path $_outfile -NewName ${_tmp_file_name}\r\n         \r\n        ktpass \/in ${_tmp_file} `\r\n            \/out ${_outfile} `\r\n            \/princ ${_princ} `\r\n            \/mapuser ${_mapuser} `\r\n            \/ptype KRB5_NT_PRINCIPAL `\r\n            \/crypto ${_etype} `\r\n            \/DumpSalt `\r\n           \/pass ${_password}\r\n    }\r\n    Else {\r\n        ktpass \/out ${_outfile} `\r\n            \/princ ${_princ} `\r\n            \/mapuser ${_mapuser} `\r\n            \/ptype KRB5_NT_PRINCIPAL `\r\n            \/crypto ${_etype} `\r\n            \/DumpSalt `\r\n            \/pass ${_password}\r\n    }\r\n     \r\n    If (Test-Path ${_tmp_file}) { Remove-Item ${_tmp_file} }\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594028006479_N104E7\"><strong class=\"emphasis\">To create the keytab file, do the following:<\/strong><\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Sign in as <span class=\"dialog\">Domain Administrator<\/span> on the <span class=\"dialog\">Domain Controller<\/span>.<\/li><li class=\"step\">Open a <span class=\"dialog\">PowerShell<\/span> and <span class=\"dialog\">copy &amp; paste<\/span> the helper function above.<\/li><li class=\"step\">Run the following command to create a keytab file for the SPN <code class=\"codeinline\">HTTP\/a.airlock.com<\/code>:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10226\">$systemuser_password = \"STRONG_PASSWORD\"\r\n$keytab_file = \"C:\\tmp\\airlock.com.keytab\"\r\n$etype = \"AES256-SHA1\"\r\n\r\ncreate_keytab_file HTTP\/a.airlock.com@AIRLOCK.COM `\r\n    syskerb-airlock-a@AIRLOCK.COM `\r\n    ${etype} `\r\n    ${systemuser_password} `\r\n    ${keytab_file}<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><p class=\"par\" id=\"1594028006479_N10506\">The example below shows how to create a keytab file containing more than one SPN. Assume that the SPN <code class=\"codeinline\">HTTP\/b.airlock.com<\/code> is registered to the <code class=\"codeinline\">syskerb-airlock-b<\/code> user.<\/p><p class=\"par\" id=\"1594028006479_N1050F\"><strong class=\"emphasis\">Example: How to create a keytab file with more than one SPN<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10512\">$systemuser_password = \"STRONG_PASSWORD\"\r\n$keytab_file = \"C:\\tmp\\airlock.com.keytab\"\r\n$etype = \"AES256-SHA1\"\r\n\r\ncreate_keytab_file HTTP\/a.airlock.com@AIRLOCK.COM `\r\n    syskerb-airlock-a@AIRLOCK.COM `\r\n    ${etype} `\r\n    ${systemuser_password} `\r\n    ${keytab_file}\r\n\r\ncreate_keytab_file HTTP\/b.airlock.com@AIRLOCK.COM `\r\n    syskerb-airlock-b@AIRLOCK.COM `\r\n    ${etype} `\r\n    ${systemuser_password} `\r\n    ${keytab_file}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594028006479_N10517\">Keep in mind that the keytab file contains sensitive key material and should be protected appropriately.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';