var m_1594199615688Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Example configuration for protected self-service flow<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594199615688\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Example configuration for protected self-service flow<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview of this Example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594199615688_N10013\">The e-mail address change is used in this example since it is a typical self-service flow, where a user provides information that must be validated before it is persisted.<\/p><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Such flows very often contain the following steps:<\/li><li class=\"step\">Obtain the information from the user. In this case the e-mail address.<\/li><li class=\"step\">Validate the information provided by the user. In this case, sending an e-mail message to the user and verifying the receipt.<\/li><li class=\"step\">Persist the information provided. In this case, store the new e-mail address in the user account.<\/li><\/ol><p class=\"par\" id=\"1594199615688_N10018\">After configuring the IAM flow, the corresponding UI must also be configured. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N1001A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create plugin for the e-mail address registration flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Create a new plugin of type <span class=\"dialog\">Self Service Flow<\/span> under: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Protected Self-Services<\/span> &gt;&gt; <span class=\"dialog\">Protected Self-Service Flows<\/span><\/li><li class=\"step\">Create a plugin for the Flow ID to create a name for this flow. This name identifies the flow and it will be used by client applications to start an instance of this flow.<\/li><p class=\"par\" id=\"1594199615688_N100391694174705141\">In this example, the flow has the ID: <span class=\"dialog\">email-change<\/span>.<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N10023\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create steps for the email address registration flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594199615688_N10028\">The first step is to create a <span class=\"dialog\">User Data Edit Step<\/span> plugin. It allows the user to enter context data and it can be configured which data items the user may supply.<\/p><p class=\"par\" id=\"1594199615688_N1002A\">The details of the configuration of the data edit step for the email address very much depend on the requirements and on the desired user experience.<\/p><p class=\"par\" id=\"1594199615688_N1004F\">In our example, we use the email address as an alias for the username and we require all users to use the alias so that we can use an internal identifier for the username. <\/p><p class=\"par\" id=\"1594199615688_N1004F1694174705141\">To support this use case, the <span class=\"dialog\">User Data Edit Step<\/span> is configured as follows:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Required \u2013 enabled, to enforce providing an e-mail address.<\/li><li class=\"enum-element\">Unique \u2013 enabled, to prevent duplicate conflicts in the alias\' of different users.<\/li><li class=\"enum-element\">Enable Stealth Mode \u2013 enabled, to protect against e-mail enumeration.<\/li><li class=\"enum-element\">Maximum Input Length \u2013 the default is 100 characters.<\/li><li class=\"enum-element\">The validator is empty because the default validator already checks for a well-formed e-mail address. Configure a regex validator if you require additional validation.<\/li><\/ul><p class=\"par\" id=\"1594199615688_N10037\">The next step will validate the information provided by the user. <\/p><p class=\"par\" id=\"1594199615688_N10039\">This example validates the e-mail address by sending an e-mail message to this address. The E-Mail Change Verification Step plugin will do just that. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">It requires some configuration:<\/strong><\/li><li class=\"enum-element\"><span class=\"dialog\">E-Mail Item<\/span> - This is the same plugin as was used in the User Data Edit step. It is required here to ensure that the stealth mode configuration is honored correctly in the verification step.<\/li><li class=\"enum-element\"><span class=\"dialog\">E-Mail Address Provider<\/span> - To verify the e-mail address supplied by the user in the first step. Use the Changed E-Mail Address Provider. <\/li><li class=\"enum-element\"><span class=\"dialog\">E-Mail Service<\/span> - Provide an SMTP Emal Service Plugin to send out the verification e-mail message.<\/li><li class=\"enum-element\"><span class=\"dialog\">OTP Generator<\/span> - Verification requires the user to manually enter a code obtained from the e-mail message sent. Configure the generator for this code in this plugin.<\/li><li class=\"enum-element\"><span class=\"dialog\">E-Mail Message Provider<\/span> - configures the e-mail message to be sent to the user. Subject and Body used here are the default values for the <span class=\"dialog\">E-Mail Address Change<\/span> flow. In the value providers, the <span class=\"dialog\">Context Data Map<\/span> should be configured to address the user with his name and the <span class=\"dialog\">Value Provider Map<\/span> is used to inject the correct value for new_email into the message. <\/li><\/ul><p class=\"par\" id=\"1594199615688_N100A5\">The last step of the flow is the persistence of the newly provided and successfully validated e-mail address. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This works as follows:<\/strong><\/li><li class=\"enum-element\">Create a new step with an <span class=\"dialog\">Apply Changes Step<\/span>.<\/li><li class=\"enum-element\">In this step choose the <span class=\"dialog\">Apply E-Mail Change<\/span> as the handler.<\/li><li class=\"enum-element\">In the plugin select the \'email\' entry for the <span class=\"dialog\">Context Data Name<\/span>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N10045\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configure the Loginapp UI for the email address registration flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594199615688_N1004A\">Once the flow has been created it can be used by clients through the REST interface. To enable the flow in the Loginapp, the <span class=\"dialog\">UI Settings<\/span> must be adapted as well.<\/p><p class=\"par\" id=\"1594199615688_N100A8\">Create a new <span class=\"dialog\">Protected Self-Service UI<\/span> plugin in the <span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Protected Self-Service UIs<\/span>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">When you configure this plugin, you have the following options:<\/strong><\/li><li class=\"enum-element\">Select the flow ID for which the UI should be generated.<\/li><li class=\"enum-element\">Provide customized UIs for particular steps (optional)<\/li><li class=\"enum-element\">Decide if Cancel or Goto buttons should be visible to the user<\/li><li class=\"enum-element\">Configure a maintenance message UI (if required)<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Also in the UI configuration, you may choose where the UI will redirect the user:<\/strong><\/li><li class=\"enum-element\">on successful completion of the flow<\/li><li class=\"enum-element\">on cancellation of the flow<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N100E5\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594199615688_N100E8\">Care should be taken when configuring self-registration flows for accounts with alias usernames without verification steps. Such setups are subject to race conditions and it may be possible for an attacker to generate multiple user accounts with the same alias. While such accounts are unusable and will not affect the normal operation of Airlock IAM, it is not desirable for an attacker to be able to create them.<\/p><p class=\"par\" id=\"1594199615688_N100EA\">To avoid this problem, it is possible to configure a unique index on the database to force all attributes in the username alias to be unique. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594199615688_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945413.html\">Loginapp UI<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';