var m_1594636413808Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Register Device Token<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636413808\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Register Device Token<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636413808_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636413808_N102AC\">To perform the following call, the REST client must generate an EC key pair and provide the EC public key in JWK form (see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/tools.ietf.org\/html\/rfc7517\" target=\"_blank\">RFC7517<\/a> for JWK). <br\/>The private key must be stored securely in the client and must be suitable to use the configured JWT signing algorithm i.e. ES256, ES256K, ES384 or ES512 (see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/tools.ietf.org\/html\/rfc7518\" target=\"_blank\">RFC7518<\/a>\u00A0for algorithm names and <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/tools.ietf.org\/html\/rfc7519\" target=\"_blank\">RFC7519<\/a> for JWT).<\/p><p class=\"par\" id=\"1594636413808_N102E9\">The serial ID and the label are optional and only used for device token management in order to \"recognize\" a device token.<\/p><p class=\"par\" id=\"1594636413808_N102EB\"><strong class=\"emphasis\">HTTP Request: Register device token public key<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102EE\">POST \/auth-login\/rest\/protected\/my\/tokens\/device-tokens\/\r\n\r\n{\r\n\t\"data\" : {\r\n\t\t\"attributes\" : {\r\n\t\t    \"label\" : \"My iPhone 9\",\r\n\t\t    \"serial\" : \"abcd28287462910299374\",\r\n\t\t    \"publicJwk\" : {\r\n\t\t\t    \"crv\" : \"P-521\",\r\n\t\t\t    \"x\" : \"APH6qoL85V5FLvzlxUDrIiBiBRRh0utD35l6mk2cNEVvgv113KaMIruC7rhKqnkDSpPGGdXVVjc4X2TQje4R3QQ6\",\r\n\t\t\t    \"y\" : \"ARZsiXSiHWq0UghIFqWLBhh6sq4Lf11o_qXWESlIE1PapKfkJRhU8ThskAdO3k8tL9ESBI0AbrLXttVne-kyF8CN\",\r\n\t\t\t    \"kty\" : \"EC\"\r\n\t\t    }\r\n\t\t},\r\n\t\t\"type\" : \"my.token.device-token.add\"\r\n\t}\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594636413808_N102F0\"><strong class=\"emphasis\">HTTP Response: Reflects registered device token<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102F3\">HTTP\/1.1 200 OK\r\n\r\n{\r\n    \"meta\": {\r\n        \"type\": \"jsonapi.metadata.document\",\r\n        \"timestamp\": \"2018-02-13T09:26:26.884+01:00\"\r\n    },\r\n    \"data\": {\r\n        \"type\": \"my.token.device-token\",\r\n        \"id\": \"110\",\r\n        \"attributes\": {\r\n            \"validTo\": \"2018-03-15T09:26:26.789+01:00\",\r\n            \"serial\": \"abcd28287462910299374\",\r\n            \"label\": \"My iPhone 9\"\r\n        }\r\n    }\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636413808_N102F8\">The REST client must store the device token ID - 110 in the above example - with the private key. It is needed when using the key in device token authentication (see below).<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636413808_N102FA\">The <span class=\"dialog\">validTo<\/span> attribute tells the REST client how long the device token is valid. After the valid-to date, IAM will no longer accept the device token and the REST client must register a new key (or re-register the same).<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';