var m_1594636414240Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Flow Engine interaction with REST API <\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636414240\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Flow Engine interaction with REST API <\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636414240_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636414240_N101CD\">The following diagram gives a schematic view of how the flow engine processes flow steps and how the flow engine interacts with the REST API.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636414240_N101D2\">The example below illustrates the fact, that the flow steps configured in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> do not correspond one-to-one to REST requests and responses. Each REST request calls exactly one interactive step method. If the REST request is successful one or more init methods of the following steps will be processed automatically until the next interactive step is encountered. Only at this point, the REST response is sent back to the client.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Thus the response to a request may be sent back by either of the following:<\/li><li class=\"enum-element\">by the method of the step that processed the request.<\/li><li class=\"enum-element\">by a different method of the step that processed a request.<\/li><li class=\"enum-element\">by the init method of a subsequent step in the flow.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594636414240_N101D6\">This\u00A0diagram\u00A0reuses the example flow sequence presented in\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945410.html\">User self-registration REST API<\/a>:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1594636414240_N102C9\"><img alt=\"118883201.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/_c3_9cberarbeitete_Altdaten\/references\/mediaset\/PNG\/1x\/118883201.png.theme\/1.5\/en-us.118883201.png_html.png\" style=\"width:;height:1071px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1594636414240_N101ED\">The schematic above illustrates a sequence of flow steps and highlights some of the options that the designer of a flow may consider. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Of particular interest are the following aspects:<\/strong><\/li><li class=\"step\">The flow is started by a REST call to the <code class=\"codeinline\">registration\/data<\/code>\u00A0endpoint.<\/li><li class=\"step\">The flow state machine initializes itself to handle this particular self-registration flow.<\/li><li class=\"step\">The flow is started with the <span class=\"dialog\">INIT<\/span>\u00A0method\u00A0of the <span class=\"dialog\">registration data<\/span> step.<\/li><li class=\"step\">Control is handed back to the <span class=\"dialog\">Flow State Machine<\/span> and since the REST request is for the <code class=\"codeinline\">registration\/data<\/code>\u00A0endpoint\u00A0the <span class=\"dialog\">registration data<\/span>\u00A0method\u00A0is immediately called. The method processes the attributes. In this example, the validation is not successful. The failure including the reason for the failure is reported back to the <span class=\"dialog\">User Client<\/span> as a REST response. In the REST response,\u00A0<code class=\"codeinline\">USER_DATA_REGISTRATION_REQUIRED<\/code>\u00A0is indicated as the only next step possible at this point in the flow.<\/li><li class=\"step\">The client sends another REST Request to the <code class=\"codeinline\">registration\/data<\/code>\u00A0endpoint\u00A0and this time supplies the full\/correct set of attributes. The <span class=\"dialog\">Flow State Machine<\/span> calls the method with the attributes from the REST request. The method validates successfully and returns a successful response. In the REST response, the method returns\u00A0<code class=\"codeinline\">USER_DATA_REGISTRATION_POSSIBLE<\/code>\u00A0to indicate that both <code class=\"codeinline\">registration\/data<\/code> and <code class=\"codeinline\">continue<\/code> are possible as next request.<\/li><li class=\"step\">The client sends a REST request to the <code class=\"codeinline\">registration\/continue<\/code>\u00A0endpoint. The <span class=\"dialog\">Flow State Machine<\/span> supplies the information to the <code class=\"codeinline\">continue<\/code>\u00A0method\u00A0of the <span class=\"dialog\">registration data<\/span> step. This method reports success back to the flow state machine.<\/li><li class=\"step\">The <span class=\"dialog\">Flow State Machine<\/span> immediately calls the <span class=\"dialog\">INIT<\/span>\u00A0endpoint\u00A0of the <span class=\"dialog\">generate username<\/span> step. This step generates a username and returns a successful response to the <span class=\"dialog\">Flow State Machine<\/span>.<\/li><li class=\"step\">The\u00A0<span class=\"dialog\">Flow State Machine<\/span> immediately calls the <span class=\"dialog\">INIT<\/span>\u00A0method\u00A0of the <span class=\"dialog\">email otp<\/span> check step. The <span class=\"dialog\">INIT<\/span> method generates an email message with an OTP code to be sent to the email address supplied during the <span class=\"dialog\">registration data<\/span> step. It then creates a successful response to the <span class=\"dialog\">User Client<\/span> and indicates that <span class=\"dialog\">email otp check<\/span> is the only next step possible in the flow.\u00A0<\/li><li class=\"step\">The <span class=\"dialog\">User Client<\/span> sends a REST request to the <code class=\"codeinline\">verification\/email\/otp\/check<\/code>\u00A0endpoint\u00A0containing the OTP code. The\u00A0<span class=\"dialog\">Flow State Machine<\/span> calls the <span class=\"dialog\">email otp check<\/span> method with the OTP code as an attribute. The method verifies the OTP code and verification fails. A REST response is sent to the <span class=\"dialog\">User Client<\/span> indicating a failure and the failure reason. As a next step, the <span class=\"dialog\">email otp check<\/span> method is offered.<\/li><li class=\"step\">The client\u00A0creates a second REST request to the <code class=\"codeinline\">verification\/email\/otp\/check<\/code>\u00A0endpoint\u00A0containing the correct OTP code. <span class=\"dialog\">The\u00A0Flow State Machine<\/span> calls the <span class=\"dialog\">email otp check<\/span>\u00A0method\u00A0with the OTP code as an attribute.\u00A0The method verifies the OTP code and verification\u00A0succeeds.\u00A0This triggers the flow state machine to automatically continue with the next step.<\/li><li class=\"step\">The <span class=\"dialog\">INIT<\/span>\u00A0method\u00A0of the <span class=\"dialog\">registration data<\/span> step is for an interactive step. It creates a REST response for the success of the previous step and uses <code class=\"codeinline\">USER_DATA_REGISTRATION_REQUIRED<\/code> to demand a password to be supplied.\u00A0<\/li><li class=\"step\">The client creates a REST request to <code class=\"codeinline\">registration\/data<\/code> to supply a password. The password\u00A0method\u00A0processes the supplied password and sends back a REST response indicating success. As a next step, a call to continue is required.<\/li><li class=\"step\">The client creates a REST request for the <code class=\"codeinline\">registration\/continue<\/code>\u00A0endpoint. The flow state machine calls the continue method registration data step. This method reports success to the flow state machine.<\/li><li class=\"step\">The flow state machine immediately calls the <span class=\"dialog\">INIT<\/span>\u00A0method\u00A0of the\u00A0<span class=\"dialog\">user persisting<\/span> step.\u00A0The <span class=\"dialog\">user persisting<\/span> step writes the user information to the data store, creates a REST response to the client indicating success, and reports a success back to the flow state machine.\u00A0<\/li><li class=\"step\">The flow state machine terminates the flow.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';