var m_1594636415664Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Flow tags and red flags<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636415664\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Flow tags and red flags<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415664_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415664_N100A1\">Tags are properties acquired during a flow and they are stored in the flow session. Tags can be used to control the flow and act as guards ensuring particular steps have successfully completed.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following attributes are stored in the flow session for each tag:<\/li><li class=\"enum-element\">name<\/li><li class=\"enum-element\">issue date<\/li><li class=\"enum-element\">timeout (optional)<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Currently, the following timeouts are supported: <\/li><li class=\"enum-element\"><span class=\"dialog\">Tag Lifetime<\/span> \u2013 the tag expires after a configurable amount of time after it was issued.<\/li><li class=\"enum-element\"><span class=\"dialog\">Tag Idle Timeout<\/span> \u2013 the tag expires after a configurable amount of time the HTTP session on the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> was idle.<\/li><\/ul><\/ul><p class=\"par\" id=\"1594636415664_N100B4\">Typical examples of tag names are <span class=\"dialog\">PASSWORD_VERIFIED<\/span> or <span class=\"dialog\">MTAN_VERIFIED<\/span>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415664_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Acquiring tags<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415664_N100BB\">Tags are issued by IAM\u00A0upon successful completion of a step. The configuration property\u00A0<span class=\"dialog\">Tags On Success<\/span> in the step configuration defines what tags are issued by the step.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415664_N10035\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Tag usage<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Tags are for example used for the following (excerpt):<\/li><li class=\"enum-element\">Preconditions on flow steps<\/li><p class=\"par\" id=\"1594636415664_N100F5\">Similar to assertions, tags can be defined as preconditions on steps. A step cannot be entered unless the required tags are available in the session.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415664_N100CE\"><strong class=\"emphasis\">Security Hint<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415664_N100D1\">We recommend using step preconditions to validate security properties on flows. For example, use tags to make explicit that a step can only be entered in case the condition <span class=\"dialog\">PASSWORD_VERIFIED<\/span> holds.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415664_N1006D\">These kinds of guarantees, a.k.a. <i class=\"italics\">guards<\/i>, especially help to keep complex flows securely.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">Skip conditions on flow steps<\/li><p class=\"par\" id=\"1594636415664_N10106\">Tags are used in skip conditions in the step configuration. A step is skipped if the corresponding skip condition is fulfilled. To skip a step if one or more tags are present in the flow, use the <span class=\"dialog\">Has Tag<\/span> condition. This concept is for example used to implement step-up authentication.<\/p><li class=\"enum-element\">Flow control with selection<\/li><p class=\"par\" id=\"1594636415664_N1007E\">Like with the skip conditions, the <span class=\"dialog\">Has Tag<\/span> condition can be used to control the flow in <i class=\"italics\">selections<\/i> (see separate article).<\/p><li class=\"enum-element\">Identity Propagation<\/li><p class=\"par\" id=\"1594636415664_N1008F\">Tags can be used to propagate roles and permissions in identity propagation.<\/p><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415664_N10090\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Flow sessions and tag timeouts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415664_N10093\">When a flow is started, tags from the session are copied to the flow so the flow can use tags acquired in previous flows. This is, for example, essential when implementing step-up authentication.<\/p><p class=\"par\" id=\"1594636415664_N10095\">Similarly, tags acquired during a flow are copied to the session after the flow has successfully completed.<\/p><p class=\"par\" id=\"1594636415664_N10097\"><i class=\"italics\">Tag timeouts<\/i> define how long a tag is valid.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Currently, the following timeout types are supported: <\/li><li class=\"enum-element\"><span class=\"dialog\">Tag Lifetime<\/span>: the tag expires after a configurable amount of time after it was issued.<\/li><li class=\"enum-element\"><span class=\"dialog\">Tag Idle Timeout<\/span>: the tag expires after a configurable amount of time the HTTP session on the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> was idle.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415664_N100BA\">Note that timeouts are evaluated only on the tags in the session and not on the tags issued during the flow. New tags are only evaluated with regard to timeouts once they have been copied to the session.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415664_N10023\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Red flags<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415664_N10133\">Red flags have some similarities with tags in the sense that flow steps may raise and consume them. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are however several aspects where red flags differ from tags:<\/strong><\/li><li class=\"enum-element\">Red flags only exist in the context of a flow. The red flag must be raised and consumed within the same flow.<\/li><li class=\"enum-element\">Failure to consume a red flag before the end of a flow forces this flow to fail with a corresponding\u00A0error.<\/li><li class=\"enum-element\">Red flags have a clear semantic: Only specific steps may raise a particular red flag and only specific steps may consume this red flag.<\/li><\/ul><p class=\"par\" id=\"1594636415664_N1014B\"><strong class=\"emphasis\">Example:<\/strong> <\/p><p class=\"par\" id=\"1594636415664_N101C3\">A typical example of a red flag is the mandatory password change. Steps, e.g. the <span class=\"dialog\">Username Password Authentication Step<\/span> raises the red flag <span class=\"dialog\">MANDATORY_PASSWORD_CHANGE<\/span> to indicate that a subsequent step must execute a mandatory password change. This is normally handled by the <span class=\"dialog\">Mandatory Password Change<\/span> step. If no step consumes the flag, the flow fails.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';