var m_1594636415731Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Goto (flow concept)<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636415731\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Goto (flow concept)<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N10184\"><i class=\"italics\">Goto<\/i> describes the process of jumping from one step to another independently of the configured step order. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N10013\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">The Goto concept<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N10016\">A Goto jump has a <i class=\"italics\">source step<\/i> and a <i class=\"italics\">target step<\/i>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Source step<\/li><li class=\"enum-element\">A source step can have several potential Goto <i class=\"italics\">targets. <\/i>They are configured in the source step.<\/li><li class=\"enum-element\">Pre- and skip conditions of source steps are evaluated: If the evaluation of a precondition fails, the flow is aborted. If the evaluation of a skip condition succeeds, the step is skipped.<\/li><li class=\"enum-element\">Source steps that are left by a Goto are <i class=\"italics\">aborted<\/i> in the sense that they will not provide a successful step result and therefore will never add tags to the flow.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Target step<\/li><li class=\"enum-element\">The target step has a <i class=\"italics\">step ID,<\/i> which must be unique within the flow.\u00A0<\/li><li class=\"enum-element\">Pre- and skip conditions of target steps are evaluated.\u00A0<\/li><li class=\"enum-element\">If the evaluation of a precondition fails, the flow is aborted. If the evaluation of a skip condition succeeds, the step is skipped and flow processing continues normally.<\/li><\/ul><p class=\"par\" id=\"1594636415731_N1003F\">Goto jumps to steps\u00A0other than the configured targets or to targets outside of the flow are prohibited.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N1003C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Interactive Goto<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N101A7\">For interactive steps, the Goto target\'s endpoint can be used to instruct the flow processor to continue with a different step.\u00A0The target step may be interactive or non-interactive.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example:<\/li><li class=\"enum-element\">An authentication flow has been started and the user is on the <span class=\"dialog\">Username Password Authentication Step<\/span>.<\/li><li class=\"enum-element\">The user provides the correct credentials and the flow automatically continues to the <span class=\"dialog\">mTAN Authentication Step<\/span>.<\/li><li class=\"enum-element\">The user decides to use a different second factor.<\/li><li class=\"enum-element\">Using the Goto-Targets endpoint the list of possible target steps is retrieved. The user selects email OTP from the list.<\/li><li class=\"enum-element\"> Using the Goto-Target endpoint the flow is instructed to continue flow processing with the chosen target step.<\/li><li class=\"enum-element\">The user receives an email, provides the correct code, and is then authenticated.  <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goto REST endpoints<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N100691642688360364\">For every flow type, a REST endpoint supporting two methods is exposed. They are used to retrieve possible Goto targets and follow a goto, i.e., tell the flow state machine what step to process next.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">...\/goto-targets\/retrieve\/<\/code> \u2013 retrieve all valid Goto targets steps for the current step.<\/li><li class=\"enum-element\"><code class=\"codeinline\">...\/goto-targets\/&lt;stepId&gt;\/goto\/<\/code> \u2013 jump to the specified Goto target step.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N1004B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Non-interactive Goto<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N101B2\">Gotos can be triggered programmatically by any flow step. In this case, this step will act as a Goto source.<\/p><p class=\"par\" id=\"1594636415731_N101B4\">For non-interactive flow steps, the programmatically triggered Goto is the only way the step can act as a Goto source: The Goto target\'s endpoint cannot be used for this step, as flow execution is non-interactive (not REST calls).<\/p><p class=\"par\" id=\"1594636415731_N101B6\">A programmatically triggered Goto may use both interactive and non-interactive steps as Goto targets.<\/p><p class=\"par\" id=\"1594636415731_N101B8\"><strong class=\"emphasis\">Custom steps<\/strong><br\/>Custom step config classes need to extend <code class=\"codeinline\">AbstractInteractiveFlowStepConfig<\/code> to be capable to perform an interactive Goto. Internal Gotos can always be performed by adding an <code class=\"codeinline\">InternalGotoTargetConfig<\/code> to any custom step config and implementing the\u00A0<code class=\"codeinline\">getInternalGotoTargets()<\/code> method to return these targets.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N10069\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Failed Goto<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636415731_N101CA\">It is possible to configure Gotos as a failure. This has the same effect as a normal Goto but can lead to increased failure counters. In flows that support failure counters, e.g. authentication and transaction approval flows, executing a failing Goto leads to increasing the currently active failure counter on the database, possibly locking the user.<\/p><p class=\"par\" id=\"1594636415731_N101DB\"><strong class=\"emphasis\">Example: <\/strong><br\/>Using a failing Goto in the authentication example above prevents the user from unlimited switches between mTAN and email OTP. This prevents an unlimited number of SMS messages from being sent.\u00A0<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636415731_N10078\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goto security considerations<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415731_N101E7\"><strong class=\"emphasis\">Count failures<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415731_N101EA\">Configuring Gotos may lead to a user being able to execute parts of a flow an unlimited number of times. If this compromises the security, e.g. by allowing a brute-force attack, use transitions as described above to lock the user after a limited number of Gotos.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415731_N101FE\"><strong class=\"emphasis\">Avoid complex flows<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636415731_N10201\">Gotos allow for a lot of flexibility. On the other hand, if Goto transitions are used heavily, this may lead to complex flows. In particular, configurations may be difficult to understand and without careful analysis, it may be hard to anticipate security bugs introduced through minor configuration changes. <\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Therefore, we recommend:<\/li><li class=\"enum-element\">For the use cases that employ Gotos, make sure these use cases are well-defined and easy to understand.<\/li><li class=\"enum-element\">Perform in-depth security analysis of your flow. Analyze the flow again after changing the configuration.<\/li><li class=\"enum-element\">Favor explicit flow constructs over Gotos. For example, use a selection step instead of modeling selection using Gotos.\u00A0<\/li><li class=\"enum-element\">Use Fail Gotos whenever repeating a Goto has negative Security implications (see above).\u00A0<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';