var m_1594636416175Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Configuration using JWT bearer tokens<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636416175\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Configuration using JWT bearer tokens<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416175_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636416175_N10009\">This article describes how to configure <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> and <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> for using JWT bearer tokens with one-shot authentication.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416175_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Client authentication and identity propagation in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Use flow-based authentication:\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435033143.html\">Authentication REST API<\/a><\/li><li class=\"enum-element\">Enable header-based session tracking in Airlock Gateway<\/li><\/ul><p class=\"par\" id=\"1594636416175_N1004E\">To enable header-based session tracking in Airlock Gateway, consider the following example (expert settings in a mapping):<\/p><pre class=\"code\" id=\"N10050\">Session.Tracking.HeaderToken.Enable                               \"TRUE\"\r\nSession.Tracking.HeaderToken.Response.Header.Name                 \"Access-Token\"\r\nSession.Tracking.HeaderToken.Request.Header.Name                  \"Authorization\"\r\nSession.Tracking.HeaderToken.Request.Header.Value.Pattern         \"^Bearer ([[:graph:]]+)$\"\r\nSession.Tracking.HeaderToken.Request.Header.Value.IgnoreCase      \"TRUE\"\r\nSession.Tracking.HeaderToken.Request.Header.Value.Template        \"$1\"<\/pre><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Add a target application for the protected service and configure it (authentication flow, <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> roles\/credentials).\u00A0<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the target application configuration, configure identity propagation such that a JWT is sent to the REST client:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Use an <span class=\"dialog\">HTTP Response Header Identity Propagator<\/span> plugin (within the <span class=\"dialog\">REST Identity Propagator<\/span>).<\/li><li class=\"enum-element\"><span class=\"dialog\">Headers<\/span>: use plugin <span class=\"dialog\">Encoded User Data Response Header<\/span>.<\/li><li class=\"enum-element\"><span class=\"dialog\">Header name<\/span>: do\u00A0<i class=\"italics\">not<\/i> use the same header as configured for session tracking in Airlock Gateway (see above).<\/li><li class=\"enum-element\"><span class=\"dialog\">Ticket Service<\/span>: use the <span class=\"dialog\">Mapping Ticket Service<\/span> and add the desired information to it (remember that it gets sent to the REST client!)<\/li><li class=\"enum-element\"><span class=\"dialog\">Ticket Encoder<\/span>: use the <span class=\"dialog\">JWT Ticket Encoder<\/span> with adequate cryptographic protection (signature and\/or encryption). Choose a reasonably short validity period.<\/li><\/ul><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416175_N10092\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">One-Shot end-point in IAM<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636416175_N10095\">Go to: <span class=\"dialog\">Loginapp<\/span>\u00A0&gt;&gt; <span class=\"dialog\">One-Shot Authentication<\/span><\/p><p class=\"par\" id=\"1594636416175_N100A0\">Add a target application for the protected service and configure it as follows:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"dialog\">Credential Extractor<\/span>: use plugin <span class=\"dialog\">HTTP Header Token Extractor (as SSO Credential)<\/span> with the <span class=\"dialog\">JWT Ticket Encoder<\/span>.<\/li><li class=\"enum-element\"><span class=\"dialog\">Authenticator<\/span>: use the plugin <span class=\"dialog\">SSO Credential Authenticator<\/span>.<\/li><li class=\"enum-element\"><span class=\"dialog\">Failure Responses<\/span>: configure responses as desired - always use responses of type <span class=\"dialog\">FINAL_RESPONSE<\/span>\u00A0<\/li><li class=\"enum-element\"><span class=\"dialog\">Identity Propagator<\/span>: as required by back-end application<\/li><li class=\"enum-element\"><span class=\"dialog\">URL pattern<\/span>: according to the back-end application<\/li><li class=\"enum-element\"><span class=\"dialog\">Header Value Conversion Pattern<\/span> and <span class=\"dialog\">Header Value Conversion Replacement:<\/span> optionally configure a string conversion of the header (i.e. to remove the token name).<\/li><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636416175_N1029F\"><strong class=\"emphasis\">Shared One-Shot Configuration<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636416175_N102A2\">The one-shot settings can be used for multiple protected services.  Choose the <span class=\"dialog\">URL pattern<\/span> property to match all services for which the same settings apply.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416175_N100D8\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><strong class=\"emphasis\"><span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> Configuration<\/strong><\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Make sure there is an IAM mapping and <span class=\"dialog\">One-Shot Functionality<\/span> is enabled in the allow rule list.<\/li><li class=\"enum-element\">Add a <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Gateway<\/span> mapping for the service\/API to be protected<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set <span class=\"dialog\">Denied access URL<\/span> to\u00A0<code class=\"codeinline\">\/&lt;iam-mapping-entry-path&gt;\/login-oneshot<\/code>.<\/li><li class=\"enum-element\">From the <span class=\"dialog\">Authentication flow<\/span> drop-down, select <span class=\"dialog\">One-Shot<\/span>.<\/li><\/ul><li class=\"enum-element\">Enable <span class=\"dialog\">Bearer Token Session Tracking<\/span> on the IAM mapping and on the mappings of the protected services: see above<\/li><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594636416175_N102BF\">JWTs can become quite large. Therefore it is advisable to increase the maximum length of the session tracking header in the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> (Mapping Security Gate Expert Settings):<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N102C1\">Session.Tracking.ExternalToken.MaxLength                  \"1024\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';