var m_1594636416249Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Recommendations for using OAuth and OIDC<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594636416249\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Recommendations for using OAuth and OIDC<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416249_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">OAuth 2.0\/OpenID Connect in general<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636416249_N1017B\">OAuth 2.0 \/ OpenID Connect must be considered a framework for designing solutions to delegate access. The framework allows for a lot of flexibility. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">For any solution designed in this framework, be aware of the following:<\/strong><\/li><li class=\"step\">The fact that a solution follows the OAuth 2.0 specification <strong class=\"emphasis\">does not imply that the solution is secure<\/strong>. To obtain secure solutions, one must specifically design them for the security requirements at hand and ensure their security using appropriate measures such as, but not limited to: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">security consulting, <\/li><li class=\"enum-element\">internal and external security reviews in the design, <\/li><li class=\"enum-element\">implementation and integration phase,<\/li><li class=\"enum-element\">penetration tests.<\/li><\/ul><li class=\"step\">The framework has been designed to allow access delegation. However, OAuth 2.0 is often employed to implement single sign-on (i.e., to achieve authentication goals). <strong class=\"emphasis\">Historically, this has led to many vulnerable authentication solutions<\/strong>. We would like to stress our recommendation (1.), especially in this case.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416249_N10020\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">OAuth 2.0\/OpenID Connect in mobile applications<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594636416249_N1018B\">Over the past few years, the use of OAuth 2.0\/OpenID Connect for mobile applications has increased drastically. This led to a variety of vulnerable implementations. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">In particular, the following points are important for secure implementations:<\/strong><\/li><li class=\"step\">The OAuth 2.0 framework heavily relies on browser redirects. If this mechanism is omitted or replaced by other mechanisms in mobile applications, these solutions are prone to be insecure.<\/li><li class=\"step\">Public native app clients should implement the <i class=\"italics\">Proof Key for Code Exchange<\/i> (PKCE) extension to OAuth. Airlock IAM as authorization servers should be configured to use PKCE support to secure the authorization process.<\/li><li class=\"step\">OAuth 2.0 authorization requests from native apps should only be made through external user agents, i.e., the user\'s browser.<\/li><li class=\"step\">Using the Implicit Grant has led to insecure solutions. This grant type is not recommended for mobile applications.<\/li><li class=\"step\">The general points discussed in the previous subsection.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594636416249_N10044\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/tools.ietf.org\/html\/rfc8252\" target=\"_blank\">(IETF) RFC 8252 -  OAuth 2.0 for Native Apps<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/tools.ietf.org\/html\/rfc7636\" target=\"_blank\">RFC 7636 \u2013 Proof Key for Code Exchange by OAuth Public Clients<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';