var m_1594920812947Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Mapping for the bank API calls<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920812947\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Mapping for the bank API calls<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920812947_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920812947_N10141\">For each type of bank API call (e.g. \"\/accounts\", \"\/payments\", \"\/consents\"\/) a mapping with the following PSD2-specific settings must be configured and connected to the just created virtual host.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Define a mapping matching the corresponding API calls (e.g. \"\/accounts\")<\/li><li class=\"step\">Configure all security rules (Allow Rules, Deny Rules, API Security, etc.), \"Request Actions\" and \"Response Actions\" required by the bank\'s APIs.<\/li><div xmlns=\"\" class=\"container-warning advice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_advice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920812947_N1014E\">Consider the following settings - they have proven to work in practice. It does not claim to be complete.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Define (and use) an allow rule allowing HTTP methods \"GET\", \"POST\", \"PUT\", and \"DELETE\". The default \"Allow all\" only allows \"GET\" and \"POST\".<\/li><li class=\"enum-element\">In addition to the\u00A0headers in the \"(default) Request header whitelist\"\u00A0 \"<code class=\"codeinline\">|Digest|Signature|ASPSP-SCA-Approach|Consent-ID<\/code>\".<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Restrict access to the mapping based on the TPP roles (exactly as in the TPP\'s client certificate).\u00A0The following table lists the typical access restriction settings:<\/li><table border=\"0\" cellspacing=\"0\" class=\"table table table- table- table-\" id=\"1594920812947_N1015C\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10170\">Mapping Name<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10173\">Entry Path<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10176\">Typically restricted to roles<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1017A\">xs2a-accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N1017D\">\/v1\/accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10180\">PSP_AI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10184\">xs2a-card-accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10187\">\/v1\/card-accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1018A\">PSP_AI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1018E\">xs2a-consents<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10191\">\/v1\/consents<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10194\">PSP_AI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10198\">xs2a-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N1019B\">\/v1\/payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1019E\">PSP_PI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101A2\">xs2a-bulk-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N101A5\">\/v1\/bulk-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101A8\">PSP_PI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101AC\">xs2a-periodic-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N101AF\">\/v1\/periodic-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101B2\">PSP_PI<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101B6\">xs2a-funds-confirmations<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N101B9\">\/v1\/funds-confirmations<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101BC\">PSP_IC<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101C0\">xs2a-signing-baskets<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N101C3\">\/v1\/signing-baskets<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N101C6\">PSP_AI, PSP_IC<\/p><\/div><\/td><\/tr><\/tbody><\/table><li class=\"step\">Select Authentication Flow \"One-Shot with body\" (the body is required for IAM to be able to verify the HTTP request signatures)<\/li><li class=\"step\">Define the \"Denied access URL\" such that it points to Airlock IAM\'s one-shot endpoint. Typically: \"\/auth\/login-oneshot\".<\/li><li class=\"step\">The \"Session handling\" setting must be set to \"Sessionless\"<\/li><li class=\"step\">Ensure that \"SSL client certificate\" is set to \"Inherit from Virtual Host\"<\/li><li class=\"step\">Add the following \"Apache Expert Setting\" to the mapping:\u00A0<code class=\"codeinline\">RequestHeader set AL_ENV_REQUEST_LINE expr=%{THE_REQUEST}<\/code><\/li><p class=\"par\" id=\"1594920812947_N102A1\">This is required for IAM to be able to verify the HTTP request signatures.<\/p><li class=\"step\">Enable \"Send environment cookies\" (this is also required\u00A0for IAM to be able to verify the HTTP request signatures.)<\/li><li class=\"step\">Create a HTTP Header whitelist to allow non-standard HTTP headers required by NextGenPSD2 (for HTTP signature verification):<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Copy the \"(default) Request header whitelist\" (click on \"customize this action\")<\/li><li class=\"step\">Add the following headers to the customized action (initially called \"Copy of (default) ...\"):<code class=\"codeinline\">|Date|X-Request-Id|PSU-.*|TPP-.*<\/code><\/li><li class=\"step\">Enable the new whitelist<\/li><li class=\"step\">Disable the \"(default) Request header whitelist\"<\/li><\/ol><li class=\"step\">To allow the \"Signature\" and the \"TTP-Signature-Certificate\" headers, you need to add the following deny rule exceptions:<\/li><table border=\"0\" cellspacing=\"0\" class=\"table table table- table- table-\" id=\"1594920812947_N10204\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1021C\">for <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> Versions<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N1021F\">with deny rule \"Security Level\"<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10222\">add exception to \"Deny Rule\"<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10225\">using \"Header Name Pattern\"<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812947_N1022A\">all<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N1022D\">Strict (recommended)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N10230\">(default HTML_003b) HTML attribute in quoted context in HTTP header value<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812947_N10234\"><code class=\"codeinline\">^Signature$<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10239\">Standard<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812947_N1023C\">(default HTML_004b) Known HTML attribute in quoted context in HTTP header value<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-innerrow table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812947_N10241\">&gt;= 7.1<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innerrow table-cell-innercol table-cell-col-even-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812947_N10245\">Strict<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innerrow table-cell-innercol table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812947_N10249\">(default SAN_060b) Header value longer than 300 characters<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N1024C\"><code class=\"codeinline\">^Signature$<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812947_N10251\"><code class=\"codeinline\">^TPP-Signature-Certificate$<\/code><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';