var m_1594920812995Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Mapping for the bank API calls<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920812995\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Mapping for the bank API calls<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920812995_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920812995_N100EE\">For each type of bank API call (e.g. \"\/accounts\", \"\/payments\", \"\/consents\"\/) a mapping with the following PSD2-specific settings must be configured and connected to the virtual host just created.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Define a mapping matching the corresponding API calls (e.g. \"\/accounts\")<\/li><li class=\"step\">Configure all security rules (Allow Rules, Deny Rules, API Security, etc.), \"Request Actions\" and \"Response Actions\" required by the bank\'s APIs.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920812995_N100FB\">Consider the following settings - they have proven to work in practice. It does not claim to be complete.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Define (and use) an allow rule allowing HTTP methods \"GET\", \"POST\", \"PUT\", and \"DELETE\". The default \"Allow all\" only allows \"GET\" and \"POST\".<\/li><li class=\"enum-element\">In addition to the\u00A0headers in the \"(default) Request header whitelist\"\u00A0 \"<code class=\"codeinline\">|Digest|Signature|ASPSP-SCA-Approach|Consent-ID<\/code>\".<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Restrict access to the mapping based on the TPP roles (exactly as in the corresponding OAuth scope).\u00A0<\/li><p class=\"par\" id=\"1594920812995_N1013F\"><strong class=\"emphasis\">The following table lists the typical access restriction settings:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table- table-\" id=\"1594920812995_N10109\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1011D\">Mapping Name<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N10120\">Entry Path<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10123\">Typically restricted to roles<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10127\">xs2a-accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N1012A\">\/v1\/accounts<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1012D\">aisp<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10131\">xs2a-beneficiaries<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N10134\">\/v1\/trusted-beneficiaries<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10137\">aisp<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1013B\">xs2a-user-identity<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N1013E\">\/v1\/end-user-identity<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10141\">aisp<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10145\">xs2a-consents<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N10148\">\/v1\/consents<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1014B\">aisp<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1014F\">xs2a-funds-confirmations<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N10152\">\/v1\/funds-confirmations<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10155\">cbpii<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N10159\">xs2a-payments<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N1015C\">\/v1\/payment-requests<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N1015F\">pisp<\/p><\/div><\/td><\/tr><\/tbody><\/table><li class=\"step\">Select Authentication Flow \"One-Shot with body\" (the body is required for IAM to be able to verify the HTTP request signatures)<\/li><li class=\"step\">Define the \"Denied access URL\" such that it points to Airlock IAM\'s one-shot endpoint. Typically: \"\/auth\/login-oneshot\".<\/li><li class=\"step\">The \"Session handling\" setting must be set to \"Sessionless\"<\/li><li class=\"step\">Ensure that \"SSL client certificate\" is set to \"Inherit from Virtual Host\"<\/li><li class=\"step\">Add the following \"Apache Expert Setting\" to the mapping:\u00A0<code class=\"codeinline\">RequestHeader set AL_ENV_REQUEST_LINE expr=%{THE_REQUEST}<\/code><\/li><p class=\"par\" id=\"1594920812995_N10215\">This is required for IAM to be able to verify the HTTP request signatures.<\/p><li class=\"step\">Enable \"Send environment cookies\" (this is also required\u00A0for IAM to be able to verify the HTTP request signatures.)<\/li><li class=\"step\">Create a HTTP Header whitelist to allow non-standard HTTP headers required by STET PSD2 (for HTTP signature verification):<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Copy the \"(default) Request header whitelist\" (click on \"customize this action\")<\/li><li class=\"step\">Add the following headers to the customized action (initially called \"Copy of (default) ...\"):<code class=\"codeinline\">|Date|X-Request-Id|PSU-.*<\/code><\/li><li class=\"step\">Enable the new whitelist<\/li><li class=\"step\">Disable the \"(default) Request header whitelist\"<\/li><\/ol><li class=\"step\">To allow the \"Signature\" and the \"TTP-Signature-Certificate\" headers, you need to add the following deny rule exceptions:<\/li><table border=\"0\" cellspacing=\"0\" class=\"table table table- table- table-\" id=\"1594920812995_N1019D\"><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N101B5\">for <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> Versions<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101B8\">with deny rule \"Security Level\"<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N101BB\">add exception to \"Deny Rule\"<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101BE\">using \"Header Name Pattern\"<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812995_N101C3\">all<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101C6\">Strict (recommended)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N101C9\">(default HTML_003b) HTML attribute in quoted context in HTTP header value<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812995_N101CD\"><code class=\"codeinline\">^Signature$<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101D2\">Standard<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-odd-\"><div><p class=\"par\" id=\"1594920812995_N101D5\">(default HTML_004b) Known HTML attribute in quoted context in HTTP header value<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-innerrow table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812995_N101DA\">&gt;= 7.1<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innerrow table-cell-innercol table-cell-col-even-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812995_N101DE\">Strict<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innerrow table-cell-innercol table-cell-col-odd-\" rowspan=\"2\"><div><p class=\"par\" id=\"1594920812995_N101E2\">(default SAN_060b) Header value longer than 300 characters<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101E5\"><code class=\"codeinline\">^Signature$<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1594920812995_N101EA\"><code class=\"codeinline\">^TPP-Signature-Certificate$<\/code><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';