var m_1594920813001Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>IAM configuration for bank API calls\u00A0<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920813001\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration for bank API calls\u00A0<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920813001_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920813001_N10133\">In order to verify the bank API calls (e.g. \/payments, \/accounts\/, etc.) the following configuration steps are necessary. See linked separate detail pages where necessary. All OAuth-related settings are described separately further below.<\/p><p class=\"par\" id=\"1594920813001_N10135\">Please refer to\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945348.html\">HTTP request authentication (One-Shot flow)<\/a> for general information on \"one-shot\" configuration.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Create a new \"Target Application\/Service\" in <span class=\"dialog\">Loginapp<\/span>\u00A0&gt;&gt; <span class=\"dialog\">One-Shot Authentication<\/span><\/li><p class=\"par\" id=\"1594920813001_N101811579699897376\">Within the target application, proceed as follows.<\/p><li class=\"step\">Configure the \u201ECredential Extractor\u201C: \u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945498.html\">HTTP request signature verification for STET<\/a><\/li><li class=\"step\">Setup HTTP Request Authentication:\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945499.html\">TPP Authentication using client certificates and OAuth 2.0 for STET<\/a><\/li><li class=\"step\">Define STET-compliant error responses (HTTP status code in failure cases):<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">For property \"Failure Responses\" use the Plugin \"Configurable Error Mapper\"\u00A0<\/li><li class=\"step\">Use a \"Failure HTTP Response\" with the following values for properties \"Default Authentication Failure Response\", \"Authorization Failure Response (user has no access)\", and \"Credential Extraction Failure Response\":<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">HTTP Status Code: 400<\/li><li class=\"step\">Workflow: FINAL_RESPONSE<\/li><\/ol><\/ol><li class=\"step\">Setup Identity Propagation:<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">\"Identity Propagation\" is used to inform the bank\'s API service about who the TPP is. Any IAM or custom \"Identity Propagator\" that allows attaching information to an HTTP request (using the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>\'s control API) may be used.<\/li><li class=\"step\">The TPP\'s \"organizationIdentifier\" is available as \"username\" in the Identity Propagator plugins<\/li><li class=\"step\">The granted OAuth 2.0 scopes are available as user roles\u00A0in the Identity Propagator plugins<\/li><li class=\"step\">We recommend sending a JWT in an HTTP header to the bank\'s API service. This would involve the following plugins:<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">\"HTTP Header Identity Propagator\" as Identity Propagator; use an \"Encoded User Data Header\" plugin to add a JWT<\/li><li class=\"step\">\"Mapping Ticket Service\" to put together the information in the JWT (use \"@username\" and \"@roles\" as value reference)<\/li><li class=\"step\">\"JWT Ticket Encoder\" to define how to assemble and cryptographically protect the JWT<\/li><\/ol><\/ol><li class=\"step\">Disable the \"User Trail Log\": if left enabled, a user trail log entry is written for every bank API request. This might \"flood\" the user trail log and prevent important user trail log entries from being available.<\/li><li class=\"step\">Choose an URL pattern: Since the TPP roles are checked on the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>, there is normally no need to add a separate \"Target Application\/Service\" for each bank API call.<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Choose an URL pattern that matches all bank API calls (e.g.\u00A0https:\/\/api.bank.example.com\/v1\/.*)<\/li><li class=\"step\">If it is the default \"Target Application\/Service\" the URL pattern is ignored<\/li><li class=\"step\">If you wish to use different settings for single bank APIs (e.g. some identity propagation settings for \"\/payments\" and others for \"\/accounts\"), create multiple \"Target Application\/Service\" plugins and choose the corresponding URL patterns.<\/li><\/ol><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';