var m_1594920815327Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Further examples using MessageFormat<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920815327\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Further examples using MessageFormat<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920815327_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Addresses<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920815327_N100C3\">One common requirement is to display addresses with unknown number of address lines. To avoid empty lines, there\u2019s a custom MessageFormat type called \u201C<span class=\"dialog\">addLineBreak<\/span>\u201D which adds a line break after the value if (and only if) the value was actually nonempty.<\/p><p class=\"par\" id=\"1594920815327_N100C8\"><strong class=\"emphasis\">Example:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1013B\">${ADDRESS_1,addLineBreak}${ADDRESS_2,addLineBreak}${ADDRESS_3,addLineBreak}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100CD\">For more flexibility, there\'s also another type <span class=\"dialog\">addString<\/span> to append any generic String if the given value is not empty. Due to limitations of MessageFormat which automatically trims any additional arguments, any strings that start or end with a space <span class=\"dialog\">must<\/span> be quoted with double quotes, for Example: <code class=\"codeinline\">\", \"<\/code> or <code class=\"codeinline\">\" and \"<\/code>.<\/p><p class=\"par\" id=\"1594920815327_N100DB\"><strong class=\"emphasis\">Example 1, adding a single space after the value (if it is defined):<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10153\">${VARIABLE,addString,\" \"}\u00A0 -&gt;\u00A0 \"value \"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100E1\"><strong class=\"emphasis\">Example 2, adding a comma plus a space after the value (if it is defined):<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1015C\">${VARIABLE,addString,\", \"} -&gt; \"value, \"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100E6\"><strong class=\"emphasis\">Example 3, adding an arbitrary String, surrounded by spaces:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10165\">${VARIABLE,addString,\" String \"} -&gt; \"value String \"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100EB\"><strong class=\"emphasis\">Example 4, adding an arbitrary String without surrounding spaces; quoting is optional here:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1016E\">${VARIABLE,addString,String} -&gt; \"valueString\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920815327_N10059\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Integers<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920815327_N100F5\">Integer value displayed with two forced decimal places: <\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1017D\">${anInteger,number,0.00}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100F9\">For integer parameters, a ChoiceFormat can be used to display texts depending on the actual value. <\/p><p class=\"par\" id=\"1594920815327_N1018F\"><strong class=\"emphasis\">Example:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10185\">${anInteger,choice,0#No tokens|1#One token|1&lt;{0} tokens}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920815327_N100FE\">This results in \u201C<i class=\"italics\">No tokens<\/i>\u201D for the integer zero, \u201C<i class=\"italics\">One token<\/i>\u201D for the integer one and \u201C<i class=\"italics\">n tokens<\/i>\u201D for any integer greater than one.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';