var m_1594920816675Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using profiles<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920816675\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using profiles<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920816675_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N10045\">In some scenarios (e.g. some Docker deployments) it is preferable to use the environment to emulate profiles.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N10047\">Instead of creating a profile properties file, the environment can be used to change which modules are enabled. For every application parameter, an environment variable can be set; use all caps and replace punctuation with underscores.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N10049\">E.g. \"IAM_MODULES=loginapp\" in the environment can be used to override the \"iam.modules\" parameter from the <code class=\"codeinline\">instance.properties<\/code> file.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N1004E\"><strong class=\"emphasis\">Creating Profiles<\/strong><\/p><p class=\"par\" id=\"1594920816675_N10050\">A profile is a <code class=\"codeinline\">.properties<\/code>\u00A0file in the <code class=\"codeinline\">profiles\/<\/code> directory\u00A0that overrides some of the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945274.html\">application parameters<\/a> defined in\u00A0<code class=\"codeinline\">instance.properties.<\/code><\/p><p class=\"par\" id=\"1594920816675_N10068\">To create a new profile named \"external\", a new file named\u00A0<code class=\"codeinline\">external.properties<\/code> must be created. The contents of a profile configuration file is similar to\u00A0<code class=\"codeinline\">instance.properties<\/code>. <\/p><p class=\"par\" id=\"1594920816675_N1008F\"><strong class=\"emphasis\">For example:<\/strong><\/p><p class=\"par\" id=\"1594920816675_N10070\"><i class=\"italics\">instances\/auth\/profiles\/external.properties<\/i><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10073\"># The external profile only launches Loginapp\r\niam.modules = loginapp<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N10075\"><i class=\"italics\">instances\/auth\/profiles\/internal.properties<\/i><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10078\"># The internal profile only launches Adminapp and the service container applications\r\niam.modules = adminapp, service-container<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N1007A\">Having created these files, we can say that the instance \"auth\" now has two different launch profiles. Profiles are primarily applied when launching Airlock IAM. You will note that many CLI commands do not include an option where a profile can be specified.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N1007F\">If a profile exposed to the internet, for example a Loginapp, does not require access to some secrets, consider using a separate sensitive value store.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N10081\">For integration and test environments, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945288.html\">Configuration environments<\/a> can be used to limit the exposure of production secrets.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920816675_N1007A1651826900440\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Launching with profiles<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920816675_N10095\"><strong class=\"emphasis\">Using the previously created profiles, we can now launch the applications separately on two different machines:<\/strong><\/p><p class=\"par\" id=\"1594920816675_N10097\"><i class=\"italics\">airlock@internal.example.com<\/i><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1009A\">iam run -c \/home\/airlock\/iam -i auth -p internal<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N1009C\"><i class=\"italics\">external.example.com<\/i><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1009F\">iam run -c \/home\/airlock\/iam -i auth -p external<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N100A1\"><strong class=\"emphasis\">Launching Multiple Profiles on the Same Machine<\/strong><\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816675_N100A6\">Launching multiple Airlock IAM profiles on one machine provides less isolation protection than using separate machines.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1594920816675_N100A8\">In order to launch multiple profiles on the same machine, it is necessary to change the web server port. In addition to configuring the\u00A0<code class=\"codeinline\">iam.modules<\/code>\u00A0parameter, the ports for the connectors must be changed. By default both processes would try to bind to 8443 for HTTPS and 8080 for HTTP, which does not work. Different ports must be assigned to each profile.<\/p><p class=\"par\" id=\"1594920816675_N100AD\">If the machine has multiple network interfaces it is also possible to change the address from the default \"0.0.0.0\" to the IP address of the machine for a given network interface.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920816675_N100AD1651826900440\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">System-service integration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920816675_N100B4\">With systemd, each profile should have its own service file. The\u00A0<code class=\"codeinline\">iam systemd<\/code> command supports the same\u00A0<code class=\"codeinline\">--profile<\/code> command line argument. See\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945524.html\">Starting and stopping Airlock IAM (system service integration)<\/a>.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';