var m_1594920816683Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Log rotation<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1594920816683\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Log rotation<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1594920816683_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1594920816683_N10266\">Most log files are rotated daily. The <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945274.html\">Application parameters<\/a> containing <code class=\"codeinline\">rotate.max-days<\/code> can be used to configure the maximum number of log files to keep.\u00A0Note that because of technical limitations, web server log file rotation may behave differently.<\/p><p class=\"par\" id=\"1594920816683_N10275\">The only exception is the <i class=\"italics\">parsable<\/i> log files (<code class=\"codeinline\">*.parsable.log<\/code>) which are rotated once they hit a fixed file size.<\/p><p class=\"par\" id=\"1594920816683_N10277\">We recommend moving\/copying log files from the server running Airlock IAM as soon as they are rotated. Ideally, the application server running IAM, should not be used for long-term log file storage. A cron job with something like the example script below or UNIX tools such as <i class=\"italics\">logrotate<\/i> can be used.\u00A0Another option is using <i class=\"italics\">syslog<\/i>, Docker\/Kubernetes log drivers, and log agents like Fluentd, Splunk to transport logs as they are produced.<\/p><p class=\"par\" id=\"1594920816683_N10279\"><span class=\"dialog\">Example: Copy Log Files Script<\/span><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1027C\"># Copy all rotated log files for instance named \"$INSTANCE_NAME\" to \"$DESTINATION\"\r\nfind \"$IAM_CONFIG_ROOT\/instances\/$INSTANCE_NAME\/logs\" -name \'*.log.*\' -not -name \"*.$(date \'+%Y-%m-%d\')\" -exec mv {} \"$DESTINATION\" \\;\r\n# Optionally follow up with compression\r\ngzip -9rv \"$DESTINATION\"\r\n\r\n# The exclusion of the current date works around the different web server log naming scheme (mentioned above) and adds some additional safety in avoiding not-yet-rotated log files.<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816683_N10281\">There are two ways of making sure these log files don\'t grow indefinitely:<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Using the build-in log file clean-up parameters. See: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945278.html\">Logging configuration<\/a><\/li><li class=\"enum-element\">An external process moves these log files regularly. (e.g. a cron job)<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1594920816683_N1005E\">Log4j does not support log rotation for symlink paths (log files cannot be deleted in this case). Instead of using symlinks, set the direct storage path, e.g.: <code class=\"codeinline\">iam.log.structured-file.dir = \/var\/log\/iam<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';