var m_1595233404688Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Configuring the JVM for PKCS #11<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1595233404688\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Configuring the JVM for PKCS #11<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233404688_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1595233404688_N100FA\">PKCS #11 support is enabled in Java by first configuring a security provider with a configuration file for the specific HSM in use.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233404688_N1000F1596718013336\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create a Sun PKCS #11 security provider configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233404688_N10104\">Technically Airlock IAM is not limited to the SunPKCS11 security provider but can use any JCA\/JCE compliant security provider. However, other security providers are not tested by Airlock IAM.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1595233404688_N10106\">Create a new file named\u00A0<code class=\"codeinline\">\/opt\/airlock\/java.security<\/code>\u00A0referencing the HSM-specific\u00A0<code class=\"codeinline\">.cfg<\/code>\u00A0file.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233404688_N1010E\"><i class=\"italics\">conf\/security\/java.security<\/i><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10111\">security.provider.13=SunPKCS11 \/opt\/airlock\/luna.cfg<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1595233404688_N10113\">The \"13\" is there because in the Java which is bundled with Airlock IAM, there are 12 default security providers. You may double check this by looking at\u00A0<code class=\"codeinline\">jdk-11\/conf\/security\/java.security.<\/code><\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233404688_N1011A\">Do not configure both a custom HSM provider and the SunPKCS11-provider. During testing this has lead to errors and disconnects.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233404688_N1003B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Create a Java PKCS #11 configuration file for the HSM<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1595233404688_N10121\">Create a Java PKCS #11 configuration file for the HSM. A short example is given below, for detailed documentation see the\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.oracle.com\/javase\/10\/security\/pkcs11-reference-guide1.htm\" target=\"_blank\">Java PCKS #11 Documentation<\/a>\u00A0or the documentation of your HSM.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233404688_N10136\"><i class=\"italics\">luna.cfg<\/i><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10139\">name = Luna\r\nlibrary = \/opt\/luna\/libs\/cryptoki.so\r\ndescription = Luna config\r\nslot = 1<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1595233404688_N1013B\">The \"<code class=\"codeinline\">name<\/code>\" is an identifier can be freely chosen. \"<code class=\"codeinline\">library<\/code>\" must point to the PKCS #11 library of the HSM. \"<code class=\"codeinline\">description<\/code>\" can be any description and is optional. The \"<code class=\"codeinline\">slot<\/code>\" identifies the slot number where the keys for Airlock IAM are stored on the HSM. Alternatively, the index of the slot can be configured with \"<code class=\"codeinline\">slotListIndex<\/code>\". This file must be stored somewhere where the JVM can read it.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';