var m_1595233404734Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Representer authorization in user representation<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1595233404734\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Representer authorization in user representation<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233404734_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1595233404734_N10310\">Before starting a user representation, the system checks whether the current representer is allowed to represent a particular user. In order to perform the necessary authorization, the system calls a plugin that implements the Java interface <code class=\"codeinline\">RepresentationAuthorization<\/code>.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10315\">package com.airlock.iam.login.app.misc.representation.authorization;\r\nimport com.airlock.iam.core.misc.authen.Authentee;\r\n\/**\r\n * Defines the authorization that is required when the user representation feature is used.\r\n * The authorization defines whether a user has enough rights to represent another user of the system.\r\n *\/\r\npublic interface RepresentationAuthorization {\r\n    \/**\r\n     * Checks whether a representer is authorized to take the identity of a representee.\r\n     * @param representer The authenticated user ({@link Authentee}) who wants to represent another user.\r\n     * @param representee The user name who is to be represented.\r\n     * @return True if the representer is authorized to represent the representee.\r\n     *\/\r\n    public boolean isUserRepresentable (Authentee representer, String representee);\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Currently, two different plugins that implement this interface are available in the product:<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Allow All Representation Authorization<\/strong> \u2013 this plugin doesn\'t do any authorization and always returns <code class=\"codeinline\">true<\/code>.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Role Based Representation Authorization<\/strong> \u2013 this plugin checks whether the representer has at least one of the required roles, which can be configured in this plugin.<\/li><\/ul><p class=\"par\" id=\"1595233404734_N10326\">Companies that use the representation feature can implement their own authorization scheme. For example, if a bank\'s policy requires that only a customer\'s personal service consultant can represent that particular customer, the bank could implement a <code class=\"codeinline\">RepresentationAuthorization<\/code> plugin that calls a service in one of the bank\'s servers that checks whether the representee is assigned as personal service consultant to the selected customer.<\/p><p class=\"par\" id=\"1595233404734_N1032B\">If the representer is not authorized to represent the desired user, a representation denied page is shown explaining the reason.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233404734_N10037\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"include-text\" data-objid=\"1642098242727\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Further information can be found in the IAM Custom Development Guide. You can request the latest version of the <i class=\"italics\">IAM Custom Development Guide<\/i> by opening a support ticket. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/techzone.ergon.ch\/support-process\" target=\"_blank\">(ergon.ch) Techzone - Airlock support process<\/a>) for more information. <\/span><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';