var m_1595233444265Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using the embedded H2 database<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1595233444265\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using the embedded H2 database<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1595233444265_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1595233444265_N102F5\">IAM may be started with an embedded H2 database which can be used for testing and demoing.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">It roughly offers the following features:<\/strong><\/li><li class=\"enum-element\">Implemented as \"IAM module\" (like the Loginapp, Adminapp, etc.).<\/li><li class=\"enum-element\">H2 Web Console (web application with database browser and SQL shell).<\/li><li class=\"enum-element\">Automatic initial schema creation (if no schema deployed).<\/li><\/ul><p class=\"par\" id=\"1595233444265_N10311\">To enable the embedded H2 database, the <code class=\"codeinline\">h2<\/code> IAM module must be added to the list of loaded <code class=\"codeinline\">iam.modules<\/code> in the instance properties file. By default, this file is stored under <code class=\"codeinline\">\/home\/airlock\/iam\/instances\/auth\/instance.properties<\/code>.<\/p><p class=\"par\" id=\"1595233444265_N10313\"><strong class=\"emphasis\">Uncomment and add <code class=\"codeinline\">h2<\/code> to the <code class=\"codeinline\">iam.modules<\/code> line to enable the H2 database module for the IAM instance:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10316\">## Modules to enable. Comma separated list. \r\n## Possible values: adminapp, loginapp, transaction-approval, api-policy-service, service-container, h2 \r\niam.modules = adminapp, loginapp, transaction-approval, api-policy-service, service-container, h2<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1595233444265_N10318\"><strong class=\"emphasis\">To configure the database, the following H2 instance properties may be used (values shown in the example are default values):<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1031D\">### WEB SERVER URL PATHS \r\n## Path to modules (e.g. http:\/\/localhost:8080\/auth-admin)\r\n...  \r\n#iam.h2.url.path = \/${instance.name}-h2\r\n\r\n### H2 DATABASE \r\n## The embedded H2 database is for testing purposes only. \r\n## For production please refer to the documentation for more information. \r\n \r\n## When h2 is enabled in iam.modules, an embedded H2 database will be started with Airlock IAM \r\n#iam.h2.data.dir = instances\/${instance.name}\/h2 \r\n#iam.h2.jdbc.url = jdbc\\:h2\\:tcp\\:\/\/localhost\\:9001\/iamdb \r\n#iam.h2.jdbc.user = airlock \r\n#iam.h2.jdbc.password = password<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233444265_N10322\">To display the current H2 settings, run: <code class=\"codeinline\">iam default-parameters | grep iam.h2<\/code><\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1595233444265_N10329\">If separating the Loginapp from the Adminapp of IAM (see\u00A0<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945525.html\">Sandboxing with profiles<\/a>), running the H2 database in the Adminapp part is a good idea.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';