var m_1597341392321Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Hardware token management for Airlock 2FA<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1597341392321\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-theme-ct\"><div class=\" headline-theme-content\"><h1 class=\" headline-theme\">Use case<\/h1><\/div><\/div><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Hardware token management for Airlock 2FA<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1597341392321_N1000C\">This article shows an example of how to assign and manage Airlock 2FA hardware tokens for a user.<\/p><p class=\"par\" id=\"1597341392321_N10010\">Please refer to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435054139.html\">Token management (Airlock 2FA)<\/a> for general Airlock 2FA token management examples.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand how Airlock 2FA hardware tokens can be assigned and shipped to a user.<\/li><li class=\"enum-element\">Understand how to manage Airlock 2FA hardware tokens.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435054139_N10042\">The following examples use the Airlock IAM Adminapp. A REST API for all administrative actions of the Airlock IAM Adminapp is available.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">All admin actions shown below are subject to access control.<\/li><li class=\"enum-element\">Review the access control configuration in the Adminapp.<\/li><li class=\"enum-element\">In the following, we assume, that the administrator has all the necessary privileges.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The IAM Adminapp is configured, so users and authentication tokens can be managed.<\/li><li class=\"enum-element\">The <span class=\"dialog\">Airlock 2FA Token Controller<\/span> is configured in the IAM Adminapp.<\/li><li class=\"enum-element\">The administrator has enough privileges (roles) to perform all shown actions.<\/li><li class=\"enum-element\">All examples are given on an existing user account.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Hardware tokens are available for the configured Airlock 2FA service.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N1007D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Assign Airlock 2FA hardware token to a user<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597341392321_N10080\">To assign a hardware token to a user, the following steps must be performed in the <span class=\"dialog\">Airlock 2FA<\/span> tab of the selected user.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Click on the button <span class=\"dialog\">Assign hardware token<\/span>.<\/li><li class=\"step\">Take a hardware token from the stock of assignable hardware tokens and enter the tokens serial number into the dialog shown on the screen.<\/li><figure class=\"media\"><div class=\"media-theme shadow\" id=\"1597341392321_N1008E\"><img alt=\"Adminapp - Airlock 2FA, Assign available hardware token, Serial number\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Adminapp\/Adminapp_-_Airlock_2FA_2c_Assign_available_hardware_token_2c_Serial_number.theme\/1.3\/en-us.Adminapp_-_Airlock_2FA_2c_Assign_available_hardware_token_2c_Serial_number_html.png\" style=\"width:;height:226px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For faster lookup, just enter the last three or four digits of the serial number.<\/li><li class=\"enum-element\">You may also use a barcode scanner to select the token.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N100B5\">The <span class=\"dialog\">Airlock IAM Token Controller<\/span> plugin may be configured to allow assigning a hardware token to multiple users of the same service. If configured to allow that, even hardware tokens that are already assigned to a user will be listed.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Click on the <span class=\"dialog\">Assign<\/span> button.<\/li><li class=\"step result\">The hardware token is now assigned and ready to use.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N100BA\">If the token at hand cannot be found in the list of assignable tokens, this may have one of the following reasons:<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The token is not assigned to your organization in the Futurae cloud. A hardware token can be used across services but only be within one organization.<\/li><li class=\"enum-element\">The token is assigned to another user and the configuration forbids assigning it to multiple users (the default). Either find the assigned user and unassign the token or allow assigning hardware tokens to multiple users (in the <span class=\"dialog\">Airlock 2FA Token Controller<\/span> configuration). Hardware tokens can only be assigned to multiple users within one service.<\/li><li class=\"enum-element\">The token has been assigned to another user in the past and has then been archived (instead of being unassigned). <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Line\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"line\">-<\/span>Archived tokens cannot be assigned again. <\/li><li class=\"enum-element\"><span class=\"line\">-<\/span>Unarchiving hardware tokens requires contacting Airlock support.<\/li><\/ul><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N100C6\">Hardware tokens are ready to use directly after the assignment process. In other words: Assigned hardware tokens can be used as the second authentication factor by the legitimate user or even on behalf of a user immediately after the assignment.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Make sure that the token is only accessible by the legitimate user.<\/li><li class=\"enum-element\">Choose a secure shipment or handover method.<\/li><li class=\"enum-element\">Depending on the ordered hardware tokens, the user must enter an activation code as a legitimation step before the first usage.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N100D1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Printing a shipment letter for hardware tokens<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597341392321_N100D4\">There are several ways to hand over the device to a user. The IAM Adminapp directly supports printing shipment letters.<\/p><p class=\"par\" id=\"1597341392321_N100D6\">Hardware token shipment letters can be directly generated from the IAM Adminapp by pressing the <span class=\"dialog\">Create shipment letter<\/span> button. Shipment letters typically contain a text, the recipient address, the token serial number, and optionally the activation code.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Shipment letter support is configured in the <span class=\"dialog\">Airlock 2FA Token Controller<\/span> plugin.<\/li><li class=\"enum-element\">How the letter is generated (and printed) is defined by the renderer configuration.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N101141599050916114\">A hardware token may be assigned to multiple users (this requires special configuration of the <span class=\"dialog\">Airlock 2FA Token Controller<\/span>). If this is the case, the shipment letter may only contain information about the one user that the letter was printed or generated for.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N10129\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Airlock 2FA hardware token management<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597341392321_N1012C\">The following screenshot shows two hardware tokens in the <span class=\"dialog\">Airlock 2FA<\/span> tab on the user detail page: a QR code token and an OTP token:<\/p><figure class=\"media shadow\"><div class=\"media-theme shadow\" id=\"1597341392321_N100EF\"><img alt=\"Adminapp - Airlock 2FA Hardware Device, list of devices\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Adminapp\/Adminapp_-_Airlock_2FA_Hardware_Device_2c_list_of_devices.theme\/1.4\/en-us.Adminapp_-_Airlock_2FA_Hardware_Device_2c_list_of_devices_html.png\" style=\"width:1024px;height:786.3914120561519px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1597341392321_N1011C\"><col style=\"width:15%;\"\/><col style=\"width:85%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-odd-Nolines\" colspan=\"2\"><div><p class=\"par\" id=\"1597341392321_N1012E\"><strong class=\"emphasis\">Possible actions:<\/strong><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1597341392321_N10139\"><span class=\"dialog\">Unassign<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1597341392321_N1013F\">Unassigns the hardware token from the user in a way that it can be reassigned again. It will show up again when selecting hardware tokens for assignment. This is the right thing to do if a token has been assigned by accident or if the token has been returned to the administrator.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N10109\">Unassigned hardware tokens can no longer be used by the end-user and reassigning requires knowledge of the serial number.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N1010B\">This action cannot be undone.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1597341392321_N1015D\"><span class=\"dialog\">Archive<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1597341392321_N10163\">Archives the hardware token, i.e. permanently removes the hardware token from usage. It will not be among the set of assignable tokens after archiving. Take this action if the token was stolen, has been lost, or is damaged.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N101181597739797614\">The token will no longer be usable by the end-user and reassigning will not be possible. Unarchiving hardware tokens involves contacting Airlock support.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597341392321_N1011A1597739797614\">This action cannot be undone.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1597341392321_N10181\"><span class=\"dialog\">Create shipment letter<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1597341392321_N10187\">Creates a shipment letter to send the token to the user.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1597341392321_N101C9\"><span class=\"dialog\">Synchronize<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1597341392321_N101CF\">Synchronize OTP hardware tokens: use this if the internal clock of the OTP hardware token is out of synch with the current time and therefore OTP tokens are no more accepted. <\/p><p class=\"par\" id=\"1597341392321_N101D1\">This may be necessary for OTP hardware tokens that have not been used for a long time.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N10156\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Modification of Airlock 2FA accounts directly in Futurae\'s management web application should be avoided. This is because data regarding activation letters are stored in the Airlock IAM database only and because Airlock IAM does not support all features that can be managed in the Futurae cloud.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">PIN protection of hardware tokens is currently not supported by Airlock IAM. Please contact Airlock staff if you are interested in this feature: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:order@airlock.com?subject=Airlock%202FA%20hardware%20tokens\">order@airlock.com<\/a>.<\/li><li class=\"enum-element\">Whether a hardware token requires an activation code before first usage or not needs to be specified <u class=\"underline\">before ordering the tokens<\/u>. Already delivered tokens cannot be changed.<\/li><li class=\"enum-element\">Assigning hardware tokens to multiple users is only possible if enabled in the configuration and within the same service.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597341392321_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597341390832.html\">Offline QR code authentication<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435026525.html\">Airlock 2FA token management configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945388.html\">IAM REST APIs<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';