var m_1597849731173Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>SSO tickets in the OAuth\/OIDC context<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1597849731173\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">SSO tickets in the OAuth\/OIDC context<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N10006\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731173_N10007\">This section describes SSO tickets and what they can be used for in the OAuth context. It provides recommendations for a secure implementation of SSO tickets. A detailed example shows how SSO tickets are used within an OAuth\/OIDC re-authentication process.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Purpose of SSO tickets <\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731173_N10012\">SSO (single-sign-on) tickets are bearer tokens to re-authenticate a user. Re-authentication is performed during high-risk transactions to verify that an authorized user indeed executes a requested action. With SSO tickets, consenting to a transaction\'s details is impossible.  <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N10030\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Security Recommendations for SSO tickets<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731173_N1001C\">SSO tickets provide a powerful mechanism for replacing user interactions in an authentication flow. This increases the risk of attacks aiming at the elevation of rights. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731173_N100251688719354173\"><strong class=\"emphasis\">Therefore, special care should be taken to avoid the abuse of SSO tickets.<\/strong><\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">When using SSO tickets:  <\/li><li class=\"enum-element\">Don\'t reuse existing SSO tickets (one-time use only).<\/li><li class=\"enum-element\">Don\'t use the same SSO ticket for multiple use cases, e.g., by reusing Airlock IAM plugins. <\/li><li class=\"enum-element\">Assign a very short ticket lifetime. <\/li><li class=\"enum-element\">Sign and encrypt the tickets. <\/li><li class=\"enum-element\">Treat SSO tickets as a single authentication factor. Hence, they should never be used for identity propagation to applications requiring a strong authentication result.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N10059\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Obtaining an SSO ticket<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731173_N1005D\">When accessing a resource\'s endpoint, the client must provide an access token as a bearer token. If the resource server requires an SSO ticket, the access token must be exchanged for an SSO ticket. To obtain the SSO ticket, the user must re-authenticate.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N10060\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using an SSO ticket<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731173_N10064\">An SSO ticket must be submitted as a <code class=\"codeinline\">login_hint<\/code> in an authorization code flow. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">A request starting an authorization code flow with an SSO ticket must provide these parameters:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">login_hint<\/code> \u2013 SSO ticket to be used to authenticate the user.<\/li><li class=\"enum-element\"><code class=\"codeinline\">acr_values<\/code> \u2013 to request a minimum authentication quality.<\/li><li class=\"enum-element\"><code class=\"codeinline\">prompt=login<\/code> \u2013 to ensure that any existing authentication state has been removed before the authorization code grant starts the authentication process.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Re-authentication process example in detail<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731173_N10079\">This example demonstrates a complete re-authentication process involving SSO tickets. The user with a fully authenticated and authorized session is forced to re-authenticate with a second factor. The back-end resource server is in control over the forced re-authentication of the user. This is achieved using the OIDC authorization code flow and an OIDC SSO ticket. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">For security reasons, two different SSO tickets are used:<\/strong> <\/li><li class=\"enum-element\"><i class=\"italics\">OIDC SSO ticket<\/i> \u2013 It is created by the resource server and consumed at the start of the authorization code flow. Its scope is limited to the authorization server. Therefore, it can\'t be used in an authentication flow. <\/li><li class=\"enum-element\"><i class=\"italics\">AuthN SSO ticket<\/i> \u2013 It is issued by the authorization server and consumed at the beginning of the authentication flow. <\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Overview of the re-authentication process using SSO tickets:<\/strong><\/li><li class=\"enum-element\">The back-end resource uses session management to revoke the access token with scope <i class=\"italics\">one-time scope<\/i>. <\/li><li class=\"enum-element\">This forces the client to obtain a new access token by performing a token refresh. <\/li><li class=\"enum-element\">The scope <i class=\"italics\">one-time scope<\/i> is removed from the access token upon token refresh. <\/li><li class=\"enum-element\">At this point, the client can either<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">start the authorization code flow directly, forcing the user to enter both authentication factors one after the other. <\/li><li class=\"enum-element\">the client can refresh the access token, retrieve an SSO ticket and start an authorization code flow with prompt, <code class=\"codeinline\">acr_values<\/code>, and SSO ticket. This will allow the user to authenticate with only the 2nd factor. <\/li><\/ol><li class=\"enum-element\">At the end of the authorization code flow, the client has an access token containing the <i class=\"italics\">one-time scope<\/i> and presents this to the back-end resource. <\/li><li class=\"enum-element\">The back-end resource validates this access token. <\/li><li class=\"enum-element\">The back-end resource immediately revokes the access token using session management to prevent the reuse of the token.<\/li><\/ul><p class=\"par\" id=\"1597849731173_N10090\">The sequence diagram below shows the involved steps and the messages between the different entities in detail:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1597849731173_N10A34\"><img alt=\"RE-Auth_Flow\" class=\"media-theme-img-tag svg\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8824.RE-Auth_Flow.theme\/1.1\/en-us.8824.RE-Auth_Flow_original.svg\" style=\"width:1024px;height:942.0606060606061px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731173_N1009A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">For an example configuration, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731243.html\">Forced user re-authentication<\/a>.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1625752917694.html\">Single sign-on (SSO) ticket authentication<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';