var m_1597849731223Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Authorization code flow usage<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1597849731223\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Authorization code flow usage<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N10006\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use Case Scenario<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N10007\">This use case demonstrates the different steps required to execute an authorization code flow with user interactions.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N1000F1600182078571\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N10013\">The client is already registered through dynamic client registration (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731233.html\">client credentials grant usage example<\/a>) or configured as a static client in the configuration (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N100321600182078571\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview of Steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">A client starts an authorization code flow (authorize call).<\/li><li class=\"step\">The user is authenticated and accepts the consent request.<\/li><li class=\"step\">The client receives the authorization code.<\/li><li class=\"step\">The client sends the authorization code to the AS and exchanges it for an ID, access, and refresh token (token call).<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N10044\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Start the Authorization Code Flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N10048\">To start the authorization code flow, open a browser window and enter the following URL:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731223_N10052\"><strong class=\"emphasis\">Browser URL to start an authorization code flow<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10018\">https:\/\/oidc.airlock.com\/auth-login\/oauth2\/v3\/myAS\/authorize?\r\n    response_type=<strong class=\"emphasis\">code<\/strong>    &amp;redirect_uri=https:\/\/oidc.airlock.com\/application\/demo\r\n       &amp;client_id=oidc-client\r\n    &amp;state=ee26b0dd4a...28a8ff \r\n    &amp;scope=employee%20openid \r\n    <\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To successfully start an authorization code flow, the following conditions must be met:<\/strong><\/li><li class=\"enum-element\">A redirect_uri must be present in the request.<\/li><li class=\"enum-element\">The redirect_uri must be on the list of redirect_uris registered during client registration.<\/li><li class=\"enum-element\">A client_id must be present.<\/li><li class=\"enum-element\">The scope \"openid\" must be present.<\/li><li class=\"enum-element\">One additional scope must be present, if the authorization server has required scopes configured.<\/li><li class=\"enum-element\">The redirect_url must be URL encoded.<\/li><\/ul><p class=\"par\" id=\"1597849731223_N10037\">If one of the conditions is not met, the authorization server will return an error message in the browser.<\/p><p class=\"par\" id=\"1597849731223_N10039\">Submitting the <code class=\"codeinline\">state<\/code> parameter is not required by the standard, but it is strongly recommended to protect against CSRF.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N1008B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Authentication and Consent<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N1008F\"><strong class=\"emphasis\">Airlock IAM will present a login screen:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1597849731223_N11571\"><img alt=\"jdoe Loginapp\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/OAuth_2.0_OIDC\/jdoe_Loginapp.theme\/1.2\/en-us.jdoe_Loginapp_html.png\" style=\"width:;height:520px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1597849731223_N10014\"><strong class=\"emphasis\">... and optionally ask for consent:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1597849731223_N11584\"><img alt=\"Authorization of a request\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/OAuth_2.0_OIDC\/Authorization_of_a_request.theme\/1.2\/en-us.Authorization_of_a_request_html.png\" style=\"width:;height:452px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N100B1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 3 \u2013 Authorization Code<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N100B5\">If both authentication and consent grants have succeeded, Airlock IAM will redirect the browser to the <code class=\"codeinline\">redirect_uri<\/code> requested that was provided in step 1. The redirect URI contains the authorization code.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731223_N100D6\"><strong class=\"emphasis\">Redirect URI with authorization code:<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100CB\">https:\/\/oidc.airlock.com\/application\/demo?\r\n     code=xRbH9uoaMMWB6urmWsg8b1xwJQF~JfD2s9CoUvwVWX42YxBwqfeC2RVWeG1HkvkdtxHz\r\n     &amp;state=ee26b0dd4a...28a8ff<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1597849731223_N100BF\">Note that with this request the authorization code is sent to the relying party (client).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731223_N100DE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 4 \u2013 Obtain ID, Access, and Refresh Tokens<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731223_N100E2\">The relying party (client) receives the authorization code and sends it to the AS to get the ID, access, and refresh tokens. Note that the following request is not sent by the browser but by the relying party.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731223_N10114\"><strong class=\"emphasis\">Token endpoint request<\/strong> (sent by RP\/client and not by the browser)<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100F8\">https:\/\/oidc.airlock.com\/auth-login\/rest\/oauth2\/authorization-servers\/myAS\/token<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Content-Type: <code class=\"codeinline\">application\/x-www-form-urlencoded<\/code><\/li><li class=\"enum-element\">Authorization: <code class=\"codeinline\">Basic dXNlcm5hbWU6cGFzc3dvcmQ<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">grant_type=authorization_code<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">code=xRbH9uoaMMWB6urmWsg8b1xwJQF~JfD2s9CoUvwVWX42YxBwqfeC2RVWeG1Hkv<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">redirect_uri=https:\/\/oidc.airlock.com\/application\/demo<\/code><\/li><\/ul><p class=\"par\" id=\"1597849731223_N10032\">It is recommended to configure the authorization server, to enforce authentication on the token endpoint.<\/p><p class=\"par\" id=\"1597849731223_N10034\"><strong class=\"emphasis\">The authorization server will respond as follows:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731223_N1005F\"><strong class=\"emphasis\">Code Block  token endpoint response<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10045\">200 OK\r\n {\r\n    \"access_token\": \"eyJraWQiOiI3YWRmMz...E9nfs7YyJZdRFP\",\r\n    \"scope\": \"email\",\r\n    \"id_token\": \"eyJraWQiOiI3YWRmMzgp74...Ex86vUkyMGqxQg\",\r\n    \"token_type\": \"bearer\",\r\n    \"expires_in\": 17999\r\n }<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';