var m_1597849731238Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Resource access with token usage<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1597849731238\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Resource access with token usage<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731238_N10006\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use Case Scenario<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This scenario demonstrates the following use case:<\/strong><\/li><li class=\"enum-element\">A client accesses a resource and provides a valid access token<\/li><li class=\"enum-element\">The resource inspects the access token<\/li><\/ul><p class=\"par\" id=\"1597849731238_N1000F\">In this example, Airlock IAM acts as both an authorization and resource server. <\/p><p class=\"par\" id=\"1597849731238_N10011\">The ordering of the steps in this example is incorrect, but to keep the request and response close to each other, the response to the resource access is shown immediately after the request instead of first inspecting the access token.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731238_N1001D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Resource access<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731238_N100211600182302960\">For the purpose of this example, we use the resource\'s endpoint to retrieve a resource called <code class=\"codeinline\">rbac<\/code>. This resource will return a JSON object containing the email and the user\'s roles. In a real-world example, this might be an ebanking server that is requested to return a list of accounts of the user identified in the access token.<\/p><p class=\"par\" id=\"1597849731238_N100241600182302960\">To authorize the call, we must supply an access token as a bearer token in the Authorization header.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731238_N10026\"><strong class=\"emphasis\">Resource access request<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001A\">GET https:\/\/oidc.airlock.com\/auth-login\/rest\/oauth2\/authorization-servers\/myAS\/resources\/rbac<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1597849731238_N1002A\"><strong class=\"emphasis\">This request will, after successful token introspection, receive the following response:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731238_N10053\"><strong class=\"emphasis\">Resource access response<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1003D\">200 OK\r\n {\r\n     \"email\": \"john.doe@ergon.ch\",\r\n     \"role\": [\r\n         \"customer\"\r\n    ] \r\n} <\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731238_N10086\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Token Introspection<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1597849731238_N1008A\">Before returning the response to the resource access in Step 1, the resource will inspect the access token provided. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To this end, the resource will query the token introspection endpoint with a request:<\/strong><\/li><li class=\"enum-element\">The resource server uses its credentials when querying the token introspection endpoint.<\/li><li class=\"enum-element\">The credentials of the resource server are supplied using <code class=\"codeinline\">basic_auth<\/code> in the authorization header and are configured as part of the token introspection endpoint.<\/li><li class=\"enum-element\">The resource server provides the access token to be inspected as an <code class=\"codeinline\">x-www-form-urlencoded<\/code> value.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731238_N10034\"><strong class=\"emphasis\">Token Introspection request<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10058\">POST https:\/\/oidc.airlock.com\/rest\/oauth2\/authorization-servers\/myAS\/introspect\r\n Content-Type: application\/x-www-form-urlencoded\r\n Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ\r\n\r\n  token=eyJraWQiOiI...izyE7sDxw<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1597849731238_N100CA\">This request will receive the following response if the access token supplied is valid. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following elements in the response are noteworthy:<\/strong><\/li><li class=\"enum-element\">Token introspection will return the username in the sub-parameter.<\/li><li class=\"enum-element\">Token introspection will return the scope, as it was granted after consent and applying the whitelist. <\/li><li class=\"enum-element\">Token introspection will return the identifier of the client that obtained the access token from the authorization server.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731238_N1006E\"><strong class=\"emphasis\">Token introspection response<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1006F\">200 OK\r\n {\r\n     \"sub\": \"jdoe\",\r\n     \"scope\": \"ebanking\",\r\n     \"active\": true,\r\n     \"exp\": 1599502326,\r\n     \"iat\": 1599484326,\r\n     \"client_id\": \"oidc-client\"\r\n }<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';