var m_1597849731256Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use Case \u2013 Strong authentication<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1597849731256\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use Case \u2013 Strong authentication<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731256_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The configuration for strong-app is identical to the configuration for weak-app:<\/li><li class=\"enum-element\">REST target application configuration requires a new <span class=\"dialog\">Target Application<\/span> <i class=\"italics\">strong-app<\/i>. <br\/>The authentication flow must require multi-factor authentication and set the corresponding tags. <\/li><li class=\"enum-element\">The configuration requires an <span class=\"dialog\">ACR to Flow Application ID Mapping<\/span> for <code class=\"codeinline\">strong-acr<\/code> and a <span class=\"dialog\">Flow Condition Based OIDC ID Token ACR Value<\/span> plugin that matches the tag set by the authentication flow.<\/li><li class=\"enum-element\">Loginapp UI configuration requires an <span class=\"dialog\">Authentication &amp; Authorization UI<\/span>,<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1597849731256_N1002A1600236172771\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using the strong-app example<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731256_N1002C\"><strong class=\"emphasis\">Authorize call<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10032\">https:\/\/oidc.airlock.com\/auth-login\/oauth2\/v3\/myAS\/authorize?response_type=code&amp;\r\n    redirect_uri=https:\/\/app.airlock.com\/function&amp;\r\n    client_id=oidcConformance_clientId&amp;\r\n    scope=openid&amp;\r\n    acr_values=strong-acr&amp;\r\n    state=ee26b0dd4a...28a8ff<\/pre><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Expected behaviour:<\/li><li class=\"step\">Use the above URL in a browser. This is required since the Loginapp UI configured depends heavily on javascript and without browser it will not be rendered.<\/li><li class=\"step\">The login screen will be shown \u2013 enter username and password.<\/li><li class=\"step\">The second login screen is shown \u2013 enter mTAN code.<\/li><li class=\"step\">If local consents are configured, the consent screen is shown.<\/li><li class=\"step\">The authorization server will now respond with a <code class=\"codeinline\">302<\/code> status code and provide a location parameter with URL, the authorization code and the state parameter on this URL.<\/li><\/ol><p class=\"par\" id=\"1597849731256_N1003D\">Depending on your configuration, this may lead to an error in the browser, if the location cannot be resolved. If you look at the network tab in your browser\'s developer tools, you will find the redirect URL you are looking for.  <\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731256_N1005E\"><strong class=\"emphasis\">Finding the redirect URL<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10059\">Location: https:\/\/app.airlock.com\/function?\r\n    code=msaUh91PAW...KoiHc8ihp6En&amp;\r\n    state=ee26b0dd4a...28a8ff<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1597849731256_N10062\"><strong class=\"emphasis\">Use the code provided in this location parameter to exchange the authentication code for access and refresh tokens:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731256_N1008C\"><strong class=\"emphasis\">Redirect URL to weak-app<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10065\">POST https:\/\/oidc.airlock.com\/auth-login\/rest\/oauth2\/authorization-servers\/myAS\/token\r\n    Content-Type: application\/x-www-form-urlencoded\r\n    Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ\r\n\r\n    grant_type=authorization_code\r\n    code=msaUh91PAW...KoiHc8ihp6En\r\n    redirect_uri=https:\/\/app.airlock.com\/function\r\n    state=ee26b0dd4a...28a8ff<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1597849731256_N10091\">In the response there will also be an ID token. Due to the roles to ACR mapping, the acquired role <i class=\"italics\">strong-role<\/i> will be mapped to the <code class=\"codeinline\">strong-acr<\/code> ACR value and returned in the ID token. <\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1597849731256_N100C6\"><strong class=\"emphasis\">ID token from response<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10071\">{\r\n    \"sub\": \"mike\",\r\n    \"aud\": \"oidcConformance_clientId\",\r\n    \"acr\": \"strong-acr\",\r\n    \"roles\": [\r\n    \"employee\",\r\n    ],\r\n    \"auth_time\": 1598100981,\r\n    \"iss\": \"https:\/\/oidc.airlock.com\/auth-login\/rest\/oauth2\/authorization-servers\/myAS\",\r\n    \"exp\": 1598101107,\r\n    \"iat\": 1598100987,\r\n    \"family_name\": \"Doe\"\r\n }<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';