var m_1600698220464Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Token migration self-service<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1600698220464\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-theme-ct\"><div class=\" headline-theme-content\"><h1 class=\" headline-theme\">Use case<\/h1><\/div><\/div><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Token migration self-service<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1600698220464_N1000C\">This article explains how an end-user can enroll an Airlock 2FA app without an activation letter. The end-user is authenticated first and can then enroll an Airlock 2FA app by scanning a QR code displayed in the login application.<\/p><p class=\"par\" id=\"1600698220464_N10010\">The described process can be used to migrate users from an arbitrary second factor (e.g. mTAN) to Airlock 2FA as a second factor. This process is called <span class=\"dialog\">token migration<\/span>.<\/p><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1600698220464_N10016\">Note that users cannot self-migrate to Airlock 2FA hardware tokens. Hardware tokens are assigned by the administrators and may not be enrolled by the user.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand how token migration works in general.<\/li><li class=\"enum-element\">Understand how Airlock 2FA token migration works.<\/li><li class=\"enum-element\">Learn details about the prerequisites and limitations of token migration<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1600698220464_N10042\">Token migration is an end-user self-service and part of the authentication process. It requires an established authentication method prior to the token migration. The established (old) token is used to authenticate the user, then the end-user is asked to enroll the (new) token of a different type.<\/p><p class=\"par\" id=\"1600698220464_N100681583506980583\">Users are marked for migration using the Adminapp or the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Adminapp REST API<\/span>.<\/p><p class=\"par\" id=\"1600698220464_N100D3\">Token migration is configurable as optional or mandatory. In addition, a grace period can be set which allows the end-user to freely postpone his migration within the defined period.<\/p><p class=\"par\" id=\"1600698220464_N100D6\">With these features, end-users can easily be migrated to a new second factor without activation letters and administrative effort.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1600698220464_N10074\">If Airlock 2FA is used as the second factor in strong authentication, it is necessary to authenticate the end-user in a strong way before migration.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1600698220464_N10075\">While it is possible to enroll Airlock 2FA just based on username and password, the security risks of such a setup must be considered thoroughly.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435067229_N1005B\">Note that there are different types of Airlock 2FA enrollment:<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Enrollment using activation letters<\/li><li class=\"enum-element\">Migration from another 2nd factor to Airlock 2FA as a self-service.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">User account exists in IAM and users can be authenticated (e.g. username, password, and mTAN).<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user\'s smartphone is connected to the internet and is able to connect to the Futurae cloud.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Token migration (online enrollment)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1600698220464_N100F4\">The following flow chart shows how token migration works.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1600698220464_N1010F\"><img alt=\"UC-Migration\" class=\"media-theme-img-tag svg\" src=\"..\/media\/03_Media\/Vector_drawings\/Airlock_2FA\/8749.UC-Migration.theme\/2.2\/en-us.8749.UC-Migration_original.svg\" style=\"width:;height:646.72px;border:0;\"\/><\/div><\/figure><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">(1)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100B4\">The end-user is authenticated with existing credentials and usually an established second factor (for example username, password, and mTAN).<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(2)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100BF1583421751155\">The end-user is asked to migrate to Airlock 2FA. Depending on the configuration, migration is optional or mandatory to the user.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(3)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100CA\">An enrollment QR code is presented to the user.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(4)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100DF\">The end-user installs the Airlock 2FA app if necessary. The end-user scans the QR code to enroll the app.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100E5\">The app connects to the Futurae cloud for enrollment.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(6)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1600698220464_N100E6\">Airlock IAM verifies the enrollment and shows a confirmation page to the end-user.<\/p><\/td><\/tr><\/table><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1600698220464_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849715364.html\">Airlock 2FA token migration - REST flow example<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';