var m_1608049762158Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>About attestation<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1608049762158\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">About attestation<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1608049762158_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1608049762158_N100411608550709834\">Attestation is a step in the FIDO registration ceremony in which the FIDO relying party can verify the make and model of the FIDO Authenticator that is about to register.  <\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">During the registration ceremony, the FIDO Authenticators public key is signed with an (authenticator model-specific) attestation key. <\/li><li class=\"enum-element\">Attestation keys have associated attestation certificates, that chain to a root certificate. All authenticators of the same make and model <strong class=\"emphasis\">share the same attestation certificate<\/strong>. <\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1608049762158_N10019\">A FIDO Authenticators make and model can be verified by <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> by consulting the configured trust store.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1608049762158_N1002F\">The <span class=\"dialog\">FIDO Alliance Metadata Service<\/span> (MDS) is not supported in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1608049762158_N1004C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">What does attestation accomplish?<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The terms assertion and attestation are not synonymous:<\/li><li class=\"enum-element\">Assertion occurs every time when authenticating.<\/li><li class=\"enum-element\">Attestation occurs during registration once.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Attestation accomplishes three things: <\/li><li class=\"step\">If attackers manage to intercept a registration message with their own, they would not be able to swap out the new public key with their own. The attestation signature wouldn\u2019t match.<\/li><li class=\"step\">The FIDO relying party can verify the origin (e.g. manufacturer) of the authenticator being used but can\'t identify or track the individual user. This preserves the privacy of the user.<\/li><li class=\"step\">A service can be configured to only accept a specific type or group of device types based upon:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Line\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"line\">-<\/span>One or more FIDO Authenticator makers\/vendors.<\/li><li class=\"enum-element\"><span class=\"line\">-<\/span>FIDO Authenticators with trusted security.<\/li><li class=\"enum-element\"><span class=\"line\">-<\/span>Authenticators with specific features of user verification i.e. with biometrics of a certain level of accuracy.<\/li><\/ul><\/ol><p class=\"par\" id=\"1608049762158_N10060\"><strong class=\"emphasis\">Conclusion:<\/strong><br\/>The FIDO attestation step enables the relying party to trust that the registration request is from a specific make and model of FIDO Authenticator.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1608049762158_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example: Full basic attestation<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1608049762158_N10018\">Our example explains a simplified <span class=\"dialog\">full basic attestation<\/span> with a roaming FIDO Authenticator.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1608049762158_N10042\"><img alt=\"FIDO_MDS lookup\" class=\"media-theme-img-tag svg\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Grafiken\/8754.FIDO_MDS_lookup.theme\/1.2\/en-us.8754.FIDO_MDS_lookup_original.svg\" style=\"width:;height:330px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">During the registration ceremony, the FIDO Authenticator creates a new credential key pair. The credential public key, that is sent to the relying party, is signed with the attestation private key.<\/li><li class=\"step\">The FIDO relying party may verify that the attestation signature on the newly created public key came from the device, by looking up the attestation key chain in the configured trust store.<\/li><li class=\"step result\">This is hstablishes its trust in the authenticity of the credential public key.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1608049762158_N10051\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Surrogate basic attestation (aka self-attestation)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1608049762158_N10040\">Registration of FIDO Authenticators typically requires that a user already has a sufficiently authenticated session and communication is already secured over SSL\/TLS. <br\/>Thus, replacing the attestation key is not possible for attackers. For this reason, many services will accept FIDO Authenticators that are using surrogate attestation\/self-attestation.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Surrogate basic attestation model is typically used for:<\/li><li class=\"enum-element\">FIDO Authenticators that don\'t have any specific attestation key.<\/li><li class=\"enum-element\">FIDO Authenticators without meaningful protection (e.g. strong biometric authentication) measures for an attestation private key.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1608049762158_N10092\">With surrogate basic attestation, the authentication key self-signs the surrogate attestation message instead of using a burned-in vendor-signed attestation certificate.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1608049762158_N1007C\">It is important to understand that FIDO Authenticators should not generate new attestation keys with every instance of a device. Instead, the FIDO\'s privacy principles require sufficient user anonymity that can only be accomplished when an attestation key is used for a sufficiently large number of authenticators. This mitigates the risk that users can be tracked based upon a unique attestation certificate.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1608049762158_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO Alliance documentation: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/fidoalliance.org\/metadata\/\" target=\"_blank\">FIDO Alliance Metadata Service (MDS)<\/a><\/li><li class=\"enum-element\">W3C attestation description: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.w3.org\/Submission\/2015\/SUBM-fido-key-attestation-20151120\/#attestation-models\" target=\"_blank\">FIDO attestation models<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';