var m_1610721891198Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use case: FIDO passwordless authentication in IAM<\/title><meta content=\"passkeys, Passkey\" name=\"keywords\"\/><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1610721891198\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use case: FIDO passwordless authentication in IAM<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721891198_N1000C\">This article explains on a conceptual level how to authenticate end-users using <span class=\"dialog\">FIDO passwordless<\/span> as the sole factor (no username, no password). It also provides information relevant for correct use and configuration.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand passwordless authentication with FIDO in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/li><li class=\"enum-element\">Understand the interaction between involved components.<\/li><li class=\"enum-element\">Learn details about prerequisites and limitations.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721891198_N10042\">End-user authentication with FIDO authenticators\/passkeys can be done in several ways. One of them is using <span class=\"dialog\">FIDO passwordless<\/span>, i.e. FIDO as the sole authentication factor. In this scenario, the end-user does not have to enter a username or password but only uses the FIDO authenticator.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721891198_N100401610704240460\">Note that FIDO can also be used as the second factor in an authentication flow. This does not necessarily imply that the end-user has to enter a password.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721891198_N100521610704240460\">How to use FIDO as the second authentication step is described separately.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1610721891198_N100541610704240460\">In all cases, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> acts as FIDO relying party.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An end-user account exists in IAM.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user has FIDO enabled as a possible authentication method.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator has been registered as a <span class=\"dialog\">resident key<\/span>. This is guaranteed if the FIDO configuration setting <span class=\"dialog\">Require resident keys<\/span> was enabled during the registration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user has a supported FIDO authenticator capable of storing resident keys.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator complies with the settings in the FIDO configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-users browser or mobile app supports FIDO passwordless (i.e. support CTAP2).<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator has been registered with the end-users account.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">FIDO passwordless authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721891198_N100F4\">The following flow chart shows how <span class=\"dialog\">FIDO passwordless<\/span> works with <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1610721891198_N10091\"><img alt=\"UC-FIDO-passwordless-with-IAM\" class=\"media-theme-img-tag svg\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Grafiken\/8756.UC-FIDO-passwordless-with-IAM.theme\/1.2\/en-us.8756.UC-FIDO-passwordless-with-IAM_original.svg\" style=\"width:;height:646.72px;border:0;\"\/><\/div><\/figure><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">(1)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100B4\">The browser or mobile app initiates the authentication process. This may be done by trying to access a protected resource or by calling the FIDO passwordless REST API directly.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(2)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100BF1583421751155\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> creates a FIDO challenge. At this stage, the end-user to be authenticated is not yet known.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(3)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100C51583421751155\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> sends a challenge together with end-user verification preferences to the FIDO client (browser or mobile app).<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(4)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100CB\">The browser interacts with the end-user and the FIDO authenticator to retrieve the response to the challenge, and it sends the response back to <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\"><\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100B5\"><span class=\"include-text\" data-objid=\"1610645267301\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">If multiple suitable FIDO authenticators are available to the FIDO client, a selection dialog is presented to the end-user.<\/span><\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100DF\">From the response from the FIDO authenticator, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> can determine the end-user to be authenticated and check whether the response is valid for the used FIDO credential.<\/p><p class=\"par\" id=\"1610721891198_N100DD\">Details of the verification depend on the FIDO configuration settings in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> and may involve the verification of a FIDO attestation.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(6)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721891198_N100E5\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM automatically redirects the user\'s browser to the intended target application or service.<\/span><\/p><\/td><\/tr><\/table><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N1007F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721891198_N10082\">The following limitations apply when using <span class=\"dialog\">FIDO passwordless<\/span> in an authentication flow.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO is only supported by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\"><span class=\"dialog\">Loginapp UI<\/span><\/span> and the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO authenticators must support <span class=\"dialog\">resident keys<\/span> for (later) passwordless authentication. This can be enforced during FIDO registration (token migration and self-service) and enabled in the FIDO settings in the IAM configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO authenticators that have not been registered as resident keys need to be re-registered to use FIDO passwordless.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Not all browsers or mobile apps support passwordless authentication with FIDO.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO passwordless end-user experience varies between web browsers when multiple resident FIDO credentials can be used for FIDO authentication. In this case, there is a menu from the web-browser requiring the end-user to select the correct FIDO authenticator. The menu cannot be customized or influenced.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721891198_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1610645267216.html\">Use case: FIDO as 2nd factor or approval step in IAM<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"\" target=\"_blank\"><\/a><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1612361353459.html\">FIDO configuration overview<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1612361355393.html\">FIDO passwordless authentication - REST flow example<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/fidoalliance.org\/fido2\/fido2-web-authentication-webauthn\/\" target=\"_blank\">FIDO2 platform and browser compatibility (fido alliance)<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';