var m_1610721895507Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use case: FIDO token migration self-service<\/title><meta content=\"passkeys, Passkey\" name=\"keywords\"\/><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1610721895507\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use case: FIDO token migration self-service<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721895507_N1000C\">This article describes the <span class=\"dialog\">token migration self-service<\/span> that can be used to move end-users from using an arbitrary second factor to using FIDO.<\/p><p class=\"par\" id=\"1610721895507_N1001D\">The described process allows end-users to register a FIDO authenticator during the login process.<\/p><p class=\"par\" id=\"1610721895507_N100251611558323050\">To register FIDO authenticators after the login process, i.e. for already authenticated end-users, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1610721896747.html\">Use case: FIDO registration self-service<\/a> instead.<\/p><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721895507_N10019\">Note that FIDO credentials can be managed by administrators in the <span class=\"dialog\">IAM Adminapp<\/span>, but they can only be <strong class=\"emphasis\">registered by the end-user<\/strong> in a self-service. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand how token migration works in general.<\/li><li class=\"enum-element\">Understand how token migration to FIDO works.<\/li><li class=\"enum-element\">Learn details about prerequisites and limitations.<\/li><\/ul><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1600698220464_N10042\">Token migration is an end-user self-service and part of the authentication process. It requires an established authentication method prior to the token migration. The established (old) token is used to authenticate the user, then the end-user is asked to enroll the (new) token of a different type.<\/p><p class=\"par\" id=\"1600698220464_N100681583506980583\">Users are marked for migration using the Adminapp or the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Adminapp REST API<\/span>.<\/p><p class=\"par\" id=\"1600698220464_N100D3\">Token migration is configurable as optional or mandatory. In addition, a grace period can be set which allows the end-user to freely postpone his migration within the defined period.<\/p><p class=\"par\" id=\"1600698220464_N100D6\">With these features, end-users can easily be migrated to a new second factor without activation letters and administrative effort.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721895507_N10074\">If FIDO is used as the second factor in strong authentication, it is required to authenticate the end-user in a strong way before token migration.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721895507_N10075\">While it is possible to enroll FIDO Authenticators just based on username and password, the security risks of such a setup must be considered thoroughly.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1610645267216_N100541610704240460\">In all cases, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> acts as FIDO relying party.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An end-user account exists in IAM and end-users can be authenticated (e.g. username, password, and a 2nd factor).<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO is set as the authentication method to migrate to for the end-user.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user has a supported FIDO authenticator.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator complies with the settings in the FIDO configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-users browser or mobile app supports FIDO.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">To support FIDO passwordless authentication (now or in the future), make sure to require keys to be <span class=\"dialog\">resident<\/span> during the registration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator has been registered with the end-users account.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Token migration <\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721895507_N100F4\">The following flow chart shows how token migration to FIDO works:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1610721895507_N100BF1611310177817\"><img alt=\"UC-FIDO-token-migration-with-IAM\" class=\"media-theme-img-tag svg\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Grafiken\/8757.UC-FIDO-token-migration-with-IAM.theme\/1.2\/en-us.8757.UC-FIDO-token-migration-with-IAM_original.svg\" style=\"width:;height:646.72px;border:0;\"\/><\/div><\/figure><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">(1)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100B4\">The end-user is authenticated with existing credentials and usually an established second factor. This may be another FIDO authenticator or a different second factor.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(2)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100BF1583421751155\">The end-user is asked to migrate to FIDO. Depending on the configuration, migration is optional or mandatory to the user.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(3)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100C51583421751155\">The end-user has to choose a <span class=\"dialog\">display name<\/span> for the registered FIDO authenticator. The display name later helps the user (or the helpdesk) to identify the authenticator. This is especially important if a user registers multiple authenticators.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(4)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100ED\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> sends a FIDO registration challenge to the FIDO client (browser or mobile app).<\/p><p class=\"par\" id=\"1610721895507_N100EF\">Together with the challenge, constraints restricting the set of allowed FIDO authenticators are send to the FIDO client. The constraints depend on the FIDO settings in the configuration. They include:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Signature algorithm constraints.<\/li><li class=\"enum-element\">List of excluded FIDO authenticators (e.g. already registered ones).<\/li><li class=\"enum-element\">User verification preferences.<\/li><li class=\"enum-element\">Type of authenticator (platform or cross-platform)<\/li><li class=\"enum-element\">Whether <span class=\"dialog\">FIDO passwordless<\/span> must be supported<\/li><li class=\"enum-element\">FIDO attestation preferences<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100CB\">The browser interacts with the user and the FIDO authenticator to retrieve the response to the challenge, and it sends the response back to <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\"><\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100B5\"><span class=\"include-text\" data-objid=\"1610645267301\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">If multiple suitable FIDO authenticators are available to the FIDO client, a selection dialog is presented to the end-user.<\/span><\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(6)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721895507_N100DF\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> verifies the response to the challenge and checks whether all FIDO authenticator constraints are met. Details of the verification depend on the FIDO configuration settings in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><p class=\"par\" id=\"1610721895507_N10126\">If the verification succeeds, the FIDO credential is stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> user database and a confirmation is sent to the caller.<\/p><\/td><\/tr><\/table><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N1013A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Screen Flow Example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721895507_N1013D1611310814248\">The following screenshot series shows an exemplary token migration flow in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> for a roaming FIDO Authenticator.<\/p><p class=\"par\" id=\"1610721895507_N1014B\">Browser dialog details depend on the browser make and version.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Dialog in which the end-user is asked to migrate to FIDO (during login process):<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1610721895507_N10151\"><img alt=\"FIDO-token-migration-step1-start-migration\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Screenshots\/FIDO-token-migration-step1-start-migration.theme\/1.2\/en-us.FIDO-token-migration-step1-start-migration_html.png\" style=\"width:;height:215px;border:0;\"\/><\/div><\/figure><li class=\"step\">Dialog to enter the display name of the FIDO authenticator to be registered:<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1610721895507_N1015F\"><img alt=\"FIDO-token-mgiration-step2-enter-displayname\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Screenshots\/FIDO-token-mgiration-step2-enter-displayname.theme\/1.2\/en-us.FIDO-token-mgiration-step2-enter-displayname_html.png\" style=\"width:;height:227px;border:0;\"\/><\/div><\/figure><li class=\"step\">Dialog requesting the end-user to insert and interact with the FIDO authenticator:<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1610721895507_N1016D\"><img alt=\"FIDO-token-migration-step3-device-seclection\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Screenshots\/FIDO-token-migration-step3-device-seclection.theme\/1.2\/en-us.FIDO-token-migration-step3-device-seclection_html.png\" style=\"width:;height:469px;border:0;\"\/><\/div><\/figure><li class=\"step\">Confirmation dialog asking the end-user, whether the selected FIDO authenticator may be used for registration:<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1610721895507_N1017B\"><img alt=\"FIDO-token-mgiration-step3-browser-allow\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Screenshots\/FIDO-token-mgiration-step3-browser-allow.theme\/1.2\/en-us.FIDO-token-mgiration-step3-browser-allow_html.png\" style=\"width:;height:430px;border:0;\"\/><\/div><\/figure><li class=\"step result\">The registration of the FIDO credential is completed after this step.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N1007F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721895507_N10082\">The following limitations apply in FIDO token migration:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO is only supported by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\"><span class=\"dialog\">Loginapp UI<\/span><\/span> and the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO authenticators must support <span class=\"dialog\">resident keys<\/span> for (later) passwordless authentication. This can be enforced during FIDO registration (token migration and self-service) and enabled in the FIDO settings in the IAM configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Not all FIDO Attestation statement formats are supported by Airlock IAM. Please review the set of supported formats in the documentation of the FIDO attestation verifying plugin in the FIDO settings.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721895507_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1610721896747.html\">Use case: FIDO registration self-service<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1612361353459.html\">FIDO configuration overview<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1613069310345.html\">FIDO token migration - REST flow example<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';