var m_1610721896747Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use case: FIDO registration self-service<\/title><meta content=\"passkey, Passkeys\" name=\"keywords\"\/><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1610721896747\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use case: FIDO registration self-service<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721896747_N1000C\">This article explains how a logged-in end-user can register FIDO Authenticator with the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> account and.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721896747_N10013\">End-users need to be authenticated for the registration self-service.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721896747_N10015\">To register FIDO Authenticators during the login process, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1610721895507.html\">Use case: FIDO token migration self-service<\/a> instead.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721895507_N10019\">Note that FIDO credentials can be managed by administrators in the <span class=\"dialog\">IAM Adminapp<\/span>, but they can only be <strong class=\"emphasis\">registered by the end-user<\/strong> in a self-service. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand how the FIDO registration self-service works.<\/li><li class=\"enum-element\">Learn details about the prerequisites and limitations of FIDO registration.<\/li><\/ul><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N1005D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721896747_N10042\">The FIDO registration is part of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span> and its web UI. The registration process is implemented as a <span class=\"dialog\">protected self-service flow<\/span>. This allows great flexibility in combining the FIDO registration with other steps and for any authorization and access conditions.<\/p><p class=\"par\" id=\"1610721896747_N10072\"><strong class=\"emphasis\">Great care should be taken especially regarding authorization and access conditions:<\/strong> <br\/>If FIDO should be used for strong authentication, it is mandatory to authenticate the end-user in a strong way before FIDO registration, because the authenticity of the registered FIDO Authenticators is based on the security prevalent during the registration self-service.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721896747_N10075\">While it is possible to enroll FIDO Authenticators just based on username and password, the security risks of such a setup must be considered thoroughly.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1610721896747_N1007F1611561245173\">Thus, we strongly recommended protecting the FIDO registration self-service flow with an <span class=\"dialog\">access condition<\/span> that guarantees sufficient end-user authentication. This is especially useful if different levels of authentication are allowed (or might be configured in the future).<\/p><p class=\"par\" id=\"1610645267216_N100541610704240460\">In all cases, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> acts as FIDO relying party.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An end-user account exists in IAM and end-users can be authenticated (e.g. username, password, and a 2nd factor).<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user has a supported FIDO authenticator.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO authenticator complies with the settings in the FIDO configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-users browser or mobile app supports FIDO.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">To support FIDO passwordless authentication (now or in the future), make sure to require keys to be <span class=\"dialog\">resident<\/span> during the registration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A protected self-service flow to register FIDO authenticators has been configured.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The FIDO registration flow\'s configured access condition is fulfilled.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user is authorized to register FIDO authenticators (i.e. the FIDO registration flow\'s configured authorization condition is fulfilled).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Token migration <\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721896747_N100F4\">The following flow chart shows how the FIDO registration step can be used:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1610721896747_N100CE\"><img alt=\"UC-FIDO-token-registration-self-service-with-IAM\" class=\"media-theme-img-tag svg\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.4\/FIDO2_and_WebAuthn\/FIDO_Grafiken\/8758.UC-FIDO-token-registration-self-service-with-IAM.theme\/1.2\/en-us.8758.UC-FIDO-token-registration-self-service-with-IAM_original.svg\" style=\"width:;height:676.16px;border:0;\"\/><\/div><\/figure><div class=\"legend-ct legend-ct\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\">(1)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100B4\">The end-user is strongly authenticated with existing credentials and usually an established second factor. This may be another FIDO authenticator or a different second factor.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(2)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100BF1583421751155\">The end-user starts the FIDO registration self-service flow. This may be for example by clicking on a link or pressing a button in an app.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> verifies that:<\/li><li class=\"enum-element\">the user is authenticated.<\/li><li class=\"enum-element\">the configured <span class=\"dialog\">access condition<\/span> is fulfilled.<\/li><li class=\"enum-element\">the configured <span class=\"dialog\">authorization condition<\/span> is fulfilled.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(3)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100C51583421751155\">The end-user has to choose a <span class=\"dialog\">display name<\/span> for the registered FIDO Authenticator. The display name later helps the end-user (or the helpdesk) to identify the authenticator \u2013 this is especially important if a user registers multiple authenticators.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(4)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100ED\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> sends a FIDO registration challenge to the FIDO client (browser or mobile app).<\/p><p class=\"par\" id=\"1610721896747_N100EF\">The challenge and a set of constraints for accepted FIDO Authenticators are sent to the FIDO client. The constraints depend on the FIDO settings in the configuration. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">They include:<\/li><li class=\"enum-element\">Signature algorithm constraints.<\/li><li class=\"enum-element\">List of excluded FIDO Authenticators (e.g. already registered ones).<\/li><li class=\"enum-element\">User verification preferences.<\/li><li class=\"enum-element\">Type of authenticator (platform or cross-platform).<\/li><li class=\"enum-element\">Whether <span class=\"dialog\">FIDO passwordless<\/span> must be supported.<\/li><li class=\"enum-element\">FIDO attestation preferences.<\/li><\/ul><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100CB\">The browser interacts with the user and the FIDO Authenticator to retrieve the response to the challenge, and it sends the response back to <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\"><\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100B5\"><span class=\"include-text\" data-objid=\"1610645267301\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">If multiple suitable FIDO authenticators are available to the FIDO client, a selection dialog is presented to the end-user.<\/span><\/p><\/td><\/tr><tr class=\"legend-row\"><td class=\"legend-term\">(5)<\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1610721896747_N100DF\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> verifies the response to the challenge and checks whether all FIDO Authenticator constraints are met. The verification details depend on the FIDO configuration settings in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<\/p><p class=\"par\" id=\"1610721896747_N10126\">If the verification succeeds, the FIDO credential is stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> user database and a confirmation is sent to the caller.<\/p><\/td><\/tr><\/table><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721896747_N10156\">Arbitrary other steps may be added before and\/or after the FIDO registration step in the self-service flow.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1610721896747_N10158\">You may, for example, add another 2nd factor (e.g. <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock 2FA<\/span>) to further secure the FIDO registration flow.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N1007F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1610721896747_N10082\">The following limitations apply in FIDO token migration.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO is only supported by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\"><span class=\"dialog\">Loginapp UI<\/span><\/span> and the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">FIDO authenticators must support <span class=\"dialog\">resident keys<\/span> for (later) passwordless authentication. This can be enforced during FIDO registration (token migration and self-service) and enabled in the FIDO settings in the IAM configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Not all FIDO Attestation statement formats are supported by Airlock IAM. Please review the set of supported formats in the documentation of the FIDO attestation verifying plugin in the FIDO settings.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">There are no end-user self-services to list or edit registered FIDO authenticators. The only protected self-service is the one to register new FIDO authenticators. Registered FIDO authenticators can only be managed using the IAM Adminapp (or its <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Adminapp REST API<\/span>).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1610721896747_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1610721895507.html\">Use case: FIDO token migration self-service<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1612361353459.html\">FIDO configuration overview<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1613465988623.html\">FIDO token registration - REST flow example<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';