var m_1613069310947Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use Case: Regular end-users as realm administrators<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1613069310947\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use Case: Regular end-users as realm administrators<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1613069310947_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1613069310947_N10007\">This use case applies to an organization where employees with regular end-user accounts shall be enabled to access the Adminapp as realm administrators. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The solution presented here has the following characteristics:<\/li><li class=\"enum-element\">The solution allows a regular end-user to obtain an SSO ticket that contains both roles and the realm value for the Adminapp.<\/li><li class=\"enum-element\">The Adminapp authenticates the administrator with the SSO ticket and limit access using roles and realm value from the SSO ticket.<\/li><li class=\"enum-element\">For an end-user to be authorized to obtain the SSO ticket, the user must have at least the <span class=\"dialog\">useradmin<\/span> role and may have the <span class=\"dialog\">tokenadmin<\/span> role.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1613069310947_N10018\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of the target application<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisites<\/li><li class=\"enum-element\">The attribute to store the realm value for both end-users and administrators is named <i class=\"italics\">realm<\/i>.<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Instruction<\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span><\/li><li class=\"step\">Create a new <span class=\"dialog\">Target Application<\/span> and add it to the <span class=\"dialog\">Applications<\/span> list.<\/li><li class=\"step\">Configure the target application as required: Configure or choose an authentication flow, and create an application ID (used in UI settings below).<\/li><li class=\"step\">Configure an <span class=\"dialog\">Application Selector<\/span> such that the URL of the Adminapp matches the selector. This ensures that the target application is selected when trying to access the Adminapp.<\/li><li class=\"step\">To the Identity Propagation list, add a <span class=\"dialog\">Generic ID Propagator<\/span> plugin and configure it as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Use a <span class=\"dialog\">Ticket String Provider<\/span> plugin with a <span class=\"dialog\">JWT Ticket Encoder<\/span> plugin in order to create a JWT.<\/li><li class=\"enum-element\">Set <span class=\"dialog\">Username Ticket Key<\/span> as <i class=\"italics\">username<\/i>.<\/li><li class=\"enum-element\">Issuer as appropriate, e.g. <i class=\"italics\">Airlock IAM<\/i>.<\/li><li class=\"enum-element\">Set <span class=\"dialog\">Valid Not Before Skew<\/span> to <i class=\"italics\">5<\/i>.<\/li><li class=\"enum-element\">Set claims stored as an array with two values: <i class=\"italics\">roles<\/i> and <i class=\"italics\">realm<\/i>. The roles are taken from the end-user\'s roles (using <code class=\"codeinline\">@roles<\/code> as value reference) and the realm from the context data attribute bearing the realm.<\/li><li class=\"enum-element\">Create and configure a <span class=\"dialog\">JWT Ticket Signer<\/span>. Use an HMAC algorithm.<\/li><\/ul><li class=\"step\">As Ticket Adder use the <span class=\"dialog\">SPA Forward Location Parameter Adder<\/span>. It will send the JWT ticket to the Loginapp UI so it can be sent to the Adminapp.<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span><\/li><li class=\"step\">Add an <span class=\"dialog\">Authentication UI<\/span> referring to the above target application by selecting the corresponding application ID.<\/li><li class=\"step\">Add a Target URI Resolver plugin and define the default URL of the Adminapp, e.g., <code class=\"codeinline\">https:\/\/myhost.com\/auth-admin\/<\/code>.<\/li><li class=\"step result\">The <span class=\"dialog\">Target Application<\/span> is now configured.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1613069310947_N10147\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of the Adminapp<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisite<\/li><li class=\"enum-element\">none<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Instruction<\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Administrators<\/span> &gt;&gt; <span class=\"dialog\">SSO Ticket Authentication<\/span><\/li><li class=\"step\">Configure <span class=\"dialog\">Query Parameter Name<\/span> to match the parameter name of the Ticket Added configured in the Loginapp (see above). The default value is <code class=\"codeinline\">sso<\/code>.<\/li><li class=\"step\">Configure a <span class=\"dialog\">JWT Ticket Decoder<\/span> such that it can decode JWT tickets issued by the Loginapp.<\/li><li class=\"step\">Configure <span class=\"dialog\">Username Key<\/span> and <span class=\"dialog\">Roles Key<\/span> such that it matches the keys when issuing the JWT in the Loginapp.<\/li><li class=\"step\">Set Roles Blocklist as appropriate (e.g. to disallow the <code class=\"codeinline\">superadmin<\/code> role if required).<\/li><li class=\"step\">To the <span class=\"dialog\">Ticket Processors<\/span> list add a <span class=\"dialog\">Context Data Import Ticket Processor<\/span> to import the <code class=\"codeinline\">realm<\/code> attribute.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';