var m_1614328142493Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Loginapp Design Kit REST response mocking configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142493\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> REST response mocking configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142493_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142493_N10007\">Advanced customizing using JavaScript may involve sending REST requests to a back-end. In a production environment, the back-end is in most cases <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>. Since the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> is designed to run standalone without a running <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instance, it provides a mechanism to mock the back-end.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two ways JavaScript can send REST requests:<\/li><li class=\"enum-element\">Using <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\" target=\"_blank\">XMLHttpRequest<\/a>.<\/li><li class=\"enum-element\">Using the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Fetch_API\" target=\"_blank\">Fetch API<\/a>.<\/li><\/ul><p class=\"par\" id=\"1614328142493_N10037\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> supports the mocking of both.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142493_N10041\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Basic configuration and matching<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142493_N10045\">Using the setting <code class=\"codeinline\">config.customResponses<\/code>  in <code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/sdk\/config\/custom.sdk.config.js<\/code> , an array of responses can be defined:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100831614771568652\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            ... \r\n        } \r\n    }, \r\n    { \r\n        url: \'\/another\/path\', \r\n        response: { \r\n            ... \r\n        } \r\n    } \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142493_N1003E\">At runtime, when a request is sent by JavaScript, the mock is determined by checking whether the actual request\'s URL ends with one of the configured URLs within <code class=\"codeinline\">customResponses<\/code> ignoring the HTTP method. It is not necessary to fully qualify the full URL in the configuration. The first entry that matches will be used to mock the response.<\/p><p class=\"par\" id=\"1614328142493_N10040\">In addition to matching the URL, you can optionally also provide the HTTP method:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100911614771568652\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        method: \'POST\', \/\/ Optional. If undefined, all HTTP methods match. \r\n        response: { \r\n            ... \r\n        } \r\n    }, \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            ... \r\n        } \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142493_N10079\">In this example, a request sent to \/some\/path only matches the first mock response if the HTTP method is POST. If any other HTTP method is used for \/some\/path, the second mock would apply.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142493_N100E0\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Mocking XMLHttpRequest<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142493_N100E4\">To mock the response of an <code class=\"codeinline\">XMLHttpRequest<\/code>, the <code class=\"codeinline\">xhr<\/code> property has to be defined within the response. In most cases, JavaScript code only cares about the JSON payload returned by the server. <\/p><p class=\"par\" id=\"1614328142493_N100A41614771568652\">This can easily be configured as follows:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AA\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            xhr: { \r\n                body: { \r\n                    \/\/ Your JSON response \r\n                } \r\n            } \r\n        } \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142493_N1003A\">However, sometimes the application needs to look at other response details. To that end, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> provides the following fields with the defaults that are used in the Design Kit unless explicitly defined:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100CE\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            xhr: { \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/status *\/ \r\n                status: 200, \r\n                  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/statusText *\/ \r\n                statusText: \'OK\', \r\n                  \r\n                \/** \r\n                 * Key-value pairs of a header. Example: \r\n                 * \r\n                 * { \r\n                 *   \"Content-Type\": \"application\/json; charset=utf-8\", \r\n                 *   \"X-API-Limit\": 100 \r\n                 * } \r\n                 *\/ \r\n                headers: { \r\n                    \'Content-Type\': \'application\/json\' \r\n                }, \r\n                  \r\n                  \r\n                \/** \r\n                 * The body of the response. Supported types are JSON or text. \r\n                 * @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/response \r\n                 *\/ \r\n                body: {}, \r\n                  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/responseType *\/ \r\n                type: \'json\', \r\n                  \r\n                \/** \r\n                  * If not explicitly configured, defaults to the JSON.stringify(body). \r\n                  * @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/responseText \r\n                  *\/ \r\n                responseText: undefined, \r\n                  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/responseXML *\/ \r\n                responseXML: undefined, \r\n                  \r\n                \/** \r\n                  * If not explicitly configured, defaults to the URL that matched the mock response. \r\n                  * @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/XMLHttpRequest\/responseURL \r\n                  *\/ \r\n                responseURL: undefined \r\n            } \r\n        } \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142493_N101D7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Mocking the Fetch API<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142493_N101DB\">The mocking of the <span class=\"dialog\">Fetch API<\/span> is similar to the one for <code class=\"codeinline\">XMLHttpRequest<\/code>. In the simple case, they only difference is using <code class=\"codeinline\">fetch<\/code> instead of <code class=\"codeinline\">xhr<\/code> in the response:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100EB\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            fetch: { \r\n                body: { \r\n                    \/\/ Your JSON response \r\n                } \r\n            } \r\n        } \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142493_N1021E\">If needed, there are additional properties that can be set. The values show the defaults used by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> unless explicitly defined:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10106\">config.customResponses = [ \r\n    { \r\n        url: \'\/some\/path\', \r\n        response: { \r\n            fetch: { \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Response\/status *\/ \r\n                status: 200, \r\n  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Response\/statusText *\/ \r\n                statusText: \'OK\', \r\n  \r\n                \/** \r\n                 * Key-value pairs of a header. Example: \r\n                 * \r\n                 * { \r\n                 *   \"Content-Type\": \"application\/json; charset=utf-8\", \r\n                 *   \"X-API-Limit\": 100 \r\n                 * } \r\n                 *\/ \r\n                headers: { \r\n                    \'Content-Type\': \'application\/json\' \r\n                }, \r\n  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Body\/body *\/ \r\n                body: {}, \r\n  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Response\/type *\/ \r\n                type: \'basic\', \r\n  \r\n                \/** @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Response\/redirected *\/ \r\n                redirected: false, \r\n  \r\n                \/** \r\n                  * If not explicitly configured, defaults to the URL that matched the mock response. \r\n                  * @see https:\/\/developer.mozilla.org\/en-US\/docs\/Web\/API\/Response\/url \r\n                  *\/ \r\n                url: undefined \r\n            } \r\n        } \r\n    }, \r\n];<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';