var m_1614328142513Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>IAM HTML body attributes<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142513\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">IAM HTML body attributes<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142513_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142513_N10007\">The Loginapp UI adds IAM-related attributes to the HTML <code class=\"codeinline\">body<\/code> tag in order to make customizing easier.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142513_N10013\"><strong class=\"emphasis\">Example:<\/strong> HTML body tag with IAM-specific attributes<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10017\">&lt;body \r\n\tid=\"iamAuthPassword\" \r\n\tdata-iam-flow-id=\"demo\" \r\n\tdata-iam-step-id=\"pwcheck\" \r\n\tdata-iam-domain=\"authentication\"\r\n&gt;\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In particular, the following attributes are added:<\/li><li class=\"enum-element\"><code class=\"codeinline\">data-iam-flow-id<\/code>: The ID of the current IAM flow.<\/li><li class=\"enum-element\"><code class=\"codeinline\">data-iam-step-id<\/code>: The ID of the current IAM flow step.<\/li><li class=\"enum-element\"><code class=\"codeinline\">data-iam-domain<\/code>: The affected domain in the Loginapp. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The attribute assumes one of the following values (more values may have been added):<\/li><li class=\"enum-element\"><code class=\"codeinline\">authentication<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">registration<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">protected.self-service<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">public-self-service<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">error<\/code><\/li><\/ul><\/ul><p class=\"par\" id=\"1614328142513_N1003A\">The attributes may, for example, be used to change the color of the header depending on flow ID and step ID by adapting <code class=\"codeinline\">_custom-styles.scss<\/code>  as follows:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001C\"> \/\/ Change background color when flow ID equals \'demo\'\r\n [data-iam-flow-id=\'demo\'] {\r\n    .iam-card-header { \r\n        background-color: red;\r\n    }\r\n}\r\n\r\n\/\/ Change background color when step ID equals \'example\'\r\n [data-iam-step-id=\'example\'] {\r\n    .iam-card-header {\r\n         background-color: green;\r\n    } \r\n} \r\n\r\n\/\/ Change background color when flow ID equals \'demo\' and step ID equals \'example\'\r\n   [data-iam-flow-id=\'demo\'][data-iam-step-id=\'example\'] {\r\n    .iam-card-header { \r\n        background-color: blue;\r\n    }\r\n}\r\n\r\n\/\/ Change background color for all pages in the authentication domain\r\n[data-iam-domain=\'authentication\'] {\r\n    .iam-card-header {\r\n        background-color: gray;\r\n    }\r\n}   <\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142513_N10048\">For more information on how to add flow ID and step ID to the Loginapp Design Kit\'s navigation menu, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142469.html\">SDK navigation menu configuration<\/a>.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';