var m_1614328142550Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Customizing an existing product page using the Loginapp Design Kit<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142550\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Customizing an existing product page using the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142550_N10007\">While in most cases, existing product pages of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> such as the password or mTAN authentication pages can be customized by modifying SASS\/CSS only, it might not be sufficient for all use-cases. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Examples, where SASS\/CSS is not sufficient, are among others:<\/li><li class=\"enum-element\">Adding new UI elements to a page, e.g. a subtitle.<\/li><li class=\"enum-element\">Changing the order UI elements.<\/li><li class=\"enum-element\">Adding dynamic behavior, e.g. a password meter.<\/li><\/ul><p class=\"par\" id=\"1614328142550_N1001D\">To that end, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> provides a mechanism to further customize existing product pages.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142526_N101F0\">To avoid problems with caching, it is recommended to use SASS whenever possible.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N1011E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Modify an existing page with separate HTML files (preferred method)<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142537_N1013E1626176470785\">For optimal performance, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> inlines the HTML file\'s content at build time.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142550_N101351626179491501\"><strong class=\"emphasis\">Path to the folder where custom HTML files have to be placed:<\/strong><br\/><code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/assets\/custom\/templates<\/code><\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Names of the custom HTML files:<\/strong><\/li><li class=\"enum-element\">before-container.html<\/li><li class=\"enum-element\">before-content.html<\/li><li class=\"enum-element\">after-content.html<\/li><li class=\"enum-element\">after-container.html<\/li><\/ul><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10126\">customBlocks() { \r\n            return [ \r\n                { \r\n                    html: this.fetchHtml(\'assets\/custom\/templates\/before-container.html\'), \r\n                    position: this.customBlockPosition.BEFORE_CONTAINER, \r\n                }, \r\n                { \r\n                    html: this.fetchHtml(\'assets\/custom\/templates\/before-content.html\'), \r\n                    position: this.customBlockPosition.BEFORE_CONTENT, \r\n                }, \r\n                { \r\n                    html: this.fetchHtml(\'assets\/custom\/templates\/after-content.html\'), \r\n                    position: this.customBlockPosition.AFTER_CONTENT, \r\n                }, \r\n                { \r\n                    html: this.fetchHtml(\'assets\/custom\/templates\/after-container.html\'), \r\n                    position: this.customBlockPosition.AFTER_CONTAINER, \r\n                } \r\n            ]; \r\n        }<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N100291614599780807\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Basic structure for JavaScript with custom HTML layout<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142550_N1002D1614599780807\">Customizations using JavaScript take place here:<br\/><code class=\"codeinline\">$CUSTOM_DIRECTORY\/src\/assets\/custom\/js\/iam-custom.js<\/code> <\/p><p class=\"par\" id=\"1614328142550_N1004E\">The basic structure when customizing a page is as follows:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10054\">iam.api.customizing.initialize = function () { \r\n  \r\n    \/\/ Define a new page \r\n    class MyCustomProductPage extends iam.api.types.CustomProductPage { \r\n        \/\/ ... \r\n    } \r\n  \r\n    \/\/ Register the page: \r\n    iam.api.customizing.registerPage(new MyCustomProductPage()); \r\n};<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142550_N10034\">The page has to be defined by extending from: <br\/><code class=\"codeinline\">iam.api.types.CustomProductPage<\/code> <\/p><p class=\"par\" id=\"1614328142550_N1005D\">The page has to be registered subsequently, using: <br\/><code class=\"codeinline\">iam.api.customizing.registerPage<\/code><\/p><p class=\"par\" id=\"1614328142550_N10063\">When the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> loads a new page, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> checks each custom page whether it is applicable or not.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142550_N10044\">For the remainder of this section, the surrounding function <code class=\"codeinline\">iam.api.customizing.initialize<\/code> is not shown in the code examples. However, remember that all JavaScript customizations must happen within this function as shown above.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N1008A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Selecting applicable pages with JavaScript<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142550_N1008E\">In order to decide which customizations of pages are applicable, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> provides an API function <code class=\"codeinline\">isApplicable<\/code> as illustrated below:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100A1\">class MyCustomProductPage extends iam.api.types.CustomProductPage { \r\n  \r\n    isApplicable({pageId, flowId, stepId}) { \r\n        return pageId === \'iamAuthPassword\'; \/\/ example for customizing the product\'s password page \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142550_N1002D\">With this method, it is possible to programmatically define whether this customization of a page should be applied or not. The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> invokes this method whenever a new page is displayed.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The arguments provided are:<\/li><li class=\"enum-element\"><code class=\"codeinline\">pageId<\/code> \u2013 a unique ID for each page of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span>.<\/li><li class=\"enum-element\"><code class=\"codeinline\">flowId<\/code> \u2013 the flow currently in progress (may be undefined for non-flow pages).<\/li><li class=\"enum-element\"><code class=\"codeinline\">stepId<\/code> \u2013 the flow\'s step currently in progress (may be undefined for non-flow pages and flow pages without an explicit step ID).<\/li><\/ul><p class=\"par\" id=\"1614328142550_N10037\">Note that the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> allows multiple page customizations to be applicable. Each page customization determined to be applicable will be applied to the page being displayed.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N100CF\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Inline HTML in JavaScript<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142550_N100D3\">In order to modify an existing page, specific life cycle methods are provided as below:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100EE\">class MyCustomProductPage extends iam.api.types.CustomProductPage { \r\n  \r\n    \/\/ Invoked whenever the page is active and is being entered\/navigated to \r\n    onPageEnter() { \r\n        \/\/ ... \r\n    } \r\n  \r\n    \/\/ Invoked whenever the page is active and is being left \r\n    onPageExit() { \r\n        \/\/ ... \r\n    } \r\n  \r\n    \/\/ Invoked upon language change \r\n    onLanguageChange(language) { \r\n        \/\/ ... \r\n    } \r\n  \r\n    \/\/ Convenience method to provide custom HTML \'blocks\' at four defined positions \r\n    \/\/ on the page. Each of those positions is optional. There are four different \r\n    \/\/ positions where custom blocks can be displayed, in vertical order: \r\n    \/\/ - BEFORE_CONTAINER \r\n    \/\/ - BEFORE_CONTENT \r\n    \/\/ - AFTER_CONTENT \r\n    \/\/ - AFTER_CONTAINER \r\n    customBlocks() { \r\n        return [ \r\n            { \r\n                html: \'&lt;div&gt;before container&lt;\/div&gt;\', \r\n                position: this.customBlockPosition.BEFORE_CONTAINER, \r\n            }, \r\n            { \r\n                html: \'&lt;div&gt;before content&lt;\/div&gt;\', \r\n                position: this.customBlockPosition.BEFORE_CONTENT, \r\n            }, \r\n            { \r\n                html: \'&lt;div&gt;after content&lt;\/div&gt;\', \r\n                position: this.customBlockPosition.AFTER_CONTENT, \r\n            }, \r\n            { \r\n                html: \'&lt;div&gt;after container&lt;\/div&gt;\', \r\n                position: this.customBlockPosition.AFTER_CONTAINER, \r\n            } \r\n        ]; \r\n    } \r\n  \r\n    \/\/ Additional HTML rendering that cannot be done using custom blocks. \r\n    \/\/ Note that this function can be used in combination with custom blocks. \r\n    \/\/ Caution: this method can be invoked more than once on a page: \r\n    \/\/ when entering the page, but also every time when switching the language. \r\n    \/\/ For correct behavior, it must therefore be ensured that previous renderings are undone. \r\n    render () { \r\n        \/\/ ... \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142550_N1018F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Full product page example for JavaScript with inline HTML<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142550_N10193\">The following example shows the customization of the <i class=\"italics\">password page<\/i>. It defines all custom blocks and additionally implements the render method to define a subtitle:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100FE\">iam.api.customizing.initialize = function () { \r\n  \r\n    class MyCustomPasswordPage extends iam.api.types.CustomProductPage { \r\n  \r\n        isApplicable({pageId, flowId, stepId}) { \r\n            return pageId === \'iamAuthPassword\'; \/\/ Only apply to the password page \r\n        } \r\n  \r\n        onPageEnter() { \r\n            console.log(\'entering: iamAuthPassword\'); \/\/ for the sake of illustration \r\n        } \r\n  \r\n        onPageExit() { \r\n            console.log(\'exiting: iamAuthPassword\'); \/\/ for the sake of illustration \r\n        } \r\n  \r\n        customBlocks() { \r\n            return [ \r\n                { \r\n                    html: \'&lt;div&gt;before container&lt;\/div&gt;\', \r\n                    position: this.customBlockPosition.BEFORE_CONTAINER, \r\n                }, \r\n                { \r\n                    html: \'&lt;div&gt;before content&lt;\/div&gt;\', \r\n                    position: this.customBlockPosition.BEFORE_CONTENT, \r\n                }, \r\n                { \r\n                    html: \'&lt;div&gt;after content&lt;\/div&gt;\', \r\n                    position: this.customBlockPosition.AFTER_CONTENT, \r\n                }, \r\n                { \r\n                    html: \'&lt;div&gt;after container&lt;\/div&gt;\', \r\n                    position: this.customBlockPosition.AFTER_CONTAINER, \r\n                } \r\n            ]; \r\n        } \r\n  \r\n        render() { \r\n            \/\/ Example to illustrate how to add a subtitle: \r\n            const cardHeader = document.getElementsByClassName(\'iam-card-header\')[0]; \r\n            let subtitle = document.getElementById(\'customSubtitle\') \r\n            if (subtitle) { \r\n                \/\/ Undo previous renderings: \r\n                subtitle.parentNode.removeChild(subtitle); \r\n            } \r\n            subtitle = document.createElement(\"h3\"); \r\n            subtitle.setAttribute(\'id\', \'customSubtitle\'); \r\n            subtitle.appendChild(document.createTextNode(this.translate(\'custom.login.subtitle\'))); \r\n            cardHeader.appendChild(subtitle); \r\n        } \r\n    } \r\n  \r\n    \/\/ Register the page: \r\n    iam.api.customizing.registerPage(new MyCustomPasswordPage()); \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';