var m_1614328142561Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Adding new pages using the Loginapp Design Kit<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142561\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Adding new pages using the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142561_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142561_N10007\">The Loginapp Design Kit\u200B allows adding entire pages written in JavaScript to provide maximum flexibility.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Custom JavaScript pages may be required in the following cases:<\/li><li class=\"enum-element\">For custom server-side flow steps that require a front-end that cannot be done using the Configurable Step UI Config plugin UI in IAM\'s server-side configuration.<\/li><li class=\"enum-element\">For existing product pages that have to be altered in such a way, the mechanism provided for <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142550.html\">Customizing an existing product page using the Loginapp Design Kit<\/a> is insufficient.<\/li><\/ul><p class=\"par\" id=\"1614328142561_N1001B\">On top of all API methods defined for <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142550.html\">Customizing an existing product page using the Loginapp Design Kit<\/a>, this method provides additional API methods for custom pages.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">While writing custom pages in JavaScript is very powerful, it also comes with additional responsibilities:<\/strong><\/li><li class=\"enum-element\">rendering the page\'s HTML, <\/li><li class=\"enum-element\">handling form input and validation, <\/li><li class=\"enum-element\">dealing with button clicks and interacting with the back-end must be implemented individually. <\/li><p class=\"par\" id=\"1614328142561_N10052\">This mechanism should be chosen with care since it also comes with additional costs and complexity. Therefore, choose this option only if needed and ensure a good understanding of JavaScript. <\/p><\/ul><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N101F0\">To avoid problems with caching, we recommend using SASS whenever possible.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142561_N10039\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Rendering a page using JavaScript<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142561_N10046\">When writing a page in JavaScript, one of the key tasks is to render the content of the page itself. For that, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> provides the following methods:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10045\">iam.api.customizing.initialize = function () { \r\n    class MyCustomJavaScriptPage extends iam.api.types.CustomJavaScriptPage { \r\n  \r\n        \/\/ Defines the page\'s HTML content \r\n        contentHtml() { \r\n            return \'...\'; \r\n        } \r\n  \r\n        \/\/ Invoked when the above provided HTML has been rendered into the page \r\n        afterRender() { \r\n            \/\/ Whatever logic required, e.g. putting focus on a field \r\n        } \r\n    } \r\n  \r\n    \/\/ Register the page: \r\n    iam.api.customizing.registerPage(new MyCustomJavaScriptPage()); \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N1008E\">To be available in the Loginapp Design Kit\'s menu, add custom pages to the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142469.html\">Loginapp Design Kit navigation menu<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N100B5\">For the remainder of this section, the surrounding function <code class=\"codeinline\">iam.api.customizing.initialize<\/code> is not shown in the code examples. However, remember that all JavaScript customizations must happen within this function as shown above.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142561_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Handing control back to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">With custom pages, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> hands control over to the custom JavaScript to:<\/li><li class=\"enum-element\">Render the page.<\/li><li class=\"enum-element\">Handle the input.<\/li><li class=\"enum-element\">Perform calls to Flow API REST endpoints.<\/li><\/ul><p class=\"par\" id=\"1614328142561_N10011\">The REST responses are either successful or failed flow-responses.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">A custom page has two options to handle them:<\/li><li class=\"enum-element\">Deal with them autonomously.<\/li><li class=\"enum-element\">Hand control back to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> to handle them.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N10111\"><strong class=\"emphasis\">Example:<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AC\">iam.api.customizing.initialize = function () { \r\n    class MyCustomJavaScriptPage extends iam.api.types.CustomJavaScriptPage { \r\n  \r\n        \/\/ Defines the page\'s HTML content \r\n        contentHtml() { \r\n            return \'...\'; \r\n        } \r\n  \r\n        \/\/ Invoked when the above provided HTML has been rendered into the page \r\n        afterRender() { \r\n            \/\/ Whatever logic required, e.g. putting focus on a field \r\n        } \r\n    } \r\n  \r\n    \/\/ Register the page: \r\n    iam.api.customizing.registerPage(new MyCustomJavaScriptPage()); \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142561_N10067\">In this basic example, when the <code class=\"codeinline\">POST<\/code> to the back-end was successful, <code class=\"codeinline\">handleSuccessfulFlowResponse<\/code> is called. <br\/>The UI will then automatically determine what to do, e.g. navigate to the next page. On the other hand, if interaction fails, <code class=\"codeinline\">handleFailedFlowResponse<\/code> is called. <\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N100BC\">Note that the error handling in this example might be oversimplified for the general case. I.e. a failed interaction might require the Loginapp UI to render validation errors or alerts and only status codes like <code class=\"codeinline\">401<\/code> or <code class=\"codeinline\">403<\/code> might lead to the invocation of <code class=\"codeinline\">handleFailedFlowResponse<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142561_N10077\">To use the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> without a back-end may require mocking the REST endpoints called by JavaScript. For more details, refer to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142493.html\">Loginapp Design Kit REST response mocking configuration<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142561_N101AA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Full page render example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142561_N101AE\">The following example illustrates how to render a page that looks like the standard mTAN authentication page and how to add back-end invocations in <code class=\"codeinline\">afterRender<\/code>. Note that this is a simple example that could be further improved, e.g., by dealing with other status codes or handling error responses containing field validation errors.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100F81614857052049\">iam.api.customizing.initialize = function () { \r\n    class MyCustomPage extends iam.api.types.CustomJavaScriptPage { \r\n  \r\n        isApplicable({pageId, flowId, stepId}) { \r\n            return pageId === \'my-custom-page\'; \r\n        } \r\n  \r\n        afterRender() { \r\n            document.getElementById(\'otp\').focus(); \r\n            const me = this; \r\n  \r\n            \/\/ Example using XHR: \r\n            document.getElementById(\'myCustomMtanForm\').addEventListener(\'submit\', function (event) { \r\n                event.preventDefault(); \r\n                const data = me.formToJson(document.getElementById(\'myCustomMtanForm\')); \r\n                const xhr = new XMLHttpRequest(); \r\n                xhr.onreadystatechange = function () { \r\n                    if (this.readyState !== 4) { \r\n                        return; \r\n                    } \r\n                    if (this.status === 200) { \r\n                        me.handleSuccessfulFlowResponse(xhr); \r\n                    } else { \r\n                        me.handleFailedFlowResponse(xhr); \r\n                    } \r\n                }; \r\n                xhr.open(\'POST\', me.getRestBaseUrl() + \'\/public\/authentication\/mtan\/otp\/check\'); \r\n                xhr.setRequestHeader(\'Content-Type\', \'application\/json\'); \r\n                xhr.setRequestHeader(\'X-Same-Domain\', 1); \r\n                xhr.send(JSON.stringify(data)); \r\n            }); \r\n  \r\n            \/\/ Same example using \'fetch\': \r\n            \/\/ document.getElementById(\'myCustomMtanForm\').addEventListener(\'submit\', function (event) { \r\n            \/\/    event.preventDefault(); \r\n            \/\/    const data = me.formToJson(document.getElementById(\'myCustomMtanForm\')); \r\n            \/\/    fetch(me.getRestBaseUrl() + \'\/public\/authentication\/mtan\/otp\/check\', { \r\n            \/\/        method: \'POST\', \r\n            \/\/        headers: { \r\n            \/\/            \'Content-Type\': \'application\/json\', \r\n            \/\/            \'X-Same-Domain\': 1 \r\n            \/\/        }, \r\n            \/\/        body: JSON.stringify(data) \r\n            \/\/    }).then(response =&gt; { \r\n            \/\/        if (response.status === 200) { \r\n            \/\/            me.handleSuccessfulFlowResponse(response); \r\n            \/\/        } else { \r\n            \/\/            me.handleFailedFlowResponse(response); \r\n            \/\/        } \r\n            \/\/    }); \r\n            \/\/ }); \r\n  \r\n            document.getElementById(\'otp\').addEventListener(\'keyup\', function () { \r\n                const hasNoInput = document.getElementById(\'otp\').value.length === 0; \r\n                document.getElementById(\'checkOtp\').disabled = hasNoInput; \r\n            }); \r\n        } \r\n  \r\n        getRestBaseUrl() { \r\n            const base = document.getElementsByTagName(\'base\')[0].href; \r\n            const regex = new RegExp(\'\/ui\/?$\'); \r\n            return base.replace(regex, \'\') + \'\/rest\'; \r\n        } \r\n  \r\n        formToJson(form) { \r\n            const formData = {}; \r\n            const elements = form.querySelectorAll(\"input, select, textarea\"); \r\n            for (let i = 0; i &lt; elements.length; ++i) { \r\n                const element = elements[i]; \r\n                if (element.name) { \r\n                    formData[element.name] = element.value; \r\n                } \r\n            } \r\n            return formData; \r\n        } \r\n  \r\n        onPageEnter() { \r\n            console.log(\'entering: my-custom-page\'); \/\/ for the sake of illustration \r\n        } \r\n  \r\n        onPageExit() { \r\n            console.log(\'exiting: my-custom-page\'); \/\/ for the sake of illustration \r\n        } \r\n  \r\n        contentHtml() { \r\n            return `&lt;form id=\"myCustomMtanForm\" novalidate=\"\" autocomplete=\"off\"&gt; \r\n                    &lt;div class=\"iam-row-group\"&gt; \r\n                        &lt;div class=\"iam-form-group iam-row\"&gt; \r\n                            &lt;label class=\"iam-col-12 iam-col-md-5 iam-col-form-label\" for=\"otp\"&gt; \r\n                                {{#translate}}authentication.mtan.otp{{\/translate}} \r\n                            &lt;\/label&gt; \r\n                            &lt;div class=\"iam-col-12 iam-col-md-7\"&gt; \r\n                                &lt;input class=\"iam-form-control\" type=\"text\" id=\"otp\" name=\"otp\" placeholder=\"\"&gt; \r\n                            &lt;\/div&gt; \r\n                        &lt;\/div&gt; \r\n                    &lt;\/div&gt; \r\n                    &lt;div class=\"iam-form-group iam-row\"&gt; \r\n                        &lt;div class=\"iam-col-12 iam-button-group\"&gt; \r\n                                &lt;button class=\"iam-btn iam-btn-block-level-sm-down iam-float-right iam-btn-outline-primary\" \r\n                                        type=\"submit\" id=\"checkOtp\" title=\"\" disabled&gt; \r\n                                    {{#translate}}authentication.mtan.actions.check-otp{{\/translate}} \r\n                                &lt;\/button&gt; \r\n                        &lt;\/div&gt; \r\n                    &lt;\/div&gt; \r\n                &lt;\/form&gt;`; \r\n        } \r\n    } \r\n  \r\n    \/\/ Register the page: \r\n    iam.api.customizing.registerPage(new MyCustomPage()); \r\n};<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';