var m_1614328142568Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>HTML rendering and HTML template variables in the Loginapp Design Kit<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142568\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">HTML rendering and HTML template variables in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142568_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142568_N10007\">When customizing HTML templates, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> adds variables that can be used when rendering the HTML. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">HTML can be rendered in different ways as shown below:<\/li><li class=\"enum-element\">Using plain HTML.<\/li><li class=\"enum-element\">Using <code class=\"codeinline\">renderHtml<\/code> <strong class=\"emphasis\">without<\/strong> arguments.<\/li><li class=\"enum-element\">Using <code class=\"codeinline\">renderHtml<\/code> <strong class=\"emphasis\">with<\/strong> arguments.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142568_N100151614601026623\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using plain HTML<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142568_N100191614601026623\">The simplest case, plain HTML is directly returned from a method, e.g.:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1004B\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n    headerHtml () { \r\n        return \'&lt;div class=\"custom-header\"&gt;&lt;div class=\"custom-header-logo\"&gt;&lt;\/div&gt;&lt;\/div&gt;\'; \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142568_N1002C\">Plain HTML typically is static content that does not require translations or any other variables.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142568_N1004A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using renderHtml without arguments<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">By default, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> provides variables that are always available when rendering HTML such as:<\/li><li class=\"enum-element\">A translate function to translate i18n keys into human-readable text.<br\/>See: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142575.html\">Internationalization and translation with the Loginapp Design Kit<\/a>.<\/li><li class=\"enum-element\">Language information using <code class=\"codeinline\">availableLanguages<\/code>  and determine which one is active (<code class=\"codeinline\">languageActive<\/code>) as well as translate the language into a human-readable text (<code class=\"codeinline\">languageText<\/code>). <br\/>See: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142537.html\">Customization of the Loginapp UI layout using default HTML files<\/a>.<\/li><\/ul><p class=\"par\" id=\"1614328142568_N100781614601026623\">These functions and values are always available even when providing your own arguments to the <code class=\"codeinline\">renderHtml<\/code> method.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142568_N10099\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using renderHtml with arguments<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142568_N1002D\">It is also possible to pass additional arguments to the <code class=\"codeinline\">renderHtml<\/code> method:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100A7\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n    headerHtml() { \r\n        const username = \'John\'; \r\n        const address = { street: \'Airlock Street\', houseNumber: 17 }; \r\n        return this.renderHtml(\'&lt;div&gt;{{#translate}}custom.i18n.key.to.translate{{\/translate}}, your address is {{address.street}} {{address.houseNumber}}&lt;\/div&gt;\', \r\n               { \r\n                   name: username, \r\n                   address: address \r\n               }); \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142568_N1005E\">The arguments can directly be used in the HTML as shown with the address, but can also be accessed as interpolation parameters in an i18n translation, e.g. with the following key:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100AF\">custom.i18n.key.to.translate = Hello {{name}}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142568_N1007B\"><code class=\"codeinline\">renderHtml<\/code> will automatically escape all variables to prevent injection attacks. <\/p><p class=\"par\" id=\"1614328142568_N100C3\">Using the translate method, with interpolation parameters inside the renderHtml method, may lead to escaped special characters (&lt; &gt; \' \" &amp; =&gt; &amp;lt; &amp;gt; &amp;#39; &amp;quot; &amp;amp;) beeing displayed in the browser.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142568_N100B9\">For security reasons we strongly recommend using the renderHtml method with templates (keys in curly brackets) rather than writing strings, variables etc. directly into the HTML.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142568_N100CC\"><code class=\"codeinline\">\/\/ (This is bad)\r\n<\/code><br\/><code class=\"codeinline\">\'&lt;div&gt;\' + variable + \'&lt;\/div&gt;\'<\/code><span class=\"media-theme-inline\" id=\"1614328142568_N100D2\"><img alt=\"Icon - Red dot - element has been removed\" class=\"media-theme-img-tag-inline svg\" src=\"..\/media\/03_Media\/Icons\/Gateway\/8849.Icon_-_Red_dot_-_element_has_been_removed.theme\/1.5\/en-us.8849.Icon_-_Red_dot_-_element_has_been_removed_original.svg\" style=\"width:;height:16px;border:0;\"\/><\/span><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1614328142568_N100D9\"><code class=\"codeinline\">\/\/ (This is good)\r\n<\/code><br\/><code class=\"codeinline\">renderHtml(\'&lt;div&gt;{{variable}}&lt;\/div&gt;\', { variable });<\/code><span class=\"media-theme-inline\" id=\"1614328142568_N100E0\"><img alt=\"Icon - ON\" class=\"media-theme-img-tag-inline svg\" src=\"..\/media\/03_Media\/Icons\/Sonstige\/8850.Icon_-_ON.theme\/1.3\/en-us.8850.Icon_-_ON_original.svg\" style=\"width:;height:20px;border:0;\"\/><\/span><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';