var m_1614328142575Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Internationalization and translation with the Loginapp Design Kit<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1614328142575\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Internationalization and translation with the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span><\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142575_N10006\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142575_N10007\">Internationalization and translation are important whenever end-user UIs are being rendered. There are two ways how to translate text, within an HTML template or programmatically.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142575_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using translations in HTML<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142575_N10011\">HTML often contains text that needs to be available in different languages. The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Design Kit<\/span> provides a mechanism to access translations in a simple way:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10031\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n   \r\n    headerHtml() { \r\n        return \'&lt;div&gt;{{#translate}}custom.i18n.key.to.translate{{\/translate}}&lt;\/div&gt;\'; \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142575_N1002D\">It is also possible to pass arguments for text that contains interpolation parameters:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10039\">custom.i18n.key.to.translate = Hello {{name}}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1003E\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n   \r\n    headerHtml() { \r\n        return \'&lt;div&gt;{{#translate}}{\"key\": \"custom.i18n.key.to.translate\", \"arguments\": {\"name\": \"john\"}}{{\/translate}}&lt;\/div&gt;\'; \r\n    } \r\n} \r\n  \r\n\/\/ \"Hello john\"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142575_N10071\">Alternatively, the arguments can be passed to the <code class=\"codeinline\">renderHtml<\/code> method.<br\/>See: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142568.html\">HTML rendering and HTML template variables in the Loginapp Design Kit<\/a><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1614328142575_N100A6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Programmatic translations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1614328142575_N100AA\">Translations might also be retrieved programmatically, e.g.:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1005F\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n   \r\n    onPageEnter() { \r\n        var translation = this.translate(\'custom.i18n.key.to.translate\'); \r\n        console.log(translation); \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142575_N1002F\">As with translations in HTML, interpolation parameters can be used as follows:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10067\">custom.i18n.key.to.translate = You are working with version {{version}} of {{name}}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1006C\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n   \r\n    onPageEnter() { \r\n        var translation = this.translate(\'custom.i18n.key.to.translate\', { version: \'10.6.1\', name: \'CustomApp\' }); \r\n        console.log(translation); \r\n    } \r\n} \r\n   \r\n\/\/ -&gt; \"You are working with version 10.6.1 of CustomApp\"<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1614328142575_N10075\">Alternatively, entire data models can also be passed:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10074\">custom.i18n.key.to.translate = You are working with version {{app.version}} of {{app.name}}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10079\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n   \r\n    onPageEnter() { \r\n        const app = { \r\n            name: \"CustomApp\", \r\n            version: \'10.6.1\', \r\n            build: \'192ed\' \r\n        }; \r\n   \r\n        var translation = this.translate(\'custom.i18n.key.to.translate\', { app }); \r\n        console.log(translation); \r\n    } \r\n} \r\n   \r\n\/\/ -&gt; \"You are working with version 10.6.1 of CustomApp\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';