var m_1626375362344Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Advanced customization options for the Loginapp REST API layout<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1626375362344\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Advanced customization options for the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span> layout<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N10018\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To overcome the limitations of only 3 customizable default HTML files for header, content, and footer layout, you have the following options:<\/li><li class=\"step\">Setting up separate non-default HTML files by referencing a set of custom HTML files in the JavaScript file. In addition to the standard default HTML customization, this option allows you to store multiple layouts, for example.<\/li><li class=\"step\">Adding inline HTML in JavaScript. This option also allows multiple layouts but can be more complex and less flexible to manage, compared to a set of separate plain HTML files.<\/li><\/ol><p class=\"par\" id=\"1626375362344_N10026\">Both customization approaches require the modification of the JavaScript file but i.e. provide methods to adapt the layout to page events.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Modification of the JavaScript file<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375362344_N1001F\">The JavaScript file is placed here: <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10049\">$CUSTOM_DIRECTORY\/src\/assets\/custom\/js\/iam-custom.js<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1626375362344_N1004C\">The basic structure when using a non-default HTML layout is as follows:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10052\">iam.api.customizing.initialize = function () { \r\n  \r\n    \/\/ Define a layout \r\n    class MyCustomLayout extends iam.api.types.CustomLayout { \r\n        \/\/ ... \r\n    } \r\n  \r\n    \/\/ Register the layout: \r\n    iam.api.customizing.registerLayout(new MyCustomLayout()); \r\n};<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1626375362344_N10034\">The layout has to be defined by extending from:  <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100651626778525699\">iam.api.types.CustomLayout<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1626375362344_N1005B\">The defined layout has to be registered subsequently, using: <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10072\">iam.api.customizing.registerLayout<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N10044\">As a reminder to this section, the surrounding function <code class=\"codeinline\">iam.api.customizing.initialize<\/code> is not shown in all code examples. However, <strong class=\"emphasis\">all JavaScript customizations must happen within this function<\/strong>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N1007C1614599655820\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Selecting applicable layouts with JavaScript<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375362344_N10080\">In order for a layout to be applicable to a specific page, its <code class=\"codeinline\">isApplicable<\/code> method must be evaluated as <code class=\"codeinline\">true<\/code> when the page is loaded:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1007F\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n  \r\n    isApplicable({pageId, flowId, stepId, uiTenantId}) { \r\n        return true; \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1626375362344_N1002D\">By default, the <code class=\"codeinline\">isApplicable<\/code> method is inherited from <code class=\"codeinline\">CustomLayout<\/code> and always returns <code class=\"codeinline\">true<\/code>. This means that the layout will always be applied, greatly simplifying the case when only one layout is defined.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Otherwise, <code class=\"codeinline\">isApplicable<\/code> has to be modified to select the appropriate layout based on the following parameters:<\/li><li class=\"enum-element\"><code class=\"codeinline\">pageId<\/code> \u2013 a unique ID for each page of the UI.<\/li><li class=\"enum-element\"><code class=\"codeinline\">flowId<\/code> \u2013 the flow currently in progress (can be undefined for non-flow pages).<\/li><li class=\"enum-element\"><code class=\"codeinline\">stepId<\/code> \u2013 the flow currently in progress (can be undefined for non-flow pages and flow pages without an explicit flow ID).<\/li><li class=\"enum-element\"><code class=\"codeinline\">uiTenantId<\/code> - provides the identity of the client in OAuth, OIDC and SAML use cases. Is null in all other cases.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N10037\">Note that the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> allows more than just one layout to be applicable, all of which will be applied to the page being displayed. When no layout is applicable, the product\'s default layout is used.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N1008B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Extending from <i class=\"italics\">iam.api.types.CustomLayout<\/i><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375362344_N100C5\">To customize header, footer, and content frame, implement the following methods:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100BB\">class MyCustomLayout extends iam.api.types.CustomLayout { \r\n      \r\n    headerHtml() { \r\n        return ...; \r\n    } \r\n      \r\n    contentHtml() { \r\n        return ...; \r\n    } \r\n      \r\n    footerHtml() { \r\n        return ...; \r\n    } \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1626375362344_N1003B\">When inheriting from <code class=\"codeinline\">CustomLayout<\/code>, no HTML is defined for header, footer, and content. Each method must therefore be implemented when specific HTML is required.<\/p><p class=\"par\" id=\"1626375362344_N1003F\">In contrast to header and footer, the <code class=\"codeinline\">contentHTML()<\/code> method needs to define where the actual content of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> should be rendered to. To do so, it is required to mark an HTML element using HTML ID <code class=\"codeinline\">iamContentTargetContainer<\/code>.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N100DB\"><strong class=\"emphasis\">Example 1\u2013 contentHtml in separate file:<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100DE\">contentHtml() { \r\n    return this.fetchHtml(\'assets\/custom\/templates\/my-custom-content.html\'); \r\n}<\/pre><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N1010E\">The content of the separate HTML would follow :<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10110\">&lt;div class=\"iam-container iam-content-container\"&gt; \r\n                &lt;div class=\"iam-row\"&gt; \r\n                    &lt;div id=\"iamContentTargetContainer\" class=\"iam-col-12\"&gt;&lt;\/div&gt; \r\n                &lt;\/div&gt; \r\n            &lt;\/div&gt;<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">When using separate (non-inline) HTML:<\/li><li class=\"enum-element\">For optimal performance, the Loginapp Design Kit will then inline the file\'s content at build time. For this to work, the path of the file to be loaded has to be a plain string all in one line. Using variables or otherwise concatenating the file path will not work.<\/li><li class=\"enum-element\">In production mode, the build fails if a referenced file does not exist.<\/li><li class=\"enum-element\">In development mode, file deletions or renames are not properly detected and the UI may still show content that does no longer exists. A restart of the development mode helps in this case. <\/li><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N10128\"><strong class=\"emphasis\">Example 2 \u2013 contentHtml as inline code:<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1012C\">contentHtml() { \r\n    return `&lt;div class=\"iam-container iam-content-container\"&gt; \r\n                &lt;div class=\"iam-row\"&gt; \r\n                    &lt;div id=\"iamContentTargetContainer\" class=\"iam-col-12\"&gt;&lt;\/div&gt; \r\n                &lt;\/div&gt; \r\n            &lt;\/div&gt;`; \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375362344_N1006A\">Content HTML that lacks the marking HTML ID will lead to a <strong class=\"emphasis\">broken and unpredictable layout<\/strong>. Conversely, any content within the marked element will be cleared.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N101D7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Full layout definition example for JavaScript with inline HTML<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375362344_N101DB\">The following example for inline HTML code illustrates how to define a layout that applies to all pages of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span>. It uses the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> standard Loginapp HTML that is provided by default.<\/p><p class=\"par\" id=\"1626375362344_N1015F\">The example code and can easily be adapted for separately stored\/managed HTML files, which would be the preferred method in most cases.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10125\">iam.api.customizing.initialize = function () { \r\n    class MyCustomLayout extends iam.api.types.CustomLayout { \r\n  \r\n        isApplicable({pageId, flowId, stepId, uiTenantId}) { \r\n            return true; \r\n        } \r\n  \r\n        headerHtml() { \r\n            return `&lt;div class=\"iam-container iam-header-container\" role=\"header\"&gt; \r\n                        &lt;div class=\"iam-row\"&gt; \r\n                            &lt;div class=\"iam-col-12\"&gt; \r\n                                &lt;div id=\"iamLanguageSwitcher\"&gt; \r\n                                    &lt;header class=\"iam-header\" id=\"header\"&gt; \r\n                                        &lt;div class=\"iam-language-switcher\"&gt; \r\n                                            {{#availableLanguages}} \r\n                                                &lt;a \r\n                                                    id=\"switchLanguageTo-{{languageKey}}\" \r\n                                                    class=\"iam-language-switcher-link {{#languageActive}}iam-active{{\/languageActive}}\" \r\n                                                    data-lang=\"{{languageKey}}\" \r\n                                                    href=\"javascript:void(0)\"&gt; \r\n                                                    {{languageText}} \r\n                                                &lt;\/a&gt; \r\n                                            {{\/availableLanguages}} \r\n                                        &lt;\/div&gt; \r\n                                    &lt;\/header&gt; \r\n                                &lt;\/div&gt; \r\n                            &lt;\/div&gt; \r\n                        &lt;\/div&gt; \r\n                    &lt;\/div&gt;`; \r\n        } \r\n  \r\n        contentHtml() { \r\n            return `&lt;div class=\"iam-container iam-content-container\"&gt; \r\n                        &lt;div class=\"iam-row\"&gt; \r\n                            &lt;div id=\"iamContentTargetContainer\" class=\"iam-col-12\"&gt;&lt;\/div&gt; \r\n                        &lt;\/div&gt; \r\n                    &lt;\/div&gt;`; \r\n        } \r\n  \r\n        footerHtml() { \r\n            return `&lt;div class=\"iam-container iam-footer-container\" role=\"footer\"&gt; \r\n                        &lt;div class=\"iam-row\"&gt; \r\n                            &lt;div class=\"iam-col-12\"&gt; \r\n                                &lt;footer class=\"iam-footer\" id=\"footer\"&gt; \r\n                                    &lt;div class=\"iam-logo\"&gt;&lt;\/div&gt; \r\n                                &lt;\/footer&gt; \r\n                            &lt;\/div&gt; \r\n                        &lt;\/div&gt; \r\n                    &lt;\/div&gt;`; \r\n        } \r\n    } \r\n  \r\n    \/\/ Register the layout: \r\n    iam.api.customizing.registerLayout(new MyCustomLayout()); \r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375362344_N10155\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642782416463.html\">Customizing the language switcher<\/a> for an example.<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054151.html\">Extended tenant ID-dependent customization of the Loginapp UI<\/a> for more information about the <code class=\"codeinline\">uiTenantId<\/code>.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';