var m_1626375384481Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Processing claims (user attributes) from the AS in IAM<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1626375384481\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Processing claims (user attributes) from the AS in IAM<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375384481_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375384481_N1000B\">IAM can process user claims - pieces of information about a user - from different resources and use them in authentication flows and identity propagation.<\/p><p class=\"par\" id=\"1626375384481_N1000D\">In this context, the term <span class=\"dialog\">resource<\/span> refers to sources of claims and should not be confused with the <span class=\"dialog\">Resource Server<\/span> defined in OIDC. In the IAM configuration, use <i class=\"italics\">resource mappings<\/i> to map remote resources to the local IAM user.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible sources of claims are:<\/strong><\/li><li class=\"enum-element\">ID token<\/li><li class=\"enum-element\">Remote service endpoints (e.g., <code class=\"codeinline\">userinfo<\/code> endpoint)<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible types of claims are:<\/strong><\/li><li class=\"enum-element\">User identities (<code class=\"codeinline\">username<\/code>, <code class=\"codeinline\">sub<\/code>, <code class=\"codeinline\">issuer<\/code>, <code class=\"codeinline\">aud<\/code>, etc.)<\/li><li class=\"enum-element\">Roles<\/li><li class=\"enum-element\">Context data<\/li><li class=\"enum-element\">Information related to authentication and authorization (ACR values, scopes, etc.)<\/li><li class=\"enum-element\">Technical information (validity, etc)<\/li><\/ul><p class=\"par\" id=\"1626375384481_N1004B\">To determine the user identity of the foreign authorization server, it is required to configure at least one resource mapping that defines the username. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">In addition to the username, any other resources available may be mapped at login:<\/strong><\/li><li class=\"enum-element\">User role resources will map their values into the <i class=\"italics\">authentee roles<\/i> of the user logging in. <\/li><li class=\"enum-element\">User context data resources will map their values into the<i class=\"italics\"> authentee context data<\/i>.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375384481_N10107\">In order to avoid ambiguity and to ensure a valid username, exactly one <span class=\"dialog\">Remote Username Resource<\/span> must be configured.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375384481_N10109\">In OpenID Connect, it is possible to use an ID Token resource (claim)\u00A0instead of requesting a remote resource\u00A0to be mapped.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375384481_N100F4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Collecting claims from different resources<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The configuration of resources is organized in the following way:<\/strong><\/li><li class=\"enum-element\">One or more resource requests may be sent to a resource endpoint at login.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For each of these resource requests, there is a list of <span class=\"dialog\">Contained Resources<\/span>. This allows taking advantage of resource requests that return more than one piece of information at a time.<\/li><li class=\"enum-element\">Contained resources may be one of three types<\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\"><span class=\"dialog\">OAuth 2.0 Remote Username Resource<\/span>\u2013 uniquely identifies the username.<\/li><li class=\"step\"><span class=\"dialog\">OAuth 2.0 Remote User Role Resource<\/span>\u2013 these values are available as <i class=\"italics\">authentee roles<\/i> after login.<\/li><li class=\"step\"><span class=\"dialog\">OAuth 2.0 Remote Context Data Resource<\/span>\u2013 any other information about the user.<\/li><\/ol><li class=\"enum-element\">To maintain a high level of compatibility, the access token format can be configured differently for each request.<\/li><\/ul><\/ul><p class=\"par\" id=\"1626375384481_N10121\"><strong class=\"emphasis\">This diagram shows the involved plugins and their relationships:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1626375384481_N10156\"><img alt=\"OAuth 2 SSO configuration\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/XML-Diagrameditor\/IAM\/OAuth_2_SSO_configuration.theme\/1.2\/en-us.OAuth_2_SSO_configuration_html.png\" style=\"width:1024px;height:531.4307400379507px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1626375384481_N10130\">If the user-defined through the resource mappings should be authenticated as is (meaning that <i class=\"italics\">Account Linking<\/i> is disabled), users logging in via OAuth 2.0 do not exist in a local database but reside completely on the authorization server, all components depending on users being in a local database have to be disabled.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375384481_N10065\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Identity propagation<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1626375384481_N10068\">The collection of claims is the only particular part of using IAM as a client. Once the claims are available, they can be used in regular identity propagation.<\/p><p class=\"par\" id=\"1626375384481_N1008A\">Identity propagation is configured on the target application and it may combine a subset of the collected claims to be forwarded to that target application to identify the user.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1626375384481_N10076\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1631819651210.html\">Identity propagation<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';