var m_1631819651210Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Identity propagation<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1631819651210\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Identity propagation<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1631819651210_N1000C\">The term <i class=\"italics\">identity propagation<\/i> is used to summarize various methods of how <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> can provide information about an authenticated user to a target application. Identity propagation is highly flexible so that identity information can be propagated to the target application in a format suitable for the target application.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1631819651210_N100261643100167956\"><img alt=\"Identity Propagation basics\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8786.Identity_Propagation_basics.theme\/1.1\/en-us.8786.Identity_Propagation_basics_original.svg\" style=\"width:;height:293px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N1000E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Target applications<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1631819651210_N100111632151419884\">What information about a user is propagated on identity propagation and how this information is structured and encoded depends on the target application that receives this information. Identity propagation is therefore configured directly on the target application. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configuration of identity propagators on the target application has the following advantages:<\/li><li class=\"enum-element\">Every target application can be configured with its own set of identity propagators. <\/li><li class=\"enum-element\">Every target application can be configured with multiple different identity propagators.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N10038\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Identity attributes to propagate<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1631819651210_N1003B\">The user\'s identity is the obvious piece of information sent to a target application, so the application knows who it is dealing with. However, target applications require different additional useful pieces of information. The following table shows the most important identity propagation attributes available in <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span>.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1631819651210_N1004B\"><caption class=\"table-title\">Table: Typical attributes in identity propagation<\/caption><col style=\"width:25%;\"\/><col style=\"width:75%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N1005E\">Attribute<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N10063\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10069\">User ID (also referred to as <i class=\"italics\">username<\/i>)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N10071\">An identifier used by the target application to uniquely identify the authenticated user.<\/p><p class=\"par\" id=\"1631819651210_N10073\">The user ID does not necessarily have to be the same for all target applications. The user ID does not necessarily have to be equal to what the user entered in the login form.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10079\">Provided username<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N1007E1632844349026\">The string the end-user entered in the login form (e.g. username, contract number, email address).<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10084\">Representer user ID<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N10089\">In case the authenticated user is being represented by a representer, this attribute specifies who is representing the user.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N1008F\">Roles<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N10094\">Roles granted to the user during authentication.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N1009A\">Context data<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N1009F\">Context data attributes of the user (e.g. postal address or email address). The attributes may be from the user database, another identity provider (OAuth, OIDC), or extracted from an SSO ticket.<\/p><p class=\"par\" id=\"1631819651210_N100C4\">Propagating context data may be an alternative to synchronizing user data repositories in some scenarios.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N100A5\">OAuth tokens<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N100AA\">Access and ID tokens from OAuth\/OIDC flows.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N100B0\">Login statistics<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N100B5\">Login-related statistical information such as latest login dates, number of failed logins, etc.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N100BB\">Password<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N100C0\">In some special cases (e.g. HTTP Basic Authorization), the user\'s password is required for identity propagation. It is only available if explicitly configured to be available.<\/p><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N100CC\">Whether an identity propagation attribute is available for propagation or not depends on the capabilities of the identity propagator plugin and the configured <i class=\"italics\">value providers<\/i>.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N100EA\">Please read the identity propagator plugin\'s documentation in the Config Editor for detailed information.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N10127\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Encoding identity attributes<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1631819651210_N1012A\">To transport identity attributes to target applications, the attributes must be encoded and usually also protected in some way. <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> supports various encoding schemes providing different levels of security.<\/p><p class=\"par\" id=\"1631819651210_N1013A1632846025304\">If possible, we recommend using JWT (JSON web token) encoding: it is a widespread standard supported by most target application frameworks and it offers proven security features.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N1013F\">Protecting propagated identity information is crucial for the overall security of the system. The receiving target application must be able to verify that the sender of the information (in our case <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>) is trusted. Propagated identity information must - in general - therefore be <strong class=\"emphasis\">digitally signed<\/strong>.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N10152\">If the propagated information is confidential, the identity information must additionally be <strong class=\"emphasis\">encrypted<\/strong>.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N10157\">Failing to adequately protect the propagated information may result in severe security flaws.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1631819651210_N1015C\">Some identity propagator types (e.g. OAuth and SAML) already specify how the information is encoded and protected. In these cases, the configuration does not offer the choice of encoding.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N100EC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Ways to propagate identity data<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1631819651210_N10163\">There are many ways to transport user identity information from <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> to the target applications. The following table lists ways supported by the product. More transport types can be implemented by providing custom identity propagator plugins.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1631819651210_N10173\"><caption class=\"table-title\">Table: Ways to transport identity attributes to target applications<\/caption><col style=\"width:25%;\"\/><col style=\"width:75%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10186\">Transport type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N1018B\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10191\">HTTP Cookie<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N10196\">Identity information is stored in an HTTP cookie and sent to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> cookie store. The cookie is added to all subsequent requests in the corresponding session and sent to the target application.<\/p><p class=\"par\" id=\"1631819651210_N101A6\">Note that with the default gateway settings, the cookie is never sent to the browser (or any other HTTP client), but is stored in the gateway\'s session memory. Therefore, the default cookie settings of the gateway provide a high level of security.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N101AC\">HTTP Header<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N101B1\">Identity information is sent to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> in such a way that the gateway adds an HTTP header to all subsequent target application requests in the corresponding session.<\/p><p class=\"par\" id=\"1631819651210_N101C1\">Note that the header is never sent to the browser (or other HTTP clients) but stored in the gateway\'s session store. It, therefore, provides a high level of security.<\/p><p class=\"par\" id=\"1631819651210_N101E0\">Identity information can also be sent directly to the browser (or other HTTP clients) in an HTTP header.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N101C7\">URL parameter (SSO ticket)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N101CC\">Identity information is sent to the browser (or other HTTP clients) as a URL parameter of an HTTP redirect.<\/p><p class=\"par\" id=\"1631819651210_N101CE\">The identity information is sent via the client and therefore needs to be protected adequately.<\/p><p class=\"par\" id=\"1631819651210_N101D0\">This method can be used to transport identity information to arbitrary target applications even if they are not protected by Airlock or if they are in a different protection domain.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N101D6\">OAuth 2.0 \/ OIDC<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N101DB\">Identity information is transported to target applications by using the standard OAuth 2.0 or OpenID Connect (OIDC) protocols.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N101E1\">SAML 2.0<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N101E6\">Identity information is transported to target applications by using the standard SAML 2.0 web profiles.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N101EC\">HTTP Basic Auth<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N101F1\">Log in the user on target applications by sending the <span class=\"dialog\">HTTP Basic Authorization<\/span> header. User information is sent to the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> in a way that the header is sent in subsequent requests on the same session to the target application.<\/p><p class=\"par\" id=\"1631819651210_N10237\">Note that this requires the user\'s password to be available during identity propagation.<\/p><p class=\"par\" id=\"1631819651210_N101FC\">This method may be used for legacy systems if no better alternative method is available.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1631819651210_N10202\">Kerberos<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1631819651210_N1024A\">Send the username and roles to the target application using the back-side Kerberos feature of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span>.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1631819651210_N1011F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1632806980435.html\">Identity propagation configuration in the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945258.html\">Interaction models for authentication<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1595233404738.html\">Identity propagation in user representation<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';