var m_1632806979611Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>SSO configuration example for Google OP with Airlock IAM as OIDC client<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1632806979611\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">SSO configuration example for Google OP with Airlock IAM as OIDC client<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10009\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1632806979611_N1000A\">This configuration example illustrates how to use Google as OIDC Provider (OP) with Airlock IAM as an OIDC client. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Technologies used in this example are:<\/li><li class=\"enum-element\"><i class=\"italics\">OIDC Discovery Flow Client<\/i> configured for Google OP. This plugin uses the <code class=\"codeinline\">.well-known\/openid-configuration<\/code> endpoint to retrieve the details of the Google configuration.<\/li><li class=\"enum-element\"><i class=\"italics\">Loginapp UI<\/i> with <i class=\"italics\">Authentication Flows<\/i> for authentication <\/li><li class=\"enum-element\">Password page customization to present an <span class=\"dialog\">Authenticate with Google<\/span> button.<\/li><li class=\"enum-element\"><i class=\"italics\">Loginapp Design Kit<\/i> to customize a Google button on the login page.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10021\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Background information<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1632806979611_N10024\">This use case will demonstrate how the example given in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1629119821139.html\">Example: Mobile app with IAM as OAuth client<\/a> needs to be configured.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10031\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configure Google as OP<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Follow the instructions on <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/developers.google.com\/identity\/protocols\/OpenIDConnect\" target=\"_blank\">OpenID Connect<\/a><\/li><li class=\"step\">Create a project in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/console.developers.google.com\/\" target=\"_blank\">Google API Console<\/a><\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Choose a project name (e.g. <i class=\"italics\"><\/i><code class=\"codeinline\">Airlock IAM Integration<\/code>) <\/li><\/ul><li class=\"step\">Create a <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/console.developers.google.com\/apis\/credentials\/consent\" target=\"_blank\">Consent Screen page<\/a><\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Choose an application name (e.g. <i class=\"italics\"><\/i><code class=\"codeinline\">Airlock IAM<\/code>) <\/li><li class=\"enum-element\">Enter authorized domains (e.g. <i class=\"italics\"><\/i><code class=\"codeinline\">example.com<\/code>) <\/li><\/ul><li class=\"step\">Create credentials for an OAuth 2.0 client ID on the  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/console.developers.google.com\/apis\/credentials\" target=\"_blank\">Credentials page<\/a><\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Choose a name (e.g. Airlock IAM Client) <\/li><li class=\"enum-element\">Enter authorized redirect URIs (e.g. <code class=\"codeinline\">https:\/\/iam.example.com\/auth-login\/oauth2\/v3\/oidc-as\/authorize<\/code>)<\/li><\/ul><li class=\"step\">From the newly created credentials obtain OAuth 2.0 credential information <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Client ID <\/li><li class=\"enum-element\">Client secret<\/li><\/ul><li class=\"step result\">Google is now configured as OP.<\/li><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1632806979611_N100A5\">For local tests: make sure the redirect URI field lists <code class=\"codeinline\">https:\/\/localhost:8443\/auth-login\/oauth2\/v3\/oidc-as\/authorize<\/code><\/p><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10026\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configure Airlock IAM as OIDC client<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0\/OIDC Clients<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">OIDC Discovery Flow Client<\/span> plugin in <span class=\"dialog\">AS Setting For Flow Clients <\/span><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Basic Settings<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">OAuth 2.0 Provider Identifier<\/span> plugin in the <span class=\"dialog\">Provider Identifier<\/span> setting <\/li><li class=\"step\">Configure <span class=\"dialog\">Provider Identifier<\/span> as <code class=\"codeinline\">google<\/code>.<\/li><li class=\"step\">Set <span class=\"dialog\">Client ID<\/span> and <span class=\"dialog\">Client Secret<\/span> to the values obtained from Google.<\/li><li class=\"step result\">The <span class=\"dialog\">OIDC Discovery Flow Client<\/span> is configured with Google credentials.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Communication and Discovery<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">HTTP Client Config<\/span> plugin in the <span class=\"dialog\">HTTP Client<\/span> setting<\/li><li class=\"step\">Set the <span class=\"dialog\">Discovery Endpoint URL<\/span> to <code class=\"codeinline\">https:\/\/accounts.google.com\/.well-known\/openid-configuration<\/code><\/li><li class=\"step result\">The <span class=\"dialog\">OIDC Discovery Flow Client<\/span> can connect to Google.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\"><span class=\"dialog\">Authorization Request<\/span><\/span><\/li><li class=\"step\">Add <code class=\"codeinline\">openid<\/code> to the <span class=\"dialog\">Scopes To Request<\/span> setting list<\/li><li class=\"step\">Optionally add additional scopes. (e.g. <code class=\"codeinline\">email<\/code>)<\/li><li class=\"step\">Configure and <span class=\"dialog\">OAuth 2.0 UI Client Redirect URI<\/span> plugin in the <span class=\"dialog\">Client Redirect URI<\/span> setting.<\/li><li class=\"step\">In the <span class=\"dialog\">OAuth 2.0 UI Client Redirect URI<\/span> set the External Base URL (e.g. <code class=\"codeinline\">https:\/\/iam.example.com\/auth-login\/<\/code>)<\/li><li class=\"step result\">The <span class=\"dialog\">OIDC Discovery Flow Client<\/span> will request scopes and supply the correct Client Redirect URI. <br\/>\u00A0<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">ID Token<\/span><\/li><li class=\"step\">Add an <span class=\"dialog\">OIDC RS256 Signature Validator<\/span> plugin in the <span class=\"dialog\">Signature Validator<\/span> setting<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configure the <span class=\"dialog\">OIDC RS256 Signature Validator<\/span> with<\/li><li class=\"enum-element\"><span class=\"dialog\">Remote Key Location<\/span> as <code class=\"codeinline\">https:\/\/www.googleapis.com\/oauth2\/v3\/certs<\/code><\/li><li class=\"enum-element\"><span class=\"dialog\">HTTP Client<\/span> reuse the <span class=\"dialog\">HTTP Client Config<\/span> plugin from <span class=\"dialog\">Communication and Discovery<\/span><\/li><\/ul><li class=\"step\">Set <span class=\"dialog\">Custom Issuer Claim<\/span> to <code class=\"codeinline\">https:\/\/accounts.google.com<\/code><\/li><li class=\"step\">The <span class=\"dialog\">OIDC Discovery Flow Client<\/span> will validate and interpret the ID Token returned by Google.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to: <br\/>Resource Mappings<\/li><li class=\"step\">Create an <span class=\"dialog\">OAuth 2.0 Remote Username Resource<\/span> plugin in the <span class=\"dialog\">ID Token Resources<\/span> setting list.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Create an <span class=\"dialog\">OAuth 2.0 Simple Resource Selector<\/span> plugin in the <span class=\"dialog\">Resource Selector<\/span> and use <code class=\"codeinline\">sub<\/code> as <span class=\"dialog\">Key<\/span>.<\/li><li class=\"enum-element\">Optionally create additional <span class=\"dialog\">OAuth 2.0 Remote Context Data Resource<\/span> plugins or <span class=\"dialog\">OAuth 2.0 Remote User Roles Resource<\/span> plugins.<\/li><\/ul><li class=\"step result\">The <span class=\"dialog\">OIDC Discovery Flow Client<\/span> will map the claims from the ID Token into the local session.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10188\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication Flows<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span><\/li><li class=\"step\">Create a <span class=\"dialog\">Target Application<\/span> plugin in the <span class=\"dialog\">Applications<\/span> setting list.<\/li><li class=\"step\">Create an <span class=\"dialog\">Application ID <\/span>plugin in the <span class=\"dialog\">Application ID<\/span> setting. <\/li><li class=\"step\">Create an <span class=\"dialog\">Authentication Flow<\/span> plugin in the <span class=\"dialog\">Authentication Flow<\/span> setting.<\/li><li class=\"step\">Create a <span class=\"dialog\">Generic ID Propagator<\/span> plugin in the <span class=\"dialog\">Identity Propagation<\/span> setting list.<\/li><li class=\"step result\">The target application is ready to be configured with an ID, an authentication flow, and an identity propagator.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Application ID<\/span><\/li><li class=\"step\">Choose an <span class=\"dialog\">ID<\/span> (e.g. <code class=\"codeinline\">google-app<\/code>). This <span class=\"dialog\">ID<\/span> will be used for translations on the login page.<\/li><li class=\"step result\">The <span class=\"dialog\">Target Application<\/span> is configured with an <span class=\"dialog\">ID<\/span>.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">OAuth 2.0 SSO Step<\/span> in the <span class=\"dialog\">Steps<\/span> setting list.<\/li><li class=\"step\">Configure the OAuth 2.0 SSO Step with<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Choose the <span class=\"dialog\">OAuth 2.0 Provider Identifier<\/span> from the previous configuration as the <span class=\"dialog\">Provider Identifier<\/span> (e.g. <code class=\"codeinline\">OAuth 2.0 Provider Identifier - google<\/code>)<\/li><\/ul><li class=\"step result\">The <span class=\"dialog\">Authentication Flow<\/span> is configured.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Generic ID Propagator<\/span><\/li><li class=\"step\">Configure a <span class=\"dialog\">Ticket String Provider<\/span> plugin in the <span class=\"dialog\">Ticket String Provider<\/span> setting and <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Configure a <span class=\"dialog\">User Identity Map<\/span> plugin in the <span class=\"dialog\">Value Providers<\/span> setting list. <\/li><li class=\"enum-element\">Configure a <span class=\"dialog\">Ticket Key Value<\/span> plugin in the <span class=\"dialog\">Key-Value Pairs<\/span> setting with the <span class=\"dialog\">Ticket Key<\/span> set to <code class=\"codeinline\">username<\/code> and the <span class=\"dialog\">Value Selector<\/span> set to <code class=\"codeinline\">user-id<\/code>.<\/li><li class=\"enum-element\">Configure a <span class=\"dialog\">JWT Ticket Encoder<\/span> in the <span class=\"dialog\">Ticket Encoder<\/span> Setting with <span class=\"dialog\">Username Ticket Key <\/span>set to <code class=\"codeinline\">username<\/code>.<\/li><\/ul><li class=\"step\">Configure a <span class=\"dialog\">URL String Encoder<\/span> in the <span class=\"dialog\">Encoders<\/span> setting list.<\/li><li class=\"step\">Configure a <span class=\"dialog\">Cookie Ticket Adder<\/span> in the <span class=\"dialog\">Ticket Adder<\/span> setting and set the <span class=\"dialog\">Cookie Name<\/span> (e.g. <code class=\"codeinline\">AUTH_TICKET<\/code>).<\/li><li class=\"step result\">The <span class=\"dialog\">Identity Propagator<\/span> propagates the <code class=\"codeinline\">username<\/code> to the backend application in a cookie.<\/li><\/ol><p class=\"par\" id=\"1632806979611_N10249\"><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N1024A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Loginapp UI<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Authentication UIs<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">Authentication &amp; Authorization UI<\/span> in the <span class=\"dialog\">Flow UIs<\/span> setting list.<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Authentication &amp; Authorization UI<\/span><\/li><li class=\"step\">Configure the <span class=\"dialog\">Target Application ID<\/span> by selecting the previously configured <span class=\"dialog\">Application ID <\/span>plugin.<\/li><li class=\"step\">Create a <span class=\"dialog\">Target URI Resolver <\/span>in the Target URI Resolver setting with<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set the <span class=\"dialog\">Default Value<\/span> (e.g. <code class=\"codeinline\">\/client-login\/ui\/app\/protected\/portal<\/code>)<\/li><li class=\"enum-element\">Configure the <span class=\"dialog\">Allowed URIs<\/span> setting list.<\/li><\/ul><li class=\"step result\">The <span class=\"dialog\">Loginapp UI<\/span> is configured for the <span class=\"dialog\">Target Application<\/span>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10283\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Login Page<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1632806979611_N10286\">This configuration is optional. It is required, if both local authentication and authentication through the Google OP should be possible. With this configuration, an additional button will be present on the regular password authentication page.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go To:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Authentication UIs<\/span> &gt;&gt; &lt;Default Authentication Flow&gt; <\/li><li class=\"step\">Create a <span class=\"dialog\">Password Authentication UI<\/span> plugin in the <span class=\"dialog\">Customized Step UIs<\/span> settings list.<\/li><li class=\"step\">Create a <span class=\"dialog\">Step ID<\/span> plugin in the <span class=\"dialog\">Step ID<\/span> setting and configure the <span class=\"dialog\">ID<\/span> (e.g. <code class=\"codeinline\">pwcheck<\/code>)<\/li><li class=\"step\">Create an <span class=\"dialog\">Application ID<\/span> plugin in the <span class=\"dialog\">Additional Authentication Buttons<\/span> setting list and set the <span class=\"dialog\">Application ID<\/span> as the <span class=\"dialog\">ID<\/span> (e.g. <code class=\"codeinline\">google-app<\/code>)<\/li><li class=\"step result\">The default login page will now show a button to start the authentication via the Google OP.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N1028D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Customization with the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/>&lt;Loginapp Design Kit customization directory&gt;<code class=\"codeinline\">\/src\/assets\/custom\/i18n<\/code><\/li><li class=\"step\">Add the required translations for all required languages (e.g. <code class=\"codeinline\">authentication.password.actions.target.google-app = Authenticate with Google<\/code>)<\/li><li class=\"step\">Build and deploy the new version of the customization zip archive.<\/li><li class=\"step result\">The login page of the default authentication flow will now show a button with the label <code class=\"codeinline\">Authenticate with Google<\/code><\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1632806979611_N10343\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945480.html\">Airlock IAM as OAuth Client\/OIDC Relying Party (RP)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626375380143.html\">Configuration of Airlock IAM as OAuth Client \/ OIDC Relying Party (RP)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945406.html\">Flow-based authentication<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1582547572482.html\">Loginapp UI configuration for authentication and authorization flows<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1582547572492.html\">Loginapp Design Kit for Loginapp UI customization<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';