var m_1636653086505Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Remember-Me in authentication flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1636653086505\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Remember-Me in authentication flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1636653086505_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1636653086505_N100CB\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> Remember-Me solution allows for simplifying authentication flows for the users based on persistent cookies stored in the user\'s web browser (or any other client).<\/p><p class=\"par\" id=\"1636653086505_N1001F\">When activated, it stores a persistent cookie in the browser after the end-user has been authenticated. The cookie is then processed in subsequent sessions to re-identify the user and may be used for simplifying the authentication flow, e.g., skip the password check.<\/p><p class=\"par\" id=\"1636653086505_N10022\">Note that a self-service allows end-users to view and manage their stored remember-me tokens.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Typical use-cases for the features are:<\/strong><\/li><li class=\"enum-element\">Skip the 1st authentication step by checking a <i class=\"italics\">keep me logged-in<\/i> checkbox on the login page.<\/li><li class=\"enum-element\">Skip the 2nd authentication step by checking a <i class=\"italics\">trust this browser<\/i> checkbox on the 2nd-factor page.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1636653086505_N10093\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Implementation overview<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following two authentication flow steps implement the Remember-Me feature:<\/strong><\/li><li class=\"enum-element\"><span class=\"dialog\">Remember-Me User Identifying Step<\/span> \u2013 verifies the Remember-Me cookie, identifies the user, and issues tags that can be used to simplify the authentication flow.<\/li><li class=\"enum-element\"><span class=\"dialog\">Remember-Me Token Generating Step<\/span> \u2013 generates the cookie with the Remember-Me token. It is in the authentication flow after authenticating the user and is typically activated using the <strong class=\"emphasis\">dynamic step activation<\/strong> (DSA) feature.<\/li><\/ul><p class=\"par\" id=\"1636653086505_N1001C\">In addition to using the steps in an authentication flow, the <strong class=\"emphasis\">logout behavior configuration<\/strong> determines what to do if a user explicitly logs out, i.e., clicks on a logout button or link. <\/p><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Depending on the use case one of the following behaviors is required:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">REMOVE_COOKIE<\/code> \u2013 removes the cookie when pressing the logout button, so the user has to be fully re-authenticated in the next session. This behavior is the default and typically used if the Remember-Me feature is used to skip the password check.<\/li><li class=\"enum-element\"><code class=\"codeinline\">KEEP_COOKIE<\/code> \u2013 lets the cookie remain untouched when pressing the logout button so it can still be used in the next session. This behavior is, for example, used when using the Remember-Me feature to skip the 2nd authentication factor.<\/li><\/ol><p class=\"par\" id=\"1636653086505_N10066\">In case of an account lock, Remember-Me cookies can be automatically invalidated. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1689952155511.html\">Cleanup on user lock<\/a> for details.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1636653086505_N1003C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Only one Remember-Me cookie can be stored in a browser\/device for all authentication flows. The Remember-Me steps may be used in several flows but all refer to the same cookie. This requires only one Remember-Me configuration for all flows.<\/li><li class=\"enum-element\">Only one user can be identified by a Remember-Me cookie. When another user logs in using the same browser\/device, the Remember-Me cookie in the browser\'s cookie store is overwritten.<\/li><li class=\"enum-element\">So far limited management capabilities have been implemented. The user management in the Adminapp is limited to seeing whether a user has stored logins at all and a button to invalidate all stored logins of the user.<\/li><li class=\"enum-element\">The REST API has been designed for clients with built-in cookie support.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1636653086505_N1003A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Remember-Me token migration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1636653086505_N1003D\">Remember-Me tokens issued by the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">JSP-Loginapp<\/span> are accepted by the Remember-Me feature of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> (but not vice versa). Thus, when migrating to the new login application, users can still profit from Remember-Me tokens and do not have to fully authenticate themselves.<\/p><p class=\"par\" id=\"1636653086505_N100FC\">To enable token migration, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">JSP-Loginapp<\/span>\'s Remember-Me settings must be referenced in the authentication flow configuration\'s Remember-Me settings.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1636653086505_N10110\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span> related, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831365286.html\">Remember-Me settings and configuration for the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> related, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690249704.html\">Remember-Me configuration Loginapp UI<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1661841841921.html\">Browser\/Device Management Self-Service (Remember-Me)<\/a><\/li><li class=\"enum-element\">Adminapp related, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831385759.html\">Remember-Me configuration in Adminapp<\/a><\/li><li class=\"enum-element\">Service container related, <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831403526.html\">Remember-Me token cleanup task configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642098258957.html\">Dynamic step activation (DSA) - flow concept<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1689952155511.html\">Cleanup Remember-Me cookies on user lock<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';