var m_1637831208229Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Keep me logged-in \u2013 persistent authentication between sessions<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1637831208229\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Keep me logged-in \u2013 persistent authentication between sessions<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1637831208229_N10019\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1637831208229_N1001A1638196704679\">The following example targets a simple but common use case with username and password authentication. The <span class=\"dialog\">Keep me logged-in<\/span> checkbox on the login screen activates the Remember-Me feature which automatically identifies the user when using the same browser. This can be used to simplify the login process, e.g. skip the password check.<\/p><figure class=\"media\"><div class=\"media-theme shadow\" id=\"1637831208229_N100121637931839163\"><img alt=\"63972174.png\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/_c3_9cberarbeitete_Altdaten\/references\/mediaset\/PNG\/6x\/63972174.png.theme\/1.5\/en-us.63972174.png_html.png\" style=\"width:;height:343px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1637831208229_N1001D1637931839163\">It roughly works as follows: <\/p><p class=\"par\" id=\"1637831208229_N10025\">After successful authentication, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> stores a persistent Remember-Me cookie in the browser. If the user returns with the same browser on a new session, the Remember-Me cookie is validated and the user does not have to enter the username and password when logging in.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For subsequent sessions with the same browser, the login process is simplified until:<\/li><li class=\"enum-element\">The Remember-Me cookie has expired (in the browser or on <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span>).<\/li><li class=\"enum-element\">The Remember-Me cookie has been tampered with.<\/li><li class=\"enum-element\">A different user logs in with the same browser (not using the browser\'s private mode).<\/li><li class=\"enum-element\">A user administrator has deleted the stored Remember-Me token on <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user explicitly logs out (assuming that logout behavior is configured to remove the cookie on logout). In this case, a new Remember-Me cookie is only issued after re-authentication.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1637831208229_N10017\">Note that we strongly recommend limiting the validity time of the Remember-Me cookie in the configuration.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1637831208229_N10044\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1637831208229_N10049\">Our use case requires a simple flow with the following steps in the shown order:<\/p><figure class=\"media\"><div class=\"media-theme shadow\" id=\"1637831208229_N100441638366733210\"><img alt=\"simple_Remember-me_flowsteps\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/Config_Editor_REST_API\/simple_Remember-me_flowsteps.theme\/1.2\/en-us.simple_Remember-me_flowsteps_html.png\" style=\"width:;height:137px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1637831208229_N10050\"><col style=\"width:30%;\"\/><col style=\"width:15%;\"\/><col style=\"width:55%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N10066\"><strong class=\"emphasis\">Step name<\/strong><\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1637831208229_N1006C1638368332357\"><strong class=\"emphasis\">Tags\/Guards<\/strong><\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N100721638368332357\"><strong class=\"emphasis\">Description<\/strong><\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N10079\">Step 1 \u2013<br\/><span class=\"dialog\">Remember-Me User Identifying Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Tags On Success: <\/li><li class=\"enum-element\"><code class=\"codeinline\">WEAK_AUTHENTICATION<\/code><\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><ol class=\"enum-enum-instruction container-enum enum-standard Alpha first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">This step validates the Remember-Me cookie:<\/li><li class=\"enum-element\">If the token from the user\'s cookie is valid, step 2 is skipped because of the issued tag in this step and the skip condition in the next step.<\/li><li class=\"enum-element\">If the token is missing or the token is invalid, the user has to proceed with step 2, because no tag is issued in this step.<\/li><\/ol><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N10091\">Step 2 \u2013<br\/><span class=\"dialog\">Username Password Authentication Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Skip Condition<\/li><li class=\"enum-element\">Has <code class=\"codeinline\">WEAK_AUTHENTICATION<\/code><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Tags On Success<\/li><li class=\"enum-element\"><code class=\"codeinline\">WEAK_AUTHENTICATION<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">PASSWORD_VERIFIED<\/code><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Activates<\/li><li class=\"enum-element\">Step 3<\/li><\/ul><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N1009E\">This step checks the user and password and issues a tag if successful.<\/p><p class=\"par\" id=\"1637831208229_N100EB\">Additionally, it may activate the next step using the dynamic step activation (DSA) feature. This leads to the <span class=\"dialog\">Keep me logged-in<\/span> check being shown on the login page.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N100AE\">Step 3 \u2013 <br\/><span class=\"dialog\">Remember-Me Token Generating Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Pre Condition<\/li><li class=\"enum-element\"><code class=\"codeinline\">PASSWORD_VERIFIED<\/code><\/li><\/ul><p class=\"par\" id=\"1637831208229_N10112\"><strong class=\"emphasis\">This step needs to be activated.<\/strong><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1637831208229_N100ED\">This step generates a Remember-Me cookie, sends it to the browser, and stores the necessary information in the IAM database.<\/p><p class=\"par\" id=\"1637831208229_N1010E\">The step needs to be activated using the dynamic step activation (DSA) feature. If it is not activated, it is skipped.<\/p><p class=\"par\" id=\"1637831208229_N1011F\">The precondition assures that the step can only be executed after successful username password verification. The precondition can be used to avoid configuration mistakes and is not strictly necessary in this example flow.<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1637831208229_N1012F\">To get the expected results, the logout behavior configuration of the Remember-Me feature must be set to <span class=\"dialog\">REMOVE_COOKIE<\/span>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1637831208229_N1003D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example sequences with and without the <i class=\"italics\"><\/i><span class=\"dialog\">Keep me logged-in<\/span> checkbox enabled<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1637831208229_N10042\">The following simplified sequence diagram shows three different sessions. The authentication step is skipped due to successful Remember-Me cookie validation only in <i class=\"italics\">Session 2<\/i>.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1637831208229_N1002E\"><img alt=\"remember-me cookie\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8760.remember-me_cookie.theme\/1.2\/en-us.8760.remember-me_cookie_original.svg\" style=\"width:;height:708px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Session 1 and Session 2<\/li><li class=\"step\">When <i class=\"italics\">Session 1<\/i> starts, there is no Remember-Me cookie and thus Remember-Me User Identifying Step does nothing. The user enters the username password and checks the <span class=\"dialog\">Keep me logged-in<\/span> checkbox.<\/li><li class=\"step result\">On successful authentication, IAM generates a new Remember-Me cookie. The Remember-Me cookie is sent to the browser and the necessary information is stored in the IAM database.<\/li><li class=\"step\">The user closes the browser (no explicit logout) and <i class=\"italics\">Session 1<\/i> is terminated because of a session timeout.<\/li><li class=\"step result\"> The Remember-Me cookie is still in the browser and the corresponding data in the IAM database is still valid.<\/li><li class=\"step\">When <i class=\"italics\">Session 2<\/i> starts, the Remember-Me cookie token is sent to Airlock IAM.<\/li><li class=\"step\">Because the cookie token is valid, the IAM authentication flow skips the username + password step.<\/li><li class=\"step\">At the end of <i class=\"italics\">Session 2<\/i>, the user uses the logout button to end the session.<\/li><li class=\"step result\">Airlock IAM invalidates the Remember-Me cookie both in the browser and the IAM database, because of the user\'s logout. On the next login, the username + password step can not be skipped anymore.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction fixedStart-6 Continue\" start=\"6\" style=\"--lastC:5\"><li class=\"enum-title\">Session 3<\/li><p class=\"par\" id=\"1637831208229_N100821638196704679\">At the end of <i class=\"italics\">Session 2<\/i>, the Remember-Me cookie has been invalidated because of the logout in step 5.<\/p><li class=\"step\">When <i class=\"italics\">Session 3<\/i> starts, no Remember-Me cookie is sent to IAM. Therefore, the user is asked to enter the username and password. The user chooses not to check the <span class=\"dialog\">Keep me logged-in<\/span> checkbox.<\/li><li class=\"step result\">No new Remember-Me cookie is generated.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1637831208229_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Additional information<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1637831208229_N10176\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> configuration template <span class=\"dialog\">Demo configuration<\/span> features a complex authentication flow using the Remember-Me feature for the here described use-case.<\/p><p class=\"par\" id=\"1637831208229_N10188\">The demo configuration shows how to configure many IAM features  \u2013 you may want to check it out.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1637831208229_N1018D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831365286.html\">Remember-Me settings and configuration for the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690249704.html\">Remember-Me configuration Loginapp UI<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642098258957.html\">Dynamic step activation (DSA) - flow concept<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';