var m_1639690251641Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Scope configuration in IAM flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1639690251641\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Scope configuration in IAM flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1639690251641_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1639690251641_N1000F\">Airlock IAM offers solutions for complex scope-related requirements, including applying a scope policy to multiple clients. Moreover, custom claims can be added and applied using conditional rules.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1639690251641_N100C71689682214968\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of scope policy<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1639690251641_N100CA1689682214968\">If configured, the <span class=\"dialog\">Scope Policy<\/span> property defines how the requested scopes are processed before scope consent or scope filtering. The scope policy can be configured separately for each grant type supported by Airlock IAM.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1639690251641_N1001D\">The scope policy defines how the requested scopes are validated and processed before they are used for scope consent or filtering.    Notice that the mandatory <code class=\"codeinline\">openid<\/code> scope requested by the client merely acts as a marker and is ignored when applying the policy, i.e., when requesting only the <code class=\"codeinline\">openid<\/code> scope, the scope policy treats this as a request without scopes.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are 4 scope policies available:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Scopes Mandatory<\/i> \u2013  here, the request must contain at least one scope in addition to the scope <code class=\"codeinline\">openid<\/code>. Otherwise, the request is denied. <\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Allowed<\/i> \u2013  it is optional for the client to request scopes other than <code class=\"codeinline\">openid<\/code>.<\/li><li class=\"enum-element\"><i class=\"italics\">Always Overwrite Scopes<\/i> \u2013 the scopes requested by the client are ignored and replaced by the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list. If the client has no default scopes, this is treated as if the client has not requested any scopes.<\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Overwritten<\/i> \u2013 when the client does not request any scopes other than <code class=\"codeinline\">openid<\/code>, the request is treated as if the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list were requested.<\/li><p class=\"par\" id=\"1639690251641_N10050\">See the IAM plugin documentation for full details of the scope policy configuration.<\/p><\/ul><p class=\"par\" id=\"1639690251641_N100321689601916556\"><strong class=\"emphasis\">The scope policies can be configured separately for each grant\/flow type:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1639690251641_N1002F1689576244839_N5856F\"><col style=\"width:25%;\"\/><col style=\"width:50%;\"\/><col style=\"width:25%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100ED\">Grant type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100E7\">Where to configure<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10046\">Scope handling<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1004C1689576244839\">OAuth 2.0 Authorization Code Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100FC\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Authorization Code Grant<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span> (section Advanced Settings)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\" rowspan=\"3\" valign=\"middle\"><div><p class=\"par\" id=\"1639690251641_N100521689576244839\">The selected policy is applied to the requested scopes before the scope filtering and the consent step for all grant types.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10058\">OAuth 2.0 Client Credentials Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1011B\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Client Credentials Grant<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N1005E1689576244839\">OIDC Authorization Code \/ Hybrid Flow<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10130\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OIDC Authorization Code \/ Hybrid Flow<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span> (section Advanced Settings)<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10159\">OAuth 2.0 Token Exchange Grant<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N10146\"><span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Token Exchange Grant<\/span> &gt;&gt; <span class=\"dialog\">Token Exchange Rules<\/span> &gt;&gt; <span class=\"dialog\">Scope Claim<\/span> &gt;&gt; <span class=\"dialog\">Scope Policy<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1639690251641_N100691689576244839\">The selected scope policy is applied to the output of the IAM scope processor.<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1639690251641_N100631689841248949\">In addition to the scope policy, the property <span class=\"dialog\">Allow Issuing Tokens With No Scope<\/span> can be enabled\/disabled. If this option is enabled and the resulting scopes from applying the scope policy result in an empty scope, the request fails.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Example 1 (scope filter mode):<\/strong><\/li><li class=\"step\">A statically configured client requests a number of scopes, e.g., <code class=\"codeinline\">firstName<\/code>, <code class=\"codeinline\">lastName<\/code>.<\/li><li class=\"step\">The client\'s <span class=\"dialog\">Allowed\/Default Scopes<\/span> list contains the scopes <code class=\"codeinline\">firstName<\/code>, <code class=\"codeinline\">lastName<\/code>, and <code class=\"codeinline\">fullName<\/code>.<\/li><li class=\"step\"><span class=\"dialog\">Filter Requested Scopes<\/span> is enabled for the client.<\/li><li class=\"step\">The configured <span class=\"dialog\">Scope Policy<\/span> is <i class=\"italics\">Scopes Mandatory<\/i>.<\/li><li class=\"step result\">In this case, the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list works as an <strong class=\"emphasis\">allow list<\/strong>. The requested scopes are filtered against the allowed scopes, leaving the original scopes <code class=\"codeinline\">firstName<\/code> and <code class=\"codeinline\">lastName<\/code> untouched.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Example 2 (set default scopes mode):<\/strong><\/li><li class=\"step\">A statically configured client requests a number of scopes, e.g., <code class=\"codeinline\">firstName<\/code>, <code class=\"codeinline\">lastName<\/code>.<\/li><li class=\"step\">The client\'s <span class=\"dialog\">Allowed\/Default Scopes<\/span> list is configured with the scopes <code class=\"codeinline\">firstName<\/code>, <code class=\"codeinline\">lastName<\/code>, and <code class=\"codeinline\">fullName<\/code>.<\/li><li class=\"step\"><span class=\"dialog\">Filter Requested Scopes<\/span> is enabled or disabled for the client.<\/li><li class=\"step\">The configured <span class=\"dialog\">Scope Policy<\/span> is <i class=\"italics\">Always Overwrite Scopes<\/i>.<\/li><li class=\"step result\">In this case, the requested scopes are <strong class=\"emphasis\">ignored and overwritten<\/strong> by the default scopes <code class=\"codeinline\">firstName<\/code> and <code class=\"codeinline\">lastName<\/code>, and <code class=\"codeinline\">fullName<\/code> from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1639690251641_N100A5\">See the plugin documentation for an in-depth explanation of each policy for statically configured and clients stored in the database.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1639690251641_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of Scope Filtering<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1639690251641_N10176\">Scope filtering is available for <span class=\"dialog\">OAuth 2.0 Authorization Code Grant<\/span> and <span class=\"dialog\">OIDC Authorization Code \/ Hybrid Flow<\/span>.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration example for <span class=\"dialog\"><i class=\"italics\">OAuth 2.0 Authorization Code Grant<\/i><\/span> and <span class=\"dialog\"><i class=\"italics\">OIDC Authorization Code \/ Hybrid Flow<\/i><\/span> with scope filtering<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0\/OIDC Authorization Servers<\/span> &gt;&gt; {{AS-Id}} &gt;&gt; <span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">OAuth 2.0 Authorization Code Grant<\/span> OR <span class=\"dialog\">OIDC Authorization Code \/ Hybrid Flow<\/span> &gt;&gt; Section <span class=\"dialog\">Flow Settings<\/span> <\/li><li class=\"step\">Create and edit an  <span class=\"dialog\">OAuth 2.0 Custom Scopes Flow Settings plugin<\/span> in the <span class=\"dialog\">Scope Filtering<\/span> property.<\/li><li class=\"step\">Optionally create <span class=\"dialog\">Flow Condition Based OAuth 2.0 Scope Condition<\/span> plugins as required.<\/li><li class=\"step\">Optionally create <span class=\"dialog\">Role Based OAuth 2.0 Scope Condition<\/span> plugins as required.<\/li><li class=\"step result\">The AS will be able to determine locally which of the requested scopes may be added to the resulting tokens.<\/li><\/ol><p class=\"par\" id=\"1639690251641_N1003C\">In step 3. of the above list, it is possible to configure an <span class=\"dialog\">OAuth 2.0 Defaults Scopes Flow Settings<\/span> plugin if scopes should be derived from roles only. <\/p><p class=\"par\" id=\"1639690251641_N10041\">The following example demonstrates how the <span class=\"dialog\">OAuth 2.0 Custom Scopes Flow Settings<\/span> plugin can achieve the same effect of scopes derived from user roles.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration example of using <i class=\"italics\">OAuth 2.0 Custom Scopes Flow Settings<\/i> with scopes derived from user roles:<\/strong><\/li><li class=\"step\">Create and edit a <span class=\"dialog\">Role Based OAuth 2.0 Scope Condition<\/span> plugin.<\/li><li class=\"step\">Configure the <span class=\"dialog\">Scope Matcher<\/span> property as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Create and edit an <span class=\"dialog\">OAuth 2.0 Scope Matcher<\/span> plugin.<\/li><li class=\"enum-element\">Configure the <span class=\"dialog\">Scope Name Pattern<\/span> as \".*\"<\/li><\/ul><li class=\"step\">Configure the <span class=\"dialog\">Role Provider<\/span> property as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Add an <span class=\"dialog\">All User Roles<\/span> plugin to the <span class=\"dialog\">Role Provider<\/span> list.<\/li><\/ul><li class=\"step result\">The <span class=\"dialog\">Scope Matcher<\/span> ensures that all requested scopes are tested against the roles retrieved by the <span class=\"dialog\">Role Provider<\/span>.  If a pair of requested scope and provided role is identical, they are added to the tokens.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration example of using <i class=\"italics\">OAuth 2.0 Custom Scopes Flow Settings<\/i> to accept all requested scopes:<\/strong><\/li><li class=\"step\">Create and edit a <span class=\"dialog\">Flow Condition Based OAuth 2.0 Scope Condition<\/span> plugin<\/li><li class=\"step\">Configure the <span class=\"dialog\">Scope Matcher<\/span> property as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Create and edit an <span class=\"dialog\">OAuth 2.0 Scope Matcher<\/span> plugin.<\/li><li class=\"enum-element\">Configure the <span class=\"dialog\">Scope Name Pattern<\/span> as \".*\"<\/li><\/ul><li class=\"step\">Configure the <span class=\"dialog\">Role Condition<\/span> property as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Add the <span class=\"dialog\">Always Selectable<\/span> plugin to the <span class=\"dialog\">Role Provider<\/span> list.<\/li><\/ul><li class=\"step result\">The <span class=\"dialog\">Scope Matcher<\/span> ensures that all requested scopes are tested and the <span class=\"dialog\">Always Selectable<\/span> condition ensures that all scopes are accepted.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1639690251641_N100C7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">Conceptual article <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945473.html\">OAuth 2.0 scopes  and claims<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';