var m_1642098258957Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Dynamic step activation (DSA) - flow concept<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1642098258957\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Dynamic step activation (DSA) - flow concept<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642098258957_N10013\">Dynamic step activation (DSA) is a flow concept that allows steps to activate (or deactivate) steps later in the flow. It gives the end-user (or REST client) control over optional steps.<\/p><p class=\"par\" id=\"1642098258957_N100111642714558728\"><strong class=\"emphasis\">Example: <\/strong><br\/>Using the DSA concept, an end-user may, for example, activate a <span class=\"dialog\">Remember-Me Step<\/span> by checking a box (\"Keep me logged-in\") on the login page:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1642098258957_N10012\"><img alt=\"63972174.png\" class=\"media-theme-img-tag png\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/_c3_9cberarbeitete_Altdaten\/references\/mediaset\/PNG\/6x\/63972174.png.theme\/1.5\/en-us.63972174.png_html.png\" style=\"width:;height:343px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1642098258957_N10027\">In the example, checking the box activates the <span class=\"dialog\">Remember-Me Step<\/span> later in the flow.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N1001D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example use cases<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For a better understanding of what you can do with DSA, consider the following usage example:<\/li><li class=\"enum-element\">The end-user activates the remember-me feature during login.<\/li><li class=\"enum-element\">The end-user activates password change during login.<\/li><li class=\"enum-element\">The end-user activates the activation of an additional 2nd-factor token right after the login.<\/li><li class=\"enum-element\">The end-user chooses to provide extra profile information during self-registration.<\/li><li class=\"enum-element\">The end-user orders an activation letter by activating a corresponding letter-ordering step.<\/li><li class=\"enum-element\">The end-user chooses to skip part of the self-registration process by deactivating one or more steps.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10048\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">General information<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642098258957_N1004B\">Consider the following example flow. <span class=\"dialog\">Step 1<\/span> and <span class=\"dialog\">Step 2<\/span> are processed in order but <span class=\"dialog\">Step 3<\/span> is only processed if it has been activated by <span class=\"dialog\">Step 1<\/span>. If it has not been activated, it is skipped.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1642098258957_N1005E\"><img alt=\"DynamicStepActivation1\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/Flow_drawings\/8835.DynamicStepActivation1.theme\/1.1\/en-us.8835.DynamicStepActivation1_original.svg\" style=\"width:;height:213px;border:0;\"\/><\/div><\/figure><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">A step may be activated by another step if all the following conditions are met:<\/li><li class=\"enum-element\">The step is configured to require activation.<\/li><li class=\"enum-element\">The step has a step ID.<\/li><li class=\"enum-element\">The step implementation supports activations (most but not all steps support step activation).<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Additional information worth noting:<\/li><li class=\"enum-element\">A step may activate multiple (independent) other steps. In this case, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> displays multiple checkboxes.<\/li><li class=\"enum-element\">The activation state of a step is stored in the flow session. If step 3, for example, activates step 5, it may find step 5 already activated by another step.<\/li><li class=\"enum-element\">Dynamic step activation is available for all flow types.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10098\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Activating a sequence of steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642098258957_N1009B\">It may be required to activate a sequence of steps instead of a single step:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1642098258957_N1009E\"><img alt=\"DynamicStepActivation2\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/Flow_drawings\/8836.DynamicStepActivation2.theme\/1.1\/en-us.8836.DynamicStepActivation2_original.svg\" style=\"width:1024px;height:194.04982206405694px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To achieve this, the following setup is recommended:<\/li><li class=\"step\">Use dynamic step activation for the first step to be activated (<span class=\"dialog\">Step 3<\/span> in the example)<\/li><li class=\"step\">For all following activated steps (<span class=\"dialog\">Step 4<\/span> and <span class=\"dialog\">Step 5<\/span> in the example), use the skip condition <span class=\"dialog\">Logical NOT<\/span> on the condition <span class=\"dialog\">Step Activated<\/span>. Thus, <span class=\"dialog\">Step 4<\/span> and <span class=\"dialog\">Step 5<\/span> are skipped if <span class=\"dialog\">Step 3<\/span> has not been activated. In other words, <span class=\"dialog\">Step 4<\/span> and <span class=\"dialog\">Step 5<\/span> are only executed if <span class=\"dialog\">Step 3<\/span> has been executed.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1642098258957_N100D3\">The same behavior may be achieved by activating a Selection Step and defining <span class=\"dialog\">Step 3<\/span>, <span class=\"dialog\">Step 4<\/span>, and <span class=\"dialog\">Step 5<\/span> in the sole selection option that is always selected.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1642098258957_N100DE1642718063318\">This solution results in the same flow execution but requires a more complex configuration and deeper nesting.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10094\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">REST API and <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642098258957_N100A4\">The REST APIs of all flow types (Loginapp: public and protected self-services, authentication, self-registration; Transaction approval) provides the following end-points for dynamic step activation:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">...\/dynamic-steps\/retrieve<\/code> - returns all steps that can be activated from the current step<\/li><li class=\"enum-element\"><code class=\"codeinline\">...\/dynamic-steps\/&lt;step-id&gt;\/activate<\/code> - activates a step<\/li><li class=\"enum-element\"><code class=\"codeinline\">...\/dynamic-steps\/&lt;step-id&gt;\/deactivate<\/code> - deactivates a step<\/li><p class=\"par\" id=\"1642098258957_N100B3\">Please refer to the REST API specification for further details.<\/p><\/ul><p class=\"par\" id=\"1642098258957_N10109\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> dynamically renders step activations by displaying one or more checkboxes as shown in the screenshot above.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10119\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642098258957_N1011C\">Dynamic step activation is configured both on the step to be activated and on the activating step.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In the step to be activated:<\/li><li class=\"enum-element\">Set a <span class=\"dialog\">Step ID<\/span>.<\/li><li class=\"enum-element\">Check the <span class=\"dialog\">Requires Activation<\/span> checkbox.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In the step activating one or more other steps:<\/li><li class=\"enum-element\">Specify the steps to be activated with property <span class=\"dialog\">Dynamic Step Activations<\/span>.<\/li><li class=\"enum-element\">In each <span class=\"dialog\">Dynamic Step Activation<\/span> entry, use the step ID of the step to be activated.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N10138\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following known limitations exist:<\/li><li class=\"enum-element\">DSA is not available for <span class=\"dialog\">Configurable UI<\/span> components in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span>.<\/li><li class=\"enum-element\">DSA is not available for <span class=\"dialog\">Context Data UI<\/span> components in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span>.<\/li><li class=\"enum-element\">DSA does not work across flows (a step can only be activated within a flow).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642098258957_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945388.html\">IAM REST APIs<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Detailed usage examples:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831208229.html\">Keep me logged-in \u2013 persistent authentication between sessions<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831287844.html\">Trust this browser\/device \u2013 persistent 2nd-factor authentication<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';