var m_1642782415579Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Fine-grained customization using tenant ID, flow ID, and\/or step ID<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1642782415579\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Fine-grained customization using tenant ID, flow ID, and\/or step ID<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1642782415579_N1005D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642782415579_N10061\">When using <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> with multiple tenants, multiple flows, or having multiple instances of the same step in one flow, it may be required to have different customizations per tenant, flow, or even per step. Tenant, flow, and\/or step IDs can be prepended to the key names to achieve this. <\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1642782415579_N100B9\"><strong class=\"emphasis\">Example:<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1642782415579_N100BC\">Using <code class=\"codeinline\">authentication.password.username<\/code> as the example key will result in the below key lookup strategy.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Using flow ID, step ID, and tenant ID:<br\/><code class=\"codeinline\">custom.flow-step-tenant.&lt;FLOW_ID&gt;.&lt;STEP_ID&gt;.&lt;TENANT_ID&gt;.&lt;KEY&gt;.authentication.password.username<\/code> <\/li><li class=\"enum-element\">Using step ID and tenant ID:<br\/><code class=\"codeinline\">custom.step-tenant.&lt;STEP_ID&gt;.&lt;TENANT_ID&gt;.&lt;KEY&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using flow ID and tenant ID:<br\/><code class=\"codeinline\">custom.flow-tenant.&lt;FLOW_ID&gt;.&lt;TENANT_ID&gt;.&lt;KEY&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using tenant ID:<br\/><code class=\"codeinline\">custom.tenant.&lt;TENANT_ID&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using flow ID and step ID: <br\/><code class=\"codeinline\">custom.flow-step.&lt;FLOW_ID&gt;.&lt;STEP_ID&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using only step ID: <br\/><code class=\"codeinline\">custom.step.&lt;STEP_ID&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using only flow ID: <br\/><code class=\"codeinline\">custom.flow.&lt;FLOW_ID&gt;.authentication.password.username<\/code><\/li><li class=\"enum-element\">Using neither: <br\/><code class=\"codeinline\">authentication.password.username<\/code><\/li><\/ul><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1642782415579_N10013\">Lookups are performed in this order and terminate on the first match.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1642782415579_N10015\">Note that to see pages with the specific tenant, flow, or step IDs in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span>, either the default flow ID must be configured in <code class=\"codeinline\">custom.sdk.config.js<\/code> and\/or the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142469.html\">Loginapp Design Kit navigation menu configuration<\/a> accordingly.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1642782415579_N1007C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054151.html\">Extended tenant ID-dependent customization of the Loginapp UI<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';