var m_1642782416463Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Customizing the language switcher<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1642782416463\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Customizing the language switcher<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1642782416463_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1642782416463_N10013\">When customizing the language switcher in HTML, a few aspects have to be considered in order to make the language switch work out of the box. Consider the following example:<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1000F\">{{#availableLanguages}}\r\n    &lt;a\r\n        id=\"switchLanguageTo-{{languageKey}}\"\r\n        class=\"iam-language-switcher-link {{#languageActive}}iam-active{{\/languageActive}}\"\r\n        data-lang=\"{{languageKey}}\"\r\n        href=\"javascript:void(0)\"&gt;\r\n        {{languageText}}\r\n    &lt;\/a&gt;\r\n{{\/availableLanguages}} <\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1642782416463_N1001E\">To loop over all available languages, use the <code class=\"codeinline\">availableLanguages<\/code> macro. For each language, the following properties are available: <\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">languageKey<\/code>: denotes the language key, e.g. \"de\" <\/li><li class=\"enum-element\"><code class=\"codeinline\">languageActive<\/code>: whether or not the language is the one currently being used<\/li><li class=\"enum-element\"><code class=\"codeinline\">languageText<\/code>: the human-readable translation of the language. The text is inferred from a translation key <code class=\"codeinline\">general.language.languageKey<\/code>, e.g. general.language.de <\/li><\/ul><p class=\"par\" id=\"1642782416463_N1001B\">In order for the language switch to work properly, the following two constraints must be met as shown in the example above: <\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The HTML element to be clicked by a user must have CSS class<code class=\"codeinline\"> iam-language-switcher-link<\/code><\/li><li class=\"step\">The same element must have an attribute named data-lang with the value of languageKey.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';