var m_1644518868627Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Authentication context classes in the SAML IDP<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1644518868627\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Authentication context classes in the SAML IDP<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1644518868627_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1644518868627_N10013\">A <i class=\"italics\">SAML authentication context class<\/i> describes a level of assurance or authentication method used in a SAML sign-on process.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">SAML authentication context classes are used on the SAML IDP in two different ways:<\/li><li class=\"enum-element\"><strong class=\"emphasis\">In SAML assertions<\/strong>: to tell the service providers (SPs) how the user was authenticated.&gt;&gt;<\/li><li class=\"enum-element\">I<strong class=\"emphasis\">n SAML AuthnRequests<\/strong>: to ask the IDP to authenticate the user in a specific way.<\/li><\/ul><p class=\"par\" id=\"1644518868627_N10020\">How to use and configure the two usage types is described in the following.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1644518868627_N10022\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication context classes in SAML assertions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1644518868627_N10025\">To let the SAML SP know how the user was authenticated, an <i class=\"italics\">authentication context class<\/i> is included in the SAML assertion. Authentication context classes are strings defined in the SAML specification (see list further below).<\/p><p class=\"par\" id=\"1644518868627_N10032\">To configure <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> to include the desired authentication context in SAML assertions, do the following:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Include all authentication context classes that may possibly be included in the SAML assertion in the extended IDP metadata file (<code class=\"codeinline\">idp-extended.xml<\/code>) - see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1644518843819.html\">SAML IDP configuration for the Loginapp REST API<\/a>. The first in the list is used if no information is available which to select.<\/li><li class=\"step\">In the IAM configuration (Config Editor), go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML Settings<\/span> &gt;&gt; <span class=\"dialog\">SAML 2.0 Identity Provider<\/span><\/li><li class=\"step\">Set property <span class=\"dialog\">Default Authentication Context<\/span> to the authentication context class you wish to be included in the SAML assertion if no other authentication context class can be determined based on the mappings. If there is only one authentication method, this is sufficient and you may skip the next step.<\/li><li class=\"step\">In property <span class=\"dialog\">Authentication Context Mappings<\/span>, a mapping may be defined. It allows choosing the authentication context class based on an authentication flow condition. <br\/><strong class=\"emphasis\">Example:<\/strong> To choose the authentication context class  <code class=\"codeinline\">TimeSyncToken<\/code> after the user has been authenticated with an OTP code, use a <span class=\"dialog\">Has Tag<\/span> condition with a specific <span class=\"dialog\">Tag<\/span> (e.g. <code class=\"codeinline\">OTP_VERIFIED<\/code>) and make sure that the tag is granted in the authentication flow after successful OTP verification.<\/li><\/ol><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N1007B1645020845058\">When using flow conditions to choose authentication context classes, make sure to fully understand the semantics of the conditions. Failing to do so may result in the wrong authentication context class being sent to the SP.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N1007D\">For example, the condition <span class=\"dialog\">Active Authentication Method<\/span> (on the value <code class=\"codeinline\">MTAN<\/code>) or the tag <span class=\"dialog\">Has mTAN Token<\/span> do not guarantee that the authentication flow really involved an mTAN token verification.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N10088\">It is suggested to grant a specific tag for each authentication step (e.g. <code class=\"codeinline\">MTAN_VERIFIED<\/code>) and test on this using a <span class=\"dialog\">Has Tag<\/span> condition.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N1009C1645092570796\"><strong class=\"emphasis\">Configuration hint<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N1009F1645092570796\">The flow conditions in property <span class=\"dialog\">Authentication Context Mappings<\/span> are processed in the defined order and the first matching mapping is used. Make sure the mapping order is such that the desired mapping is chosen.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N100A41645092570796\">Example: Assume that a successfully passed authentication flow always grants the tag <code class=\"codeinline\">PASSWORD_VERIFIED<\/code> and only in some cases <code class=\"codeinline\">MTAN_VERIFIED<\/code>. Then, the mapping with the condition on the <code class=\"codeinline\">MTAN_VERIFIED<\/code> tag must be first and the mapping with the condition on the <code class=\"codeinline\">PASSWORD_VERIFIED<\/code> second. If placed in the wrong order, the mapping with the <code class=\"codeinline\">PASSWORD_VERIFIED<\/code> condition would always be selected.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1644518868627_N1002A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication context classes in SAML AuthnRequests<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1644518868627_N1009E1645080278983\">An authentication context may also be requested by the SP in the AuthnRequest: This is how an SP expresses that it requires a certain authentication context to be in the assertion after authentication.<\/p><p class=\"par\" id=\"1644518868627_N100A0\">This may, for example, be used to implement SP-triggered authentication step-up. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Consider the following example scenario:<\/li><li class=\"enum-element\">The user is authenticated with a password and accesses the SP <code class=\"codeinline\">remote-sp1<\/code> with a SAML assertion bearing the authentication context class <code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:Password<\/code>.<\/li><li class=\"enum-element\">Because the user tries to access a critical resource, the SP decides to request a stronger authentication scheme from the IDP. To do so, it sends an AuthnRequest bearing the authentication context <code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileTwoFactorContract<\/code> to the SAML IDP.<\/li><li class=\"enum-element\">The IDP receives the AuthnRequest and asks the user for a 2nd authentication factor (mTAN in this example). Then it sends a new SAML assertion bearing the requested authentication context to the SP.<\/li><\/ul><p class=\"par\" id=\"1644518868627_N100B11645080278983\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> supports this scenario by mapping requested authentication context classes to separate application IDs. This mechanism allows the user to go through a specific authentication flow for each requested authentication context.<\/p><p class=\"par\" id=\"1644518868627_N100CB\">The above example step-up scenario is configured as follows: The instructions are based on an existing SAML target application with application id <code class=\"codeinline\">remote-sp1-application<\/code> as described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1644518852689.html\">Adding SAML SPs to the IDP configuration for the Loginapp REST API <\/a>.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span><\/li><li class=\"step\">Add a new <span class=\"dialog\">Target Application<\/span> with Application ID <code class=\"codeinline\">remote-sp1-step-up<\/code> and configure it as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Configure an <span class=\"dialog\">Authentication Flow<\/span> that extends the authentication flow of the target application <code class=\"codeinline\">remote-sp1-application<\/code> by a 2nd factor. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945406.html\">Flow-based authentication<\/a> for more information on step-up flows.<\/li><li class=\"enum-element\">Use the same identity <span class=\"dialog\">SAML 2.0 Identity Propagator<\/span> plugin as used in target application <code class=\"codeinline\">remote-sp1-application<\/code> (or create a new <span class=\"dialog\">SAML 2.0 Identity Propagator<\/span> also referring to the <span class=\"dialog\">SP Entity ID<\/span> <code class=\"codeinline\">sp1<\/code>).<\/li><\/ul><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML Settings<\/span> &gt;&gt; <span class=\"dialog\">SAML 2.0 Identity Provider)<\/span> &gt;&gt; <span class=\"dialog\">SAML 2.0 Service Provider<\/span> for entity ID <code class=\"codeinline\">sp1<\/code>.<\/li><li class=\"step\">Add a new mapping plugin the <span class=\"dialog\">RequestedAuthnContext to Flow Application ID<\/span> property and configure it as follows.<\/li><li class=\"step\">In <span class=\"dialog\">Requested Authentication Context<\/span> selected the desired requested authentication context class (in our example <code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorContract<\/code>).<\/li><li class=\"step\">In <span class=\"dialog\">Flow Application ID<\/span> select the application ID <code class=\"codeinline\">remote-sp1-step-up<\/code>.<\/li><li class=\"step\">Open the extended SP metadata file (sp1-extended.xml) and make sure that the authentication context in question is listed in the attribute <code class=\"codeinline\">spAuthncontextClassrefMapping<\/code> as in the example below. The list specifies all authentication contexts that are allowed to be requested. <\/li><\/ol><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10179\">&lt;Attribute name=\"spAuthncontextClassrefMapping\"&gt;\r\n\t&lt;Value&gt;urn:oasis:names:tc:SAML:2.0:ac:classes:Password|0|default&lt;\/Value&gt;\r\n\t&lt;Value&gt;urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorContract|1&lt;\/Value&gt;\r\n&lt;\/Attribute&gt;\r\n<\/pre><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N1017E\">The syntax is as follows: <code class=\"codeinline\">&lt;classref-name&gt;|&lt;auth-level&gt;[|default]<\/code>. The one with the <code class=\"codeinline\">default<\/code> label is chosen by default for the SP. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1644518868627_N10184\">Note that the authentication context class entries in the extended IDP metadata file are without the auth level and default tag. If copying them to the IDP configuration, remember to remove <code class=\"codeinline\">|0|<\/code>default, <code class=\"codeinline\">|1<\/code>, and alike.<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction fixedStart-8 Continue\" start=\"8\" style=\"--lastC:7\"><li class=\"step\">The previous steps make sure, that the authentication context sent by the SP is accepted and it defines what flow to start for each authentication context. <br\/>To ensure, that the requested authentication context is included in the assertion after successful authentication, follow the instructions in section <span class=\"dialog\">Authentication context classes in SAML assertions<\/span> at the beginning of this article.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1644518868627_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">SAML Authentication context classes<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1644518868627_N10030\">The SAML specification defines the following authentication context classes. You may use them in the extended IDP metadata file (see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1644518843819.html\">SAML IDP configuration for the Loginapp REST API<\/a>).<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1644518868627_N1004C\"><col style=\"width:100%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N1005A\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:InternetProtocol<\/code> <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10060\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:InternetProtocolPassword<\/code> <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10066\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N1006C\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorUnregistered<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10072\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileTwoFactorUnregistered<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10078\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileOneFactorContract<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N1007E\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:MobileTwoFactorContract<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10084\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:Password<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N1008A\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10090\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:PreviousSession<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N10096\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:X509<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N1009C\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:PGP<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100A2\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:SPKI<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100A8\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:XMLDSig<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100AE\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100B4\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:SmartcardPKI<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100BA\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:SoftwarePKI<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100C0\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:Telephony<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100C6\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:NomadTelephony<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100CC\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:PersonalTelephony<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100D2\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:AuthenticatedTelephony<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100D8\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:SecureRemotePassword<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100DE\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:TLSClient<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100E4\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:TimeSyncToken<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1644518868627_N100EA\"><code class=\"codeinline\">urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified<\/code><\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1644518868627_N100F1\">For detailed information, refer to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.oasis-open.org\/security\/saml\/v2.0\/saml-authn-context-2.0-os.pdf\" target=\"_blank\">OASIS SAML 2.0 Authntication Context Classes<\/a> (PDF).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1644518868627_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links (optional block)<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1644518843819.html\">SAML IDP configuration for the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1644518852689.html\">Adding SAML SPs to the IDP configuration for the Loginapp REST API <\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';