var m_1646748633572Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title> H2 database migration for Airlock IAM 7.6 or newer<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1646748633572\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\"> H2 database migration for Airlock IAM 7.6 or newer<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1646748633572_N1000B\">This tutorial describes how to upgrade the H2 database when upgrading from Airlock IAM 7.5 or older to Airlock IAM 7.6 and newer.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1646748633572_N10010\">This tutorial is meant for the embedded H2 database in Airlock IAM. It may be applied mutatis mutandis to other types of H2 deployments as well.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N10016\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Why and when the database migration is required<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1646748633572_N10019\">With Airlock 7.6 the embedded H2 database has been upgraded from version 1.4.197 to 2.1.210. The version change was necessary because of several severe security vulnerabilities in the old version.<\/p><p class=\"par\" id=\"1646748633572_N1001B\">The newer H2 version uses a different internal data format. The database itself must therefore be upgraded.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1646748633572_N10020\"><strong class=\"emphasis\">If using the embedded h2 database and upgrading from IAM 7.5 (or older) to IAM 7.6 (or newer), the database must be upgraded.<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1646748633572_N10023\">Data from old H2 databases cannot be read by IAM 7.6 or newer.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1646748633572_N1002C\">If you are not sure, whether the embedded H2 database is used, you may check if it gets started with Airlock IAM as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Open the file <code class=\"codeinline\">instance.properties<\/code> in the instance directory.<br\/>Example: <code class=\"codeinline\">less \/home\/airlock\/iam\/instances\/auth\/instance.properties<\/code><\/li><li class=\"step\">Check if the value <code class=\"codeinline\">h2<\/code> is part of the list in property <code class=\"codeinline\">iam.modules<\/code>.<\/li><li class=\"step\">Alternatively, you may check the value of the properties by running the IAM command-line utility: <br\/>Example: <code class=\"codeinline\">iam info -i auth | grep iam.modules<\/code><\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N10025\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites for the database migration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1646748633572_N10028\">To perform the update, the following prerequisites must be met:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The IAM installation of the old IAM version (e.g. 7.5) must still be available.<\/li><li class=\"enum-element\">The new IAM version (e.g. 7.6) must be installed.<\/li><li class=\"enum-element\">The affected IAM instance must be stopped.<\/li><\/ul><p class=\"par\" id=\"1646748633572_N10065\">The table below lists all pieces of information required for the upgrade. To keep the instructions below valid for different IAM and h2 versions, it uses the variables shown in the following table. For each step, an example is given using the example values in the table.<\/p><p class=\"par\" id=\"1646748633572_N100611648710784413\">The values in the example column are valid for a default IAM installation (e.g. using the installer) with instance <code class=\"codeinline\">auth<\/code>. The h2 versions are valid when upgrading from IAM 7.5.2 to IAM 7.6.  <\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1646748633572_N10061\"><col style=\"width:25%;\"\/><col style=\"width:50%;\"\/><col style=\"width:25%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10077\">VARIABLE<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-header table-header-horizontal table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N1007C\">Meaning<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10081\">Value used in example<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10087\"><code class=\"codeinline\">H2_VERSION_OLD<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N1008D\">Refers to the H2 version found in the lib folder of the old IAM version.<\/p><p class=\"par\" id=\"1646748633572_N1008F\">Version 1.4.197 is valid for versions  IAM 7.3 up to at least 7.5.2.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10094\"><code class=\"codeinline\">1.4.197<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N1009B\"><code class=\"codeinline\">H2_VERSION_NEW<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N100A1\">Refers to the H2 version found in the lib folder of the new IAM version.<\/p><p class=\"par\" id=\"1646748633572_N100A3\">Version 2.1.210 is valid for IAM 7.6.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100A8\"><code class=\"codeinline\">2.1.210<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100C9\"><code class=\"codeinline\">IAM_VERSION_OLD<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N100D0\">Refers to the absolute installation directory of the IAM binaries of the version before the upgrade. <\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100D6\"><code class=\"codeinline\">\/opt\/airlock-iam-7.5.2<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100DF\"><code class=\"codeinline\">IAM_VERSION_NEW<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N100E6\">Refers to the absolute installation directory of the IAM binaries of the version after the upgrade.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100EC\"><code class=\"codeinline\">\/opt\/airlock-iam-7.6<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N100F5\"><code class=\"codeinline\">H2_DATA_DIR<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N100FC\">Refers to the <i class=\"italics\">absolute<\/i> h2 data directory. It is configured by property <code class=\"codeinline\">iam.h2.data.dir<\/code> in the <code class=\"codeinline\">instance.properties<\/code> file.<\/p><p class=\"par\" id=\"1646748633572_N10104\">Alternatively it can be determined using the IAM command-line interface: <br\/><code class=\"codeinline\">iam info -i &lt;instance-name&gt; |\u00A0grep iam.h2.data.dir<\/code><\/p><p class=\"par\" id=\"1646748633572_N10115\">Note that the <code class=\"codeinline\">iam.h2.data.dir<\/code> is usually relative to the IAM base dir. Make sure to use the absolute path. The H2 script used below will not accept a relative path.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N1010D\"><code class=\"codeinline\">\/home\/airlock\/iam\/instances\/auth\/h2<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10114\"><code class=\"codeinline\">H2_DB_NAME<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N1011A\">Refers to the H2 database name. It is the last part of the JDBC URL that is configured by property <code class=\"codeinline\">\u200B\u200B<\/code><code class=\"codeinline\">iam.h2.jdbc.url<\/code> in the <code class=\"codeinline\">instance.properties<\/code> file.<br\/>Alternatively the JDBC URL can be determined using the IAM command-line interface: <br\/><code class=\"codeinline\">iam info -i &lt;instance-name&gt; |\u00A0grep iam.h2.jdbc.url<\/code><\/p><p class=\"par\" id=\"1646748633572_N10129\">Example: in the JDBC URL <code class=\"codeinline\">jdbc:h2:tcp:\/\/localhost:9001\/iamdb<\/code> the database name is <code class=\"codeinline\">iamdb<\/code>.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10134\"><code class=\"codeinline\">iamdb<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N1013B\"><code class=\"codeinline\">H2_USER<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N10141\">Refers to the database user that is used to connect to the H2 database. It is configured by property <code class=\"codeinline\">iam.h2.jdbc.user<\/code> in the <code class=\"codeinline\">instance.properties<\/code> file.<\/p><p class=\"par\" id=\"1646748633572_N10149\">Alternatively it can be determined using the IAM command-line interface: <br\/><code class=\"codeinline\">iam info -i &lt;instance-name&gt; |\u00A0grep iam.h2.jdbc.user<\/code> <\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10152\"><code class=\"codeinline\">airlock<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N10159\"><code class=\"codeinline\">H2_PASSWORD<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-innerrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N1015F\">Refers to the database password that is used to connect to the H2 database. It is configured by property <code class=\"codeinline\">iam.h2.jdbc.password<\/code> in the <code class=\"codeinline\">instance.properties<\/code> file.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N1016A\"><code class=\"codeinline\">password<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N1019B\"><code class=\"codeinline\">BACKUP_DIR<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-innercol table-cell-col-even-\"><div><p class=\"par\" id=\"1646748633572_N101A1\">Existing directory to move backup data during the migration. The directory must exist.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-odd-\"><div><p class=\"par\" id=\"1646748633572_N101A61646984949478\"><code class=\"codeinline\">\/home\/airlock\/<\/code><\/p><\/div><\/td><\/tr><\/tbody><\/table><div class=\"legend-ct legend-ct isTableLegend\"><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"legend-table legend isTableLegend\"><colgroup><col width=\"40px\"\/><col width=\"1%\"\/><col width=\"89%\"\/><\/colgroup><tr class=\"legend-row\"><td class=\"legend-term\"><\/td><td><\/td><td class=\"legend-def\"><p class=\"par\" id=\"1646748633572_N100FD\"><\/p><\/td><\/tr><\/table><\/div><p class=\"par\" id=\"1646748633572_N101C0\">To use the example scripts below, you may use the following shell variables and set them to values matching your environment.<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101C8\">H2_VERSION_OLD=1.4.197\r\nH2_VERSION_NEW=2.1.210\r\nIAM_VERSION_OLD=\/opt\/airlock-iam-7.5.2\r\nIAM_VERSION_NEW=\/opt\/airlock-iam-7.6\r\nH2_DATA_DIR=\/home\/airlock\/iam\/instances\/auth\/h2\r\nH2_DB_NAME=iamdb\r\nH2_USER=airlock\r\nH2_PASSWORD=password\r\nBACKUP_DIR=\/home\/airlock<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N101A6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Backup the database (using the old H2 library)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1646748633572_N101A9\">Back up the database using the <i class=\"italics\">old<\/i> H2 library, as shown in the example script below.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1646748633572_N101AE\">Make sure to perform the step using the correct OS user such it has access to the H2 database files and to the installed IAM binaries. The user must be able to write files in a way that they are usable by Airlock IAM (ownership and permission).<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1646748633572_N101B0\">In a standard IAM setup, that was created using the installer script, perform the steps as user <code class=\"codeinline\">airlock<\/code>: <br\/><code class=\"codeinline\">su - airlock<\/code><\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101CD\"># (1) remove, rename or move any backup files from previous database migrations from $BACKUP_DIR to avoid conflicts\r\n# (2) backup database\r\n$IAM_VERSION_OLD\/jre\/bin\/java -cp $IAM_VERSION_OLD\/lib\/h2-$H2_VERSION_OLD.jar org.h2.tools.Script \\\r\n   -url \"jdbc:h2:file:$H2_DATA_DIR\/$H2_DB_NAME\" \\\r\n   -user $H2_USER \\\r\n   -password $H2_PASSWORD \\\r\n   -script $BACKUP_DIR\/h2-backup.zip \\\r\n   -options compression zip\r\n\r\n# (3) move away the h2 database files to avoid conflicts when restoring\r\nmv $H2_DATA_DIR\/$H2_DB_NAME* $BACKUP_DIR\r\n <\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N101FC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Restore the database (using the new H2 library)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1646748633572_N101FF\">Restore up the database using the <i class=\"italics\">new<\/i> H2 library, as shown in the example script below.  <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1020A\"># (4) restore database\r\n $IAM_VERSION_NEW\/jre\/bin\/java -cp $IAM_VERSION_NEW\/lib\/h2-$H2_VERSION_NEW.jar org.h2.tools.RunScript \\\r\n   -url \"jdbc:h2:file:$H2_DATA_DIR\/$H2_DB_NAME;NON_KEYWORDS=VALUE\" \\\r\n   -user $H2_USER \\\r\n   -password $H2_PASSWORD \\\r\n   -script ~\/h2-backup.zip \\\r\n   -options compression zip\r\n\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1646748633572_N1020C\">Do not forget to start the IAM instance again.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1646748633572_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945524.html\">Starting and stopping Airlock IAM (system service integration)<\/a><\/li><li class=\"enum-element\">H2 documentation: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"http:\/\/www.h2database.com\/html\/tutorial.html#upgrade_backup_restore\" target=\"_blank\">http:\/\/www.h2database.com\/html\/tutorial.html#upgrade_backup_restore<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';