var m_1649928953593Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using the Flow Continuation Step in public self-service flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1649928953593\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using the Flow Continuation Step in public self-service flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1649928953593_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649928953593_N10013\">The concept of <i class=\"italics\">flow continuation<\/i> is a mechanism that allows a user-related flow to be started and continued at a later time based on a stored token. While such a flow can be started anywhere, continuation is limited to public self-service flows.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649928953593_N1002B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">How it works<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649928953593_N10030\">Flow continuation is separated into the two components <i class=\"italics\">initiation point<\/i> and <i class=\"italics\">continuation flow<\/i>. The initiating point may be any component that is capable of issuing a <i class=\"italics\">Flow Continuation Token<\/i>. The initiation point issues the token and stores information about the user in the IAM database. The <i class=\"italics\">Flow Continuation Token<\/i> can subsequently be sent to the user, e.g. in an email containing a link. The token link in the email can be used by the user at a later time because the <i class=\"italics\">Flow Continuation Token<\/i> can be validated by a <span class=\"dialog\">Flow Continuation Step<\/span> of the continuation flow at any time.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Available initiation points in Airlock IAM (as of IAM 7.7):<\/li><li class=\"enum-element\"><span class=\"dialog\">Send Email Link Step<\/span> in public self-service flows.<\/li><li class=\"enum-element\"><span class=\"dialog\">Send Email Link Step<\/span> in self-registration flows.<\/li><li class=\"enum-element\"><span class=\"dialog\">Password Token Controller<\/span> in the Adminapp\'s user management.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649928953593_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1649928953593_N10023\"><img alt=\"FlowContinuation\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.7\/DOC-824\/8847.FlowContinuation.theme\/1.3\/en-us.8847.FlowContinuation_original.svg\" style=\"width:;height:463px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">An authorized user uses the public self-service <span class=\"dialog\">Send Email Link Step<\/span> as the initiation point. The step creates a <i class=\"italics\">Flow Continuation Token<\/i> in the database, embeds it in a link, and sends it to the user via email.<\/li><li class=\"step result\">The <i class=\"italics\">Flow Continuation Token<\/i> is stored in the IAM database and can be used in the continuation flow, a public self-service flow containing a <span class=\"dialog\">Flow Continuation Step<\/span>.<\/li><li class=\"step\">When the email link is used by the user, the continuation flow is started. <\/li><li class=\"step\">The <span class=\"dialog\">Flow Continuation Step<\/span> validates the <i class=\"italics\">Flow Continuation Token<\/i> and identifies the user by reading the data stored in the IAM database.<\/li><li class=\"step\">The public self-service flow continues with the user identified by the <span class=\"dialog\">Flow Continuation Step<\/span>.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649928953593_N1006F\">Note that the <i class=\"italics\">initiation point<\/i> and the public self-service <i class=\"italics\">continuation flow<\/i> with the <span class=\"dialog\">Flow Continuation Step<\/span> do not have to operate on the same HTTP session. This is because the user information associated with the <i class=\"italics\">Flow Continuation Token<\/i> is stored in the IAM database.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649928953593_N10071\">This allows for use-cases where the initiation point and the continuation flow are in different components. For example, the starting point of the <i class=\"italics\">initiation point<\/i> may be in the helpdesk\'s browser session and the <i class=\"italics\">continuation flow<\/i> may be in the user\'s browser session.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1649928953593_N1007F\">The <span class=\"dialog\">Flow Continuation Step<\/span> is a non-interactive step and takes the Flow Continuation Token from the HTTP request header <code class=\"codeinline\">X-Flow-Continuation-Token<\/code>.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649928953593_N10088\">The following example request shows how the Flow Continuation Token is sent to the continuation flow as an HTTP header in the request selecting the corresponding flow. <br\/>Note that most other HTTP headers have been removed for simplicity.<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1008A\"><strong class=\"emphasis\">POST \/auth-login\/rest\/public\/self-service\/flows\/password-reset-continue\/select HTTP\/1.1\r\n<\/strong>Content-Type: application\/json\r\nAccept: application\/json, text\/plain, *\/*\r\nUser-Agent: Mozilla\/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit\/605.1.15 (KHTML, like Gecko) Version\/15.4 Safari\/605.1.15\r\nContent-Length: 0\r\n<strong class=\"emphasis\">X-Flow-Continuation-Token: 5zJztFS4osAWnV6KLGdSSXjFjZZATaBsVJW2vSQZtG1i18NZo3MjQu69PJpe4cTPTqfXTxRYppwkpSx2b89Er3hwWBWAcgqS9Qif\r\n<\/strong><\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649928953593_N100B0\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649928953593_N100B3\">The flow continuation concept cannot be used to split any flow at any point. Since the flow continuation token only stores information about the user in the database (and not the whole state of the flow), the following restrictions apply.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A user account for the affected user must exist in the database.<\/li><li class=\"enum-element\">All user data entered or manipulated within the initiation point (e.g. self-registration flow) must be persisted within the initiation point. Open changes are not transported to the continuation flow in the flow continuation token.<\/li><li class=\"enum-element\">The continuation flow must be a public self-service flow.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649928953593_N100A0\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Usage examples:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649928967687.html\">Email link password reset flow example (using flow continuation)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929046362.html\">Email links for user verification in self-registration flows<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929144216.html\">Password management in the IAM Adminapp<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';