var m_1649929251310Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Use case: Propagating arbitrary non-persistent strings attributes with the Generic ID Propagator<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1649929251310\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Use case: Propagating arbitrary non-persistent strings attributes with the Generic ID Propagator<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929251310_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1649929251310_N10009\">Authentication flow steps may store arbitrary non-persistent key-strings pairs (= strings that are not stored in the IAM database) in the flow session. The key-string pairs are available in the identity propagation, i.e., they may be sent to back-end applications.<\/p><p class=\"par\" id=\"1649929251310_N10011\">This article describes how to propagate key-string pairs using the <span class=\"dialog\">Generic ID Propagator<\/span> plugin.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649929251310_N100121654238594109\">The possibility to store arbitrary non-persistent string values in the authentication flow session has originally been implemented for attributes extracted from SAML assertions (IAM as SAML SP). Future IAM flow steps, as well as custom code, may store other string attributes in the authentication flow session.  <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929251310_N10021\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">One or more authentication flow steps store non-persistent key-string pairs in the authentication flow session.<\/li><li class=\"enum-element\">A <span class=\"dialog\">Generic ID Propagator<\/span> plugin is configured as an identity propagator in the affected target application. <\/li><li class=\"enum-element\">The identity propagator uses <span class=\"dialog\">Ticket String Provider<\/span> plugins that support <i class=\"italics\">value providers<\/i>. In the example, the plugin <span class=\"dialog\">Ticket String Provider<\/span> is used. <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929251310_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration for a single key-string pair<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected application   <\/li><li class=\"step\">In property <span class=\"dialog\">Identity Propagation<\/span>, open the <span class=\"dialog\">Generic ID Propagator<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Ticket String Provider<\/span>, create and edit the <span class=\"dialog\">Ticket String Provider<\/span> plugin (or similar plugin supporting value providers).<\/li><li class=\"step\">In property <span class=\"dialog\">Value Providers<\/span>, create and edit a <span class=\"dialog\">Value Provider Map<\/span> plugin or edit the plugin, if it is already in the list.<\/li><li class=\"step\">In property <span class=\"dialog\">Value Providers<\/span>, create a new plugin of the type <span class=\"dialog\">Container Flow Attribute String Provider<\/span> and choose a <span class=\"dialog\">Key<\/span> to reference it later.<\/li><li class=\"step\">In the <span class=\"dialog\">Container Flow Attribute String Provider<\/span>, reference the value to be chosen from the flow string container.<\/li><li class=\"step result\">The selected value is now available through the <span class=\"dialog\">Generic ID Propagator<\/span> under the specified key and can be used for further processing in the configured ticket string provider.      <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929251310_N10076\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration for multiple key-string pairs<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected application &gt;&gt; <span class=\"dialog\">Identity Propagation<\/span>  &gt;&gt; <span class=\"dialog\">Generic ID Propagator<\/span> &gt;&gt; <span class=\"dialog\">Ticket String Provider<\/span> (or other <span class=\"dialog\">Ticket String Provider<\/span> supporting value providers).   <\/li><li class=\"step\">Add the <span class=\"dialog\">Container Flow Attribute Value Map Provider<\/span> to the list of <span class=\"dialog\">Value Providers<\/span>. It adds all non-persistent key-string pairs from the authentication flow session to the values.<\/li><li class=\"step result\">All key-string values are now available and can be used for further processing in the configured ticket string provider.      <\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649929251310_N10083\">Values provided by other value provider plugins may get overwritten. To avoid this, choose unique keys (when storing the key-string attributes in the session or using the configuration option further above).<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';