var m_1649929284434Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Risk-based authentication in the Loginapp REST API\/UI<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1649929284434\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Risk-based authentication in the Loginapp REST API\/UI<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929284434_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1652373181647_N10013\">Risk-based authentication takes one or more pieces of <i class=\"italics\">context information<\/i> into account to assess the current risk. The authentication process can then be influenced based on the assessed risk. It can be used, for example, to omit the second factor in low-risk situations, deny access altogether in very risky situations, or choose a different path in the authentication flow.<\/p><p class=\"par\" id=\"1649929284434_N1001A1652683171130\">More conceptual information can be found in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1652373181647.html\">Risk-based authentication<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929284434_N10017\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Risk Assessment Step configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649929284434_N1001A\">To assess the risk during an authentication process the <span class=\"dialog\">Risk Assessment Step<\/span> is inserted into the sequence of authentication flow steps.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <i class=\"italics\">&lt;affected target application&gt;<\/i> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span>.<\/li><li class=\"step\">Add a new plugin of the type <span class=\"dialog\">Risk Assessment Step<\/span> to the list of flow steps.<\/li><li class=\"step\">Configure the <span class=\"dialog\">Risk Assessment Step<\/span> by adding one or more <span class=\"dialog\">Risk Extractors<\/span> to it.<\/li><li class=\"step\">Use the <i class=\"italics\">flow tags<\/i> produced by the risk extractors to influence the authentication flow. This is achieved by using <i class=\"italics\">skip conditions<\/i>, <i class=\"italics\">preconditions<\/i>, <i class=\"italics\">selection<\/i>, or other flow concepts.<\/li><\/ol><figure class=\"media\"><div class=\"media-theme\" id=\"1649929284434_N10060\"><img alt=\"RiskBasedAuthenticationFlow\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.7\/DOC-823\/8839.RiskBasedAuthenticationFlow.theme\/1.2\/en-us.8839.RiskBasedAuthenticationFlow_original.svg\" style=\"width:;height:409px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Hints for using the <span class=\"dialog\">Risk Assessment Step<\/span> in the authentication flow:<\/li><li class=\"enum-element\">The <span class=\"dialog\">Risk Assessment Step<\/span> adds flow tags to the flow session. The tags can then be used to influence the authentication flow and\/or identity propagation. Therefore, the <span class=\"dialog\">Risk Assessment Step<\/span>\u200B does not directly influence the authentication flow.<\/li><li class=\"enum-element\">The <span class=\"dialog\">Risk Assessment Step<\/span> may be used multiple times in the authentication flow.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929284434_N1008B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Risk extractors and order of authentication flow steps.<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649929284434_N1008E\">Risk extractor plugins take the risk context information into account and, based on the configuration, produce one or more flow tags.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Risk extractor plugin examples (more plugins may be available in the configuration):<\/li><li class=\"enum-element\"><span class=\"dialog\">IP Address Range Risk Flow Extractor<\/span>: produces flow tags based on the client\'s IP address.<\/li><li class=\"enum-element\"><span class=\"dialog\">Typical Geolocation Risk Flow Extractor<\/span>: produces flow tags based on whether the current geolocation of the client is typical for the user logging in. A geo-location service must be configured for this risk extractor.<\/li><li class=\"enum-element\"><span class=\"dialog\">Impossible Journey Risk Extractor<\/span>: produces flow tags based on the theoretical traveling speed between the current geolocation and the geolocation of the latest login. A geo-location service must be configured for this risk extractor.<\/li><li class=\"enum-element\"><span class=\"dialog\">Typical User-Agent Risk Flow Extractor<\/span>: produces flow tags based on whether the current user-agent HTTP header is typical for the user logging in.<\/li><li class=\"enum-element\"><span class=\"dialog\">Anomaly Shield State Risk Extractor<\/span>: produces flow tags based on the Anomaly Shield state reported by Airlock Gateway (8.0 or later).<\/li><li class=\"enum-element\"><span class=\"dialog\">Session Hijacking Notification Risk Extractor<\/span>: produces flow tags based on the session hijacking notification reported by Airlock Gateway.<\/li><li class=\"enum-element\"><span class=\"dialog\">Client Fingerprinting Score Risk Extractor<\/span>: produces flow tags based on the client fingerprinting score reported by Airlock Gateway<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1649929284434_N100A7\">Make sure to place the <span class=\"dialog\">Risk Assessment Step<\/span> <i class=\"italics\">after<\/i> the user-identifying step, if it contains risk extractors depending on user data.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example:<\/li><li class=\"enum-element\">The <span class=\"dialog\">Risk Extractor Step<\/span> contains the <span class=\"dialog\">Typical Geolocation Risk Flow Extractor<\/span> and therefore needs to know who is logging in.<\/li><li class=\"enum-element\">The <span class=\"dialog\">Risk Extractor Step<\/span> is placed after the <span class=\"dialog\">Username Password Authentication Step<\/span>.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1649929284434_N100C2\">Other risk extractors, e.g. the <span class=\"dialog\">IP Address Range Risk Flow Extractor<\/span>, do not depend on user data at all and may be placed before the user-identifying step.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929284434_N100C7\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Login history repository<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1649929284434_N100CA\">The <i class=\"italics\">login history repository<\/i> stores information about a user\'s successful logins. It contains contextual information such as date, time, geolocation, user agent, etc. Risk extractors can use the information to judge whether the current risk context information is <i class=\"italics\">normal<\/i> for a user or not.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For such risk extractors to work correctly, consider the following configuration settings:<\/li><li class=\"enum-element\">Configure a <span class=\"dialog\">Login History Repository<\/span> in <span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span>.<\/li><li class=\"enum-element\">For each authentication flow (independent of whether the flow contains a risk assessment step), decide whether it adds an entry to the login history if it was successful. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two ways to ensure this:<\/li><li class=\"enum-element\">If the flow uses the <span class=\"dialog\">Default Authentication Processor<\/span>: enable its <span class=\"dialog\">Write Login History<\/span> checkbox.<\/li><li class=\"enum-element\">If the flow uses the <span class=\"dialog\">Custom Flow Processors<\/span> plugin: add the plugin <span class=\"dialog\">Login History Processor<\/span> to the list of processors.<\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1649929284434_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1600698368517.html\">Flows as Airlock IAM concept<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1652373181647.html\">Risk-based authentication<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';