var m_1652877537393Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Additional Cronto device activation in authentication flows in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1652877537393\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Additional Cronto device activation in authentication flows in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877537393_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877537393_N1000B\">This article describes how to extend an existing authentication flow to allow end-users to activate an <i class=\"italics\">additional<\/i> Cronto device during authentication.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Authentication flow step or protected self-service?<\/li><li class=\"enum-element\">When using application portals (either the Airlock IAM application portal or a custom portal) configuring a protected self-service is often preferred over configuring the same functionality in an authentication flow. In this case, the self-service link would be offered on the application portal itself.<\/li><li class=\"enum-element\">Customers with a customizable target application might want to prefer configuring a protected self-service link on their application page. However, if multiple (i.e. visually different) target applications are offered, configuring device activation in an authentication step instead of placing links on different application pages can be more user-friendly.<\/li><li class=\"enum-element\">For customers with target applications that should not be further customized, configuring the device activation in an authentication step might be the best solution.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877537393_N10018\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The steps in this article assume that an authentication flow containing the <span class=\"dialog\">Cronto Authentication Step<\/span> as the 2nd factor is already configured.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877537393_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use case<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877537393_N10028\">On the Cronto authentication page, the user may choose to activate an additional Cronto device after the 2nd factor has been successfully checked. If chosen to do that, a <span class=\"dialog\">Cronto Activation Step<\/span> is activated using the <i class=\"italics\">dynamic step activation (DSA)<\/i> feature.<\/p><p class=\"par\" id=\"1652877537393_N10034\">The following screenshot shows the Cronto authentication page with the checkbox activating the <span class=\"dialog\">Cronto Activation Step<\/span>:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1652877537393_N1002C\"><img alt=\"CrontoAuthStepWithDSA\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Loginapp\/CrontoAuthStepWithDSA.theme\/1.2\/en-us.CrontoAuthStepWithDSA_html.png\" style=\"width:;height:586px;border:0;\"\/><\/div><\/figure><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following diagrams show two authentication flow configurations (both correspond to the above screenshot):<\/li><li class=\"enum-element\"><code class=\"codeinline\">auth-flow-1<\/code>: A simple 3-step version where the <span class=\"dialog\">Cronto Activation Step<\/span> is directly activated in the <span class=\"dialog\">Cronto Authentication Step<\/span>. This works if activating additional Cronto devices should be always possible.<\/li><li class=\"enum-element\"><code class=\"codeinline\">auth-flow-2<\/code>: A slightly more complex flow with 4 steps where the <span class=\"dialog\">Cronto Authentication Step<\/span> activates an intermediate <span class=\"dialog\">Selection Step<\/span>. The selection step checks whether activating another Cronto device is possible. If yes, the <span class=\"dialog\">Cronto Activation Step<\/span> is executed, if not, the user is informed that activating another device is not possible. This may be useful, if, for example, the number of activatable devices is limited.<\/li><\/ul><figure class=\"media\"><div class=\"media-theme\" id=\"1652877537393_N10067\"><img alt=\"CrontoAdditionalDeviceActivation\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.7\/DOC-851\/8838.CrontoAdditionalDeviceActivation.theme\/1.2\/en-us.8838.CrontoAdditionalDeviceActivation_original.svg\" style=\"width:;height:455px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877537393_N10071\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877537393_N10074\">The following configuration example corresponds to <i class=\"italics\">auth-flow-2<\/i> in the above diagram. It can also be found in the <span class=\"dialog\">Demo configuration<\/span> within the authentication flow for the default target application.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected flow &gt;&gt; <span class=\"dialog\">Cronto Authentication Step<\/span>.<\/li><li class=\"step\">Add a new <span class=\"dialog\">Selection Step<\/span> right after the <span class=\"dialog\">Cronto Authentication Step<\/span>.<\/li><li class=\"step\">Check the <span class=\"dialog\">Requires activation<\/span> checkbox in the new selection step.<\/li><li class=\"step\">Define a Step ID (e.g. <code class=\"codeinline\">activate-extra-cronto-device<\/code>) in the new selection step.<\/li><li class=\"step\">To the list of Available Options, add a selection option with the <span class=\"dialog\">Cronto Activation Step<\/span> and the <span class=\"dialog\">Cronto Activation Possible<\/span> condition.<\/li><li class=\"step\">To the <span class=\"dialog\">Fallback Flow<\/span> property, add an <span class=\"dialog\">Acknowledge Message Step<\/span> that explains to the end-user why the activation is not possible.<\/li><li class=\"step\">Go back to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected flow &gt;&gt; <span class=\"dialog\">Cronto Authentication Step<\/span>.   <\/li><li class=\"step\">In the <span class=\"dialog\">Dynamic Step Activations<\/span> property, add a<span class=\"dialog\"> Dynamic Step Activation<\/span> plugin. Use the step ID defined above (e.g. <code class=\"codeinline\">activate-extra-cronto-device<\/code>) to refer to the selection step.<\/li><li class=\"step result\">The Loginapp will show the checkbox <span class=\"dialog\">Activate additional Cronto device<\/span> on the Cronto Authentication page.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877537393_N10110\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> configuration: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1652877537456.html\">Activate an additional Cronto device during authentication in the Loginapp UI<\/a><\/li><li class=\"enum-element\">Conceptual information: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945336.html\">Cronto authentication (OneSpan)<\/a><\/li><li class=\"enum-element\">Alternative protected self-service: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1582547572139.html\">Protected self-service REST APIs<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642098258957.html\">Dynamic step activation (DSA) - flow concept<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636415729.html\">Flow selection and conditions<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';