var m_1652877887985Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Customizing non-UI-related text elements in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1652877887985\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Customizing non-UI-related text elements in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877887985_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two kinds of text elements. One is used by the Loginapp REST API and one by the UI:<\/li><li class=\"enum-element\">For (Loginapp) text elements displayed in the browser, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142516.html\">Customizing Loginapp UI texts and changing translations with the Loginapp Design Kit<\/a>.<\/li><li class=\"enum-element\">Text elements used for \u200Bnon-UI-related\u200B texts (such as email, SMS, or Cronto texts not shown in the browser, etc.). <strong class=\"emphasis\">This article is about these types of text elements.<\/strong><\/li><\/ol><p class=\"par\" id=\"1652877887985_N1013F\">Customizing texts of the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp REST API<\/span> module is done in <code class=\"codeinline\">*.properties<\/code> files. New language property files can be created for <i class=\"italics\">all<\/i> or <i class=\"italics\">specific<\/i> instances.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following languages are already included with each <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> installation and upgrade:<\/li><li class=\"enum-element\">German<\/li><li class=\"enum-element\">English<\/li><li class=\"enum-element\">French<\/li><li class=\"enum-element\">Italian<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877887985_N100171653915331371\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Create new property files<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877887985_N10054\">We recommend creating empty property file(s) to prepare for text changes.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678383098174_N100721679394089380\">With Airlock IAM  8.0 and later, ISO\/IEC 8859-1 (aka Latin-1) encoding for <code class=\"codeinline\">*.properties<\/code> files is no longer supported. Property files must be <i class=\"italics\">UTF-8<\/i> encoded.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard Point\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For all installed <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instances:<\/li><li class=\"enum-element\">Create the files\u00A0<code class=\"codeinline\">strings_de.properties<\/code>,\u00A0<code class=\"codeinline\">strings_en.properties<\/code> (and so on) in the directory\u00A0<code class=\"codeinline\">.\/instances\/common\/loginapp-texts\/<\/code>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard Point\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For a specific <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instance:<\/li><li class=\"enum-element\">Create the files <code class=\"codeinline\">strings_de.properties<\/code>,\u00A0<code class=\"codeinline\">strings_en.properties<\/code> (and so on) in the directory\u00A0<code class=\"codeinline\">.\/instances\/&lt;instance-name&gt;\/loginapp-texts\/<\/code>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877887985_N10017\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Copy resource keys and texts from the original language property files<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877887985_N100401653915331371\">After creating empty language property file(s), copy the required template texts from one of the original <code class=\"codeinline\">strings_*.properties<\/code> files, e.g., from the <code class=\"codeinline\">strings_en.properties<\/code> file.  Copy the resource keys (e.g. <code class=\"codeinline\">authentication.email.otp.subject<\/code>), including the corresponding template text.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> installation folder, go to: <br\/><code class=\"codeinline\">app\/loginapp\/WEB-INF\/classes\/<\/code><\/li><li class=\"step\">Use a text editor to open the corresponding language file, e.g. <code class=\"codeinline\">strings_es.properties<\/code> to customize English texts.<\/li><li class=\"step\">Find and copy the desired existing element by searching for its key, e.g. <code class=\"codeinline\">public-self-service.email.otp.body<\/code>.<\/li><li class=\"step\">Paste the copied line into the corresponding empty string-property file (see <i class=\"italics\">Step 1.<\/i>) and adapt the copied wording as required.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1678383098186_N1008C\">Do not make changes to the original <code class=\"codeinline\">strings_*.properties<\/code> file, i.e. do not make any changes to the original template files as these files will be overwritten without notice during updating and installation procedures. Only add those text elements to the newly created properties files, which should be customized, not all text elements.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The changes are applied automatically after 30 seconds.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877887985_N100E3\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Adding a new language<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877887985_N100F8\">New languages can be added by creating additional language property files.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Add a new <code class=\"codeinline\">strings_*.properties<\/code> with the 2-letter country code based on an existing properties file. The common way to add a new language is to copy and rename the <code class=\"codeinline\">strings_en.properties<\/code> for translation.<\/li><li class=\"step\">Translate the resource keys in the new language properties file.<\/li><li class=\"step\">Save the new properties file for specific or all <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instances. See <i class=\"italics\">Step 1<\/i> for the storage path.<\/li><li class=\"step\">Add the new language in the Config Editor under <span class=\"dialog\">Loginapp<\/span> &gt;&gt;  <span class=\"dialog\">Language Settings<\/span> in the list of <span class=\"dialog\">Valid Languages<\/span>.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><p class=\"par\" id=\"1674151143652_N100601676902792938\"><strong class=\"emphasis\">Example:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme shadow\" id=\"1674151143652_N10061\"><img alt=\"Language Settings\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Loginapp_REST_UI\/Language_Settings.theme\/1.1\/en-us.Language_Settings_html.png\" style=\"width:;height:323px;border:0;\"\/><\/div><\/figure><\/ul><p class=\"par\" id=\"1652877887985_N10196\">Note that depending on the used feature set, there may be other points in the configuration where the new language must be added (e.g., for language choice in user registration self-service or user management in the Adminapp).<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877887985_N10199\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Internal links:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142516.html\">Customizing Loginapp UI texts and changing translations with the Loginapp Design Kit<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1674151143652.html\">Internationalization (i18n) with language and locale codes<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';