var m_1652877890324Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Voluntary password change in the authentication flow in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1652877890324\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Voluntary password change in the authentication flow in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877890324_N1000A1654687727586\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877890324_N1000B1654687727586\">This article describes how to adapt an authentication flow such that the end-user is given the option to change the password within the flow.<\/p><p class=\"par\" id=\"1652877890324_N1000F\">Changing the password during the login process can be a useful alternative to using the corresponding protected self-service flow. When the password change is already part of the authentication process it does not require the end-user to find and navigate to the self-service after login.<\/p><p class=\"par\" id=\"1652877890324_N10012\">The following configuration instructions show how to use <i class=\"italics\">dynamic step activation<\/i> to give the end-user (or REST client) the option to activate the <span class=\"dialog\">Voluntary Password Change<\/span> step.<\/p><p class=\"par\" id=\"1652877890324_N1001B\">The details depend on whether mandatory password change is also part of the authentication flow or not. In the following, both scenarios are described.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1652877890324_N1001F1655364649075\"><img alt=\"VoluntaryPasswordChangeFlow\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_7.7\/DOC-827\/8837.VoluntaryPasswordChangeFlow.theme\/1.3\/en-us.8837.VoluntaryPasswordChangeFlow_original.svg\" style=\"width:;height:455px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1623759810383_N1004B\">The voluntary password change self-service may be used after the existing password has been stolen or revealed to non-legitimate persons.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1623759810383_N1004D\">It is therefore good practice to log out all persistently logged-in browsers and devices (OAuth, remember-me features). This can be done by configuring the corresponding steps after setting the new password.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877890324_N1001E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An authentication flow with a <span class=\"dialog\">Username Password Authentication Step<\/span> already exists.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877890324_N10038\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Simple configuration (without mandatory password change)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877890324_N1002C\">The simple configuration assumes that there is no <span class=\"dialog\">Mandatory Password Change<\/span> step required in the flow.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The configuration is therefore straightforward:<\/li><li class=\"enum-element\">Add the Voluntary Password Change step to the flow.<\/li><li class=\"enum-element\">Make it activatable in a preceding step.<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <i class=\"italics\">affected target application<\/i> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">Add the <span class=\"dialog\">Voluntary Password Change Step<\/span> for authentication to the flow.<\/li><li class=\"step\">Place the new step after the <span class=\"dialog\">Username Password Authentication Step<\/span> in the flow. <\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1652877890324_N1006B\">Note that when using strong authentication, it is best for security reasons to place the step after the 2nd-factor step.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Configure the <span class=\"dialog\">Voluntary Password Change Step<\/span>. In section <span class=\"dialog\">Flow Control<\/span>:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Select the <span class=\"dialog\">Step ID<\/span> <i class=\"italics\">voluntary-password-change<\/i>.<\/li><li class=\"enum-element\">Check the <span class=\"dialog\">Requires Activation<\/span> option.  <\/li><\/ul><li class=\"step result\">The voluntary password change step is now preconfigured. To allow a voluntary password change on the authentication step, the dynamic step activation has to be configured on the <span class=\"dialog\">Username Password Authentication Step<\/span>.<\/li><li class=\"step\">Back in the authentication flow, configure the <span class=\"dialog\">Username Password Authentication Step<\/span> in section <span class=\"dialog\">Flow Control<\/span>:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Add a new <span class=\"dialog\">Dynamic Step Activation<\/span> element.<\/li><li class=\"enum-element\"> Assign a voluntary password change step by selecting the step ID <code class=\"codeinline\">voluntary-password-change<\/code>.<\/li><\/ul><li class=\"step result\">The configuration is now completed and can be activated.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877890324_N10069\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Extended configuration (with mandatory password change)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1652877890324_N1006C\">If a mandatory and voluntary password change step is part of the authentication flow, the configuration is more complicated because we need to ensure that a password change is not required twice in the same flow.<\/p><p class=\"par\" id=\"1652877890324_N10078\">The configuration solution is based on <i class=\"italics\">flow selection<\/i> and <i class=\"italics\">flow condition<\/i> testing for mandatory password change.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <i class=\"italics\">affected target application<\/i> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">Remove the <span class=\"dialog\">Mandatory Password Change Step<\/span> from the flow and replace it with a new <span class=\"dialog\">Selection Step<\/span>.<\/li><li class=\"step\">Configure the new <span class=\"dialog\">Selection Step<\/span> in section <span class=\"dialog\">Basic Settings<\/span>. Under <span class=\"dialog\">Available Options<\/span>, add a <span class=\"dialog\">Selection Option<\/span> with:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"dialog\">Name<\/span> \u2013 anything like <code class=\"codeinline\">MANDATORY_PASSWORD_CHANGE<\/code>.<\/li><li class=\"enum-element\"><span class=\"dialog\">Steps<\/span> \u2013 select the <span class=\"dialog\">Mandatory Password Change Step<\/span> from above.<\/li><li class=\"enum-element\"><span class=\"dialog\">Condition<\/span> \u2013 use a <span class=\"dialog\">Red Flag Raised<\/span> condition testing for the <span class=\"dialog\">Mandatory Password Change Red Flag<\/span>.<\/li><\/ul><li class=\"step\">Back in the section <span class=\"dialog\">Basic Settings<\/span> of the <span class=\"dialog\">Selection Step<\/span>, add a <span class=\"dialog\">Voluntary Password Change Step<\/span> for authentication as <span class=\"dialog\">Fallback Flow<\/span>. <\/li><li class=\"step result\">Mandatory and voluntary password changes are now preconfigured. To allow a voluntary password change if no mandatory password change is required, the dynamic step activation has to be configured on the username password authentication step.<\/li><li class=\"step\">Go to the <span class=\"dialog\">Username Password Authentication Step<\/span> in the flow.<\/li><li class=\"step\">In the <span class=\"dialog\">Flow Control<\/span> section, add a new <span class=\"dialog\">Dynamic Step Activation<\/span> element and open it for configuration.<\/li><li class=\"step\"> Select the step ID <code class=\"codeinline\">voluntary-password-change<\/code> to refer to the voluntary password change step.<\/li><li class=\"step result\">The configuration is now completed and can be activated.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1652877890324_N10071\">The <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> configuration template <span class=\"dialog\">Demo Configuration<\/span> also contains the described flow.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1637831208229_N10188\">The demo configuration shows how to configure many IAM features  \u2013 you may want to check it out.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1652877890324_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Additional information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1642098258957.html\">Dynamic step activation (DSA) - flow concept<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636415729.html\">Flow selection and conditions<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1652877890299.html\">Voluntary password change in Loginapp UI authentication flow<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';