var m_1655396097020Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Username password authentication in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1655396097020\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Username password authentication in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1655396097020_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1655396097020_N10013\">This article describes how to configure username password authentication in authentication flows of the Loginapp REST API and links to other password-related features.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1655396097020_N10010\"><img alt=\"LoginScreen\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Loginapp\/LoginScreen.theme\/1.3\/en-us.LoginScreen_html.png\" style=\"width:;height:389px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1655396097020_N1001A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Username Password Authentication Step \/ Password-only Authentication Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1655396097020_N1001D\">The <span class=\"dialog\">Username Password Authentication Step<\/span> is used to check username and password and is typically placed as one of the first steps within an authentication flow, working as the first authentication factor. The step identifies the user and offers the following additional features.<\/p><p class=\"par\" id=\"1655396097020_N10028\">The same features are supported by the <span class=\"dialog\">Password-only Authentication Step<\/span> which can be used to check the password separately from a user-identifying step.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1655396097020_N10022\"><col style=\"width:30%;\"\/><col style=\"width:70%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N10034\">Feature\/Property<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N10039\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N1003F\"><span class=\"dialog\">Policy To Check On Login<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N10045\">If a policy is specified, the password check step checks whether the verified password fulfills the policy. If not, the user is forced to change the password (by raising the <i class=\"italics\">red flag<\/i> for password change).<\/p><p class=\"par\" id=\"1655396097020_N1004A\">This feature is useful when changing an existing password policy \u2013 while the policy is primarily enforced when the end-user sets a new password, this feature makes sure users with existing passwords meet the new policy after the next login.<\/p><p class=\"par\" id=\"1655396097020_N1004C\">Note: In general, it is recommended to configure the same policy as for user self-registration, password reset, and password change. This maintains a consistent level of password security. <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N10052\"><span class=\"dialog\">Password Change Red Flag<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N10058\">This setting specifies what flag to raise after successful password verification i.e. in cases where a mandatory password change is required. Reasons for a mandatory password change may be the password policy (see above), the usage of an initial password, or alike.<\/p><p class=\"par\" id=\"1655396097020_N1005A\">The red flag causes the authentication flow to fail if no subsequent step handles it, therefore enforcing the password change in the flow. Typically the <span class=\"dialog\">Mandatory Password Change Step<\/span> handles the password change and lowers the red flag. <br\/>If deviating from the default value, make sure that the corresponding <span class=\"dialog\">Mandatory Password Change Step<\/span> handles the correct red flag.<\/p><p class=\"par\" id=\"1655396097020_N10064\">Note the link to the voluntary password change below.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1655396097020_N1006D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Password repositories<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1655396097020_N10070\">The service that actually checks the password is called a <span class=\"dialog\">Password Repository<\/span> in Airlock IAM and there are several password repository implementations available (the following table is not exhaustive):<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1655396097020_N10075\"><col style=\"width:30%;\"\/><col style=\"width:70%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N10087\">Plugin<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N1008C\">Description<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N10092\"><span class=\"dialog\">Default Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N10098\">Use this plugin if using the IAM database. Airlock IAM automatically loads user information \u2013 including the password hash \u2013 when identifying the user. This plugin checks the password based on the information and does not have to access the database again.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N1009F\"><span class=\"dialog\">External Database Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N100A5\">Use this plugin, if password hashes are stored in a database different from the default IAM database. It causes extra calls to the specified database for the password check.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N100AC\"><span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N100B2\">Used for the password end-to-end encryption feature. See separate documentation link below.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N100B9\"><span class=\"dialog\">Active Directory Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N100F5\">Used to check the password against a Microsoft Active Directory (MSAD).<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N100C4\"><span class=\"dialog\">LDAP Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N10105\">Used to check the password against an LDAP directory.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1655396097020_N100CF\"><span class=\"dialog\">RADIUS Password Repository<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1655396097020_N100D5\">Checks the password by calling a RADIUS interface of a 3rd party system. <\/p><p class=\"par\" id=\"1655396097020_N100D7\">Note that it is limited to verifying passwords. Password change and policy checks are not supported.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1655396097020_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945323.html\">Username and password authentication<\/a> (conceptual)<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1652877890324.html\">Voluntary password change in the authentication flow in the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1583435033992.html\">Password reset in the Loginapp REST API \/ UI<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945410.html\">User self-registration REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1637831208229.html\">Keep me logged-in \u2013 persistent authentication between sessions<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929144216.html\">Password management in the IAM Adminapp<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636415664.html\">Flow tags and red flags<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945327.html\">End-to-End Encryption of passwords<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';