var m_1660804711176Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Front-Side Kerberos configuration in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1660804711176\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Front-Side Kerberos configuration in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N1071B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1660804711176_N1071C\">The following chapter describes how the Airlock Gateway and Airlock IAM configuration must be adapted in order to use front-side Kerberos authentication with the Loginapp UI.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N1000F1661499039159\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Airlock IAM: Kerberos configuration file (krb5.conf)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1580218960539_N10688\">Create a <code class=\"codeinline\">\/etc\/krb5.conf<\/code> file and configure it with the correct values for the Windows domain.<\/p><p class=\"par\" id=\"1580218960539_N1068D\"><strong class=\"emphasis\">\/etc\/krb5.conf<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10690\">[libdefaults]\r\ndefault_realm = AIRLOCK.COM\r\n\r\n[realms]\r\nAIRLOCK.LOCAL = {\r\nkdc = dc.airlock.com\r\ndefault_domain = AIRLOCK.COM\r\n}\r\n\r\n[domain_realm]\r\n.airlock.local = AIRLOCK.COM<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The uppercase values are settings to describe the Kerberos realm, while the lowercase values are DNS settings. Configure the settings in the same upper-\/lowercase as illustrated above.<\/li><li class=\"enum-element\">To make the new settings from the\u00A0<code class=\"codeinline\">\/etc\/krb5.conf<\/code> file active, Airlock IAM must be restarted.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1580218960539_N106A3\">Copy the <code class=\"codeinline\">*.keytab<\/code> file into the IAM instance directory (e.g. <code class=\"codeinline\">\/home\/airlock\/iam\/instances\/auth\/<\/code>).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N10046\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Airlock IAM: Flow configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1660804711176_N10049\">The authentication flow for the corresponding target application(s) must contain the <span class=\"dialog\">Kerberos Authentication Step<\/span>. The step must be the first user-identifying step - typically it is the first step in the flow.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected target application &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span> (create one if required)<\/li><li class=\"step\">Add the <span class=\"dialog\">Kerberos Authentication Step<\/span> to the flow (usually as the first step) and configure it as follows.<\/li><li class=\"step\">In property <span class=\"dialog\">Keytab File<\/span>, refer to the <code class=\"codeinline\">*.keytab<\/code> file created above. File paths may be absolute or relative to the IAM directory where the <code class=\"codeinline\">instances<\/code> directory is.<\/li><li class=\"step\">In property <span class=\"dialog\">Service Principal<\/span>, specify the SPN (Service Principal Name) associated with Airlock IAM.<\/li><li class=\"step\">Configure the properties as required. See property documentation in the Config Editor for further information.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1660804711176_N10072\">Property <span class=\"dialog\">Goto on Fallback<\/span> allows you to jump to an alternative step in the flow and is thought to better support clients that cannot do Kerberos. It could, for example, ask for a username and a password, if Kerberos is not possible.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N1000F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Airlock Gateway configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following settings are relevant in the IAM mapping on Airlock Gateway:<\/li><li class=\"enum-element\">In the <span class=\"dialog\">Allow Rules<\/span> list, <span class=\"dialog\">enable<\/span> the rule <span class=\"dialog\">Kerberos Functionality<\/span>.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following settings are relevant in the mapping(s) of the target applications that should be accessed with front-side Kerberos authentication:<\/li><li class=\"enum-element\">Set the <span class=\"dialog\">Denied Access URL<\/span> such that the target application with the <span class=\"dialog\">Kerberos Authentication Step<\/span>. Example: <code class=\"codeinline\">\/auth\/ui\/app\/auth\/application\/access\/targetApp1<\/code><\/li><\/ul><p class=\"par\" id=\"1660804711176_N1002D\">HTTP headers with Kerberos tickets may get large. It is therefore strongly recommended to increase the maximum HTTP request header size in Airlock Gateway:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to <span class=\"dialog\">Expert Settings<\/span> &gt;&gt; <span class=\"dialog\">Security Gate \/ Apache<\/span><\/li><li class=\"step\">Enable the <span class=\"dialog\">Apache Expert Settings<\/span> and configure the following setting:<\/li><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100CF\"># Increase the maximal allowed HTTP request header size\r\nLimitRequestFieldSize 16384<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Please ensure that the <span class=\"include-text\" data-objid=\"1587054500084\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock Gateway<\/span> setting configured in this step is identical to or smaller than the one configured in Airlock IAM. How this can be achieved is described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1580218960545.html#1580218960545_N1092B\">HTTP Request Header Size<\/a>.<\/li><li class=\"enum-element\">For further information about issues caused because of wrong configuration of the allowed HTTP request header size, check <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1580218960545.html#1580218960545_N1092B\">HTTP Request Header Size<\/a>.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N100FC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Note that the front-side Kerberos feature does not support falling back to NTLM (if the browser tries to do so).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804711176_N10236\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945357.html\">Front-side Kerberos authentication<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1580218960539.html\">Front-Side Kerberos configuration (one-shot flow) <\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1580218960545.html\">Troubleshooting Kerberos issues<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';