var m_1660804712081Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Example Role Removal<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1660804712081\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Example Role Removal<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804712081_N10009\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Setup<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1660804712081_N1000C\">The <i class=\"italics\">role removal<\/i> feature requires a configuration in the Airlock Gateway and a corresponding configuration in Airlock IAM.<\/p><p class=\"par\" id=\"1660804712081_N1000E\"><strong class=\"emphasis\">Airlock IAM<\/strong>:<\/p><p class=\"par\" id=\"1660804712081_N10011\">In this example, Airlock IAM is configured with three target applications with their own authentication flows and tags as follows:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1660804712081_N10014\"><img alt=\"Target_Applications\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8840.Target_Applications.theme\/1.2\/en-us.8840.Target_Applications_original.svg\" style=\"width:;height:323px;border:0;\"\/><\/div><\/figure><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Each target application has its own flow and in the respective identity propagation, the respective role is derived from the tags and added to the Gateway.<\/li><li class=\"enum-element\">The tags needed to get the roles are shared between <span class=\"dialog\">App 1<\/span> and <span class=\"dialog\">App 2<\/span>.  <\/li><li class=\"enum-element\">Target <span class=\"dialog\">App 3<\/span> and the corresponding role are only used for illustration purposes to show an unaffected app\/role.<\/li><\/ul><p class=\"par\" id=\"1660804712081_N1001F\"><strong class=\"emphasis\">Airlock Gateway<\/strong>:<\/p><p class=\"par\" id=\"1660804712081_N10022\">Airlock Gateway is configured to drop roles if the Anomaly Shield detects anomalous behavior on a particular mapping. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Anomalous behavior on <span class=\"dialog\">App 1<\/span> will remove both <code class=\"codeinline\">role1<\/code> and <code class=\"codeinline\">role2<\/code>. <\/li><li class=\"enum-element\">Anomalous behavior on <span class=\"dialog\">App 2<\/span> will remove both <code class=\"codeinline\">role1<\/code> and <code class=\"codeinline\">role2<\/code>.<\/li><li class=\"enum-element\">Anomalous behavior on <span class=\"dialog\">App 3<\/span> will remove <code class=\"codeinline\">role3<\/code>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804712081_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Sequence Diagram<\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media\"><div class=\"media-theme\" id=\"1660804712081_N10031\"><img alt=\"Remove_Roles\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8841.Remove_Roles.theme\/1.2\/en-us.8841.Remove_Roles_original.svg\" style=\"width:;height:544px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">For every request, Airlock Gateway provides Airlock IAM with the <code class=\"codeinline\">AL_ENV_ROLES<\/code> and <code class=\"codeinline\">AL_ENV_REMOVED_ROLES<\/code> environment cookies. The example starts after the user successfully authenticated for all three roles: <code class=\"codeinline\">role1<\/code>, <code class=\"codeinline\">role2<\/code>, <code class=\"codeinline\">role3<\/code>.<\/li><li class=\"step\">An event in the Gateway forces the Gateway to drop <code class=\"codeinline\">role1<\/code> and <code class=\"codeinline\">role2<\/code>.<\/li><li class=\"step\">Since the user tries to continue to work with <span class=\"dialog\">App 1<\/span>, the Gateway redirects the user to Airlock IAM to re-acquire the necessary authorization. <code class=\"codeinline\">role1<\/code> and <code class=\"codeinline\">role2<\/code> are now part of the <code class=\"codeinline\">AL_ENV_REMOVED_ROLES<\/code> environment cookie.<\/li><li class=\"step\">Airlock IAM starts an authentication flow. During the start of the flow, the <code class=\"codeinline\">AL_ENV_REMOVED_ROLES<\/code> environment cookie is processed. The removal of both <code class=\"codeinline\">role1<\/code> and <code class=\"codeinline\">role2<\/code> instruct IAM to remove the tag <code class=\"codeinline\">strong<\/code>. <br\/>Then IAM continues to process the authentication flow. Since the tag <code class=\"codeinline\">strong<\/code> is missing, the authentication flow will ask the user to re-authenticate with a second factor.<\/li><li class=\"step\">The authentication flow completes successfully and IAM instructs the Gateway to re-add <code class=\"codeinline\">role1<\/code>. <br\/>Note: <code class=\"codeinline\">role2<\/code> is not yet added. Should the user try to access <span class=\"dialog\">App 2<\/span>, the Gateway would start another authentication flow since <code class=\"codeinline\">role2<\/code> is still missing. This authentication flow would run without user interaction since the tag <code class=\"codeinline\">strong<\/code> is already in the session.<\/li><li class=\"step\">IAM stores the information that it already processed the removal of <code class=\"codeinline\">role2<\/code> to ensure that this process is only done once.<\/li><li class=\"step\">All future requests from the Gateway now contain the update environment cookies and only <code class=\"codeinline\">role2<\/code> remains in the <code class=\"codeinline\">AL_ENV_REMOVED_ROLES<\/code> environment cookie.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1660804712081_N1004F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Testing Role Removal<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1660804712081_N10073\">Testing the role removal feature is not straightforward, since it is difficult to force the Gateway to declare a session anomalous.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following ideas may help when preparing a test setup:<\/li><li class=\"enum-element\">If you create a trigger rule in the Anomaly Shield, where all indicators are gray, this rule will allow a limited number of requests without evaluation at the start of a session. The first request that evaluates, will trigger the pattern and be reported as anomalous. <\/li><li class=\"enum-element\">The <span class=\"dialog\">Multiple Countries<\/span> indicator can be triggered easily by manipulating the client\'s IP address. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/techzone.ergon.ch\/real-client-ip-behind-proxy\" target=\"_blank\">Client IP behind proxy<\/a> for more details.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';