var m_1662655591007Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Separate User Identification and Password-only Authentication steps<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662655591007\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Separate User Identification and Password-only Authentication steps<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655591007_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655591007_N10009\">Flexible authentication flows may require separate user identification and password entry steps. To support this feature the Password-only Authentication Step was introduced.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655591007_N1000E\">With the introduction of the <span class=\"dialog\">Password-only Authentication Step<\/span> in IAM 7.7 the existing <span class=\"dialog\">Password Authentication Step<\/span> was renamed to <span class=\"dialog\">Username Password Authentication Step<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655591007_N1001C\">The <span class=\"dialog\">Password-only Authentication Step<\/span> must follow after a user-identifying step. This combination of steps is vulnerable to user enumeration attacks. If this is a concern, the <span class=\"dialog\">Username Password Authentication Step<\/span> should be used instead.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655591007_N10025\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use Case Scenarios for the Password-only Authentication Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following is an incomplete list of typical use case scenarios for the <span class=\"dialog\">Password-only Authentication Step<\/span>:<\/li><li class=\"enum-element\">User-selectable authentication factor:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Step 1: The user provides the username<\/li><li class=\"enum-element\">Step 2: The user chooses whether a password, mTAN OTP or e-mail OTP will be used for authentication.<\/li><\/ul><li class=\"enum-element\">Password as fallback authentication mechanism:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Step 1: The user provides the username<\/li><li class=\"enum-element\">Step 2: The default authentication mechanism is a 2nd-factor using push (e.g. Airlock 2FA). A button is provided (using Goto) to use password authentication.<\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655591007_N1004F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of User Identification<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655591007_N10052\">A user-identifying step must be configured early in the flow since many steps rely on user information being present in the flow. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following list shows a selection of steps that will always provide the required user-identifying information:<\/li><li class=\"enum-element\"><span class=\"dialog\">User Identification Step<\/span><\/li><li class=\"enum-element\"><span class=\"dialog\">SSO Ticket Authentication Step<\/span><\/li><\/ul><p class=\"par\" id=\"1662655591007_N10064\">Other steps (e.g. <span class=\"dialog\">Remember-Me User Identifying Step<\/span>) will act as a user-identifying step if the optional information is present. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655591007_N10043\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Password-only Authentication Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655591007_N10046\">The Password-only Authentication Step is used to check the password after the user has been identified successfully. This step is typically placed right after a user-identifying step within an authentication flow, working as the first authentication factor. <\/p><p class=\"par\" id=\"1662655591007_N10063\">The step offers the same features as the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1655396097020.html\">Username password authentication in the Loginapp REST API<\/a>.<\/p><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';