var m_1662655600842Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Additional attributes in REST responses<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662655600842\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Additional attributes in REST responses<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655600842_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655600842_N10009\">In addition to the method-specific response data, the <i class=\"italics\">Loginapp REST API<\/i> provides additional attributes in many REST responses. What information is provided depends on the state of the flow engine as indicated by the <code class=\"codeinline\">nextStep<\/code> code returned in the response.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655600842_N10011\"><strong class=\"emphasis\">Example: <\/strong>The REST response in an mTAN verification step used in an authentication flow returns:<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Bullet\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">nextAuthStep<\/code>: <code class=\"codeinline\">MTAN_OTP_REQUIRED<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">phoneNumber<\/code> where the OTP was sent to as an additional attribute.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1662655600842_N10019\">The full list of additional attributes is documented in the <a href="loginapp-rest/index.html" target="_blank">Loginapp REST API Reference</a>. It lists for each <code class=\"codeinline\">nextStep<\/code> code all the additional attributes provided in the response. For each type of <i class=\"italics\">REST API<\/i> a separate table with information about additional attributes has been added to the REST API documentation.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655600842_N1001B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using additional attributes in translations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard Bullet\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The Loginapp UI allows using additional attributes in all translations.<\/li><li class=\"enum-element\">To use an additional attribute in a translation, it can be embedded with double curly braces.<\/li><li class=\"enum-element\">Structured additional attributes must use a dot notation to reference the attribute.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655600842_N10027\"><strong class=\"emphasis\">Example:<\/strong> <code class=\"codeinline\">latestAuthentication<\/code> is an additional attribute returned after a successful identity-providing step. The object has the following structure:<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10029\">latestAuthentication: {\r\n    attemptAt: \'..\',\r\n    successful: true\r\n }<\/pre><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655600842_N1002B\">To use the <code class=\"codeinline\">attemptAt<\/code> value in a translation, it is embedded as follows:<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10032\">\"Some text with placeholder {{latestAuthentication.attemptAt}} can be used.\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655600842_N10046\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Formatting additional attributes<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655600842_N10049\">Additional attributes are displayed as the REST API provides them. <\/p><p class=\"par\" id=\"1662655600842_N1004B\">The only exceptions are additional attributes of type <code class=\"codeinline\">date<\/code>. The <i class=\"italics\">Loginapp UI<\/i> formats all dates for the locale and timezone of the browser.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655600842_N10036\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Missing values in additional attributes<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The Loginapp UI shows the following behavior when values of additional attributes are missing:<\/li><li class=\"enum-element\">If all values are missing the <i class=\"italics\">Loginapp UI<\/i> displays all placeholders.<\/li><li class=\"enum-element\">If only some values are missing, the <i class=\"italics\">Loginapp UI<\/i> replaces all values that are available and it omits all other placeholders where no values have been supplied.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655600842_N1003B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1662655608015.html\">Additional attributes in the Loginapp Design Kit<\/a> on how to use additional attributes in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span>.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1662655608087.html\">JS customization of additional attributes<\/a> for advanced customization of additional attributes.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';