var m_1662655602435Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Unsupported SAML signature algorithms in IAM 7.6 and later<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1662655602435\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Unsupported SAML signature algorithms in IAM 7.6 and later<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655602435_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655602435_N10009\">This article explains why certain unsafe signature algorithms used for SAML are no more supported in Airlock IAM 7.6 and later and what to do about it.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655602435_N100101663913236693\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Affected features and versions<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Affected IAM versions:<\/strong><\/li><li class=\"enum-element\">IAM 7.6 and later<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Affected Loginapp UI features:<\/strong><\/li><li class=\"enum-element\">SAML IDP (identity provider)<\/li><li class=\"enum-element\">SAML SP (service provider)<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655602435_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Problem description<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655602435_N10010\">Airlock IAM 7.6 uses Java 17 which enables so-called <i class=\"italics\">secure validation<\/i> by default. As a consequence, some older cryptographic algorithms are disabled for security reasons.<\/p><p class=\"par\" id=\"1662655602435_N10018\">Depending on the configuration the disabled algorithms may be used in SAML (Airlock IAM as IDP or SP) and therefore the SAML features may fail to work and write a log message similar to the following example:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N1001E\">Example message for the SAML SP:<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10020\">001 SPAssertionConsumerService: \r\nException while processing SAML message \r\ncom.sun.identity.saml2.common.SAML2Exception: Single Sign On failed. \r\n...  <\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1662655602435_N10022\">The reason for the failure is only logged in <code class=\"codeinline\">DEBUG<\/code> log level:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N10015\">Example log output if the <code class=\"codeinline\">rsa-sha1<\/code> algorithm is used:<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1001A\">SPACSUtils: SPACSUtils.processResponseForFedletcom.sun.identity.saml2.common.SAML2Exception: <strong class=\"emphasis\">It is forbidden to use algorithm http:\/\/www.w3.org\/2000\/09\/xmldsig#rsa-sha1 when secure validation is enabled<\/strong>...<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following XML signature algorithms are affected in SAML:<\/strong><\/li><li class=\"enum-element\">http:\/\/www.w3.org\/2000\/09\/xmldsig#<strong class=\"emphasis\">dsa-sha1<\/strong><\/li><li class=\"enum-element\">http:\/\/www.w3.org\/2000\/09\/xmldsig#<strong class=\"emphasis\">rsa-sha1<\/strong><\/li><li class=\"enum-element\">http:\/\/www.w3.org\/2001\/04\/xmldsig-more#<strong class=\"emphasis\">rsa-md5<\/strong><\/li><\/ul><p class=\"par\" id=\"1662655602435_N1004E1663911081717\">Check the IAM SAML configuration to find out if your deployment is affected.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N10053\">The allowed XML signature verification algorithms are configured in: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML Settings<\/span> &gt;&gt; <span class=\"dialog\">SAML Federation Settings<\/span> &gt;&gt; <span class=\"dialog\">Allowed XML Signature Algorithm(s)<\/span><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N10055\">The XML signature algorithm for signing messages is configured in:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML Settings<\/span> &gt;&gt; <span class=\"dialog\">SAML Federation Settings<\/span> &gt;&gt; <span class=\"dialog\">XML Signature Algorithm<\/span><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655602435_N1002B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Preferred solution: use new algorithms<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1662655602435_N1008B\">The preferred solution is to change your SAML setup to use up-to-date XML signature algorithms. <\/p><p class=\"par\" id=\"1662655602435_N1008D\">However, this may affect other parties involved in the SAML setup: all SPs and the IDP must support the algorithms. Note, that XML signature algorithms are not only used for SAML assertions but for all digitally signed SAML messages.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Systems to check when changing to new signing algorithms:<\/strong><\/li><li class=\"enum-element\">If Airlock IAM is the IDP: make sure all involved SPs support at least one of the newly allowed XML signature algorithms.<\/li><li class=\"enum-element\">If Airlock IAM is the SP: make sure the IDP supports at least one of the newly allowed XML signature algorithms.<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To change the allowed XML signature algorithms:<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">SAML Settings<\/span> &gt;&gt; <span class=\"dialog\">SAML Federation Settings<\/span><\/li><li class=\"step\">Adapt the value of property <span class=\"dialog\">XML Signature Algorithm<\/span> to change the algorithm used to sign SAML messages.<\/li><li class=\"step\">Adapt the list of values of property <span class=\"dialog\">Allowed XML Signature Algorithm(s)<\/span> to change the list of allowed signature algorithms used to verify signed SAML messages.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Depending on the new algorithms, cryptographic key material has to be updated:<\/strong><\/li><li class=\"enum-element\">Public keys in the SAML metadata files (idp.xml and sp.xml) may need to be updated.<\/li><li class=\"enum-element\">Private keys may need to be updated.<\/li><\/ul><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N100D1\"><strong class=\"emphasis\">Example: <\/strong><br\/>If changing from a DSA to an RSA algorithm, new key pairs have to be generated.<\/p><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1662655602435_N100C5\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Alternative solution \u2013 allow old algorithms<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">As an alternative, the disallowed algorithms may be enabled. This avoids making changes in the SAML peers (remote SPs or IDP) but has the following disadvantages:<\/li><li class=\"enum-element\">The disabled algorithms are less secure.<\/li><li class=\"enum-element\">Support for the disabled algorithms may be removed altogether in future versions.<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To re-enable the disabled algorithms proceed as follows:<\/li><li class=\"step\">Copy the used JVM\'s security policy file to the common instance directory.<br\/>Example: <code class=\"codeinline\">cp &lt;iam-binaries-dir&gt;\/jre\/conf\/security\/java.security &lt;iam-install-dir&gt;\/instances\/common\/<\/code><\/li><li class=\"step\">Remove the <code class=\"codeinline\">disallowAlg<\/code> directives for the required algorithm(s). Note that it is not possible to just comment out the directive because of the multi-line string notation.<\/li><li class=\"step\">In the instance configuration of all affected instances (e.g. <code class=\"codeinline\">&lt;iam-install-dir&gt;\/instances\/auth\/instance.properties<\/code>), set the following system property in the <code class=\"codeinline\">iam.java.opts<\/code> property:<br\/><code class=\"codeinline\">iam.java.opts = -Djava.security.properties=instances\/common\/java.security<\/code><\/li><li class=\"step\">Restart the affected IAM instances.<\/li><\/ol><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1662655602435_N100FD\">The above instructions may have to be repeated after updating Airlock IAM to a new version. A new IAM version may use a new Java JRE which may contain a more up-to-date security policy file (<code class=\"codeinline\">java.security<\/code>). Without repeating the instructions above, updates to the security policy would not be applied.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';