var m_1668421874986Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>User Management Extension in the IAM Adminapp<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421874986\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">User Management Extension in the IAM Adminapp<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421874986_N1000B\">With <i class=\"italics\">user management extensions<\/i> (UMEs), the user and token management UI in the IAM Adminapp can be extended JavaScript (JS) code. It allows adding a custom tab to the user detail page that can be filled with custom content and, e.g., interact with a custom REST API.<\/p><p class=\"par\" id=\"1668421874986_N10012\">This article explains how to configure and develop <i class=\"italics\">UMEs<\/i> in the IAM Adminapp.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N10031\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Introduction<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421874986_N10034\">The following screenshot shows a very simple \"Hello World\" user management extension (UME) on the user detail page of user <i class=\"italics\">jdoe<\/i>.<\/p><figure class=\"media shadow\"><div class=\"media-theme shadow\" id=\"1668421874986_N1003A1670490004356\"><img alt=\"Adminapp - menu Users, tab UME, Hello World\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Adminapp\/Users_menu\/Adminapp_-_menu_Users_2c_tab_UME_2c_Hello_World.theme\/1.2\/en-us.Adminapp_-_menu_Users_2c_tab_UME_2c_Hello_World_html.png\" style=\"width:;height:233px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1668421874986_N10044\">User management extensions (UMEs) are displayed as separate tabs on the user detail screen and can be used to implement custom management features on users and users\' tokens.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">UMEs are designed to do the following:<\/strong><\/li><li class=\"enum-element\">Provide a custom UI for user-centric data.<\/li><li class=\"enum-element\">Call existing IAM REST APIs.<\/li><li class=\"enum-element\">Call REST APIs from a Generic Token Controller (e.g., for custom authentication tokens)<\/li><li class=\"enum-element\">Call custom REST endpoints from custom REST extensions or external systems.<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421874986_N10060\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945514.html\">Generic Token Controllers<\/a> are an alternative but less flexible way of implementing custom user management features.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N1006E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Creating and configuring a UME<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421874986_N100651670577105894\">For detailed step-by-step instructions, please refer to the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421886158.html\">Hello World Example<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Creating and configuring a UME involves the following steps:<\/strong><\/li><li class=\"step\">Create the actual UME JavaScript code (see below and linked examples) and register it using a unique UME ID.<\/li><li class=\"step\">Save the UME JavaScript code in a file named <code class=\"codeinline\">user-management-extensions.js<\/code> and store it in the IAM instance\'s <i class=\"italics\">Adminapp layout folder<\/i>. <br\/>The <i class=\"italics\">Adminapp layout folder<\/i> is defined in the <code class=\"codeinline\">instance.properties<\/code> file by property <code class=\"codeinline\">iam.adminapp.layout.dirs<\/code> and defaults to <code class=\"codeinline\">instances\/&lt;instance-name&gt;\/adminapp-layout\/<\/code>.<\/li><li class=\"step\">Add the required translations for text elements to <code class=\"codeinline\">instances\/&lt;instance-name&gt;\/adminapp-texts\/string_xx.properties<\/code>.<\/li><li class=\"step\">List the UME ID in the IAM configuration: <span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> &gt;&gt; <span class=\"dialog\">User Management Extensions<\/span>.<\/li><li class=\"step\">Adapt access control settings in <span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Access Control<\/span> &gt;&gt; <span class=\"dialog\">Display User Management Extensions<\/span> so entitled admin users can see the UME.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N100A0\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Writing the UME JavaScript<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421874986_N100A3\">UMEs are written in JavaScript and reside in the file <code class=\"codeinline\">adminapp-layout\/user-management-extensions.js<\/code> (relative to the folder of the affected IAM instance). The file may contain several UMEs.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">A UME consists of two parts:<\/strong><\/li><li class=\"enum-element\">The UME\'s class definition.<\/li><li class=\"enum-element\">A method-call registering the UME class in the Adminapp.<\/li><\/ul><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421874986_N100B2\">The following code shows the structure of a UME and explains the meaning of the UME\'s lifecycle methods to be implemented. Note that you don\'t need to implement all methods.<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100B4\">\/* User management extensions must extend the UserManagementExtension class. *\/\r\nclass MyUME extends UserManagementExtension {\r\n\r\n    shouldShow() {\r\n        \/\/ defines whether the UME should be displayed or not\r\n        \/\/ may return a boolean or a Promise resolving to a boolean\r\n        \/\/ if not defined, the UME is always displayed\r\n    }\r\n\r\n    onInit() {\r\n        \/\/ Called when the user is displayed and shouldShow() returns true\r\n        \/\/ Can be used, e.g., to preload data.\r\n        \/\/ The caller does not wait for the result. If preloading data, make sure the data is present before accessing it\r\n        \/\/ (e.g. using Promises).\r\n    }\r\n\r\n    onUserLoaded() {\r\n        \/\/ Is called when the user is loaded initially or reloaded.\r\n    }\r\n\r\n    render(node) {\r\n        \/\/ Called to render the contents of the UME\r\n        \/\/ Called once and if the language of the Adminapp is changed.\r\n        \/\/ The node passed to the function is the root node of the UME.\r\n        \/\/ A UME may only interact with the node and its children. \r\n    }\r\n\r\n    onSelect() {\r\n        \/\/ Called every time the admin switches to the UME tab.\r\n    } \r\n} \r\n\r\niam.api.userManagementExtension.register(\"myUME\", new MyUME());<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following methods from the IAM API are available in UMEs:<\/strong><\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.userManagementExtension.register(ID, UME Class)<\/code>: used to register a UME in the Adminapp (see example above).<\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.userManagementExtension.userId()<\/code>: returns the ID of the selected user.<\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.userManagementExtension.adminId()<\/code>: return the ID of the logged-in administrator.<\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.userManagementExtension.adminRoles()<\/code>: returns the array of roles of the logged-in administrator.<\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.userManagementExtension.reloadUser()<\/code>: can be called to reload the user (e.g. after modifying user data via a REST call).<\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.api.translate(key, attributes)<\/code>: used to translate text elements.<\/li><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421874986_N100EB\">Have a look at the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421886568.html\">Send Message Example<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N10110\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">API usage and limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Consider the following when developing UMEs:<\/strong><\/li><li class=\"enum-element\">Only the mentioned JS API functions from IAM may be used. Calls to other IAM-specific JS functions may change at any time. <\/li><li class=\"enum-element\">None of IAM\'s CSS classes may be used. They are considered implementation details of Airlock IAM that may change at any time. If the UME defines CSS classes, they must be prefixed with <code class=\"codeinline\">ume-&lt;ume-id&gt;-<\/code>. To prevent IAM styles from leaking into the application, we recommend encapsulating the user management extension in a <i class=\"italics\">Web Component<\/i>.<\/li><li class=\"enum-element\">The UME must not manipulate or interact with any DOM Elements, except the UME\'s root and its children.<\/li><li class=\"enum-element\">Keep in mind, that REST requests are executed in the scope of the Adminapp\'s session. This also implies that calls to protected API endpoints can be made with the session cookie of the logged-in Adminapp user.<\/li><\/ul><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421874986_N10133\">User management extensions bear risks. They allow using the full power of JavaScript combined with the possibility of executing any Adminapp REST call with the privileges of the logged-in admin user.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Consider the following when implementing UMEs:<\/li><li class=\"enum-element\">REST requests can be made with the session cookie of the logged-in Adminapp user.<\/li><li class=\"enum-element\">Consider security implications carefully if changes to the CSP are necessary to call, for example, 3rd party scripts. <\/li><li class=\"enum-element\">Do not implement access control just in the UME: the UME code is running in the browser and can therefore be manipulated. Access control has to be implemented on the server side. For example, do not use the method <code class=\"codeinline\">shouldShow()<\/code> to implement access control.<\/li><li class=\"enum-element\">The access control settings in <span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Access Control<\/span> &gt;&gt; <span class=\"dialog\">Display User Management Extensions (fine-grained)<\/span> only determines whether a UME is displayed to the admin or not. It does not implement server-side REST API access control. Without additional proper server-side access control, an admin user may not see the UME but may possibly still call the REST endpoints.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421874986_N10027\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945517.html\">Generic token REST endpoint<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421874953.html\">Generic Token Controller UI configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1591893495525.html\">Custom extension development<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';