var m_1668421886158Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>User Management Extensions (Adminapp) Hello World Example<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421886158\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">User Management Extensions (Adminapp) Hello World Example<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421886158_N10013\">This article guides through the whole process of implementing and configuring a very simple<i class=\"italics\"> User Management Extension<\/i> (UME) in the Airlock IAM Adminapp.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N10014\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following preconditions must be met to be able to go through the example:<\/strong><\/li><li class=\"enum-element\">Admin user with access to user management in the IAM adminapp.<\/li><li class=\"enum-element\">Admin user with access to the IAM configuration.<\/li><li class=\"enum-element\">Access to the IAM instance folder (e.g. <code class=\"codeinline\">...\/instances\/auth\/<\/code>) with write privileges.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N10023\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1: Write and Deploy the User Management Extension<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421886158_N10026\">The most important part of the UME is a JavaScript file that will be executed in the IAM Adminapp. It must be placed in the instance folder, so the web browser can load it in the context of the IAM Adminapp.<\/p><p class=\"par\" id=\"1668421886158_N10028\"><strong class=\"emphasis\">For this Hello World example, the following code is used:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1002A\">class MyTestUME extends UserManagementExtension {\r\n\r\n    render(node) {\r\n        node.innerHTML = \"&lt;h3&gt;Hello World&lt;\/h3&gt;\";\r\n        \/\/ Do not append to the root node, as the render function\r\n        \/\/ can be called multiple times if the language is changed\r\n        \/\/ or the user is reloaded.\r\n    }\r\n}\r\niam.api.userManagementExtension.register(\"myTestUME\", new MyTestUME());\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The code does the following:<\/strong><\/li><li class=\"enum-element\">Implement a JavaScript class extending the <code class=\"codeinline\">UserManagementExtension<\/code> class.<\/li><li class=\"enum-element\">Create HTML tags to display \"<i class=\"italics\">Hello World!<\/i>\" and adds it to the root node of the UME.<\/li><li class=\"enum-element\">Register the new class with the Adminapp using the ID <code class=\"codeinline\">myTestUME<\/code>.<\/li><\/ul><p class=\"par\" id=\"1668421886158_N10041\"><strong class=\"emphasis\">The UME will look as follows:<\/strong><\/p><figure class=\"media shadow\"><div class=\"media-theme shadow\" id=\"1668421886158_N10044\"><img alt=\"Adminapp - menu Users, tab UME, Hello World\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Adminapp\/Users_menu\/Adminapp_-_menu_Users_2c_tab_UME_2c_Hello_World.theme\/1.2\/en-us.Adminapp_-_menu_Users_2c_tab_UME_2c_Hello_World_html.png\" style=\"width:;height:233px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To deploy the JavaScript code, do the following:<\/strong><\/li><li class=\"step\">Go to the instances folder of the IAM instance (e.g. <code class=\"codeinline\">\/home\/airlock\/iam\/instances\/<\/code>).<br\/>\u00A0<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421886158_N1005B\">Make sure to use the correct OS user so newly created files get the correct ownership and permissions. If IAM was installed with the installer, the OS user is called <code class=\"codeinline\">airlock<\/code>.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Go into the instance directory of the affected IAM instance (e.g. <code class=\"codeinline\">\/auth\/<\/code>). All subsequent instructions will be relative to this directory.<\/li><li class=\"step\">Create the directory <code class=\"codeinline\">adminapp-layout<\/code>, if it does not yet exist.<\/li><li class=\"step\">In the <code class=\"codeinline\">adminapp-layout<\/code> directory, create the file <code class=\"codeinline\">user-management-extensions.js<\/code> and put the UME JavaScript code i.<\/li><div xmlns=\"\" class=\"container-warning Warning compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/assets\/icons\/Warning.gif\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_Warning\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421886158_N10074\">Make sure to name the file exactly as given above. The file may contain several UMEs.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The UME JavaScript file <code class=\"codeinline\">user-management-extensions.js<\/code> is now deployed and can be loaded by the browser in the Adminapp\'s context. File layout should be as in: <br\/><code class=\"codeinline\">...\/instances\/auth\/adminapp-layout\/user-management-extensions.js<\/code><\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N1009B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2: Configure Airlock IAM for the UME<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421886158_N1009E\">The Adminapp configuration must be adapted for the UME to be loaded and the access control settings must allow admins to use the UME.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Open the Config Editor and adapt the configuration as follows:<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> and open the <span class=\"dialog\">Advanced Settings<\/span> property group.<\/li><li class=\"step\">In property <span class=\"dialog\">User Management Extensions<\/span> add a new plugin of type <span class=\"dialog\">User Management Extension<\/span> and open it.<\/li><li class=\"step\">As <span class=\"dialog\">ID<\/span>, use the ID of the UME in the JavaScript code. This is the first argument of the <code class=\"codeinline\">register<\/code> method call, i.e., in the above example the value <span class=\"dialog\">myTestUME<\/span>.<\/li><li class=\"step result\">The UME is now registered in the Adminapp.<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Access Control<\/span> and open the <span class=\"dialog\">User Management<\/span> property group.<\/li><li class=\"step\">In Property <span class=\"dialog\">Display User Management Extensions<\/span>, add the roles of all Adminapp users who can see the UME. This could, for example, be <span class=\"dialog\">useradmin, tokenadmin, helpdesk, superadmin<\/span>.<\/li><li class=\"step result\">Access control is now set up, so entitled Adminapp users can see the UME.<\/li><li class=\"step\">Activate the configuration changes.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N100DC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 3: Add translations for text elements<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421886158_N100DF\">The UME needs at least one text element: the label displayed in the UME\'s tab. In the above screenshot, this is the string <span class=\"dialog\">My Test UME<\/span>.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To add custom translations to the adminapp proceed as follows:<\/strong><\/li><li class=\"step\">Go to the affected instance\'s directory using the correct OS user as described above. <br\/>In our example, this would be directory <code class=\"codeinline\">...\/instances\/auth\/<\/code>.<\/li><li class=\"step\">Create the directory <code class=\"codeinline\">adminapp-texts<\/code>, if it does not yet exist.<\/li><li class=\"step\">For every supported Adminapp language, add the file <code class=\"codeinline\">strings_xx.properties<\/code> (if it does not yet exist). Example: <code class=\"codeinline\">strings_en.properties<\/code>.<\/li><li class=\"step\">Add the text elements required by the UME to the file.<\/li><li class=\"step\">In our example, the only text element is the one displayed in the tab. For this use the key <code class=\"codeinline\">user.user-management-extension.myTestUME.title<\/code> as in the example below. Note the ID of the UME: <code class=\"codeinline\">myTestUME<\/code>. It is the same as used in the configuration and in the <code class=\"codeinline\">register<\/code> method call in the JavaScript file.<\/li><div xmlns=\"\" class=\"container-warning example compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10136\">user.user-management-extension.myTestUME.title = My Test UME<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Translations may be also referenced in the JavaScript code rendering the UME. The following example shows how to render HTML with translated text elements.<\/li><div xmlns=\"\" class=\"container-warning example compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10140\">node.innerHTML = \"&lt;h3&gt;Hello World&lt;\/h3&gt;\";\r\nnode.innerHTML += `&lt;p&gt;${iam.api.translate(\"user.user-management-extension.myTestUME.content.text\")}&lt;\/p&gt;`; <\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N10108\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Testing the UME and troubleshooting tips<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To test the UME:<\/strong><\/li><li class=\"enum-element\">Log into the Adminapp with a user entitled to view user details and see the UME (depends on access control settings above).<\/li><li class=\"enum-element\">Open the user details of a user in the user management.<\/li><li class=\"enum-element\">The tab <span class=\"dialog\">My Test UME<\/span> should now be displayed. <\/li><li class=\"enum-element\">Click on the tab to see the UME. It should look like in the screenshot above.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421886158_N1011E\">Once the UME is displayed you may adapt the JavaScript code and the text elements at runtime. Only press the reload button in the browser to load the latest changes from the files.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1668421886158_N10123\"><strong class=\"emphasis\">Troubleshooting tips<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">If the tab is not shown, check the following:<\/strong><\/li><li class=\"enum-element\">Review the access control settings in the configuration and check whether the logged-in admin user has the roles to view the UME.<\/li><li class=\"enum-element\">Check if the ID of the UME is exactly the same in the configuration (<span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> &gt;&gt; <span class=\"dialog\">User Management Extensions<\/span>) and in the JavaScript file <code class=\"codeinline\">user-management-extensions.js<\/code>.<\/li><li class=\"enum-element\">Make sure the <code class=\"codeinline\">user-management-extensions.js<\/code> file has the correct name, is in the right folder, and can be read by Airlock IAM (ownership and permission of file and folder it is contained in). A browser console error will be thrown if the UME JS file cannot be found or if the referred ID is not registered within that file.<\/li><\/ul><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">If the UME does not work as expected:<\/strong><\/li><li class=\"enum-element\">Open the browser\'s JavaScript console, reload the browser page and check for errors in the console.<\/li><li class=\"enum-element\">Add <code class=\"codeinline\">console.log()<\/code> or <code class=\"codeinline\">debugger;<\/code> statements to the UME lifecycle methods to find out if methods are called as expected.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421886158_N1007B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">Hello World<\/i> example is very simple. Lifecycle and API methods are described in  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421874986.html\">User Management Extension in the IAM Adminapp<\/a>.<\/li><li class=\"enum-element\">The <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421886568.html\">Send Message Example<\/a> provides a more complex example.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';