var m_1668421887059Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Token Exchange Configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1668421887059\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Token Exchange Configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421887059_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1668421887059_N1000B\">To configure a Token Exchange server (TX) the following prerequisites must be met:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisites for the supplier of the subject tokens<\/li><li class=\"enum-element\">The access or ID token supplied must be a JWT token.<\/li><li class=\"enum-element\">The issuer must be an <span class=\"dialog\">OpenID Provider<\/span> that exposes the standard <span class=\"dialog\">Discovery Endpoint<\/span>. The TX uses this endpoint to obtain the key material to verify the token. <\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisites for the TX server<\/li><li class=\"enum-element\">Airlock IAM must already be configured as an OpenID Provider or an Authorization Server. <\/li><\/ul><p class=\"par\" id=\"1668421887059_N1001F\"><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421887059_N10020\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configure the OAuth 2.0 Token Exchange plugin<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0\/OIDC Authorization Servers<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Grants\/OIDC Flows<\/span><\/li><li class=\"step\">Create an <span class=\"dialog\">OAuth 2.0 Token Exchange Grant<\/span> plugin<\/li><li class=\"step result\">The Token Exchange server plugin is ready for configuration.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Subject Token Validation<\/li><li class=\"step\">In <span class=\"dialog\">Subject Token Validation<\/span> create an <span class=\"dialog\">OpenID Connect Discovery Subject Token Validation<\/span> plugin.<\/li><li class=\"step\">Configure the plugin with a list of <span class=\"dialog\">Allowed Token Issuers<\/span>. The issuer claim from the subject token provided in the token exchange request must match one entry in this list. <\/li><li class=\"step\">Configure the plugin with an <span class=\"dialog\">HTTP Client<\/span>. The HTTP Client is used to connect to the discovery endpoint of the token issuer. Make sure the <span class=\"dialog\">Security Settings<\/span> are configured restrictively and will only trust the certificate of the discovery endpoint. <\/li><li class=\"step result\">The Token Exchange server is ready to verify subject tokens.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Token Exchange Rules<\/li><li class=\"step\">Configure at least one <span class=\"dialog\">JWT Token Exchange Rule<\/span> plugin.<\/li><li class=\"step\">Configure a <span class=\"dialog\">Requested Resource Or Audience Condition<\/span> plugin with regex patterns to match the resource or audience parameters of the token exchange requests. If multiple JWT Token Exchange Rule plugins are configured the first matching Requested Resource Or Audience Condition decides with JWT Token Exchange Rule will be used to generate the exchanged token.<\/li><li class=\"step\">Configure <span class=\"dialog\">Issued Token Type<\/span>  value and <span class=\"dialog\">Token Validity Lifetime [s]<\/span>.<br\/>The purpose of the Issued Token Type is simply to inform the client about the token format issued by the Token Exchange server.<\/li><li class=\"step\">Configure the standard claims:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Audience Claim<\/li><li class=\"enum-element\">Subject Claim<\/li><li class=\"enum-element\">Actor Claim<\/li><li class=\"enum-element\">Client Id Claim<\/li><\/ul><li class=\"step\">Optionally configure <span class=\"dialog\">Custom Claims<\/span><\/li><li class=\"step\">Configure the <span class=\"dialog\">Scope Handling<\/span>. It is possible to copy scopes from the subject token, from the request and to add static scopes. <\/li><li class=\"step\">Add a <span class=\"dialog\">Signature<\/span> to the token by configuring a <span class=\"dialog\">JWT Access Token Private Key Signature<\/span> plugin.<\/li><li class=\"step result\">A Token Exchange Rule is configured that will generate an exchanged token with data from the subject token, from the request or statically supplied data.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1668421887059_N10083\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421880439.html\">Token Exchange Overview<\/a> provides a general introduction.<\/li><li class=\"enum-element\">See also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1668421887061.html\">Token Exchange Use Case example<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a> provides information on how Airlock IAM is configured as an authorization server.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';