var m_1672991889089Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Configuration example: IAM as authorization server for Azure AD B2C<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1672991889089\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Configuration example: IAM as authorization server for Azure AD B2C<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991889089_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991889089_N10009\">This use case example describes a setup where Airlock IAM acts as an OpenID provider (authorization server) for accessing resources in the Azure cloud. <\/p><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1672991889089_N100101673620116705\">The solution shown here is a minimal configuration for testing purposes and should be considered a starting point for a more complex integration.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1672991889089_N1000D\">The following picture explains the solution setup:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1672991889089_N10016\"><img alt=\"Azure AD B2C Components\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/8851.Azure_AD_B2C_Components.theme\/1.2\/en-us.8851.Azure_AD_B2C_Components_original.svg\" style=\"width:;height:288px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Authentication steps: <\/strong><\/li><li class=\"step\">The user tries to access the web applications. This fails at the <span class=\"dialog\">Azure Frontdoor<\/span> because the user is not yet authenticated. <span class=\"dialog\">Azure AD B2C<\/span> starts an authorization code flow with Airlock IAM as OP.<\/li><li class=\"step\">The user authenticates with Airlock IAM and receives an <span class=\"dialog\">authorization code<\/span>. Airlock IAM redirects the user back using the<span class=\"dialog\"> URL<\/span> provided by Azure AD B2C.<\/li><li class=\"step\">The user connects to the redirect URL and provides the authorization code. <\/li><li class=\"step\">Azure AD B2C connects to the <span class=\"dialog\">token endpoint<\/span> of Airlock IAM to obtain access, refresh, and ID tokens. <\/li><li class=\"step\">Azure AD B2C has exchanged the access token and now the user session is allowed in Azure Frontdoor to connect to the Web Application.<\/li><\/ol><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The solution has the following properties:<\/strong><\/li><li class=\"enum-element\">Airlock IAM holds the user data and all the credentials. <\/li><li class=\"enum-element\">Airlock IAM handles user authentication using flows and the Loginapp UI.<\/li><li class=\"enum-element\">Airlock IAM also provides all the services for users to manage their accounts (e.g. self-registration, password reset, etc.).<\/li><li class=\"enum-element\">Azure AD B2C is configured as an <span class=\"dialog\">OIDC client<\/span> and extracts all user information from the ID token provided by Airlock IAM.<\/li><li class=\"enum-element\">Azure AD B2C uses an on-the-fly token exchange mechanism to transform the token provided by Airlock IAM into a token that Azure AD B2C has issued. Backend applications in the Azure cloud will not be able to immediately discern, where the user has been authenticated.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991889089_N10014\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of Airlock IAM<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991889089_N10017\">The following instructions provide minimal information to configure an AS with Azure AD B2C. If you are unfamiliar with the configuration of an authorization server in Airlock IAM see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a> for details.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">OAuth 2.0\/OIDC Authorization Server<\/strong><\/li><li class=\"step\">Set an Identifier, e.g. <code class=\"codeinline\">{{AS_Identifier}}<\/code>.<\/li><li class=\"step\">Set the Issuer ID <code class=\"codeinline\">https:\/\/{{iam.example.com}}\/auth\/rest\/oauth2\/authorization-servers\/{{AS_identifier}}<\/code><\/li><li class=\"step\">Configure a static client with credentials provided by Azure AD B2C:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">client_id<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">client_secret<\/code><\/li><\/ul><li class=\"step\">Standard Endpoint &gt;&gt; Token Endpoint<\/li><li class=\"step\">OpenID Connect Features &gt;&gt; Discovery Endpoint<\/li><li class=\"step\">Persistency &gt;&gt; User Data Source<\/li><li class=\"step\">Persistency &gt;&gt; Token Data Provider<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">OIDC authorization code flow<\/strong><\/li><li class=\"step\">Access Token &gt;&gt; JWT Access Token Format<\/li><li class=\"step\">ID Token<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">ID Token Claims (must match the configuration for Azure AD B2C):<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">given_name<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">family_name<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">email<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">username<\/code><\/li><\/ul><li class=\"enum-element\">ID Token Signature &gt;&gt; OIDC ID Token HMAC<\/li><\/ul><li class=\"step\">User Interface &gt;&gt; Consent (local consent)<\/li><li class=\"step\">Flow Settings &gt;&gt; Flow Application ID<\/li><li class=\"step\">Flow Settings - Scope Flow Settings (Azure AD B2C requires at least 1 scope, e.g. <code class=\"codeinline\">{{email}}<\/code>)<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Flow Condition Based OAuth 2.0 Scope Condition:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Scope Matcher &gt;&gt; <code class=\"codeinline\">{{email}}<\/code><\/li><li class=\"enum-element\">Condition &gt;&gt; Always Selectable<\/li><\/ul><\/ul><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Target Application<\/strong><\/li><li class=\"step\">Authentication Flow:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Password Authentication Step<\/li><li class=\"enum-element\">Mandatory Password Change Step<\/li><li class=\"enum-element\">OAuth 2.0 Consent Step<\/li><\/ul><li class=\"step\">Identity Propagation:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">OAuth 2.0\/OIDC ID Propagator<\/li><\/ul><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991889089_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration of Azure AD B2C<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard Point\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Microsoft provides documentation on how to setup Azure AD B2C to allow sign-in and sign-up with a third-party IdP using OpenID Connect:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.microsoft.com\/en-us\/azure\/active-directory-b2c\/identity-provider-generic-openid-connect?pivots=b2c-user-flow\" target=\"_blank\">Set up sign-up and sign-in with generic OpenID Connect using Azure Active Directory B2C<\/a><\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Azure AD B2C configuration<\/li><li class=\"step\">client_id, client_secret: as defined in Airlock IAM scope: <code class=\"codeinline\">openid<\/code> <code class=\"codeinline\">email<\/code> (<code class=\"codeinline\">openid<\/code> is required and Azure AD needs at least one additional scope) <\/li><li class=\"step\">response_type: <code class=\"codeinline\">code<\/code> <\/li><li class=\"step\">response_mode: <code class=\"codeinline\">query<\/code> <\/li><li class=\"step\">Domain hint: <code class=\"codeinline\">&lt;&gt;<\/code> <\/li><li class=\"step\">User ID: <code class=\"codeinline\">sub<\/code> <\/li><li class=\"step\">Displayname: <code class=\"codeinline\">{{username}}<\/code> (you  can choose any claim for this) <\/li><li class=\"step\"><code class=\"codeinline\">{{givenname}}<\/code>, <code class=\"codeinline\">{{surname}}<\/code>, <code class=\"codeinline\">{{email}}<\/code>: any claims from the ID Token<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configuration of a User Flow<\/li><li class=\"step\">Use a sign-up and sign-in user flow in the recommended version. <\/li><li class=\"step\">Configure the flow as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Name Local accounts: <i class=\"italics\">none<\/i> <\/li><li class=\"enum-element\">Custom Identity Provider: select the provider you configured before.<\/li><li class=\"enum-element\">Choose email for Multifactor authentication and set MFA enforcement to <i class=\"italics\">Off<\/i>. <\/li><li class=\"enum-element\">Leave conditional access policies empty. <\/li><li class=\"enum-element\">Select all attributes and return claims as you want.<\/li><\/ul><li class=\"step\">Test the flow with <span class=\"dialog\">Run user flow<\/span>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991889089_N1013D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991889089_N10140\">Azure AD B2C requires a user to exist in its internal database for the solution to work. It is out of scope of this document to explore mechanisms that would allow user accounts to be synchronized from Airlock IAM to Azure AD B2C.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1672991889089_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1672991889089_N100F4\">To use Azure AD B2C for sign-up and sign-in, you must also have a back-end application. Microsoft provides <code class=\"codeinline\">jwt.ms<\/code> as a simple web application that analyses and displays any tokens provided. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard Point\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For more information see:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.microsoft.com\/en-us\/azure\/active-directory-b2c\/tutorial-register-applications?tabs=app-reg-ga\" target=\"_blank\">Tutorial: Register a web application in Azure Active Directory B2C<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';