var m_1675772875165Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Using environment variables in the IAM configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1675772875165\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Using environment variables in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1675772875165_N1000B\"><i class=\"italics\">Configuration variables<\/i> make it possible to outsource parts of the configuration to environment variables. Configuration variables are resolved at <i class=\"italics\">configuration activation time<\/i> during the startup of <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>. This way, it is possible to include values in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration that are not yet available when creating the configuration.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10012\"><strong class=\"emphasis\">Configuration environments vs. configuration variables<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10019\">Some use cases of the configuration variables feature overlap with applications of the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945288.html\">Configuration environments<\/a> feature.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The main difference between the two features are:<\/li><li class=\"enum-element\">Using the configuration environment feature, environment-specific values for all environments are stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration file <code class=\"codeinline\">medusa-configuration.xml<\/code>. The environment-specific values, therefore, need to be <strong class=\"emphasis\">known at configuration time<\/strong>.<\/li><li class=\"enum-element\">Values are assigned to configuration variables at start-up time during configuration activation and <strong class=\"emphasis\">do not have to be known at configuration time<\/strong>. Moreover, they are not stored in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration file <code class=\"codeinline\">medusa-configuration.xml<\/code>.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example use cases<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configuration variables are, for example, used in the following scenarios:<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Dynamic config values<\/strong> \u2013 Use of values in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration that are dynamically determined at startup time and not available when editing the configuration.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Staging or multi-tenancy<\/strong> \u2013 Separate stage- or tenant-specific values from the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration. Keeping such values in a list of variables with sensible names makes it easy to <i class=\"italics\">diff<\/i> them.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Avoid redundancy<\/strong> \u2013 Use of values from the environment that would have to be stored in and kept in synch with the environment and in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration. Use config values from Kubernetes config maps.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Deployment automation<\/strong> \u2013 In general, configuration variables make deployment automation easier.<\/li><\/ul><p class=\"par\" id=\"1675772875165_N100C31677833992975\">This list is not exhaustive.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N10055\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview: How do configuration variables work<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In general, configuration variables work as follows.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Step 1<\/strong> \u2013 Define configuration variables on <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration properties using the Config Editor.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Step 2<\/strong> \u2013 Define environment variables with the values to be assigned to the configuration variables.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">Step 3<\/strong> \u2013 During <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> startup, the values from the environment variables are used in the configuration.<\/li><\/ul><p class=\"par\" id=\"1675772875165_N100F8\">For a detailed configuration example, see the steps below.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N1006E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Define configuration variables<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1675772875165_N10071\">To define configuration variables, use the Config Editor.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10076\"><strong class=\"emphasis\">Enabling configuration variables in the Config Editor<\/strong><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The Config Editor\'s configuration variable feature is disabled by default. It can be enabled as follows:<\/li><li class=\"enum-element\">In the instance configuration, e.g., <code class=\"codeinline\">instances\/auth\/instance.properties<\/code> set the property <code class=\"codeinline\">iam.config-editor.show-variables<\/code> to <code class=\"codeinline\">true<\/code>.<\/li><li class=\"enum-element\">Stop and restart the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> instance.<\/li><\/ul><div class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10093\">## Whether configuration variables are displayed \r\n##  and editable in the Config Editor.\r\niam.config-editor.show-variables = true\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To define a configuration variable for a configuration property, proceed as follows:<\/li><li class=\"step\">Open the corresponding plugin in the Config Editor.<\/li><li class=\"step\">Click on the <strong class=\"emphasis\"><sup>+<\/sup>v<\/strong> button on the right of the property you wish to define a variable for. A dialog opens.<br\/><br\/><span class=\"media-theme-inline shadow\" id=\"1675772875165_N100AA\"><img alt=\"ConfigVarsAddVariable\" class=\"media-theme-img-tag-inline png shadow\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.0\/DOC-1149_Config_Variables\/ConfigVarsAddVariable.theme\/1.1\/en-us.ConfigVarsAddVariable_html.png\" style=\"width:;height:36px;border:0;\"\/><\/span><br\/>\u00A0<\/li><li class=\"step\">In the dialog, define the name of the configuration variable.<br\/><br\/><span class=\"media-theme-inline shadow\" id=\"1675772875165_N100B8\"><img alt=\"ConfigVarsDefineVariable\" class=\"media-theme-img-tag-inline png shadow\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.0\/DOC-1149_Config_Variables\/ConfigVarsDefineVariable.theme\/1.1\/en-us.ConfigVarsDefineVariable_html.png\" style=\"width:;height:152px;border:0;\"\/><\/span><br\/>\u00A0<\/li><li class=\"step\">Enable the checkbox <span class=\"dialog\">Sensitive value (masked in logs)<\/span> if the value(s) assigned to the variable must not be written to the log file. <br\/>Typically, sensitive credentials such as passwords must not be logged.<\/li><li class=\"step\">Click the <span class=\"dialog\">Save<\/span> button to store the variable name.<\/li><li class=\"step result\">The variable is now defined and may be used. A red <strong class=\"emphasis\">v<\/strong> indicates that a variable is defined for the property. The property is also listed in the <span class=\"dialog\">Variables<\/span> tab in the lower part of the Config Editor.<br\/><br\/><span class=\"media-theme-inline shadow\" id=\"1675772875165_N100D5\"><img alt=\"ConfigVarsWithVariable\" class=\"media-theme-img-tag-inline png shadow\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.0\/DOC-1149_Config_Variables\/ConfigVarsWithVariable.theme\/1.1\/en-us.ConfigVarsWithVariable_html.png\" style=\"width:;height:169px;border:0;\"\/><\/span><br\/>\u00A0<\/li><p class=\"par\" id=\"1675772875165_N100F1\">The XML representation of the example from the above screenshots is as follows:<br\/><code class=\"codeinline\">&lt;property name=\"skin\" <strong class=\"emphasis\">var=\"SKIN_COLOR\"<\/strong>&gt;green&lt;\/property&gt;<\/code><\/p><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N100C1\">Why are there configuration properties without <strong class=\"emphasis\"><sup>+<\/sup>v<\/strong>?<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N100C3\">The <strong class=\"emphasis\"><sup>+<\/sup>v<\/strong> symbol used to define a configuration variable is only available on properties that explicitly have a value set. It is neither available for properties using the default value of the product (marked with the <strong class=\"emphasis\">D<\/strong>) or inheriting the value from another plugin nor for undefined properties. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1582547572093.html\">Plugin properties<\/a> for further information on <i class=\"italics\">undefined<\/i> and <i class=\"italics\">defined<\/i> properties.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To define a configuration variable for a property without the <strong class=\"emphasis\"><sup>+<\/sup>v<\/strong>:<\/li><li class=\"enum-element\">For default values, explicitly specify a value - the <strong class=\"emphasis\">D<\/strong> is then not displayed anymore.<\/li><li class=\"enum-element\">For inherited values, click the icon used to override the inherited value.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N100FA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Define environment variables<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1675772875165_N100FD\">Values that are assigned to the variables when <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> is starting up are defined in <i class=\"italics\">environment variables<\/i>.<\/p><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are various ways to define environment variables for the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> process:<\/li><li class=\"enum-element\">In shell scripts starting <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span>.<br\/><code class=\"codeinline\">export SKIN_COLOR=green<\/code><\/li><li class=\"enum-element\">In systemd service files. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816667.html\">Customizing systemd services<\/a>.<\/li><p class=\"par\" id=\"1675772875165_N1024F\"><code class=\"codeinline\">Environment=\'SKIN_COLOR=green\'<\/code><\/p><li class=\"enum-element\">Using a Kubernetes config map.<\/li><li class=\"enum-element\">Using docker CLI or <code class=\"codeinline\">docker compose<\/code> as described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1589475710479.html\">Application parameters as environment variables<\/a>.<\/li><li class=\"enum-element\">Using other OS-related means.<\/li><\/ol><p class=\"par\" id=\"1675772875165_N10155\">The above examples only showed how to set a variable value for a simple property using a string, e.g. <code class=\"codeinline\">green<\/code>. The following table shows how to set variable values for all supported property types.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1675772875165_N1015A\"><col style=\"width:20%;\"\/><col style=\"width:40%;\"\/><col style=\"width:40%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N10170\">Property Type<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N10175\">Description<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N1017A\">Examples<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N1018B\">Simple value<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101911677568013559\">Properties with a value that can be represented as a simple string.<\/p><p class=\"par\" id=\"1675772875165_N10193\">Types: String, number, boolean (<code class=\"codeinline\">true<\/code> or <code class=\"codeinline\">false<\/code>), regular expression, file.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N1019F\"><code class=\"codeinline\">SKIN_COLOR=green<\/code><\/p><p class=\"par\" id=\"1675772875165_N101A2\"><code class=\"codeinline\">SESSION_TIMEOUT=60<\/code><\/p><p class=\"par\" id=\"1675772875165_N101A51677568013559\"><code class=\"codeinline\">ENABLE_TMP_LOCKING=true<\/code><\/p><p class=\"par\" id=\"1675772875165_N101A81677568013559\"><code class=\"codeinline\">GEO_LOC_FILE=\/opt\/geo\/loc.db<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101B1\">List of simple values<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101B7\">Properties with an ordered list of simple values.<\/p><p class=\"par\" id=\"1675772875165_N101B91677568013559\">Types: String list, list of regular expressions.<\/p><p class=\"par\" id=\"1675772875165_N101BB\">Use commas to separate list elements. Double quotes may be used to include values containing a comma (CSV notation).<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101C1\"><code class=\"codeinline\">VALID_LANGS=de,en,fr,it<\/code><\/p><p class=\"par\" id=\"1675772875165_N101C4\"><code class=\"codeinline\">SOME_LIST=a,\"b,c,d\",e<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101CD1677568013559\">Plugin<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101D31677568013559\">Properties referencing another plugin configuration.<\/p><p class=\"par\" id=\"1675772875165_N101D5\">To reference a plugin configuration, use its identifier. The identifier can be set in the Config Editor. In the XML, it corresponds to the plugin attribute <code class=\"codeinline\">id<\/code>.<\/p><p class=\"par\" id=\"1675772875165_N101DA\">Using configuration variables, it is possible to reference plugin configurations that already exist in the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration. This includes unconnected plugin configurations. It is not possible to add a new plugin using configuration variables.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101E0\"><code class=\"codeinline\">PWD_POLICY=Weak Password Policy<\/code><\/p><p class=\"par\" id=\"1675772875165_N101E3\"><code class=\"codeinline\">PWD_POLICY=Strong Password Policy<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101EC\">Plugin list<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N101F2\">Properties with an ordered list of other plugin configurations.<\/p><p class=\"par\" id=\"1675772875165_N101F4\">To reference a plugin configuration, use its identifier. The identifier can be set in the Config Editor. In the XML, it corresponds to the plugin attribute <code class=\"codeinline\">id<\/code>.<\/p><p class=\"par\" id=\"1675772875165_N101F9\">Use commas to separate list elements. Double quotes may be used to include values containing a comma (CSV notation).<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N10201\"><code class=\"codeinline\">AUTH_FLOW=PwdCheckStep,PwdChangeStep<\/code><\/p><p class=\"par\" id=\"1675772875165_N10204\"><code class=\"codeinline\">ID_PROPAGATORS=JWT Profile1<\/code><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N1020D\">Plugin map<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N10213\">Properties mapping strings to plugin configurations.<\/p><p class=\"par\" id=\"1675772875165_N10215\">The value is specified as a comma-separated list with alternating keys and values. The map <code class=\"codeinline\">a -&gt; plugin1<\/code>, <code class=\"codeinline\">b -&gt; plugin2<\/code>, for example, is therefore represented as <code class=\"codeinline\">a,plugin1,b,plugin2<\/code>.<\/p><p class=\"par\" id=\"1675772875165_N1023A\">To reference a plugin configuration, use its identifier. The identifier can be set in the Config Editor. In the XML, it corresponds to the plugin attribute <code class=\"codeinline\">id<\/code>.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1675772875165_N10244\"><code class=\"codeinline\">ROLES_TO_TAGS=strong,Airlock2FATag,weak,PasswordTag<\/code><\/p><p class=\"par\" id=\"1675772875165_N10247\"><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N10277\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 3 \u2013 Configuration variable usage during <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> startup<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1675772875165_N1027A\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> reads, validates, and activates the configuration when starting up. During this process, values from environment variables are assigned to configuration values.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For each configuration variable, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> does the following:<\/li><li class=\"step\">Read the value for the variable from the environment.<\/li><li class=\"step\">If a value is defined, it is used in the corresponding property.<\/li><li class=\"step\">If no value is defined, the value from the configuration is used as if no variable was present.<\/li><\/ol><p class=\"par\" id=\"1675772875165_N10285\">After assigning values to the variables, the configuration is validated and variable usage is logged in the log output of the IAM module. The following example log message shows the usage of three configuration variables. The middle one is marked to be sensitive and its value is not logged in plain.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10287\">The following environment variables have been used in the current configuration:\r\n \r\nFUTURAE_SERVICE_SETTINGS = Futurae Test Account Settings for Airlock\r\nSERVICE_CONTAINER_SECRET = ***(masked)***\r\nSKIN_COLOR = green<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1675772875165_N10289\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1675772875165_N1028C\">The configuration variables feature has the following functional limitations.<\/p><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10291\"><strong class=\"emphasis\">Configuration validation<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10294\">Values assigned to the configuration variables are not known in the Config Editor. Thus, an <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> configuration that is valid in the Config Editor is not guaranteed to be valid after variables have been applied. Configuration activation at startup time may therefore fail.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N10299\"><strong class=\"emphasis\">Configuration migration<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N1029C\"><span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM<\/span> automatically migrates configuration files when upgrading (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1589475710333.html\">Upgrade Airlock IAM<\/a>). Manual steps may be possible if using configuration values for migration steps that depend on configuration values.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N102AA\">Since the values for the configuration variables are not known during configuration migration, the migration process cannot rely on these values.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N102AC\">If using configuration variables, carefully pay attention to the output of the configuration migration process - the <code class=\"codeinline\">iam upgrade<\/code> command - and look for messages regarding configuration variables.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N102B4\"><strong class=\"emphasis\">Limited to main IAM configuration (XML)<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1675772875165_N102B7\">Configuration variables can only be used in the main IAM configuration file medusa-configuration.xml and do not apply to other artifacts like the instance configuration or SAML metadata files.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';