var m_1678772785808Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>JWKS signature verifier settings for authentication flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1678772785808\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">JWKS signature verifier settings for authentication flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772785808_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1678772785808_N10009\">With the introduction of OAuth and OpenID Connect, the usage of bearer tokens to transport the authenticity of a user has become quite common also outside the OAuth\/OpenID Connect use cases.<\/p><p class=\"par\" id=\"1678772785808_N1000D\">To validate such bearer tokens, the relying party must have access to the public keys of the token issuer. To allow for flexible key management by the token issuer, many token issuers will now provide their key material in the form of a JWKS (JSON Web Key Set) that can be downloaded from a specific URL at the token issuer. If the token signature can be validated correctly with one of the keys of the JWKS, the validation of the token is considered successful.<\/p><p class=\"par\" id=\"1678772785808_N10010\">If the token issuer supports a JWKS endpoint, <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Airlock IAM<\/span> can be configured to use this during a regular authentication flow or during one-shot authentication.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772785808_N1000B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring JWKS in an authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">Default Application<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span>, create and edit an <span class=\"dialog\">SSO Ticket Authentication<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Ticket Decoder<\/span>, create and edit <span class=\"dialog\">JWT Ticket Decoder<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Signature Verifier<\/span>, create and edit a <span class=\"dialog\">JWKS Ticket Verifier Setting<\/span> plugin.<\/li><li class=\"step\">Edit the property <span class=\"dialog\">JWKS URL<\/span> string.<\/li><li class=\"step\">In property <span class=\"dialog\">HTTP Client<\/span>, create and edit an <span class=\"dialog\">HTTP Client Config<\/span> plugin. Set plugin values as required.<\/li><li class=\"step result\">The <span class=\"dialog\">SSO Ticket Authentication Step<\/span> will verify the signature on the ticket with keys from the JWKS endpoint configured in the <span class=\"dialog\">JWKS Ticket Verifier Setting<\/span> plugin.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1678772785808_N100AE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1678772784676.html\">JWKS signature verifier settings for one-shot authenticator<\/a> for more information on how to use JWKS during one-shot authentication.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626165444182.html\">SSO ticket authentication in the Loginapp REST API<\/a> for more information on how to use SSO tickets in authentication flows.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626375380143.html\">Configuration of Airlock IAM as OAuth Client \/ OIDC Relying Party (RP)<\/a> for more information on using OIDC discovery to determine the JWKS endpoint of an authorization server in a setup where Airlock IAM is configured as an OIDC client. <\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';