var m_1689952158019Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Flow conditions on first device usage<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1689952158019\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Flow conditions on first device usage<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1689952158019_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1689952158019_N1000B\"><span class=\"dialog\">First Usage of Device<\/span> is a condition that will return <code class=\"codeinline\">true<\/code> when a particular device is used for the first time.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This condition has the following properties:<\/strong><\/li><li class=\"enum-element\">The condition evaluates the device used in the <i class=\"italics\">most recent authentication step<\/i>.<\/li><li class=\"enum-element\">For users with multiple authentication devices, the <i class=\"italics\">most recently used device<\/i> is evaluated in the condition.<\/li><li class=\"enum-element\">The condition cannot be used in self-registration flows since self-registration is not considered device usage.<\/li><\/ul><p class=\"par\" id=\"1689952158019_N1001C\">To use this condition, a <i class=\"italics\">device usage repository<\/i> must be configured. The device usage repository is used to store how often and when a device has successfully been used for authentication.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The repository can be configured under:<\/strong><\/li><li class=\"enum-element\"><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Device Usage Repository Config<\/span> (section <i class=\"italics\">Advanced Settings<\/i>)<\/li><li class=\"enum-element\"><span class=\"dialog\">Transaction Approval<\/span> &gt;&gt; <span class=\"dialog\">Device Usage Repository Config<\/span> (section <i class=\"italics\">Advanced Settings<\/i>)<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Supported IAM flows:<\/strong><\/li><li class=\"enum-element\">Authentication Flows<\/li><li class=\"enum-element\">Public Self-Services<\/li><li class=\"enum-element\">Protected Self-Services<\/li><li class=\"enum-element\">Transaction Approval<\/li><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1689952158019_N10050\">The <span class=\"dialog\">First Usage of Device<\/span> condition only supports Airlock 2FA devices.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1689952158019_N10055\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example use case<\/h2><\/div><\/header><div class=\" block-content-ct\"><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1689952158019_N1006A\">We recommend configuring flows to first use the device for authentication and then evaluate a selection using the condition. In this order, which device is evaluated in the condition is always clear.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1689952158019_N10061\">If Airlock 2FA should be configured for <i class=\"italics\">passwordless authentication<\/i>, we recommend using the <span class=\"dialog\">First Usage of Device<\/span> condition to secure the authentication flow.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Without a <span class=\"dialog\">First Usage of Device<\/span> condition, a user can use an activation letter to activate a new device without proper authentication. Anyone could use such an activation letter to gain access to the account of the user. <\/li><li class=\"enum-element\">With a <span class=\"dialog\">First Usage of Device<\/span> condition, new 2FA authentication devices are detected. This can be used to enforce an additional, one-time user authentication step. This way, registering a new Airlock 2FA device requires an activation letter <i class=\"italics\">plus<\/i> user authentication in Airlock IAM.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1689952158019_N1005A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Internal links:<\/li><li class=\"enum-element\">Introduction and usage of <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636415729.html\">Flow selection and conditions<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';