var m_1691686267663Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Performance Tuning<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1691686267663\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Performance Tuning<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686267663_N10009\">This article is relevant for larger installations of Airlock IAM that use OAuth 2.0 or OIDC extensively and therefore have large tables with access and refresh tokens.<\/p><p class=\"par\" id=\"1691686267663_N1000B\">To improve performance in such a situation, this article explains how all OAuth 2.0 and OIDC tokens can be stored in a separate database table to profit from database query optimization.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N100131692780317301\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686267663_N100161692780317301\">The instructions provided here are entirely optional. They have been prepared for version 8.2 of Airlock IAM. To use them, it is expected that a fully configured OAuth 2.0 authorization server or an OIDC Provider is already configured.<\/p><p class=\"par\" id=\"1691686267663_N10018\">Note that some tasks require the knowledge and authorization of a database administrator.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N100131692779878035\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686267663_N10016\">The first step is to extend the database schema with new tables where all OAuth 2.0 and OIDC tokens will be stored.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Create a duplicate of the database table <span class=\"dialog\">token<\/span> under a new name, e.g. <span class=\"dialog\">oauth2_token<\/span>.<\/li><li class=\"step\">Create duplicates of all indices of the database table token for the new table.<\/li><li class=\"step\">Create a duplicate of the database table <span class=\"dialog\">token_assignment<\/span> under a new name, e.g. <span class=\"dialog\">oauth2_token_assignment<\/span>.<\/li><li class=\"step\">Create duplicates of all indices of the database table token for the new table.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">IAM Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686267663_N10010\">These steps are to update all OAuth 2.0 and OIDC plugins with the new table names.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration of the Adminapp module<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Authorization Server<\/span> <\/li><li class=\"step\">For each authorization server in the <span class=\"dialog\">Users OAuth 2.0 Authorization Server<\/span> plugin:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Edit  the <span class=\"dialog\">Session Respository<\/span> plugin<\/li><li class=\"enum-element\">Change the <span class=\"dialog\">Token Table Name<\/span> to the new database table name, e.g. <span class=\"dialog\">oauth2_token<\/span>.<\/li><li class=\"enum-element\">Change the <span class=\"dialog\">Token Assignment Table Name<\/span> to the new database table name, e.g. <span class=\"dialog\">oauth2_token_assignment<\/span>.<\/li><\/ul><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration of the Loginapp module<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0\/OIDC Authorization Servers<\/span><\/li><li class=\"step\">For the first authorization server edit the <span class=\"dialog\">OAuth 2.0\/OIDC Authorization Server<\/span> type plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Token Data Provider<\/span> create and edit a plugin of type <span class=\"dialog\">Default Token Data Provider<\/span> (e.g., with Identifier OAuth2 Token Data Provider).<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Token Persister<\/span> create and edit a plugin of type <span class=\"dialog\">Database Token Persister<\/span>. You may use the existing <span class=\"dialog\">Database Token Persister<\/span> as <span class=\"dialog\">Parent configuration<\/span>.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Token Table<\/span> change the name to the OAuth token table, e.g., <span class=\"dialog\">oauth2_token<\/span>.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Token Assignement Table<\/span> change the name to the OAuth token table, e.g., <span class=\"dialog\">oauth2_token_assignment<\/span>.<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Session Repository<\/span> connect the <span class=\"dialog\">OAuth 2.0 Session Repository<\/span> plugin created during the Adminapp configuration.<\/li><li class=\"step\">For each authorization server edit the <span class=\"dialog\">OAuth 2.0\/OIDC Authorization Server<\/span> type plugin<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Token Persister<\/span> connect the <span class=\"dialog\">Database Token Persister<\/span> plugin created in Step 3 (e.g. with Identifier OAuth2 Token Data Provider)<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Session Repository<\/span> connect the <span class=\"dialog\">OAuth 2.0 Session Repository<\/span> plugin created during the Adminapp configuration.<\/li><\/ul><\/ul><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Token Consistency Change Listener <\/strong><\/li><li class=\"step\">Go to e.g.<br\/><span class=\"dialog\">Adminapp<\/span> &gt;&gt; <span class=\"dialog\">Users<\/span> &gt;&gt; <span class=\"dialog\">User Data Source<\/span> &gt;&gt; <span class=\"dialog\">User Store<\/span> &gt;&gt; <span class=\"dialog\">Database User Persister<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">User Change Event Listeners<\/span> create and edit a plugin of type <span class=\"dialog\">Token Consistency User Change Listener<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Token Data Provider<\/span> connect the previously created <span class=\"dialog\">Database Token Persister<\/span> (e.g., with Identifier OAuth2 Token Data Provider).<\/li><li class=\"step\">In property <span class=\"dialog\">Token Services<\/span> create and edit a plugin of type <span class=\"dialog\">Generic Token Service<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Token Data Provider<\/span> connect the previously created <span class=\"dialog\">Database Token Persister<\/span> (e.g., with Identifier OAuth2 Token Data Provider).<\/li><li class=\"step\">In property <span class=\"dialog\">Types to Handle<\/span> make sure <span class=\"dialog\">OAUTH2<\/span> is listed. <\/li><li class=\"step\">Configure all remaining properties as required by your installation. <\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configuration Service Container<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Service Container<\/span> &gt;&gt; <span class=\"dialog\">Task Scheduler Config<\/span> &gt;&gt; <span class=\"dialog\">Service<\/span> &gt;&gt; <span class=\"dialog\">Tasks<\/span> &gt;&gt; <span class=\"dialog\">Task Schedule<\/span> &gt;&gt; <span class=\"dialog\">OAuth 2.0 Clean-up Task<\/span><\/li><li class=\"step\">Change the <span class=\"dialog\">Token Table Name<\/span> to the new database table name, e.g., <span class=\"dialog\">oauth2_token<\/span>.<\/li><li class=\"step\">Change the <span class=\"dialog\">Token Assignment Table Name<\/span> to the new database table name, e.g., <span class=\"dialog\">oauth2_token_assignment<\/span>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N100EE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further Optimization<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686267663_N100F1\">This setup has been designed to separate OAuth 2.0 and OIDC tokens from all other tokens. This allows database engines to optimize their query plans better.<\/p><p class=\"par\" id=\"1691686267663_N100F3\">An additional step for optimization is to review the indices on the two database tables and to remove unused indices. This will improve insert operations and optimize the overall database performance.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686267663_N10113\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945458.html\">OAuth 2.0 and OpenID Connect (OIDC) overview<\/a> for generation information about OAuth 2.0 and OIDC.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759892373.html\">OAuth 2.0 \/ OIDC configuration<\/a> for more information on how to configure an authorization server.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';