var m_1691686282380Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Self-Sovereign Identities (SSI) \u2013 an incubating feature<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1691686282380\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Self-Sovereign Identities (SSI) \u2013 an incubating feature<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N1000A1694164927908\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686282380_N1001C\">Self-Sovereign Identities (SSI) is the underlying standard for the new <i class=\"italics\">E-ID<\/i> in Switzerland and the <i class=\"italics\">EUDI<\/i> in the European Union. The standard is still evolving, and many questions regarding the protocols and formats will only be answered in the next couple of months or even years.<\/p><p class=\"par\" id=\"1691686282380_N1001E\">Nevertheless, the concept of Self-Sovereign Identities is a game changer in how citizens, customers, and employees share data with authorities and companies. To allow customers to explore these new opportunities, we have implemented a functionally rich yet still simple solution for Self-Sovereign Identities in Airlock IAM.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1691686282380_N1000E\"><i class=\"italics\">Self-Sovereign Identities<\/i> is an incubating feature. It is intended to implement proof-of-concept use cases and it is expected that the plugins provided will change fundamentally and without further notice in future releases of Airlock IAM.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">How it works<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686282380_N10009\">Self Sovereign Identities (SSI) or decentralized identities are a new paradigm in identity management that puts the end-user in control of all personal data.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The end-user, called <i class=\"italics\">holder<\/i> in SSI terminology, operates a wallet app on the mobile device. This wallet stores personal data, called <i class=\"italics\">verifiable credentials<\/i> in SSI terminology and it also implements the SSI protocol to interact with issuers and verifiers.<\/li><li class=\"enum-element\">Issuers are actors in the SSI system that provide the holder with verifiable credentials. Issuers are meant to be the authoritative source of information and to provide personal data attributes, called <i class=\"italics\">claims<\/i> in SSI terminology, in a verifiable format.<\/li><li class=\"enum-element\"><i class=\"italics\">Verifiers<\/i> are actors in the SSI system that request claims from holders. It is the holder\'s decision whether or not to approve this request and to provide the verifier with a verifiable presentation. If the request is approved, the verifier obtains the data and irrefutable proof about the issuer of the data.<\/li><\/ul><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1691686282380_N1001A\">A simple SSI use case would be the state issuing a driver\'s license as a verifiable credential into the holder\'s wallet. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1691686282380_N100431694164809029\">A policeman could ask for the presentation of the driver\'s license. If the holder accepts this request, the policeman\'s system will automatically check that the license is valid, has not been tampered with, and that the issuer is considered trustworthy.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N1000A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">SSI system architecture<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686282380_N1000D\">To use the SSI steps in IAM flows an additional component needs to be deployed and this component must also be reachable from the Internet.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1691686282380_N1002A\"><img alt=\"SSI_architecture\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Vector_drawings\/IAM\/SSI_architecture.theme\/1.0\/en-us.SSI_architecture_html.png\" style=\"width:;height:399px;border:0;\"\/><\/div><\/figure><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Important properties of the system architecture are:<\/strong><\/li><li class=\"enum-element\">There is no direct communication between the wallet app and the Airlock IAM flows.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The wallet communicates with an ACA.Py (Aries Cloud Agent) over SSI protocols and through a ngrok reverse proxy tunnel.<\/li><li class=\"enum-element\">The system browser communicates over REST API calls with the Airlock IAM flows.<\/li><\/ul><li class=\"enum-element\">The SSI plugins in Airlock IAM connect to the ACA.Py instance over SSI protocols.<\/li><li class=\"enum-element\">Both Airlock IAM and ACA.Py use their own databases.<\/li><\/ul><p class=\"par\" id=\"1691686282380_N100471693913563562\">The architecture with ngrok as a tunnel is suitable for a test setup and should be amended for a production use case.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N10010\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Available SSI flow steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1691686282380_N10013\"><col style=\"width:30%;\"\/><col style=\"width:50%;\"\/><col style=\"width:20%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10029\">Step<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N1002E\">Purpose<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N100921694073377426\">Flow type<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10039\"><span class=\"dialog\">SSI Authentication Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N1003F\">Requires the user to present a verifiable presentation and extract one claim to match against the username in the IAM user persister.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10044\">Authentication<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N1004A\"><span class=\"dialog\">Passwordless SSI Authentication Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10050\">Same as the <span class=\"dialog\">SSI Authentication Step<\/span> but can be used without an additional user identifying step.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10058\">Authentication<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N1005E\"><span class=\"dialog\">SSI Issuance Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10064\">Offers the user a verifiable credential and delivers it into the wallet application.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10069\">Authentication, <br\/>Protected Self-Service<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N10071\"><span class=\"dialog\">SSI Verification Step<\/span><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N100A0\">Requests the user to provide verifiable presentations from the wallet and verifies those presentations.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1691686282380_N1007A\">Authentication, <br\/>Self-Registration, <br\/>Public Self-Service<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N100C8\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">SSI Technology<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686282380_N100CB\">Currently, there are multiple competing technologies to specify and implement the SSI protocols and verifiable credential formats. Airlock IAM uses the technology from the Hyperledger Aries project: <\/p><div xmlns=\"\" class=\"container-warning quotation\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_quotation\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1691686282380_N100D0\">Hyperledger Aries is your complete toolkit for decentralized identity solutions and digital trust. Issue, store, and present verifiable credentials with maximum privacy preservation, and establish confidential, ongoing communication channels for rich interactions. It supports multiple protocols, credential types, ledgers, and registries. It has frameworks in multiple development languages, interoperability tools, and profiles to help everything seamlessly work together.<br\/>Source: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.hyperledger.org\/projects\/aries\" target=\"_blank\">Hyperledger Aries<\/a><\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The current implementation of SSI in Airlock IAM has been tested with the following ledgers:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"http:\/\/test.bcovrin.vonx.io\" target=\"_blank\">British Columbia Test Ledger<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/e-id-admin\/public-sandbox-trustinfrastructure\" target=\"_blank\">Public Sandbox Trust Infrastructure<\/a><\/li><\/ul><p class=\"par\" id=\"1691686282380_N1010A\">Since the implementation is based on Hyperledger Aries, other ledgers could also be used.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N1010B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Ledger integration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1691686282380_N10131\">As shown in the architecture overview, integrating a ledger with Airlock IAM  requires an additional component to run in parallel. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Airlock IAM has been tested with ACA.Py:<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/hyperledger\/aries-cloudagent-python\" target=\"_blank\">Hyperledger Aries Cloud Agent - Python (ACA.Py)<\/a> on GitHub for more details.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1691686282380_N1010E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The following are known limitations of the SSI implementation:<\/li><li class=\"enum-element\">It is not possible to manage or create credential schemas or credentials definitions with Airlock IAM. <\/li><li class=\"enum-element\">It is not possible to reuse existing connections. All flows must be initiated with a QR Code to establish a new connection between a wallet and ACA.Py.<\/li><li class=\"enum-element\">It is not possible to configure self-registration to obtain claims from a verifiable presentation and pre-fill a data edit step.<\/li><li class=\"enum-element\">There is currently no support for a mobile-only use case. To establish a connection, the end-user must be able to scan the QR code presented by Airlock IAM in a browser window.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';