var m_1693917388944Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Storing session state in an external Redis session repository<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1693917388944\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Storing session state in an external Redis session repository<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917388944_N10009\">This article describes how to store Airlock IAM session state in a <i class=\"italics\">Redis session repository<\/i>.<\/p><p class=\"par\" id=\"1693917388944_N1000F\">Airlock IAM relies on session state stored server-side. Most requests processed by Airlock IAM  must be able to access the up-to-date session state. If multiple IAM instances are active, how session information is stored and that it can be shared among the IAM instances is relevant.<\/p><p class=\"par\" id=\"1693917388944_N100121695138582347\">As of IAM 8.2, the feature is available for the Loginapp, Adminapp, and Transaction Approval modules.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10038\"><strong class=\"emphasis\">What is Redis?<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N1003B1695025228796\">Redis is a fast and proven open-source data storage solution that can be used as a distributed cache.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are two places to store session state:<\/strong><\/li><li class=\"enum-element\">In the local memory of the IAM instance. This is the default.<\/li><li class=\"enum-element\">In an external Redis session repository. How to set this up is described in this article.<\/li><\/ul><figure class=\"media\"><div class=\"media-theme\" id=\"1693917388944_N1001A\"><img alt=\"StatelessArchOverview_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.1\/DOC-16829_Stateless\/8702.StatelessArchOverview_en-us.theme\/1.1\/en-us.8702.StatelessArchOverview_en-us_original.svg\" style=\"width:;height:560px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Why store session information in Redis?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917388944_N10030\">Storing session state in an external session repository has many advantages and is especially useful in active-active setups, mostly in cloud environments such as Kubernetes. The challenge in such environments is typically maintaining a session state for short-lived containers and non-session-sticky load balancing.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Advantages of storing session state in Redis:<\/strong><\/li><li class=\"enum-element\">Load balancing does not need to be session-sticky.<\/li><li class=\"enum-element\">Allows horizontal scaling.<\/li><li class=\"enum-element\">Better support cloud-native environments (short-lived IAM containers).<\/li><li class=\"enum-element\">No session loss in failover situations.<\/li><li class=\"enum-element\">Basis for future upgrades at runtime (rolling updates).<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Disadvantages of storing session state in Redis:<\/strong><\/li><li class=\"enum-element\">Requires Redis session repository (not part of Airlock IAM).<\/li><li class=\"enum-element\">Small negative impact on performance (due to communication with Redis).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N101D4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">How to use the feature?<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917388944_N100641695028043965\">Storing session state in Redis is thought for production environments with a separately managed IAM configuration. The Config Editor does not work in active-active setups and it is therefore not possible to configure a cluster of active IAM instances using the Config Editor running in these instances. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Instead, do the following:<\/strong><\/li><li class=\"step\">Manage the configuration for the IAM cluster in a separate IAM instance (e.g. single-instance IAM setup for configuration).<\/li><li class=\"step\">Store the resulting IAM configuration XML file.<\/li><li class=\"step\">Make the configuration available to the IAM instances that are part of the cluster.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10072\">We recommend using <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772875165.html\">Configuration variables<\/a> or <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945288.html\">Configuration environments<\/a> to manage configuration for different stages.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">If using a shared instance folder for multiple active instances, consider the following:<\/strong><\/li><li class=\"enum-element\">Most files in the instance directory are read-only, <strong class=\"emphasis\">but not all.<\/strong><\/li><li class=\"enum-element\">Ensure that multiple active IAM instances do not overwrite files from each other. This is especially true for:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">.activated-configs (each IAM instance writes the configuration it activates)<\/li><li class=\"enum-element\">log files<\/li><li class=\"enum-element\">generated reports (e.g. password letters)<\/li><\/ul><li class=\"enum-element\">Where possible, adapt the configuration so files written by IAM instances are placed outside the shared instance folder.<\/li><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N100B61695029851181\">Note that not all IAM features and modules support this feature. Check the limitations section below for further details.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N101DD\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><figure class=\"media shadow\"><div class=\"media-theme shadow\" id=\"1693917388944_N100C2\"><img alt=\"StatelessConfigMainSettings\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.1\/DOC-16829_Stateless\/StatelessConfigMainSettings.theme\/1.0\/en-us.StatelessConfigMainSettings_html.png\" style=\"width:1024px;height:443.98523985239854px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To enable the feature, proceed as follows:<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">MAIN SETTINGS<\/span><\/li><p class=\"par\" id=\"1693917388944_N100E4\">If not using <span class=\"dialog\">MAIN SETTINGS<\/span>, the feature can be directly configured in the affected IAM modules (e.g. Loginapp, Adminapp).<\/p><li class=\"step\">In property <span class=\"dialog\">State Repository<\/span>, add and edit the <span class=\"dialog\">Redis State Repository<\/span> plugin.<\/li><li class=\"step\">Configure the connection to Redis (<span class=\"dialog\">Redis URI<\/span>, <span class=\"dialog\">Username<\/span>, <span class=\"dialog\">Password<\/span>). You may use the <i class=\"italics\">Testlet<\/i> (the yellow flash) to test the connection.<\/li><li class=\"step\">Configure <span class=\"dialog\">Encryption<\/span><\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Choose <span class=\"dialog\">AES 128 GCM State Encryption<\/span> to encrypt state before being sent to Redis. All instances sharing state must use the same encryption key. If the encryption key is lost, the state cannot be recovered.<\/li><li class=\"enum-element\">Choose <span class=\"dialog\">Migrating State Encryption<\/span> to migrate from no encryption to encryption (or from encryption to a different type of encryption). Read the plugin documentation for further details.<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10118\">This option is useful if migration from IAM 8.1 and you already stored state in Redis with 8.1, since IAM 8.1 did not yet support state encryption.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N1011F\">To prevent losing session state during the migration from unencrypted to encrypted session state use the plugin <span class=\"dialog\">Migrating State Encryption<\/span> and configure its property <span class=\"dialog\">Previous Encryption<\/span> as <span class=\"dialog\">No State Encryption<\/span> and <span class=\"dialog\">New Encryption<\/span> as <span class=\"dialog\">AES 128 GCM State Encryption<\/span>. The <span class=\"dialog\">Migrating State Encryption<\/span> can be replaced by the contained <span class=\"dialog\">AES 128 GCM State Encryption<\/span> after the completion of the migration. The migration duration corresponds to the maximum IAM session lifetime.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">Choose <span class=\"dialog\">No State Encryption<\/span> to store state unencrypted.<\/li><\/ul><li class=\"step\">Configure <span class=\"dialog\">TLS Settings<\/span> and <span class=\"dialog\">Performance Tuning<\/span> properties as required.<\/li><\/ol><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10233\"><strong class=\"emphasis\">Important security advisory<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10235\">Since session information includes sensitive information, it is essential that the connection to Redis is protected and only legitimate service accounts have access to the data in Redis.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917388944_N10133\">It is recommended to encrypt state information in Redis.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Configure Redis and the <i class=\"italics\">Redis State Repository plugin<\/i> such that:<\/strong><\/li><li class=\"enum-element\">Data in transit between IAM and Redis is encrypted using sensible TLS settings.<\/li><li class=\"enum-element\">Ensure IAM can verify that it connects to the correct Redis endpoint (verify server hostname with meaningful server certificate).<\/li><li class=\"enum-element\">Ensure that legitimate systems and administrators know the username and password used to access Redis.<\/li><li class=\"enum-element\">To further secure the connection, consider using client certificates.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Other configuration options to consider when using the <i class=\"italics\">Redis State Repository<\/i>:<\/strong><\/li><li class=\"enum-element\">If using many active IAM instances in parallel:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Note that connection pools 3rd-party systems (e.g. DB connections) are created per instance. This may result in more connections than the 3rd-party system can handle. <\/li><li class=\"enum-element\">Consider reconfiguring the connection pools depending on the number of IAM instances.<\/li><\/ul><li class=\"enum-element\">If <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626165444182.html\">accepting SSO tickets in authentication flows<\/a> or using <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626375362957.html\">User representation<\/a>: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">It is highly recommended to store accepted SSO tickets in the IAM database (instead of the memory). <\/li><li class=\"enum-element\">Note that Accepted SSO tickets stored in memory are <i class=\"italics\">not<\/i> stored in the Redis session repository.<\/li><\/ul><li class=\"enum-element\">Review the session timeout settings in the Loginapp and Adminapp modules (<span class=\"dialog\">Session Idle Timeout<\/span> and <span class=\"dialog\">Session Lifetime<\/span> in the <span class=\"dialog\">Advanced Settings<\/span> property group).<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N1005F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Supported IAM features and limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917388944_N10062\">Storing session states in Redis is not supported for all IAM features. The following tables show what features can be used with Redis and what is planned to be supported in future IAM releases.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1693917388944_N10064\"><col style=\"width:40%;\"\/><col style=\"width:30%;\"\/><col style=\"width:30%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1007A\">IAM Module<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1007F\">Support state<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N10084\">Since release <\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1008A\">Loginapp<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1008F\">Supported (see limitations below)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N10094\">8.1<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1009A\">Adminapp<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1009F\">Supported (see limitations below)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100A4\">8.1<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100AA\">Transaction Approval<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100AF\">Not yet supported<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100B4\">8.2<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100BA\">Service Container<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100BF\">Not supported<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100EA\">Not planned<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100C8\">API Policy Service<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N100CD\">Not supported<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N10100\">Not planned<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1693917388944_N10173\"><strong class=\"emphasis\">The <i class=\"italics\">Adminapp<\/i> is supported with the following exceptions:<\/strong><\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1693917388944_N10178\"><col style=\"width:40%;\"\/><col style=\"width:30%;\"\/><col style=\"width:30%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1018E\">Adminapp Feature<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N10193\">Support state<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N10198\">Since release<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N1019E\">Config Editor<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101A3\">Not supported.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101A8\">Not planned<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101AE\">Bulk changes (in user management).<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101B3\">Not supported.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101B8\">Not planned<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101BE\">All other features<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101C3\">Supported<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1693917388944_N101C8\">8.1<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917388944_N10046\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal Links<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1710781876728.html\">Upgrade Airlock IAM at runtime (rolling upgrade)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945288.html\">Configuration environments<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1675772875165.html\">Using environment variables in the IAM configuration<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929286122.html\">Airlock IAM instances directory<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626165444182.html\">SSO ticket authentication in the Loginapp REST API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1626375362957.html\">User representation \u2013 representee configuration in the Loginapp REST API<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External Links<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/redis.com\" target=\"_blank\">https:\/\/redis.com<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';