var m_1693917403479Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Airlock Microgateway 4.X for Airlock IAM configuration<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1693917403479\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Airlock Microgateway 4.X for Airlock IAM configuration<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917403479_N1000B\">One primary use case for Airlock Microgateway is to protect applications such as Airlock IAM against attacks.<\/p><p class=\"par\" id=\"1693917403479_N1000F\">For Airlock IAM to work correctly, it requires information about the connection between <i class=\"italics\">the browser<\/i> (or other HTTP client) and <i class=\"italics\">the first server-side HTTP endpoint<\/i>. Such information includes client IPs, URL paths, and client certificates.<\/p><p class=\"par\" id=\"1693917403479_N100121695389630669\">Unlike classic Airlock Gateway deployments, information in Airlock Microgateway deployments may come from a load balancer, an ingress controller, or the Microgateway itself. The information needs to be collected at the point in the network architecture where the TLS connection is terminated (e.g., the ingress controller) and forwarded in the correct format so that the Airlock Microgateway and Airlock IAM can process it.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Procedure-related prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">For compatibility, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1579527945281.html#1579527945281_N100B1\">Compatibility with Airlock Microgateway<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Supported Features<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917403479_N1002E1709646617245\">Airlock IAM supports the following features if used with Microgateway 4.1 and later.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Configuration of the following HTTP header extractors:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"dialog\">HTTP Request Client IP Extractor<\/span> is used by IAM in risk-based authentication and for logging purposes.<\/li><li class=\"enum-element\"><span class=\"dialog\">HTTP Request ID Extractor<\/span> is used by IAM for log correlation purposes.<\/li><li class=\"enum-element\"><span class=\"dialog\">HTTP Request URL Extractor<\/span> is used by IAM to create URLs, e.g., in OAuth 2.0 redirects and REST responses.<\/li><li class=\"enum-element\"><span class=\"dialog\">HTTP Request mTLS Client Certificate Extractor<\/span> is used by IAM to verify the client, e.g., in OAuth 2.0. It is used in OAuth\/OIDC use cases and to authenticate REST requests sent to IAM REST APIs. PEM and XFCC formats are supported \u2013 for more information, see IAM plugin documentation.<\/li><\/ul><li class=\"enum-element\">CSRF protection, as provided by Microgateway, can be used with Airlock IAM.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following features are handled by Airlock IAM independent of Microgateway:<\/strong><\/li><li class=\"enum-element\"><span class=\"dialog\">Session Idle Timeout<\/span> and <span class=\"dialog\">Session Lifetime<\/span> are configured for Loginapp and Adminapp and enforced by IAM locally. These timeouts are synchronized across IAM instances if <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917388944.html\">used with the Redis session store<\/a>.<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917403479_N10046\">In setups with Airlock Gateway, session idle timeout and session lifetimes are enforced by the Gateway using the values configured in the Gateway.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917403479_N10048\">When migrating from a Gateway to a Microgateway setup, verify the configuration of session idle timeout and session lifetime in Airlock IAM. <\/p><\/div><\/div><\/div><\/div><\/div><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following context extractors are supported if IAM is used behind an Airlock Microgateway: <\/strong><\/li><li class=\"enum-element\">Client Certificate Context Extractor<\/li><li class=\"enum-element\">IP Address Context Extractor<\/li><li class=\"enum-element\">URL Context Extractor<\/li><li class=\"enum-element\">Static Context Extractor<\/li><li class=\"enum-element\">HTTP Parameter Context Extractor<\/li><li class=\"enum-element\">Combining Context Extractor (as long as only extractors from this list are used)<\/li><li class=\"enum-element\">Concatenating Context Extractor (as long as only extractors from this list are used)<\/li><li class=\"enum-element\">No Context Extractor <\/li><p class=\"par\" id=\"1693917403479_N100C0\">Currently, only the above-listed types of context extractors are supported. However, future versions may include additional context extractors.<\/p><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N1002B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configure Airlock IAM for Microgateway<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1693917403479_N10049\">By default, Airlock IAM is configured to be run behind an Airlock Gateway. To be able to work with the Airlock Microgateway, the following set-up steps must be carried out.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Gateway Settings<\/span> add a plugin of type <span class=\"dialog\">Airlock Microgateway Settings<\/span><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Adminapp<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Gateway Settings<\/span> add a plugin of type <span class=\"dialog\">Airlock Microgateway Settings<\/span><\/li><\/ol><p class=\"par\" id=\"1693917403479_N10057\">The Airlock Microgateway Settings plugin is automatically configured for Airlock Microgateway.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N10030\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Microgateway configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To configure the Microgateway a Helm chart is provided that configures the following features:<\/strong><\/li><li class=\"enum-element\">Deny rules to protect Airlock IAM against attacks.<\/li><li class=\"enum-element\">CSRF feature of the Airlock Microgateway is enabled.<\/li><\/ul><p class=\"par\" id=\"1693917403479_N10067\">The Helm chart can be obtained from GitHub: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/airlock\/iam-helm-charts\" target=\"_blank\">Microgateway Helm chart for IAM<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N10033\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following limitations apply when using Airlock IAM with Airlock Microgateway 4.1 and later:<\/strong><\/li><li class=\"enum-element\">The Microgateway does not yet support session management and, therefore, is not ready to enforce access control (e.g., by granting roles on a session).<\/li><li class=\"enum-element\">The Microgateway does not support protecting multiple applications, so it is not possible to implement identity propagation \u200Bvia\u200B it. However, identity propagation using OIDC, OAuth, SAML, or SSO tickets is possible even if Airlock IAM is used behind the Microgateway.<\/li><li class=\"enum-element\">The Microgateway does not support a cookie store and cookies created by IAM are sent to the client.<\/li><li class=\"enum-element\">IAM does not support One-Shot authentication behind a Microgateway.<\/li><li class=\"enum-element\">Client certificates can be used for request authentication (Adminapp and Transaction Approval REST APIs) and in dynamic client registration in the Loginapp.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1693917403479_N1010C\">The features are available if using Airlock IAM with Airlock Gateway.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1693917403479_N1008A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1694711190916.html\">Comparison of gateway integration features<\/a> to see which features of Airlock IAM are supported behind the different Gateway and Microgateway products.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links:<\/strong><\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/airlock\/iam-helm-charts\" target=\"_blank\">Microgateway Helm chart for IAM<\/a> on GitHub for a sample configuration.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/docs.airlock.com\/microgateway\/latest\/\" target=\"_blank\">Airlock Microgateway online documentation<\/a> for details on microgateway configuration.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';