var m_1694711190919Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Initialize follow-up authentication flow after self-service<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1694711190919\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Initialize follow-up authentication flow after self-service<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711190919_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1694711190919_N10013\">This article explains how the <i class=\"italics\">Initialize Next Auth Flow<\/i> option can be used in public self-services. If this option is enabled, the authentication flow following the public self-service flow, can be initialized with the user identity and tags from this self-service flow.<\/p><p class=\"par\" id=\"1694711190919_N100141695388065399\">Combined with using skip conditions in authentication flows, this feature allows significant improvement of the user experience.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example use cases:<\/li><li class=\"enum-element\">Skip the username or username-password step in the login process following a password reset.<\/li><li class=\"enum-element\">Directly jump\u200B\u200B to a 2nd-factor authentication step after a successful <i class=\"italics\">unlock self-service<\/i>.<\/li><li class=\"enum-element\">Any other use case where the user <i class=\"italics\">is already authenticated<\/i> or <i class=\"italics\">has an authentication tag<\/i> within a public self-service flow, as this allows securely skipping an initial re-authentication and proceeding with a follow-up authentication step.<\/li><\/ul><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1694711190919_N10029\">The <i class=\"italics\">Initialize Next Auth Flow<\/i> option allows skipping a re-authentication step for users\' convenience. Self-services like password resets typically provide little evidence of the end user\'s identity. Therefore, access to applications or services should only be possible after additional strong authentication.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711190919_N1002F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication flow initialization<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1694711190919_N10032\">Airlock IAM\u200B requires the user to complete the corresponding authentication flow to access a target application or service. The <i class=\"italics\">Initialize Next Auth Flow<\/i> option allows using the acquired tags and user ID from a public self-service to skip an authentication step.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To make use of the user ID and tags from the public self-service flow in an authentication flow, the following is required:<\/li><li class=\"enum-element\">Enable the <i class=\"italics\">Initialize Next Auth Flow<\/i> option in the public self-service flow.<\/li><li class=\"enum-element\">Ensure the desired <i class=\"italics\">tags<\/i> for the following authentication flow are granted in the public self-service flow.<\/li><li class=\"enum-element\">Define <i class=\"italics\">skip conditions<\/i> in the desired authentication flow(s).<\/li><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1694711190919_N1004F1630393705895\">The <i class=\"italics\">next executed authentication flow<\/i> is chosen by the REST client. In the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> it is determined by UI configuration \u2013 see <span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Public Self-Service UIs<\/span> &gt;&gt; select a flow &gt;&gt; <span class=\"dialog\">Completion Target<\/span>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711190919_N10043\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1694711190919_N1007B\">The <i class=\"italics\">Initialize Next Auth Flow<\/i> feature relies on the fact that a public self-service flow authenticates the user in some way. This may be, e.g., by sending an email or SMS to the user and verify a token or link.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Example configuration:<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Public Self-Services<\/span> &gt;&gt; affected flow &gt;&gt; <span class=\"dialog\">Steps<\/span>.<\/li><li class=\"step\">In section <i class=\"italics\">Advanced Settings<\/i>, enable property <span class=\"dialog\">Initialize Next Auth Flow<\/span>.<\/li><li class=\"step\">In the one or more flow steps grant one or more tags in property <span class=\"dialog\">Tags on Success<\/span>. In this example, we choose <span class=\"dialog\">Weak Authentication Tag<\/span>. Make sure to do so in a step that cannot be skipped, e.g., the <span class=\"dialog\">Password Reset Step<\/span>.<\/li><li class=\"step\">Change to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; affected application &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">Open the authentication step to be skipped, e.g., the <span class=\"dialog\">Username Password Authentication Step<\/span>, for editing. <\/li><li class=\"step\">In property <span class=\"dialog\">Skip Condition<\/span>, add a <span class=\"dialog\">Has Tag<\/span> condition with the tag granted in the public self-service flow. In our example, this would be the <span class=\"dialog\">Weak Authentication Tag<\/span>.<\/li><li class=\"step result\">With this configuration, the user gains a <i class=\"italics\">weak authentication tag<\/i> in public self-service and, with it, the user can skip condition the <span class=\"dialog\">Username Password Authentication Step<\/span>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711190919_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945406.html\">Flow-based authentication<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594636415664.html\">Flow tags and red flags<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';