var m_1694711191135Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Prepare self-registered account for 2nd-factor enrollment<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1694711191135\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Prepare self-registered account for 2nd-factor enrollment<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711191135_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1694711191135_N10009\">In certain use cases it is desirable and - in terms of security - acceptable to enroll the 2nd authentication factor during or just after self-registration. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are two ways to implement this:<\/li><li class=\"enum-element\">Place an enrollment step directly in the self-registration flow. This is supported by selected authentication factors (e.g. <span class=\"dialog\">Airlock 2FA Activation Step<\/span>).<\/li><li class=\"enum-element\">Prepare the account so that the 2nd factor is enrolled during the first login. <strong class=\"emphasis\">This article is about this option.<\/strong><\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To prepare the user account for the enrollment of a 2nd authentication factor during the first login, the <i class=\"italics\">authentication method migration<\/i> concept is used as follows:<\/li><li class=\"step\">During self-registration, the authentication method to migrate to is stored on the new user account. This is achieved using the non-interactive plugin <span class=\"dialog\">Set Authentication Method Migration Step<\/span>.<\/li><li class=\"step\">During the next login, the user is then asked to enroll the 2nd factor. For this to work, the authentication flow must contain a migration step for the target factor (or the <span class=\"dialog\">Migration Selection Step<\/span> if there are multiple options).<\/li><\/ol><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1694711191135_N10036\">Self-registration usually provides only little evidence of the end-user\'s real identity. Enrolling a second factor based on self-registration can therefore be risky.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711191135_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Self-Registration<\/span> &gt;&gt; select a flow<\/li><li class=\"step\">To the list of flow steps, create a <span class=\"dialog\">Set Authentication Method Migration Step<\/span> plugin and place it before the final <span class=\"dialog\">User Persisting Step<\/span>. Then edit the plugin as follows:<\/li><li class=\"step\">In property <span class=\"dialog\">Authentication Method<\/span>, select the method (e.g. <i class=\"italics\">AIRLOCK_2FA<\/i>) of the authentication factor to enroll.<\/li><li class=\"step\">Optionally, in property <span class=\"dialog\">Migration Deadline<\/span>, set a deadline after which the user is forced to enroll the 2nd factor. Up to until the deadline \u2013 depending on the authentication flow configuration \u2013 the user may be allowed to skip the enrollment. <\/li><li class=\"step\">Make sure that the corresponding auth flow(s) honor the auth method migration information: Make sure to add a migration step for the target factor (or the <span class=\"dialog\">Migration Selection Step<\/span> if there are multiple options).<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1694711191135_N1002B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945329.html\">Authentication methods in IAM<\/a> for more information about authentication methods supported in Airlock IAM.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945350.html\">Step-Up authentication<\/a> for more information about on-demand access control.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';