var m_1702575900735Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>OIDC Hybrid flow usage example<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1702575900735\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">OIDC Hybrid flow usage example<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N10006\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use Case Scenario<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N10007\">This use case demonstrates the different steps required to execute an OIDC hybrid flow with user interactions.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10015\">Since the OIDC hybrid flow extends the authorization code flow, this example is very similar to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731223.html\">Authorization code flow usage<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N1000F1600182078571\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N10013\">The OIDC hybrid flow is set up in the authorization server (here IAM) and the relying party is already registered through dynamic client registration (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731233.html\">client credentials grant usage example<\/a>) or configured as a static client in the configuration (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a><\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N100321600182078571\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview of Steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">A relying party (client) starts an authorization code flow (authorize call). Requesting an additional ID and\/or access token indicates to the AS that hybrid flow should be used.<\/li><li class=\"step\">The user is authenticated and agrees to the consent request.<\/li><li class=\"step\">The client receives the authorization code. Because we are in a hybrid flow, the response also contains an ID token and\/or access token.<\/li><li class=\"step\">The client may now inspect and use the ID and\/or access token.<\/li><li class=\"step\">The client sends the authorization code to the AS and exchanges it for ID, access, and refresh tokens. Note that these ID and access tokens are <i class=\"italics\">not the same<\/i> as the ones above.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N10044\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Start the OIDC Hybrid Flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N10048\">To start the hybrid code flow, open a browser window and enter the following URL:<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10052\"><strong class=\"emphasis\">Example URL to start a hybrid flow<\/strong>:<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10018\">https:\/\/oidc.airlock.com\/auth-login\/oauth2\/v3\/myAS\/authorize?\r\n    response_type=<strong class=\"emphasis\">code+id_token+token<\/strong>    &amp;redirect_uri=https:\/\/oidc.airlock.com\/application\/demo\r\n    &amp;client_id=oidc-client\r\n    &amp;state=ee26b0dd4a...28a8ff\r\n    &amp;nonce=n-0S6_WzA2Mj \r\n    &amp;scope=employee%20openid\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To successfully start a hybrid flow, the following conditions must be met:<\/li><li class=\"enum-element\">The <code class=\"codeinline\">response_type<\/code> must include the <code class=\"codeinline\">id_token<\/code> and\/or <code class=\"codeinline\">token<\/code> part. It tells the AS to send back an additional ID and\/or access token. If neither of the two is specified, an OIDC authorization code flow is started instead. Note that the <code class=\"codeinline\">nonce<\/code> parameter is mandatory if an ID token is requested.<\/li><li class=\"enum-element\">A valid <code class=\"codeinline\">redirect_uri<\/code> must be present in the request.<\/li><li class=\"enum-element\">The <code class=\"codeinline\">redirect_uri<\/code> must be on the list of redirect_uris registered during client registration.<\/li><li class=\"enum-element\">A <code class=\"codeinline\">client_id<\/code> must be present.<\/li><li class=\"enum-element\">The scope <code class=\"codeinline\">openid<\/code> must be present.<\/li><li class=\"enum-element\">One additional scope must be present, if the authorization server has required scopes configured.<\/li><li class=\"enum-element\">The <code class=\"codeinline\">redirect_url<\/code> must be URL encoded.<\/li><\/ul><p class=\"par\" id=\"1702575900735_N10037\">If one of the conditions is not met, the authorization server returns an error message.<\/p><p class=\"par\" id=\"1702575900735_N10039\">Submitting the <code class=\"codeinline\">state<\/code> parameter is not required by the standard, but it is strongly recommended to protect against CSRF.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N1008B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Authentication and Consent<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N1008F\"><strong class=\"emphasis\">Airlock IAM will present a login screen:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1702575900735_N11571\"><img alt=\"jdoe Loginapp\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/OAuth_2.0_OIDC\/jdoe_Loginapp.theme\/1.2\/en-us.jdoe_Loginapp_html.png\" style=\"width:;height:520px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1702575900735_N10014\"><strong class=\"emphasis\">... and optionally ask for consent:<\/strong><\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1702575900735_N11584\"><img alt=\"Authorization of a request\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/OAuth_2.0_OIDC\/Authorization_of_a_request.theme\/1.2\/en-us.Authorization_of_a_request_html.png\" style=\"width:;height:452px;border:0;\"\/><\/div><\/figure><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N100B1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 3 \u2013 Retrieve Authorization Code<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N100B5\">If both authentication and consent grants have succeeded, Airlock IAM redirects the browser to the <code class=\"codeinline\">redirect_uri<\/code> requested in <i class=\"italics\">Step 1<\/i>.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N100D6\"><strong class=\"emphasis\">Redirect URL after starting hybrid code flow<\/strong> and authentication<\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100CB\">https:\/\/oidc.airlock.com\/application\/demo#     code=xRbH9uoaMMWB6urmWsg8b1xwJQF~JfD2s9CoUvwVWX42YxBwqfeC2RVWeG1HkvkdtxHz\r\n     &amp;<strong class=\"emphasis\">id_token<\/strong>=eyJ0...Zxo\r\n     &amp;<strong class=\"emphasis\">access_token<\/strong>=YL3x...ytP\r\n     &amp;<strong class=\"emphasis\">token_type<\/strong>=bearer\r\n     &amp;<strong class=\"emphasis\">expires_in<\/strong>=1234\r\n     &amp;state=ee26b0dd4a...28a8ff<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1702575900735_N100DB\">Compared to the OIDC authorization code flow, an additional ID token and access token are sent to the browser directly with the authorization code.<\/p><p class=\"par\" id=\"1702575900735_N10104\">The code and the tokens are passed as a <i class=\"italics\">fragment<\/i> rather than a query string (using # instead of ? in the URL). This is because the ID and access tokens are meant to be extracted by the web browser (or mobile app) and should not be sent to the RP (client). <\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10113\">Using a fragment (#) is the default behavior. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10115\">The Airlock IAM configuration allows changing the default to send the tokens and the code as query or form post parameters. This may be required user agent or the relying party.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10117\">See <span class=\"dialog\">Advanced Settings<\/span> in the <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731198.html\">hybrid flow configuration<\/a> for further information.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1702575900735_N1010A\">The browser (or mobile app) may now examine and use the ID and access token and then sends the authorization code to the RP (client).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N100DE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 4 \u2013 Obtain ID, Access, and Refresh Tokens<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702575900735_N100E2\">The relying party (client) receives the authorization code and sends it to the AS to get the ID, access, and refresh tokens. Note that the following request is not sent by the browser but by the relying party.<\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N10114\"><strong class=\"emphasis\">Token endpoint request<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100F8\">https:\/\/oidc.airlock.com\/auth-login\/rest\/oauth2\/authorization-servers\/myAS\/token<\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Content-Type: <code class=\"codeinline\">application\/x-www-form-urlencoded<\/code><\/li><li class=\"enum-element\">Authorization: <code class=\"codeinline\">Basic dXNlcm5hbWU6cGFzc3dvcmQ<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">grant_type=authorization_code<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">code=xRbH9uoaMMWB6urmWsg8b1xwJQF~JfD2s9CoUvwVWX42YxBwqfeC2RVWeG1HkvkdtxHz<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">redirect_uri=https:\/\/oidc.airlock.com\/application\/demo<\/code><\/li><\/ul><p class=\"par\" id=\"1702575900735_N10032\">It is recommended to configure the authorization server, to enforce authentication on the token endpoint.<\/p><p class=\"par\" id=\"1702575900735_N10034\"><strong class=\"emphasis\">The authorization server will respond as follows:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702575900735_N1005F\"><strong class=\"emphasis\">Code Block  token endpoint response<\/strong><\/p><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10045\">200 OK\r\n {\r\n    \"access_token\": \"eyJraWQiOiI3YWRmMz...E9nfs7YyJZdRFP\",\r\n    \"scope\": \"email\",\r\n    \"id_token\": \"eyJraWQiOiI3YWRmMzgp74...Ex86vUkyMGqxQg\",\r\n    \"token_type\": \"bearer\",\r\n    \"expires_in\": 17999\r\n }<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702575900735_N1014A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731198.html\">Grants and flow configuration overview<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1702575901082.html\">Configuration example: Microsoft Sharepoint SE integration with OIDC Hybrid Flow and Form Post<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';