var m_1702894079224Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Password end-to-end encryption configuration with Java key store in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1702894079224\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Password end-to-end encryption configuration with Java key store in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N1000A1661349146205\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N1000B\">This article explains how to configure password end-to-end encryption in the Loginapp REST API. It does so using the <span class=\"dialog\">Username Password Authentication Step<\/span> as an example.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702894079224_N100131661349146205\">Make sure to enable password end-to-end encryption in all flows that let the end-user enter a password.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702894079224_N100151661349146205\"><strong class=\"emphasis\">For consistent end-to-end encryption, all password-related steps have to be configured with E2EE!<\/strong><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N1000A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">About the configuration examples<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N1002C\">In the following example configurations, a <span class=\"dialog\">Username Password Authentication Step<\/span> (typically the first password-related authentication step) is configured with end-to-end password encryption (E2EE). <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Procedure summary:<\/li><li class=\"enum-element\">In the <span class=\"dialog\">Username Password Authentication Step<\/span>, a <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> is configured instead of the originally configured password repository plugin. It decrypts the password and passes the plain password to the originally used password repository.<\/li><li class=\"enum-element\">Inside the <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> the configuration is as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set the decryption type and with it configure the cryptographic keys.<\/li><li class=\"enum-element\">Configure the originally used password repository.<\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N10012\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An IAM <span class=\"dialog\">Authentication Flow<\/span> with a <span class=\"dialog\">Username Password Authentication Step<\/span> (but without E2EE) is configured for the target application.<\/li><li class=\"enum-element\">For configuration with a Java key store, a JKS or JCEKS key store file is available and the passwords to access it must be known. See also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1591893496010.html\">Using standard keystore tools<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the password step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N10078\">To enable password end-to-end encryption in a Username Password Authentication Step, proceed as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected application &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> edit the <span class=\"dialog\">Username Password Authentication Step<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Password Repository<\/span> :<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Note down the type and identifier of the password repository (<span class=\"dialog\">Default Password Repository<\/span>, <span class=\"dialog\">External Database Password Repository<\/span>, or alike) configuration for later reuse in <i class=\"italics\">step 4<\/i> of this instruction.<\/li><li class=\"enum-element\">To replace the current password repository, create and edit the <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> plugin.<\/li><\/ol><li class=\"step result\">At this point, we start configuring a new E2EE password repository plugin that can be reused for other password-related steps.<\/li><li class=\"step\">In property <span class=\"dialog\">Internal Password Repository<\/span>, add the password repository from step 3a to restore the original password repository settings.<\/li><li class=\"step\">In property <span class=\"dialog\">Password Decryption<\/span>, create and edit a <span class=\"dialog\">JWE Password Decryption<\/span> plugin to set the type of password decryption. Remember that password encryption is done by JavaScript code in the end-user\'s browser if using the <span class=\"dialog\">Loginapp UI<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Key Pair<\/span>, create and edit a <span class=\"dialog\">Public\/Private JWK Configuration<\/span> plugin.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702894079224_N10099\">Configuration <i class=\"italics\">step 3<\/i> can be repeated on other step plugins that let the user enter a password.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the key store plugin with a Java key store<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N1007F\">The shown configuration works with the <span class=\"dialog\">Loginapp UI<\/span> out of the box.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In property <span class=\"dialog\">Key Store<\/span>, create and edit a <span class=\"dialog\">Java keystore<\/span>.<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Keystore Type<\/span>, select <span class=\"dialog\">JKS - Default<\/span> or <span class=\"dialog\">JCEKS<\/span> for the type of the used Java keystore. You may specify another key type, e.g. PKCS12, as long as it is supported by the underlying implementation.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Keystore File<\/span>, add the path to the key store file, e.g. <code class=\"codeinline\">\/opt\/airlock\/keystore.jks<\/code>.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Keystore Password<\/span>, add the password to access the key store.<\/li><\/ol><li class=\"step\">Go back to the <span class=\"dialog\">Key Pair<\/span> plugin.  In property <span class=\"dialog\">Key Pair Alias<\/span>, add the entry name of the key pair in the Java key store. It specifies which key pair to use for the E2EE feature (usually there are multiple entries in a key store).<\/li><li class=\"step\">Optionally, in property <span class=\"dialog\">Private Key Password<\/span>, add a password to access the private key of the selected key pair.<\/li><li class=\"step result\">At this point, JavaScript code of the Loginapp UI will automatically encrypt the end-user\'s password. Airlock IAM calls the Java key store to receive the decrypted password.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N101BA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Follow up tasks<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N101BD\">As stated in the intro part of this section, E2EE must be configured consistently for all password-related steps linked to the corresponding target application(s) to ensure that passwords are <strong class=\"emphasis\">never transmitted unencrypted<\/strong>. This applies not only to authentication flows but also to other Airlock IAM flow types where password steps are configured.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">For example in:<\/strong><\/li><li class=\"enum-element\">Authentication flows: password check, mandatory and voluntary password change.<\/li><li class=\"enum-element\">Public self-services: password reset.<\/li><li class=\"enum-element\">Self-registration flows: when setting an initial password.<\/li><li class=\"enum-element\">Protected self-services: voluntary password change.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N1016C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Requirements for custom Loginapp front-ends<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079224_N1016F\">The system encrypting the password must do this in such a way that the decrypting code in Airlock IAM can decrypt it. The exact way passwords have to be encrypted is specified in the plugin documentation of plugin <span class=\"dialog\">JWE Password Decryption<\/span>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">This imposes the following restrictions:<\/li><li class=\"enum-element\">REST clients, e.g. in custom loginapp front-ends, must encrypt passwords according to the documentation in <span class=\"dialog\">JWE Password Decryption<\/span>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079224_N101DC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945327.html\">End-to-End Encryption of passwords<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1591893496010.html\">Using standard keystore tools<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';