var m_1702894079228Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Password end-to-end encryption configuration with AWS KMS in the Loginapp REST API<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1702894079228\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Password end-to-end encryption configuration with AWS KMS in the Loginapp REST API<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N1000A1661349146205\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N1000B\">This article explains how to configure password end-to-end encryption (E2EE) in the Loginapp REST API. It uses the <span class=\"dialog\">Username Password Authentication Step<\/span> as an example.<\/p><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702894079228_N100131661349146205\">For consistent E2EE, all password-related steps in all flows have to be configured with E2EE!<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N1000A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">About the configuration examples<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N1002C\">In the following example configurations, a <span class=\"dialog\">Username Password Authentication Step<\/span> (typically the first password-related authentication step) is configured with end-to-end password encryption. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Procedure summary:<\/li><li class=\"enum-element\">In the <span class=\"dialog\">Username Password Authentication Step<\/span>, a <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> is configured instead of the originally configured password repository plugin. It decrypts the password and passes the plain password to the originally used password repository.<\/li><li class=\"enum-element\">Inside the <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> the configuration is as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set the decryption type and with it configure the cryptographic keys.<\/li><li class=\"enum-element\">Configure the originally used password repository.<\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N10012\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An IAM <span class=\"dialog\">Authentication Flow<\/span> with a <span class=\"dialog\">Username Password Authentication Step<\/span> (but without E2EE) is already configured for the target application.<\/li><li class=\"enum-element\">For configuration with AWS KMS the service must already be configured in AWS and access credentials must be available. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1702894079230.html\">AWS KMS support for password encryption<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N10075\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the password step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N10078\">To enable password end-to-end encryption in a Username Password Authentication Step, proceed as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; affected application &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> edit the <span class=\"dialog\">Username Password Authentication Step<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Password Repository<\/span> :<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Note down the type and identifier of the password repository (<span class=\"dialog\">Default Password Repository<\/span>, <span class=\"dialog\">External Database Password Repository<\/span>, or alike) configuration for later reuse in <i class=\"italics\">step 4<\/i> of these instructions.<\/li><li class=\"enum-element\">To replace the current password repository, create and edit the <span class=\"dialog\">Default End-To-End Encryption Password Repository<\/span> plugin.<\/li><\/ol><li class=\"step result\">At this point, we start configuring a new E2EE password repository plugin that can be reused for other password-related steps.<\/li><li class=\"step\">In property <span class=\"dialog\">Internal Password Repository<\/span>, add the password repository from step 3a to restore the original password repository settings.<\/li><li class=\"step\">In property <span class=\"dialog\">Password Decryption<\/span>, create and edit an <span class=\"dialog\">AWS KMS Password Decryption<\/span> plugin to set the type of password decryption. Remember that password encryption is done by JavaScript code in the end user\'s browser if using the <span class=\"dialog\">Loginapp UI<\/span>.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1702894079228_N10099\">Configuration <i class=\"italics\">step 3b<\/i> can be repeated on other step plugins that let the user enter a password.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N10125\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the key store plugin with an AWS KMS<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N1011E\">To integrate with AWS KMS, Airlock IAM needs to be configured with the service endpoint of AWS KMS and the key identifiers to be used for E2EE.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In property <span class=\"dialog\">AWS KMS Settings<\/span>, create and edit an <span class=\"dialog\">AWS Key Management Service<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Service Access<\/span> create an <span class=\"dialog\">AWS Default Service Access<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Authentication Method<\/span> create and configure an <span class=\"dialog\">AWS Default Authentication<\/span> plugin. <\/li><li class=\"step\">In property <span class=\"dialog\">Symmetric Key ARN<\/span> configure the Amazon Ressource Name of the desired symmetric key.<\/li><li class=\"step\">In property <span class=\"dialog\">RSA Asymmetric Key ARN<\/span> configure the Amazon Resource Name of the desired asymmetric key. This is only required if database encryption is enabled.<\/li><li class=\"step\">In property <span class=\"dialog\">RSA Algorithm<\/span> select the desired encryption algorithm.<\/li><li class=\"step result\">At this point, third-party clients that support AWS KMS encryption can communicate with the Loginapp REST API. Airlock IAM calls the AWS KMS service to receive the decrypted password.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N10065\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Optional: Password hash migration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N10068\">When changing an existing Airlock IAM deployment to use AWS KMS, Airlock IAM does support migration from an existing password-hashing solution to AWS KMS. The usage of this feature is explained using a <span class=\"dialog\">Username and Password Authentication<\/span> step configured in the authentication flow of the <span class=\"dialog\">Default Application<\/span>:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\">Default Application<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow <\/span> &gt;&gt; Steps &gt;&gt; <span class=\"dialog\">Username Password Authentication Step<\/span> &gt;&gt; <span class=\"dialog\">Password Repository<\/span> &gt;&gt; <span class=\"dialog\">Internal Password Repository<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> configure and edit the property <span class=\"dialog\">Hash Function<\/span> with a <span class=\"dialog\">Password Hash Configuration<\/span> plugin. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Configure and edit the property <span class=\"dialog\">Password Hash<\/span> with an <span class=\"dialog\">AWS KMS Password Hash<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Configure the property <span class=\"dialog\">Hash Function<\/span> with the desired hash function.<\/li><li class=\"enum-element\">Configure the property <span class=\"dialog\">AWS KMS Settings<\/span> by selecting the previously configured <span class=\"dialog\">AWS Key Management Service<\/span> plugin. <\/li><\/ul><li class=\"enum-element\">Configure and edit the property <span class=\"dialog\">Encoder<\/span> with a <span class=\"dialog\">Base64 Password Hash Encoder<\/span> plugin.<\/li><\/ul><li class=\"step\">In section <span class=\"dialog\">Advanced Settings<\/span> configure the property <span class=\"dialog\">Legacy Hash Function<\/span> with the previously used hash function.<\/li><p class=\"par\" id=\"1702894079228_N10156\">The Password Hash Configuration plugin is required to compensate for the lack of encoding done in the <span class=\"dialog\">AWS KMS Password Hash<\/span> plugin. The encoding is needed to store the hash value in the IAM database.<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N101BA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Follow up tasks<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N101BD\">As stated in the intro part of this section, E2EE must be configured consistently for all password-related steps linked to the corresponding target application(s) to ensure that passwords are <strong class=\"emphasis\">never transmitted unencrypted<\/strong>. This applies not only to authentication flows but also to other Airlock IAM flow types where password steps are configured.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">For example in:<\/strong><\/li><li class=\"enum-element\">Authentication flows: password check, mandatory and voluntary password change.<\/li><li class=\"enum-element\">Public self-services: password reset.<\/li><li class=\"enum-element\">Self-registration flows: when setting an initial password.<\/li><li class=\"enum-element\">Protected self-services: voluntary password change.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N1016C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Requirements for custom Loginapp clients<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1702894079228_N1016F\">The system encrypting the password (i.e. the client) must do this in such a way that the decrypting code in Airlock IAM can decrypt it and that the supplied data can be processed in AWS KMS. <\/p><p class=\"par\" id=\"1702894079228_N1015E1705504614165\">The client will receive these additional attributes as part of REST responses if the next step supports end-to-end encryption (e.g. password check). The client must use this information when preparing the E2EE request.<\/p><p class=\"par\" id=\"1702894079228_N101611705504614165\">The REST Documentation details which next step codes may contain this information.<\/p><pre class=\"code\" id=\"N1015E\">\"e2eEncryptionInformation\": {\r\n  \"type\": \"KMS\", \/\/ describes which E2E implementation is used - for AWS KMS, the type is always KMS\r\n  \"publicKey\": \"XsrV3n0bqLUah+HS6S...\" \/\/ example base64 encoded public key - this key corresponds to the in IAM configured \"RSA Asymmetric Key ARN\" - see AWS for more information on the public key format\r\n  \"algorithm\": \"RSAES_OAEP_SHA_1\" | \"RSAES_OAEP_SHA_256\", \/\/ the algorithm used depends on IAM and AWS configuration\r\n  \"nonce\": \"p2oE-RbbU1cpy710AeVcdImgwfIXDIg8kMtxXqq2sDw=\" \/\/ random value to be used in the additional authentication data of the AES-GCM encryption\r\n}\r\n<\/pre><p class=\"par\" id=\"1702894079228_N10161\"><strong class=\"emphasis\">Expected Request Format<\/strong><\/p><p class=\"par\" id=\"1702894079228_N10165\">The expected JSON Request Body is described in the REST API documentation provided by AWS KMS. Instead of sending the plaintext password in the corresponding JSON fields, an encrypted BLOB is expected. See the following example:<\/p><p class=\"par\" id=\"1702894079228_N10168\"><code class=\"codeinline\">POST \/rest\/public\/authentication\/password\/check\/<\/code><\/p><pre class=\"code\" id=\"N1016C1705476582979\">{\r\n  \"username\": \"bob\"\r\n  \"password\": \"{\"password\":\"EKuZUtS9nm\/jVDxVQQ2SVeh\/6Yc=\",\"key\":\"uhZV5rStmYPEDGiUa6dZsYjHfPTZD9ueYNEo4zh59JhUL5biTskg7TYXz\/6NU1fBgE2tVtAhRTb0OfasJfuKT97ebgt3T3AOUcV7V8G3xtZsF12pueuEsUmhqzwN9kXzDMYKX7Qbdsdx0A7klgfMuvsRwCxAV8h6S5XvHP13Sn9dcgt24a5mmXmaYATgNX1Apfj9nP\/FIMUHEGrnmOvx+8R3KLjO143T+RI1jFrokANVp9iAaW2XHpX\/r66cUOSHal2cfHyK80SNCWJAMkPyd9xtYMY+mvWN2vIzDXkkIbOllubpzvMqof3vXWgtsvrNaDzJFA23PkyAcX\/Oe3vLAw==\",\"iv\":\"7FS4pExf0SPNABE9\"}\"\r\n}<\/pre><p class=\"par\" id=\"1702894079228_N1016F1705476582979\">IAM expects the client to encrypt the password in a defined way and provide the used encryption data in a defined format. Clients can implement the following algorithm: <\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Generate a symmetric one-time AES-GCM 256 key and a random 12 byte IV (initialization vector) for one-time encryption <\/li><li class=\"step\">Encrypt the plaintext password with the generated AES-GCM 256 key, the IV and a random nonce. Base64 encode the result and add it as <code class=\"codeinline\">password<\/code> attribute to the request.<\/li><li class=\"step\">Encrypt the one-time AES-GCM key with the provided RSA public key and algorithm (see e2eEncryptionInformation in REST response). Base64 encode it and add it as <code class=\"codeinline\">key<\/code> attribute to the request.<\/li><li class=\"step\">Base64 encode the initialization vector and add it as <code class=\"codeinline\">iv<\/code> attribute to the request.<\/li><\/ol><p class=\"par\" id=\"1702894079228_N1017B\">Example of the expected JSON BLOB contained in the \"password\" field of the password-check request:<\/p><pre class=\"code\" id=\"N1017E\">{\r\n  \"password\" \/\/ plaintext password encrypted with an AES-GCM 256 symmetric key and IV (key and IV generated on the client)\r\n  \"key\" \/\/ AES-GCM 256 symmetric key encrypted with the RSA public key received from IAM in e2eEncryptionInformation\r\n  \"iv\" \/\/ 12 byte initialization vector (generated on client)\r\n}<\/pre><p class=\"par\" id=\"1702894079228_N10189\">If the REST request has multiple E2EE fields, e.g. on password change, each password needs to be encrypted individually.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1702894079228_N101DC\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945327.html\">End-to-End Encryption of passwords<\/a> for more E2EE methods.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1702894079230.html\">AWS KMS support for password encryption<\/a> for general information about AWS KMS and information about key rotation and password hash migration.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';