var m_1706097844822Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Customization with Resource Sets<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1706097844822\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Customization with Resource Sets<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844822_N10009\"><i class=\"italics\">Resource Sets<\/i> enable IAM to support multiple different UIs in one IAM instance. Each resource set is built with the SDK and contains all the assets required to style the UI. <\/p><p class=\"par\" id=\"1706097844822_N1000D1707492727720\">To use the <i class=\"italics\">Resource Set<\/i> feature, a directory must be configured in the <code class=\"codeinline\">instance.properties<\/code> file which will contain all the available resource sets.<\/p><p class=\"par\" id=\"1706097844822_N1000B\">When a browser loads the Loginapp UI, Airlock IAM determines the correct resource set and bundles it with the Loginapp UI for delivery to the browser.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N1000D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom UI vs. TENANT_ID vs. Resource Set<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844822_N10010\">The concepts of <i class=\"italics\">Custom UI<\/i>, <i class=\"italics\">TENANT_ID<\/i>, and <i class=\"italics\">Resource Set<\/i> complement each other as follows:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table- table-block-description table-\" id=\"1706097844822_N10012\"><col style=\"width:20%;\"\/><col style=\"width:80%;\"\/><thead class=\"thead\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-firstrow table-header table-header-horizontal table-cell-col-odd-\"><div><p class=\"par\" id=\"1706097844822_N10024\">Concept<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-odd table-cell-firstrow table-cell-lastcolumn table-header table-header-horizontal table-cell-col-even-\"><div><p class=\"par\" id=\"1706097844822_N10029\">Usage<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1706097844822_N1002F\">Custom UI<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1706097844822_N10034\">The Custom UI configuration is required to identify the file location of the default resource set that contains all customizations for the UI. It is intended for situations where only one UI styling is required for an IAM instance. <\/p><p class=\"par\" id=\"1706097844822_N10036\">This type of customization has been available since the first release of the Loginapp Design Kit.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-odd table-cell-firstcolumn table-cell-innerrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1706097844822_N1003C\">TENANT_ID<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-odd table-cell-lastcolumn table-cell-innerrow table-cell-col-even-\"><div><p class=\"par\" id=\"1706097844822_N10041\">The <i class=\"italics\">TENANT_ID<\/i> is used within a single resource set to apply different stylings based on the TENANT_ID.<\/p><p class=\"par\" id=\"1706097844822_N1005D1709107502153\">It is intended for situations where the styling of the UI should be different depending on the client that is used to render the UI. <\/p><p class=\"par\" id=\"1706097844822_N10060\">This feature should be used sparingly. With an increasing number of TENANT_IDs or many differences between the customizations, the filesize of the resource set may increase and negatively impact the loading times of the UI. <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-even table-cell-firstcolumn table-cell-lastrow table-cell-col-odd-\"><div><p class=\"par\" id=\"1706097844822_N10047\">Resource Set<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-even table-cell-lastrow table-cell-lastcolumn table-cell-col-even-\"><div><p class=\"par\" id=\"1706097844822_N1004C\"><i class=\"italics\">Resource Sets<\/i> provide strong segregation of stylings by segregating different customizations into separate files. <\/p><p class=\"par\" id=\"1706097844822_N100731709107502153\">They are intended for use cases in which customizations are created and maintained by different teams or where the segregation of the stylings is important for security or privacy reasons (e.g. stylings that contain customer names or logos).<\/p><p class=\"par\" id=\"1706097844822_N10076\">The selection of a resource set is configured as a regular expression on the entry path. If no match is found, the <i class=\"italics\">Custom UI<\/i> configuration is used as the default customization of the UI. <\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1706097844822_N10055\">It is possible to combine all three customization methods and to deploy multiple resource sets with each using multiple TENANT_IDs and still have a custom UI as a fallback default styling.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N10057\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Resource Set selection strategy<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844822_N1005A\">To determine the correct resource set, IAM applies the following strategy:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The request URI is matched against configured regular expression patterns and the first matching pattern determines the filename of the resource set. <\/li><li class=\"step\">The file is searched in the directory configured as <code class=\"codeinline\">iam.loginapp.ui.resource-sets.dir<\/code> in <code class=\"codeinline\">instance.properties<\/code>. The search includes all subdirectories.<\/li><li class=\"step\">If no matching file can be found the Custom UI configured as <code class=\"codeinline\">iam.loginapp.rest.ui.customizations<\/code> in <code class=\"codeinline\">instance.properties<\/code> is used as a default.<\/li><li class=\"step\">The IAM product default is used if no default resource set is configured.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097844822_N100C4\">The filename of a resource set must be unique, regardless of where the file is stored.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097844822_N100C8\">It is possible to update and add resource sets at runtime. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N10066\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><code class=\"codeinline\">instance.properties<\/code><\/li><li class=\"step\">Modify the instance configuration (<code class=\"codeinline\">instance.properties)<\/code> as follows to configure the filename and location of the zip archive containing the customizations:<\/li><pre class=\"code\" id=\"N100A2\">iam.loginapp.ui.resource-sets.dir = instances\/common\/resource-sets\/ \r\n <\/pre><li class=\"step result\">IAM can find all available resource sets with unique filenames.<\/li><li class=\"step\">Optionally, modify the <code class=\"codeinline\">instance.properties<\/code> as follows to configure a default customization that is applied if the URL matcher (see below) does not return a result. <\/li><pre class=\"code\" id=\"N100A8\">iam.loginapp.rest.ui.customizations = instances\/common\/resource-sets\/fallback.zip<\/pre><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">URL matching<\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">UI Settings<\/span> &gt;&gt; <span class=\"dialog\">Advanced Settings<\/span><\/li><li class=\"step\">In <span class=\"dialog\">UI Resource Set Rules<\/span> add and configure a <span class=\"dialog\">Request URL Pattern UI Resource Set Rule<\/span> plugin and configure it as follows:<\/li><li class=\"step\">In <span class=\"dialog\">Request URL Pattern<\/span> configure a regular expression that matches the URL of the request.<\/li><li class=\"step\">In <span class=\"dialog\">UI Resource Set File Name<\/span> configure the base name of the archive containing the customizations. The extension \"<code class=\"codeinline\">.zip<\/code>\" is added automatically. <br\/>The filenames configured in this property are evaluated at runtime only.<\/li><p class=\"par\" id=\"1706097844822_N100DD1709107502153\">The plugins are processed in order and the first matching pattern is used.<\/p><p class=\"par\" id=\"1706097844822_N100E2\">For the URL matching it is important to choose regular expression patterns that match all requests of a particular domain so that all requests use the same resource set. For example, two flows in the same domain can\'t use different resource sets.<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N100E4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Operation<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844822_N100E7\">During operation, IAM automatically detects new resource set files and changes in existing resource set files and immediately activates them. <\/p><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097844822_N10122\">When changing or adding resource set files it is imperative to only do so by using atomic file system operations like <code class=\"codeinline\">mv<\/code> (move). Never use <code class=\"codeinline\">cp<\/code> (copy) or <code class=\"codeinline\">scp<\/code> (secure copy) as they may confuse the file watcher and have IAM believe that the resource set file is empty.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097844822_N10130\">Removing resource set files, renaming resource set files, or modifying the directory structure always requires a restart of IAM for the changes to be effective.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N100C2\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844822_N100C5\">A bank has several external asset managers located in different countries. They want to present these asset managers with an individually styled login UI using the asset manager\'s logo and their name in the text elements. The following example shows how this can be achieved.<\/p><p class=\"par\" id=\"1706097844822_N100D9\">A folder structure has been created to manage the resource sets more easily. <\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1706097844822_N100DD\"><img alt=\"resource-sets\" class=\"media-theme-img-tag png\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Loginapp\/resource-sets.theme\/1.0\/en-us.resource-sets_html.png\" style=\"width:;height:302px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1706097844822_N100C7\">This folder structure is optional. All resource sets could be located directly in the <code class=\"codeinline\">resource-sets<\/code> folder.<\/p><p class=\"par\" id=\"1706097844822_N100ED\">In the instance configuration (<code class=\"codeinline\">instance.properties<\/code>) the following entries are required:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Point\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">iam.loginapp.ui.resource-sets.dir = instances\/common\/resource-sets\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">iam.loginapp.rest.ui.customizations = instances\/common\/resource-sets\/fallback.zip<\/code><\/li><\/ul><p class=\"par\" id=\"1706097844822_N100F6\">In the IAM configuration, eight  <span class=\"dialog\">UI Resource Set Rules<\/span> plugins need to be configured. One for each resource set. Each plugin requires a  <span class=\"dialog\">Request URL Pattern<\/span> (e.g. <code class=\"codeinline\">https?:\/\/www.asset_one.at\/.*<\/code>) and a <span class=\"dialog\">UI Resource Set File Name<\/span> (e.g. <code class=\"codeinline\">asset_one<\/code>).<\/p><p class=\"par\" id=\"1706097844822_N10101\">The configuration for the <code class=\"codeinline\">fallback.zip<\/code> is only used if no  <span class=\"dialog\">Request URL Pattern<\/span> matched or if the file configured in the <span class=\"dialog\">UI Resource Set File Name<\/span> property cannot be found.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844822_N10069\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further Information and Links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Point\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">More information on TENANT_ID is provided here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1659430054151.html\">Extended tenant ID-dependent customization of the Loginapp UI<\/a><\/li><li class=\"enum-element\">The quickstart guide for the Design Kit is found here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142428.html\">Quickstart guide for the Loginapp Design Kit<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';