var m_1706097844885Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Non-interactive OIDC authentication in IAM flows<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1706097844885\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Non-interactive OIDC authentication in IAM flows<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844885_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844885_N10013\">The OIDC protocol supports the <code class=\"codeinline\"><code class=\"codeinline\">prompt=none<\/code><\/code> parameter that can be used by applications (Relying Parties) to tell Airlock IAM (as OP\/authorization server) not to interact with the end-user, such as showing a login page.<\/p><p class=\"par\" id=\"1706097844885_N10015\">Instead of interactively authenticating the end-user, Airlock IAM tells the application (RP) that interactive authentication is required. The application can then decide what to do.<\/p><p class=\"par\" id=\"1706097844885_N10018\">The feature can also be used by the application to just find out whether the end-user would have to be authenticated interactively.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097844885_N1001B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Using <i class=\"italics\">prompt=none<\/i> in IAM authentication flows<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097844885_N1001E\">If a user needs to be authenticated, Airlock IAM starts the corresponding authentication flow \u2013 even if the <code class=\"codeinline\">prompt=none<\/code> parameter was passed by the application (RP). Thus, flows must be able to handle the situation correctly, by not starting an interaction with the end-user.<\/p><p class=\"par\" id=\"1706097844885_N10023\">To achieve this, the <span class=\"dialog\">OpenId Connect prompt=none Condition<\/span> plugin can used.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are several ways to use the condition:<\/strong><\/li><li class=\"enum-element\"><strong class=\"emphasis\">With a <span class=\"dialog\">Message Acknowledgment Step<\/span><\/strong><br\/>Put a <span class=\"dialog\">Message Acknowledgment Step<\/span> before the first interactive step. As skip condition use the <span class=\"dialog\">Logical NOT<\/span> condition with the <span class=\"dialog\">OpenId Connect prompt=none Condition<\/span>, so the message step is skipped if no <code class=\"codeinline\">promt=none<\/code> request was sent. This configuration results in the <code class=\"codeinline\">error=interaction_required<\/code> HTTP parameter being sent to the application (RP) and it does not result in increasing failure counters.<br\/>Note that if the first interactive step has skip conditions, you need to also use them in the <span class=\"dialog\">Message Acknowledge Step<\/span> (using <span class=\"dialog\">Logical OR<\/span>) and you need to put another <span class=\"dialog\">Message Acknowledge Step<\/span> before the next (possible) interactive step.<\/li><li class=\"enum-element\"><strong class=\"emphasis\">With an <span class=\"dialog\">AbortStep<\/span><\/strong><br\/>The same as with the <span class=\"dialog\">Message Acknowledge Step<\/span> above but using the <span class=\"dialog\">Abort Step<\/span>. This configuration results in the <code class=\"codeinline\">error=access_denied<\/code> HTTP parameter being sent to the application (RP).<\/li><li class=\"enum-element\"><strong class=\"emphasis\">As Precondition (not recommended)<br\/>\u00A0<\/strong>Negated with the <span class=\"dialog\">Logical NOT<\/span> condition, the <span class=\"dialog\">OpenId Connect prompt=none Condition<\/span> can be used as a precondition to the first interactive step. The flow will then fail before the interaction takes place but it also increases the failed login counters of the step with the precondition. This may not be desired.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';