var m_1706097846451Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Usernameless QR code authentication<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1706097846451\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-theme-ct\"><div class=\" headline-theme-content\"><h1 class=\" headline-theme\">Use case<\/h1><\/div><\/div><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Usernameless QR code authentication<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097846451_N1000C\">This article explains on a conceptual level how <i class=\"italics\">Airlock 2FA Usernameless QR Code<\/i> authentication works. It also provides important detailed information for correct use and configuration.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand <i class=\"italics\">usernameless QR code authentication<\/i> in general.<\/li><li class=\"enum-element\">Understand the interaction between involved components.<\/li><li class=\"enum-element\">Learn details about the prerequisites and limitations of the <i class=\"italics\">usernameless QR code<\/i> feature.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097846451_N10042\">Usernameless QR Code authentication provides a great user experience in that it does not require the user to enter (and remember) a user ID. Requiring the user to scan a QR code and approve the login on the mobile phone \u2013 normally involving biometrics \u2013 provides reasonable protection against 2FA fatigue.<\/p><p class=\"par\" id=\"1706097846451_N1003F1707755117871\">Usernameless authentication may be combined with additional fingerprint scanning, face recognition, or a PIN, depending on the capabilities and setup of the smartphone and the used authenticator app.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435067227_N10056\">Airlock 2FA also supports other types of authentication. Please inform yourself about the authentication capabilities and compare them with respect to your requirements. For further information, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1585668112711.html\">Authentication factors<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10069\">This Airlock 2FA factor may also be used for transaction approval and to verify user self-services.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">User account exists in IAM.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has Airlock 2FA enabled as a possible authentication method.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The authenticator app supports Usernameless QR code login.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has installed an authenticator app supporting usernameless QR code authentication.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user\'s smartphone is connected to the internet and is able to connect to the Futurae cloud.<\/li><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10089\">Note that the app used to authenticate needs to be able to handle <i class=\"italics\">usernameless QR code login<\/i>.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N1008B\">The <i class=\"italics\">Airlock 2FA App<\/i> supports the feature in releases published in May 2024.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N1008D\">If using a custom or white label app, ensure the used <i class=\"italics\">Futurae SDK<\/i> supports <i class=\"italics\">usernameless QR login<\/i>.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10096\">Note that <i class=\"italics\">usernameless QR code<\/i> login always involves displaying and scanning a QR code. Therefore, two devices - one displaying the QR code and one scanning the QR code - are required.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Usernameless QR code authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1706097846451_N100F4\">The following flow chart shows how <i class=\"italics\">usernameless QR code<\/i> authentication works in general:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1706097846451_N1008F\"><img alt=\"UC-UsernamelessQRCode-DrawIO\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.2\/DOC-1338_Airlock_2FA_Usernameless_QR_Code\/8744.UC-UsernamelessQRCode-DrawIO.theme\/1.0\/en-us.8744.UC-UsernamelessQRCode-DrawIO_original.svg\" style=\"width:;height:674px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1706097846451_N1009B\"><col style=\"width:5%;\"\/><col style=\"width:95%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100AD\">(1)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100B4\">The authentication process is started.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100C4\">(2)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100BF1583421751155\">IAM starts an authentication session with the Futurae cloud and retrieves a QR code challenge suitable for usernameless authentication. Note that the QR code is anonymous, i.e., it is not bound to a user account.<\/p><p class=\"par\" id=\"1706097846451_N100D7\">The QR Code is displayed in the user\'s browser.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100D01704462347664\">(3)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100D5\">The web browser starts polling for the user\'s authentication decision at the Future cloud.<\/p><p class=\"par\" id=\"1706097846451_N100EA\">Note that Airlock IAM may return a new QR code while polling. QR codes are refreshed for security reasons from time to time (depending on the configured timeout).<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100DF1704462347664\">(4)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100CB\">The end user scans the QR code with the Airlock 2FA app (or other authenticator app) and is asked to approve (or deny) the authentication step.<\/p><p class=\"par\" id=\"1706097846451_N100E0\">The smartphone must be unlocked. Depending on the smartphone\'s capabilities and setup and the used app this may involve a PIN, fingerprint, or face recognition.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">If the user has multiple accounts for accessing the service, the user must choose which account to log in.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100F3\">(5)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100DF\">Airlock IAM gets the confirmation of the successful login and the user\'s ID from the Futurae cloud.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100FF\">(6)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1706097846451_N100E5\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM automatically redirects the user\'s browser to the intended target application or service.<\/span><\/p><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N1013E\"><strong class=\"emphasis\">Optional goto target after a timeout<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10143\">The QR code shown in the web browser is refreshed for security reasons from time to time. It is possible to configure an overall timeout by specifying the maximum number of QR code refreshes to display.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10146\">After the overall timeout, the browser can be redirected to another step by configuring an internal goto target. Like this, a message or an alternative way to authenticate may be displayed to the user.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1706097846451_N10149\">The internal goto target is not shown in the above diagram.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1706097846451_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1706097846498.html\">Airlock 2FA Usernameless QR code login - REST flow example<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';