var m_1709045021551Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Scriptable step overview - an incubating feature<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1709045021551\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Scriptable step overview - an incubating feature<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045021551_N10009\">Customers of Airlock IAM may face unique requirements that are difficult to address with a standardized product. The new <i class=\"italics\">Scriptable Step<\/i> allows such customers to quickly and conveniently implement solutions for such requirements.<\/p><p class=\"par\" id=\"1709045021551_N1000E1709109783831\">The Scriptable Step can be configured into any IAM flow, e.g., authentication, protected self-service, public self-service, self-registration, and transaction approval. <\/p><p class=\"par\" id=\"1709045021551_N10010\">The Scriptable Step is non-interactive, so it is not possible to create a UI for it.<\/p><div xmlns=\"\" class=\"container-warning observe\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1709045021551_N1000E\">The scriptable step is an incubating feature. It is intended to gather experience with this type of customization capability and to improve the functionality in future versions of Airlock IAM. It is possible that the plugins provided and the underlying architecture may change fundamentally and without further notice in future releases of IAM.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N1001A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Input and output<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045021551_N1001D\">To allow a scriptable step to interact with the flow, both input and output need to be configured in the plugin:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-Normal table-Normal table- table-block-description table-\" id=\"1709045021551_N1001F\"><col style=\"width:20%;\"\/><col style=\"width:80%;\"\/><tbody class=\"tbody-Normal\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1709045021551_N10031\">Script input<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstrow table-cell-firstrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><p class=\"par\" id=\"1709045021551_N10036\">A list of value map providers is configured in the plugin. The key-value pairs of all configured value maps are made available in the script.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1709045021551_N10046\">Secrets<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><p class=\"par\" id=\"1709045021551_N1004B1709115725242\">Script inputs that are persisted as sensitive configuration values (secrets) can be provided to a script through environment variables. In the script context, secrets only exist in the IAM server. The script developer is responsible for avoiding leaking secrets.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-innerrow table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1709045021551_N1003C\">Script output<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-odd table-cell-odd-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-innerrow table-cell-col-even-Normal\"><div><p class=\"par\" id=\"1709045021551_N10041\">The script can return a value map to the flow. In the configuration, a list of the acceptable keys and their data types must be configured to control what keys are accepted back by the flow.<\/p><p class=\"par\" id=\"1709045021551_N1005D\">Multiple scripting steps can segregate their return values by assigning their results to different namespaces.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-firstcolumn table-cell-firstcolumn-Normal table-cell-firstcolumn-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-col-odd-Normal\"><div><p class=\"par\" id=\"1709045021551_N10064\">Logging<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Normal table-cell-even table-cell-even-Normal table-cell-lastrow table-cell-lastrow-Normal table-cell-lastcolumn table-cell-lastcolumn-Normal table-cell-lastcolumn-Normal table-cell-col-even-Normal\"><div><p class=\"par\" id=\"1709045021551_N10069\">The scripting language is extended with an \"iam.log\" directive that logs into the Airlock IAM log.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N1004A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scripting language Lua<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045021551_N1004D\">Airlock IAM supports Lua as the scripting language (see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/www.lua.org\" target=\"_blank\">The Programming Language Lua<\/a> for more information). <\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1709045021551_N100991711455468715\"><caption class=\"table-title\">Table: Lua compatibility matrix<\/caption><col style=\"width:50%;\"\/><col style=\"width:50%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1709045021551_N100AC\">Airlock IAM version<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1709045021551_N100B11711455468715\">Lua version<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1709045021551_N100B7\">8.2.x<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1709045021551_N100BC\">5.4.6<\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1709045021551_N100C5\">If the above version dependency is not acceptable for a particular deployment scenario, the Lua interpreter and dependent libraries can be replaced with a different version. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1709045021551.html#1709045021551_N100D5\">Lua and operating system dependencies<\/a> below.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Lua was chosen for the following reasons:<\/strong><\/li><li class=\"enum-element\">Lua is lightweight and adds hardly any overhead to the IAM distribution image.<\/li><li class=\"enum-element\">Lua provides a well-maintained ecosystem of libraries.<\/li><li class=\"enum-element\">Lua is supported by a thriving community of developers.<\/li><li class=\"enum-element\">Lua is already well established, and the language is very stable.<\/li><li class=\"enum-element\">Lua is the default scripting language of the Airlock Microgateway.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N10091\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Developer support<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045021551_N100B1\">To facilitate using Lua, the <code class=\"codeinline\">lua-cjson<\/code> library has been bundled with the scripting engine. This library deserializes input variables and serializes output variables for data exchange with Airlock IAM.<\/p><p class=\"par\" id=\"1709045021551_N100B81709536183962\">Additional libraries can be added using <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/luarocks.org\/\" target=\"_blank\">The Luarocks package manager<\/a> and installed directly into the instances folder of Airlock IAM.<\/p><p class=\"par\" id=\"1709045021551_N100CC\">Scripts can log different severity levels to the regular Airlock IAM log files. Use this feature to document the progress and outcome of scriptable steps and for debugging purposes.<\/p><p class=\"par\" id=\"1709045021551_N1011C\">The scripts are written in a text box in the Scriptable Step plugin to use the scripting feature in Airlock IAM. This solution was chosen for the following reasons:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Scripts are part of the configuration and do not require additional effort to deploy or manage script files.<\/li><li class=\"enum-element\">The scripting step is not intended for large-scale customizations. Typical scripts are expected to be between 10 and 100 lines of code.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N10092\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following is a non-exhaustive list of known limitations of the scriptable step:<\/strong><\/li><li class=\"enum-element\">Airlock IAM provides no integrated IDE support for writing or debugging Lua scripts.<\/li><li class=\"enum-element\">The current implementation only supports non-interactive flow steps and, therefore, does not support any interactions with the end user.<\/li><li class=\"enum-element\">Security hardening is limited as scripts are executed in the IAM process context. There is a limitation on scripts to run at most 30 seconds to prevent scripts from using resources excessively.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045021551_N100D5\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Lua and operating system dependencies<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045021551_N100DA\">The Lua script interpreter and all the pre-bundled shared object libraries are provided in an executable format suitable for Linux operating systems. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Lua will work out of the box for the following use cases:<\/strong><\/li><li class=\"enum-element\">Airlock IAM runs as a self-contained application on a Linux operating system.<\/li><li class=\"enum-element\">Airlock IAM is deployed as a container image on any compatible platform (e.g. Kubernetes or Openshift).<\/li><\/ul><p class=\"par\" id=\"1709045021551_N100FE\">If Lua is intended to be used natively with another operating system, the <code class=\"codeinline\">lua<\/code> executable and all shared object libraries must be replaced with versions that work on the target operating system. <\/p><p class=\"par\" id=\"1709045021551_N100DD\"><strong class=\"emphasis\">Example:<\/strong><\/p><p class=\"par\" id=\"1709045021551_N100E1\">On a MacOS operating system, the following tasks must be executed to replace the executable and the shared library files.<\/p><p class=\"par\" id=\"1709045021551_N1010B\">MacOS may raise a security alert because the developer of <code class=\"codeinline\">lua<\/code>, <code class=\"codeinline\">luarocks or cjson.so<\/code> is not trusted. <strong class=\"emphasis\">This trust must be granted in: <\/strong><br\/><span class=\"dialog\">System Settings<\/span> &gt;&gt; <span class=\"dialog\">Privacy&amp;Security<\/span><\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Use <code class=\"codeinline\">brew install lua<\/code> to install the Lua script interpreter locally.<\/li><li class=\"step\">Copy the <code class=\"codeinline\">lua<\/code> executable from <code class=\"codeinline\">\/opt\/homebrew\/bin\/lua<\/code> to the Airlock IAM installation directory in <code class=\"codeinline\">$IAM_install_dir\/res\/scripting\/lua\/<\/code>.<\/li><li class=\"step\">Use <code class=\"codeinline\">brew install luarocks<\/code> to install the Luarocks package manager locally.<\/li><li class=\"step\">Use <code class=\"codeinline\">luarocks install --tree \/tmp\/cjson lua-cjson<\/code> to install the latest version of cjson locally.<\/li><li class=\"step\">Copy the .so file from <code class=\"codeinline\">\/tmp\/cjson\/lib\/lua\/&lt;version\/cjson.so<\/code> to the lib directory in the Airlock IAM installation directory in <code class=\"codeinline\">$IAM_install_dir\/res\/scripting\/lua\/lib<\/code>.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';