var m_1709045030278Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Scriptable step examples<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1709045030278\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Scriptable step examples<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N10009\">The example presented is only useful to demonstrate the capabilities of the scriptable step and how it can interact with Airlock IAM. The example is limited because most useful use cases require either proprietary services or services behind a paywall.<\/p><p class=\"par\" id=\"1709045030278_N1000D\">The example implements a self-registration flow that verifies secrets with a REST API, registers the user with another REST API, and summarizes the success in an HTML-formatted message:<\/p><figure class=\"media\"><div class=\"media-theme shadow\" id=\"1709045030278_N1000C\"><img alt=\"IAM_Scriptable_Step_Example_Flow\" class=\"media-theme-img-tag png shadow\" src=\"..\/media\/03_Media\/Screenshots\/IAM\/Config_Editor\/IAM_Scriptable_Step_Example_Flow.theme\/1.0\/en-us.IAM_Scriptable_Step_Example_Flow_html.png\" style=\"width:1024px;height:768.2440419447092px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1709045030278_N10016\">The template of this flow has been taken from the Demo Configuration bundled with Airlock IAM. <\/p><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This flow has been changed to show the following, scripting-related properties:<\/strong><\/li><li class=\"step\">A <span class=\"dialog\">Scriptable Step<\/span> implements a REST call to a 3rd party system that requires basic auth and returns <i class=\"italics\">success<\/i>\/<i class=\"italics\">failure<\/i> status to Airlock IAM.<\/li><li class=\"step\">An <span class=\"dialog\">Acknowledge Message Step<\/span> is displayed depending on the status output of the previous scriptable step. It will set a tag that forces all the following steps to be skipped in case of an error.<\/li><li class=\"step\">A <span class=\"dialog\">Scriptable Step<\/span> implements a <code class=\"codeinline\">POST<\/code> request to a 3rd party system to retrieve data for display.<\/li><li class=\"step\">A <span class=\"dialog\">Scriptable Step<\/span> to generate an HTML snippet with the data from the previous step and to return this to Airlock IAM.<\/li><li class=\"step\">An <span class=\"dialog\">Acknowledge Message Step<\/span> that displays the HTML snippet from the previous step.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard Bullet\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To use the example as intended, you can simulate the following two situations:<\/li><li class=\"enum-element\">If the user interactively chooses the same password as configured as secret in the first scriptable step, the self-registration flow will continue successfully. <\/li><li class=\"enum-element\">If the user chooses a different password, the first scriptable step will fail and all the following steps will be skipped and the self-registration will not be successful.<\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N10035\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To run the example scripts on this page, the following prerequisites must be met:<\/strong><\/li><li class=\"enum-element\">Additional libraries need to be installed in the instance directory. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">lua-curl is a shared library object that can send and receive REST requests from a Lua script. <\/li><li class=\"enum-element\">base64 is a Lua library to base64 encode and decode strings.<\/li><\/ul><li class=\"enum-element\">The <span class=\"dialog\">User Data Registration Step<\/span> has to be configured with a <span class=\"dialog\">Password User Item<\/span> plugin. In the <span class=\"dialog\">Password User Item<\/span> the <span class=\"dialog\">Password Attribute Key<\/span> must be configured with a value (e.g. <code class=\"codeinline\">PASSWORD<\/code>). This key will be used to provide the password to the script in the <span class=\"dialog\">Input Map<\/span>.<\/li><\/ul><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Installing additional libraries:<\/strong><\/li><li class=\"step\">Use <code class=\"codeinline\">luarocks install --tree $IAM_instance_dir\/scripting\/lua lua-curl<\/code>.<\/li><li class=\"step\">Use <code class=\"codeinline\">luarocks install --tree $IAM_instance_dir\/scripting\/lua base64<\/code>.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N10055\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">REST request with basic auth<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N10058\">This <span class=\"dialog\">Scriptable Step<\/span> plugin will connect to <i class=\"italics\">httpbin.org<\/i> and simulate basic auth authentication. <\/p><p class=\"par\" id=\"1709045030278_N1008E\">It will take the username (<span class=\"dialog\">Context Data Map<\/span> plugin) and password (<span class=\"dialog\">User Password Map<\/span> plugin) to create the authentication URL. <\/p><p class=\"par\" id=\"1709045030278_N10097\">It will take the username (<span class=\"dialog\">Context Data Map<\/span> plugin) and secret (<span class=\"dialog\">Input Secrets<\/span>) and create a basic auth header. <\/p><p class=\"par\" id=\"1709045030278_N100A0\">In this simulation, <i class=\"italics\">httpbin.org<\/i> will compare <code class=\"codeinline\">password<\/code> and <code class=\"codeinline\">secret<\/code>. The REST API will return a <code class=\"codeinline\">200-ok<\/code> status code if they are identical. If there is a mismatch a <code class=\"codeinline\">401 unauthorized<\/code> status code will be returned.<\/p><p class=\"par\" id=\"1709045030278_N1009D\">We can use this behavior to force the self-registration flow to either succeed if we provide the secret as user password or to fail, if we provide a different string.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Self-Registration<\/span> &gt;&gt; <span class=\"dialog\">Default Flow<\/span> <\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> create and edit a <span class=\"dialog\">Scriptable Step<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Input Map<\/span> configure a <span class=\"dialog\">Context Data Map<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Output Map<\/span> configure 2 <span class=\"dialog\">Script Output Declaration<\/span> plugins as follows.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A mandatory <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">response_code<\/code>.<\/li><li class=\"enum-element\">An optional <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">server_response<\/code>.<\/li><\/ul><li class=\"step\">In section <span class=\"dialog\">Advanced Settings<\/span> in property <span class=\"dialog\">Input Secrets<\/span> configure and edit a <span class=\"dialog\">Script Secret<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Identifier<\/span> set the value to <code class=\"codeinline\">BASIC_AUTH<\/code>.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Secret<\/span> configure a random value.<\/li><\/ul><li class=\"step\">In section <span class=\"dialog\">Advanced Settings<\/span> in property <span class=\"dialog\">Namespace<\/span> configure and edit a <span class=\"dialog\">Script Namespace<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Identifier<\/span> set the value to <code class=\"codeinline\">get-basic-auth<\/code>.<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Script<\/span> add the following Lua code:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100EC\">-- Example script that shows how a GET request with Basic Auth can be sent to a remote endpoint.\r\nlocal curl = require \"cURL\"\r\nlocal base64 = require \"base64\"\r\n\r\nfunction prepareGetRequest (responseHandler)\r\n    local targetURL = \"https:\/\/httpbin.org\/basic-auth\/\" .. iam.input_map[\"username\"] .. \"\/\" .. iam.input_map[\"PASSWORD\"]\r\n    local basic_auth_cred = base64.encode(iam.input_map[\"username\"] .. \":\" .. iam.secrets:get(\"BASIC_AUTH\"))\r\n\r\n    local request = curl.easy{\r\n        url = targetURL,\r\n        httpheader = {\r\n            \"Authorization: Basic \" .. basic_auth_cred,\r\n            \"accept: application\/jsonbla\"\r\n        },\r\n        writefunction = responseHandler,\r\n        [curl.OPT_TIMEOUT] = 10 -- request timeout\r\n    }\r\n    return request\r\nend\r\n\r\nfunction performBasicAuthGetRequest ()\r\n    local output_map = {}\r\n    local function handleResponse (response)\r\n        output_map[\"server_response\"] = response\r\n    end\r\n\r\n    local request = prepareGetRequest(handleResponse)\r\n    request:perform()\r\n\r\n    output_map[\"response_code\"] = tostring(request:getinfo(curl.INFO_RESPONSE_CODE))\r\n\r\n    request:close()\r\n    return output_map\r\nend\r\n\r\nfunction iam_on_step_init ()\r\n    iam.log:info(\"Complete input map of GET request step: \" .. iam.cjson.encode(iam.input_map))\r\n    local output_map = performBasicAuthGetRequest()\r\n    iam.log:info(\"Complete output map of GET request step: \" .. iam.cjson.encode(output_map))\r\n    return output_map\r\nend<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The plugin is ready to exchange data between IAM and script. <\/li><\/ol><p class=\"par\" id=\"1709045030278_N100C0\">The <span class=\"dialog\">Namespace<\/span> property is used in this example because another script also provides <code class=\"codeinline\">response_code<\/code> and <code class=\"codeinline\">server_response<\/code> as return values. Using <span class=\"dialog\">Namespace<\/span> avoids name conflicts in the self-registration flow.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N10132\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Conditional error message<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N10135\">The <span class=\"dialog\">Acknowledge Message Step<\/span> is used as a conditional error message and should only be shown if the previous scriptable step returned a <code class=\"codeinline\">401<\/code> status code.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> create and edit an <span class=\"dialog\">Acknowledge Message Step<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Server Message<\/span> create and edit a <span class=\"dialog\">Static String Value Provider<\/span> plugin. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the <span class=\"dialog\">Value<\/span> property define a message for the end user (e.g., The REST request was unsuccessful. Self-registration has been aborted).<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Skip Condition<\/span> create and edit a <span class=\"dialog\">String Regex Condition<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the property <span class=\"dialog\">Value Provider<\/span> create and edit a <span class=\"dialog\">String From Map Value Provider<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the property <span class=\"dialog\">Value Maps<\/span> create and edit a <span class=\"dialog\">Script Execution Result Value Map Provider<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the property <span class=\"dialog\">Namespace Config<\/span> select the namespace pluign configured in the previous step (REST request with basic auth).<\/li><\/ul><li class=\"enum-element\">In the property <span class=\"dialog\">Key<\/span> provide the key from the <span class=\"dialog\">Output Map<\/span> (e.g. <code class=\"codeinline\">response_code<\/code>).<\/li><\/ul><li class=\"enum-element\">In the property <span class=\"dialog\">Regex Pattern<\/span> define the pattern (e.g. <code class=\"codeinline\">^2.*<\/code>).<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Tags on Success<\/span> create and edit a <span class=\"dialog\">Tag<\/span> plugin. <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the property <span class=\"dialog\">Name<\/span> define an identifier (e.g. <code class=\"codeinline\">rest-failed<\/code>).<\/li><\/ul><li class=\"step result\">The step will be skipped if the key <code class=\"codeinline\">response_code<\/code> in the namespace <code class=\"codeinline\">get-basic-auth<\/code> is <code class=\"codeinline\">2xx<\/code>. In all other cases, the step will be executed, the message displayed and the tag <code class=\"codeinline\">rest-failed<\/code> will be set.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N101A4\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Skip condition on all remaining steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N101A7\">If the first <span class=\"dialog\">Scriptable Step<\/span> (REST request with basic auth) returned an error status code, all remaining steps in the flow should be skipped. For this purpose, we use the Tag set in the <span class=\"dialog\">Acknowledge Message Step<\/span> (conditional error message).<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To be configured on every further step:<\/strong><\/li><li class=\"step\">In property <span class=\"dialog\">Skip Condition<\/span> configure and edit a <span class=\"dialog\">Has Tag<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Tag<\/span> select the plugin created previously for the <code class=\"codeinline\">rest-failed<\/code> identifier.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N100CB\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Post request with JSON body<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N10109\">This <span class=\"dialog\">Scriptable Step<\/span> plugin will establish a connection to <i class=\"italics\">reqres.in<\/i> and will send a POST request with a JSON body. The <i class=\"italics\">reqres.in<\/i> endpoint will simulate adding a user with the JSON data provided. The user data, an additional user identity, and a creation date are returned in the response.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Self-Registration<\/span> &gt;&gt; <span class=\"dialog\">Default Flow<\/span> <\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> create and edit a <span class=\"dialog\">Scriptable Step<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Input Map<\/span> configure a <span class=\"dialog\">Context Data Map<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Output Map<\/span> configure 2 Script Output Declaration plugins.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">A mandatory <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">response_code<\/code>.<\/li><li class=\"enum-element\">An optional <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">server_response<\/code>.<\/li><\/ul><li class=\"step\">In <span class=\"dialog\">Advanced Settings<\/span> in property <span class=\"dialog\">Namespace<\/span> configure and edit a <span class=\"dialog\">Script Namespace<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Identifier<\/span> set the value to <code class=\"codeinline\">post-request-step<\/code>.<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Script<\/span> add the following Lua code:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10168\">-- Example script that shows how a POST request with JSON body can be sent to a remote endpoint.\r\nlocal curl = require \"cURL\"\r\n\r\nfunction buildRequestJsonBody ()\r\n    local jsonBody = {}\r\n    jsonBody[\"username\"] = iam.input_map[\"username\"]\r\n    jsonBody[\"email\"] = iam.input_map[\"email\"]\r\n    jsonBody[\"givenname\"] = iam.input_map[\"givenname\"]\r\n    jsonBody[\"surname\"] = iam.input_map[\"surname\"]\r\n    jsonBody[\"town\"] = iam.input_map[\"town\"]\r\n    jsonBody[\"birthdate\"] = iam.input_map[\"birthdate\"]\r\n    return iam.cjson.encode(jsonBody)\r\nend\r\n\r\nfunction prepareJsonPostRequest (responseHandler)\r\n    local targetURL = \"https:\/\/reqres.in\/api\/users\"\r\n    local request = curl.easy{\r\n        url = targetURL,\r\n        post = true,\r\n        httpheader = {\r\n            \"Content-Type: application\/json\"\r\n        },\r\n        postfields = buildRequestJsonBody(),\r\n        writefunction = responseHandler,\r\n        [curl.OPT_TIMEOUT] = 10 -- request timeout\r\n    }\r\n    return request\r\nend\r\n\r\nfunction performJSONPostRequest ()\r\n    local output_map = {}\r\n    local function handleResponse (response)\r\n        output_map[\"server_response\"] = response\r\n    end\r\n    local request = prepareJsonPostRequest(handleResponse)\r\n    request:perform()\r\n\r\n    output_map[\"response_code\"] = tostring(request:getinfo(curl.INFO_RESPONSE_CODE))\r\n\r\n    request:close()\r\n    return output_map\r\nend\r\n\r\nfunction iam_on_step_init ()\r\n    iam.log:info(\"Complete input map on POST request step: \" .. iam.cjson.encode(iam.input_map))\r\n    local output_map = performJSONPostRequest()\r\n    iam.log:info(\"Complete output map of POST request step: \" .. iam.cjson.encode(output_map))\r\n    return output_map\r\nend\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The plugin is ready to exchange data between IAM and script. <\/li><p class=\"par\" id=\"1709045030278_N10172\">The <span class=\"dialog\">Namespace<\/span> property is used in this example because another script also provides <code class=\"codeinline\">response_code<\/code> and <code class=\"codeinline\">server_response<\/code> as return values. Using Namespace avoids name conflicts in the self-registration flow.<\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N100CE\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Message builder<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N10182\">This  <span class=\"dialog\">Scriptable Step<\/span> will transform the JSON response of the previous step (Post request with JSON body) into human-readable HTML for the next <span class=\"dialog\">Acknowledge Message Step<\/span>. <\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Self-Registration<\/span> &gt;&gt; <span class=\"dialog\">Default Flow<\/span> <\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span> create and edit a <span class=\"dialog\">Scriptable Step<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Input Map<\/span> configure a <span class=\"dialog\">Context Data Map<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Output Map<\/span> configure 2 Script Output Declaration plugins.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">An optional <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">message<\/code>.<\/li><li class=\"enum-element\">An mandatory <span class=\"dialog\">STRING<\/span> with <span class=\"dialog\">Key<\/span> <code class=\"codeinline\">result<\/code>.<\/li><\/ul><li class=\"step\">In <span class=\"dialog\">Advanced Settings<\/span> in property <span class=\"dialog\">Namespace<\/span> configure and edit a <span class=\"dialog\">Script Namespace<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Identifier<\/span> set the value to <code class=\"codeinline\">message_builder<\/code>.<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Script<\/span> add the following Lua code:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101E5\">-- Example script that transforms the received JSON response into a human-readable HTML.\r\nlocal messageTemplate = [[\r\nAdded a new user with the following properties:\r\n&lt;ul&gt;\r\n&lt;li&gt;Username: %s&lt;\/li&gt;\r\n&lt;li&gt;E-Mail: %s&lt;\/li&gt;\r\n&lt;li&gt;First Name: %s&lt;\/li&gt;\r\n&lt;li&gt;Last Name: %s&lt;\/li&gt;\r\n&lt;li&gt;Town: %s&lt;\/li&gt;\r\n&lt;li&gt;Birth Date: %s&lt;\/li&gt;\r\n&lt;li&gt;Identity: %s&lt;\/li&gt;\r\n&lt;li&gt;Creation Date: %s&lt;\/li&gt;\r\n&lt;\/ul&gt;\r\n]]\r\n\r\nfunction getPropertyOrDefault(jsonTable, key)\r\n    if (jsonTable[key] ~= nil) then\r\n        return tostring(jsonTable[key])\r\n    else\r\n        return \"-\"\r\n    end\r\nend\r\n\r\nfunction buildMessage ()\r\n    local output_map = {}\r\n    local success, jsonTable = pcall(iam.cjson.decode, iam.input_map[\"server_response\"])\r\n    if (success == false) then\r\n        output_map[\"result\"] = \"failure\"\r\n        return output_map\r\n    end\r\n\r\n    local ackMessage = string.format(messageTemplate,\r\n            getPropertyOrDefault(jsonTable, \"username\"),\r\n            getPropertyOrDefault(jsonTable, \"email\"),\r\n            getPropertyOrDefault(jsonTable, \"givenname\"),\r\n            getPropertyOrDefault(jsonTable, \"surname\"),\r\n            getPropertyOrDefault(jsonTable, \"town\"),\r\n            getPropertyOrDefault(jsonTable, \"birthdate\"),\r\n            getPropertyOrDefault(jsonTable, \"id\"),\r\n            getPropertyOrDefault(jsonTable, \"createdAt\"))\r\n\r\n    output_map[\"message\"] = ackMessage\r\n    output_map[\"result\"] = \"success\"\r\n    return output_map\r\nend\r\n\r\nfunction iam_on_step_init ()\r\n    iam.log:info(\"Complete input map of message builder step: \" .. iam.cjson.encode(iam.input_map))\r\n    local output_map = buildMessage()\r\n    iam.log:info(\"Complete output map of message builder step: \" .. iam.cjson.encode(output_map))\r\n    return output_map\r\nend\r\n<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step result\">The plugin is ready to exchange data between IAM and script. <\/li><p class=\"par\" id=\"1709045030278_N101EF\">The <span class=\"dialog\">Namespace<\/span> property is used in this example for clarity only. No other scripts provide the same return values, and the default namespace would have been sufficient. <\/p><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1709045030278_N102B9\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">REST Response Display<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1709045030278_N102BC\">To display the data from the REST response, an <span class=\"dialog\">Acknowledge Message Step<\/span> is configured as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In property <span class=\"dialog\">Server Message<\/span> create and edit a <span class=\"dialog\">String From Value Map Provider<\/span> plugin.<\/li><li class=\"step\">In property <span class=\"dialog\">Value Maps<\/span> create and edit a <span class=\"dialog\">Script Execution Result Value Map<\/span> plugin.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Namespace Config<\/span> select the message builder namespace.<\/li><\/ul><li class=\"step\">In property <span class=\"dialog\">Key<\/span> set the key from the <span class=\"dialog\">Output Map<\/span> of the message builder (e.g. message).<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';