var m_1710781876728Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Upgrade Airlock IAM at runtime (rolling upgrade)<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1710781876728\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Upgrade Airlock IAM at runtime (rolling upgrade)<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1710781876728_N10013\">Upgrading at runtime, also referred to as <i class=\"italics\">rolling upgrade<\/i>, is the process of activating a new version of Airlock IAM without interrupting IAM operation.<\/p><p class=\"par\" id=\"1710781876728_N10014\">Airlock IAM supports rolling upgrades to a certain extent under specific circumstances.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N10017\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Preconditions for rolling upgrades<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Rolling upgrades of Airlock IAM are possible if the following preconditions are met:<\/strong><\/li><li class=\"enum-element\">At least two IAM instances are active at a time in an active-active setup.<\/li><li class=\"enum-element\">IAM session state is stored in an external Redis cluster and not in memory.<\/li><li class=\"enum-element\">The IAM version to upgrade to supports rolling updates. This is the case starting with IAM 8.2 and onwards unless otherwise stated in the release notes.<\/li><li class=\"enum-element\">The used database is supported for rolling updates by the schema upgrade scripts provided with Airlock IAM.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N1002D\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 1 \u2013 Upgrade database schema<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1710781876728_N100301712147509380\">Before upgrading the IAM instances, the database schema must be updated for the new release. To do so, use the database schema scripts provided on <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945303.html\">Relational databases for IAM<\/a>.<\/p><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1710781876728_N10044\">Not all database schema changes are designed to work with both the old and the new IAM version. Database schema change scripts may need to be specially crafted for use with rolling updates.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1710781876728_N10046\">Especially, do not use database schema upgrade scripts older than those for IAM 8.2 for updates at runtime.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1710781876728_N10048\">Carefully read the note regarding each database upgrade script.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N10025\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Step 2 \u2013 Upgrade IAM instances<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1710781876728_N10028\">Upgrading at runtime is based on running multiple IAM instances and then upgrading each instance in a way that at least one instance is available at all times, e.g. upgrading each instance after another. This can be done manually in a traditional active-active setup or automatically, e.g., in a Kubernetes setup.<\/p><p class=\"par\" id=\"1710781876728_N1002A\">During the upgrade phase, some IAM instances are running the old and some are running the new version. To make it possible to migrate the session state, a so-called <i class=\"italics\"><strong class=\"emphasis\">blue-green deployment<\/strong><\/i> model is required: it makes sure that once the state of an IAM session has been migrated to the new version, no subsequent request of that session is sent to an IAM instance running the old version.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1710781876728_N10033\">The used reverse proxy, ingress controller, or load balancer <strong class=\"emphasis\">must ensure the blue-green deployment<\/strong>. <strong class=\"emphasis\">This cannot be enforced by Airlock IAM.<\/strong><\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1710781876728_N1003A1712146891735\"><strong class=\"emphasis\">Remark: <\/strong><br\/>If the used reverse proxy, ingress controller, or load balancer is capable of session-sticky load-balancing, <i class=\"italics\">starving out<\/i> old IAM instances is possible as an alternative to blue-green deployment.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N10072\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Note the following limitations regarding updates at runtime:<\/strong><\/li><li class=\"enum-element\">Depending on the included changes, database schema updates may not be available for updates at runtime. This applies especially to H2 and MSSQL databases.<\/li><li class=\"enum-element\">Updating at runtime requires blue-green deployments. Session-sticky load balancing in combination with \"starving out\" IAM instances may be used as an alternative.<\/li><li class=\"enum-element\">While user and admin sessions are preserved when upgrading, ongoing flows (authentication, self-services, etc.) may be aborted during the update.<\/li><li class=\"enum-element\">Single HTTP requests may result in failures while upgrading.<\/li><li class=\"enum-element\">Upgrades are only supported from a lower to a higher version number and not vice versa.<\/li><li class=\"enum-element\">Note the limitations of <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917388944.html\">Storing session state in an external Redis session repository<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1710781876728_N1002E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1693917388944.html\">Storing session state in an external Redis session repository<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945303.html\">Database schema upgrade scripts<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';